// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// This file has been generated from the Jinja2 template in
// third_party/WebKit/Source/bindings/templates/union_container.cpp.tmpl

// clang-format off
#include "StringOrArrayBufferOrArrayBufferView.h"

#include "bindings/core/v8/IDLTypes.h"
#include "bindings/core/v8/NativeValueTraitsImpl.h"
#include "bindings/core/v8/ToV8ForCore.h"
#include "bindings/core/v8/V8ArrayBuffer.h"

namespace blink {

StringOrArrayBufferOrArrayBufferView::StringOrArrayBufferOrArrayBufferView() : m_type(SpecificTypeNone) {}

DOMArrayBuffer* StringOrArrayBufferOrArrayBufferView::getAsArrayBuffer() const {
  DCHECK(isArrayBuffer());
  return m_arrayBuffer;
}

void StringOrArrayBufferOrArrayBufferView::setArrayBuffer(DOMArrayBuffer* value) {
  DCHECK(isNull());
  m_arrayBuffer = value;
  m_type = SpecificTypeArrayBuffer;
}

StringOrArrayBufferOrArrayBufferView StringOrArrayBufferOrArrayBufferView::fromArrayBuffer(DOMArrayBuffer* value) {
  StringOrArrayBufferOrArrayBufferView container;
  container.setArrayBuffer(value);
  return container;
}

NotShared<DOMArrayBufferView> StringOrArrayBufferOrArrayBufferView::getAsArrayBufferView() const {
  DCHECK(isArrayBufferView());
  return m_arrayBufferView;
}

void StringOrArrayBufferOrArrayBufferView::setArrayBufferView(NotShared<DOMArrayBufferView> value) {
  DCHECK(isNull());
  m_arrayBufferView = Member<DOMArrayBufferView>(value.View());
  m_type = SpecificTypeArrayBufferView;
}

StringOrArrayBufferOrArrayBufferView StringOrArrayBufferOrArrayBufferView::fromArrayBufferView(NotShared<DOMArrayBufferView> value) {
  StringOrArrayBufferOrArrayBufferView container;
  container.setArrayBufferView(value);
  return container;
}

const String& StringOrArrayBufferOrArrayBufferView::getAsString() const {
  DCHECK(isString());
  return m_string;
}

void StringOrArrayBufferOrArrayBufferView::setString(const String& value) {
  DCHECK(isNull());
  m_string = value;
  m_type = SpecificTypeString;
}

StringOrArrayBufferOrArrayBufferView StringOrArrayBufferOrArrayBufferView::fromString(const String& value) {
  StringOrArrayBufferOrArrayBufferView container;
  container.setString(value);
  return container;
}

StringOrArrayBufferOrArrayBufferView::StringOrArrayBufferOrArrayBufferView(const StringOrArrayBufferOrArrayBufferView&) = default;
StringOrArrayBufferOrArrayBufferView::~StringOrArrayBufferOrArrayBufferView() = default;
StringOrArrayBufferOrArrayBufferView& StringOrArrayBufferOrArrayBufferView::operator=(const StringOrArrayBufferOrArrayBufferView&) = default;

DEFINE_TRACE(StringOrArrayBufferOrArrayBufferView) {
  visitor->Trace(m_arrayBuffer);
  visitor->Trace(m_arrayBufferView);
}

void V8StringOrArrayBufferOrArrayBufferView::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, StringOrArrayBufferOrArrayBufferView& impl, UnionTypeConversionMode conversionMode, ExceptionState& exceptionState) {
  if (v8Value.IsEmpty())
    return;

  if (conversionMode == UnionTypeConversionMode::kNullable && IsUndefinedOrNull(v8Value))
    return;

  if (v8Value->IsArrayBuffer()) {
    DOMArrayBuffer* cppValue = V8ArrayBuffer::toImpl(v8::Local<v8::Object>::Cast(v8Value));
    impl.setArrayBuffer(cppValue);
    return;
  }

  if (v8Value->IsArrayBufferView()) {
    NotShared<DOMArrayBufferView> cppValue = ToNotShared<NotShared<DOMArrayBufferView>>(isolate, v8Value, exceptionState);
    if (exceptionState.HadException())
      return;
    impl.setArrayBufferView(cppValue);
    return;
  }

  {
    V8StringResource<> cppValue = v8Value;
    if (!cppValue.Prepare(exceptionState))
      return;
    impl.setString(cppValue);
    return;
  }
}

v8::Local<v8::Value> ToV8(const StringOrArrayBufferOrArrayBufferView& impl, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  switch (impl.m_type) {
    case StringOrArrayBufferOrArrayBufferView::SpecificTypeNone:
      return v8::Null(isolate);
    case StringOrArrayBufferOrArrayBufferView::SpecificTypeArrayBuffer:
      return ToV8(impl.getAsArrayBuffer(), creationContext, isolate);
    case StringOrArrayBufferOrArrayBufferView::SpecificTypeArrayBufferView:
      return ToV8(impl.getAsArrayBufferView(), creationContext, isolate);
    case StringOrArrayBufferOrArrayBufferView::SpecificTypeString:
      return V8String(isolate, impl.getAsString());
    default:
      NOTREACHED();
  }
  return v8::Local<v8::Value>();
}

StringOrArrayBufferOrArrayBufferView NativeValueTraits<StringOrArrayBufferOrArrayBufferView>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  StringOrArrayBufferOrArrayBufferView impl;
  V8StringOrArrayBufferOrArrayBufferView::toImpl(isolate, value, impl, UnionTypeConversionMode::kNotNullable, exceptionState);
  return impl;
}

}  // namespace blink
