// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// This file has been generated from the Jinja2 template in
// third_party/WebKit/Source/bindings/templates/interface.cpp.tmpl

// clang-format off
#include "V8History.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/IDLTypes.h"
#include "bindings/core/v8/NativeValueTraitsImpl.h"
#include "bindings/core/v8/V8DOMConfiguration.h"
#include "bindings/core/v8/serialization/SerializedScriptValue.h"
#include "bindings/core/v8/serialization/SerializedScriptValueFactory.h"
#include "core/dom/ExecutionContext.h"
#include "core/frame/UseCounter.h"
#include "core/inspector/ConsoleMessage.h"
#include "platform/bindings/ScriptState.h"
#include "platform/bindings/V8ObjectConstructor.h"
#include "platform/bindings/V8PrivateProperty.h"
#include "platform/wtf/GetPtr.h"
#include "platform/wtf/RefPtr.h"

namespace blink {

// Suppress warning: global constructors, because struct WrapperTypeInfo is trivial
// and does not depend on another global objects.
#if defined(COMPONENT_BUILD) && defined(WIN32) && defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wglobal-constructors"
#endif
const WrapperTypeInfo V8History::wrapperTypeInfo = {
    gin::kEmbedderBlink,
    V8History::domTemplate,
    V8History::Trace,
    V8History::TraceWrappers,
    nullptr,
    "History",
    nullptr,
    WrapperTypeInfo::kWrapperTypeObjectPrototype,
    WrapperTypeInfo::kObjectClassId,
    WrapperTypeInfo::kNotInheritFromActiveScriptWrappable,
    WrapperTypeInfo::kIndependent,
};
#if defined(COMPONENT_BUILD) && defined(WIN32) && defined(__clang__)
#pragma clang diagnostic pop
#endif

// This static member must be declared by DEFINE_WRAPPERTYPEINFO in History.h.
// For details, see the comment of DEFINE_WRAPPERTYPEINFO in
// platform/bindings/ScriptWrappable.h.
const WrapperTypeInfo& History::wrapper_type_info_ = V8History::wrapperTypeInfo;

// not [ActiveScriptWrappable]
static_assert(
    !std::is_base_of<ActiveScriptWrappableBase, History>::value,
    "History inherits from ActiveScriptWrappable<>, but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");
static_assert(
    std::is_same<decltype(&History::HasPendingActivity),
                 decltype(&ScriptWrappable::HasPendingActivity)>::value,
    "History is overriding hasPendingActivity(), but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");

namespace HistoryV8Internal {

static void lengthAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  History* impl = V8History::toImpl(holder);

  V8SetReturnValueUnsigned(info, impl->length());
}

static void scrollRestorationAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  History* impl = V8History::toImpl(holder);

  V8SetReturnValueString(info, impl->scrollRestoration(), info.GetIsolate());
}

static void scrollRestorationAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  History* impl = V8History::toImpl(holder);

  ExceptionState exceptionState(isolate, ExceptionState::kSetterContext, "History", "scrollRestoration");

  // Prepare the value to be set.
  V8StringResource<> cppValue = v8Value;
  if (!cppValue.Prepare())
    return;

  // Type check per: http://heycam.github.io/webidl/#dfn-attribute-setter
  // Returns undefined without setting the value if the value is invalid.
  DummyExceptionStateForTesting dummyExceptionState;
  const char* validValues[] = {
      "auto",
      "manual",
  };
  if (!IsValidEnum(cppValue, validValues, WTF_ARRAY_LENGTH(validValues), "ScrollRestoration", dummyExceptionState)) {
    CurrentExecutionContext(isolate)->AddConsoleMessage(ConsoleMessage::Create(kJSMessageSource, kWarningMessageLevel, dummyExceptionState.Message()));
    return;
  }

  impl->setScrollRestoration(cppValue);
}

static void stateAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  History* impl = V8History::toImpl(holder);

  // [CachedAttribute]
  V8PrivateProperty::Symbol propertySymbol =
      V8PrivateProperty::GetSymbol(info.GetIsolate(),
          "History#State");
  if (!static_cast<const History*>(impl)->stateChanged()) {
    v8::Local<v8::Value> v8Value = propertySymbol.GetOrUndefined(holder);
    if (!v8Value->IsUndefined()) {
      V8SetReturnValue(info, v8Value);
      return;
    }
  }

  RefPtr<SerializedScriptValue> cppValue(WTF::GetPtr(impl->state()));

  // [CachedAttribute]
  v8::Local<v8::Value> v8Value(V8Deserialize(info.GetIsolate(), cppValue));
  propertySymbol.Set(holder, v8Value);

  V8SetReturnValue(info, v8Value);
}

static void goMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::kExecutionContext, "History", "go");

  History* impl = V8History::toImpl(info.Holder());

  ScriptState* scriptState = ScriptState::ForReceiverObject(info);

  int32_t delta;
  if (!info[0]->IsUndefined()) {
    delta = NativeValueTraits<IDLLong>::NativeValue(info.GetIsolate(), info[0], exceptionState, kNormalConversion);
    if (exceptionState.HadException())
      return;
  } else {
    delta = 0;
  }

  impl->go(scriptState, delta);
}

static void backMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  History* impl = V8History::toImpl(info.Holder());

  ScriptState* scriptState = ScriptState::ForReceiverObject(info);

  impl->back(scriptState);
}

static void forwardMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  History* impl = V8History::toImpl(info.Holder());

  ScriptState* scriptState = ScriptState::ForReceiverObject(info);

  impl->forward(scriptState);
}

static void pushStateMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::kExecutionContext, "History", "pushState");

  History* impl = V8History::toImpl(info.Holder());

  if (UNLIKELY(info.Length() < 2)) {
    exceptionState.ThrowTypeError(ExceptionMessages::NotEnoughArguments(2, info.Length()));
    return;
  }

  RefPtr<SerializedScriptValue> data;
  V8StringResource<> title;
  V8StringResource<kTreatNullAndUndefinedAsNullString> url;
  data = NativeValueTraits<SerializedScriptValue>::NativeValue(info.GetIsolate(), info[0], SerializedScriptValue::SerializeOptions(SerializedScriptValue::kForStorage), exceptionState);
  if (exceptionState.HadException())
    return;

  title = info[1];
  if (!title.Prepare())
    return;

  if (!info[2]->IsUndefined()) {
    url = info[2];
    if (!url.Prepare())
      return;
  } else {
    url = nullptr;
  }

  impl->pushState(data, title, url, exceptionState);
  if (exceptionState.HadException()) {
    return;
  }
}

static void replaceStateMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::kExecutionContext, "History", "replaceState");

  History* impl = V8History::toImpl(info.Holder());

  if (UNLIKELY(info.Length() < 2)) {
    exceptionState.ThrowTypeError(ExceptionMessages::NotEnoughArguments(2, info.Length()));
    return;
  }

  RefPtr<SerializedScriptValue> data;
  V8StringResource<> title;
  V8StringResource<kTreatNullAndUndefinedAsNullString> url;
  data = NativeValueTraits<SerializedScriptValue>::NativeValue(info.GetIsolate(), info[0], SerializedScriptValue::SerializeOptions(SerializedScriptValue::kForStorage), exceptionState);
  if (exceptionState.HadException())
    return;

  title = info[1];
  if (!title.Prepare())
    return;

  if (!info[2]->IsUndefined()) {
    url = info[2];
    if (!url.Prepare())
      return;
  } else {
    url = nullptr;
  }

  impl->replaceState(data, title, url, exceptionState);
  if (exceptionState.HadException()) {
    return;
  }
}

} // namespace HistoryV8Internal

void V8History::lengthAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  HistoryV8Internal::lengthAttributeGetter(info);
}

void V8History::scrollRestorationAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  UseCounter::Count(CurrentExecutionContext(info.GetIsolate()), WebFeature::kV8History_ScrollRestoration_AttributeGetter);

  HistoryV8Internal::scrollRestorationAttributeGetter(info);
}

void V8History::scrollRestorationAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  UseCounter::Count(CurrentExecutionContext(info.GetIsolate()), WebFeature::kV8History_ScrollRestoration_AttributeSetter);

  HistoryV8Internal::scrollRestorationAttributeSetter(v8Value, info);
}

void V8History::stateAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  HistoryV8Internal::stateAttributeGetter(info);
}

void V8History::goMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  HistoryV8Internal::goMethod(info);
}

void V8History::backMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  HistoryV8Internal::backMethod(info);
}

void V8History::forwardMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  HistoryV8Internal::forwardMethod(info);
}

void V8History::pushStateMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  HistoryV8Internal::pushStateMethod(info);
}

void V8History::replaceStateMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  HistoryV8Internal::replaceStateMethod(info);
}

static const V8DOMConfiguration::AccessorConfiguration V8HistoryAccessors[] = {
    { "length", V8History::lengthAttributeGetterCallback, nullptr, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "scrollRestoration", V8History::scrollRestorationAttributeGetterCallback, V8History::scrollRestorationAttributeSetterCallback, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "state", V8History::stateAttributeGetterCallback, nullptr, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },
};

static const V8DOMConfiguration::MethodConfiguration V8HistoryMethods[] = {
    {"go", V8History::goMethodCallback, 0, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
    {"back", V8History::backMethodCallback, 0, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
    {"forward", V8History::forwardMethodCallback, 0, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
    {"pushState", V8History::pushStateMethodCallback, 2, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
    {"replaceState", V8History::replaceStateMethodCallback, 2, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
};

static void installV8HistoryTemplate(
    v8::Isolate* isolate,
    const DOMWrapperWorld& world,
    v8::Local<v8::FunctionTemplate> interfaceTemplate) {
  // Initialize the interface object's template.
  V8DOMConfiguration::InitializeDOMInterfaceTemplate(isolate, interfaceTemplate, V8History::wrapperTypeInfo.interface_name, v8::Local<v8::FunctionTemplate>(), V8History::internalFieldCount);

  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interfaceTemplate);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instanceTemplate = interfaceTemplate->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instanceTemplate);
  v8::Local<v8::ObjectTemplate> prototypeTemplate = interfaceTemplate->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototypeTemplate);

  // Register IDL constants, attributes and operations.
  V8DOMConfiguration::InstallAccessors(
      isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate,
      signature, V8HistoryAccessors, WTF_ARRAY_LENGTH(V8HistoryAccessors));
  V8DOMConfiguration::InstallMethods(
      isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate,
      signature, V8HistoryMethods, WTF_ARRAY_LENGTH(V8HistoryMethods));

  // Custom signature

  V8History::InstallRuntimeEnabledFeaturesOnTemplate(
      isolate, world, interfaceTemplate);
}

void V8History::InstallRuntimeEnabledFeaturesOnTemplate(
    v8::Isolate* isolate,
    const DOMWrapperWorld& world,
    v8::Local<v8::FunctionTemplate> interface_template) {
  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interface_template);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instance_template = interface_template->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instance_template);
  v8::Local<v8::ObjectTemplate> prototype_template = interface_template->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototype_template);

  // Register IDL constants, attributes and operations.

  // Custom signature
}

v8::Local<v8::FunctionTemplate> V8History::domTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world) {
  return V8DOMConfiguration::DomClassTemplate(isolate, world, const_cast<WrapperTypeInfo*>(&wrapperTypeInfo), installV8HistoryTemplate);
}

bool V8History::hasInstance(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->HasInstance(&wrapperTypeInfo, v8Value);
}

v8::Local<v8::Object> V8History::findInstanceInPrototypeChain(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindInstanceInPrototypeChain(&wrapperTypeInfo, v8Value);
}

History* V8History::toImplWithTypeCheck(v8::Isolate* isolate, v8::Local<v8::Value> value) {
  return hasInstance(value, isolate) ? toImpl(v8::Local<v8::Object>::Cast(value)) : nullptr;
}

History* NativeValueTraits<History>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  History* nativeValue = V8History::toImplWithTypeCheck(isolate, value);
  if (!nativeValue) {
    exceptionState.ThrowTypeError(ExceptionMessages::FailedToConvertJSValue(
        "History"));
  }
  return nativeValue;
}

}  // namespace blink
