// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// This file has been generated from the Jinja2 template in
// third_party/WebKit/Source/bindings/templates/interface.cpp.tmpl

// clang-format off
#include "V8Navigator.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/IDLTypes.h"
#include "bindings/core/v8/NativeValueTraitsImpl.h"
#include "bindings/core/v8/V8Clipboard.h"
#include "bindings/core/v8/V8DOMConfiguration.h"
#include "core/dom/ExecutionContext.h"
#include "core/events/NavigatorEvents.h"
#include "core/frame/NavigatorClipboard.h"
#include "core/frame/UseCounter.h"
#include "platform/RuntimeEnabledFeatures.h"
#include "platform/bindings/ScriptState.h"
#include "platform/bindings/V8ObjectConstructor.h"
#include "platform/bindings/V8PrivateProperty.h"
#include "platform/wtf/GetPtr.h"
#include "platform/wtf/RefPtr.h"

namespace blink {

// Suppress warning: global constructors, because struct WrapperTypeInfo is trivial
// and does not depend on another global objects.
#if defined(COMPONENT_BUILD) && defined(WIN32) && defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wglobal-constructors"
#endif
WrapperTypeInfo V8Navigator::wrapperTypeInfo = {
    gin::kEmbedderBlink,
    V8Navigator::domTemplate,
    V8Navigator::Trace,
    V8Navigator::TraceWrappers,
    V8Navigator::preparePrototypeAndInterfaceObject,
    "Navigator",
    nullptr,
    WrapperTypeInfo::kWrapperTypeObjectPrototype,
    WrapperTypeInfo::kObjectClassId,
    WrapperTypeInfo::kNotInheritFromActiveScriptWrappable,
    WrapperTypeInfo::kIndependent,
};
#if defined(COMPONENT_BUILD) && defined(WIN32) && defined(__clang__)
#pragma clang diagnostic pop
#endif

// This static member must be declared by DEFINE_WRAPPERTYPEINFO in Navigator.h.
// For details, see the comment of DEFINE_WRAPPERTYPEINFO in
// platform/bindings/ScriptWrappable.h.
const WrapperTypeInfo& Navigator::wrapper_type_info_ = V8Navigator::wrapperTypeInfo;

// not [ActiveScriptWrappable]
static_assert(
    !std::is_base_of<ActiveScriptWrappableBase, Navigator>::value,
    "Navigator inherits from ActiveScriptWrappable<>, but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");
static_assert(
    std::is_same<decltype(&Navigator::HasPendingActivity),
                 decltype(&ScriptWrappable::HasPendingActivity)>::value,
    "Navigator is overriding hasPendingActivity(), but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");

namespace NavigatorV8Internal {

static void vendorSubAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  Navigator* impl = V8Navigator::toImpl(holder);

  V8SetReturnValueString(info, impl->vendorSub(), info.GetIsolate());
}

static void productSubAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  Navigator* impl = V8Navigator::toImpl(holder);

  V8SetReturnValueString(info, impl->productSub(), info.GetIsolate());
}

static void vendorAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  Navigator* impl = V8Navigator::toImpl(holder);

  V8SetReturnValueString(info, impl->vendor(), info.GetIsolate());
}

static void maxTouchPointsAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  Navigator* impl = V8Navigator::toImpl(holder);

  V8SetReturnValueInt(info, NavigatorEvents::maxTouchPoints(*impl));
}

static void clipboardAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  Navigator* impl = V8Navigator::toImpl(holder);

  ScriptState* scriptState = ScriptState::ForReceiverObject(info);

  Clipboard* cppValue(NavigatorClipboard::clipboard(scriptState, *impl));

  // Keep the wrapper object for the return value alive as long as |this|
  // object is alive in order to save creation time of the wrapper object.
  if (cppValue && DOMDataStore::SetReturnValue(info.GetReturnValue(), cppValue))
    return;
  v8::Local<v8::Value> v8Value(ToV8(cppValue, holder, info.GetIsolate()));
  V8PrivateProperty::GetSymbol(
      info.GetIsolate(), "KeepAlive#Navigator#clipboard")
      .Set(holder, v8Value);

  V8SetReturnValue(info, v8Value);
}

static void hardwareConcurrencyAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  Navigator* impl = V8Navigator::toImpl(holder);

  V8SetReturnValue(info, static_cast<double>(impl->hardwareConcurrency()));
}

static void cookieEnabledAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  Navigator* impl = V8Navigator::toImpl(holder);

  V8SetReturnValueBool(info, impl->cookieEnabled());
}

static void appCodeNameAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  Navigator* impl = V8Navigator::toImpl(holder);

  V8SetReturnValueString(info, impl->appCodeName(), info.GetIsolate());
}

static void appNameAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  Navigator* impl = V8Navigator::toImpl(holder);

  V8SetReturnValueString(info, impl->appName(), info.GetIsolate());
}

static void appVersionAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  Navigator* impl = V8Navigator::toImpl(holder);

  V8SetReturnValueString(info, impl->appVersion(), info.GetIsolate());
}

static void platformAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  Navigator* impl = V8Navigator::toImpl(holder);

  V8SetReturnValueString(info, impl->platform(), info.GetIsolate());
}

static void productAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  Navigator* impl = V8Navigator::toImpl(holder);

  V8SetReturnValueString(info, impl->product(), info.GetIsolate());
}

static void userAgentAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  Navigator* impl = V8Navigator::toImpl(holder);

  V8SetReturnValueString(info, impl->userAgent(), info.GetIsolate());
}

static void languageAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  Navigator* impl = V8Navigator::toImpl(holder);

  V8SetReturnValueString(info, impl->language(), info.GetIsolate());
}

static void languagesAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  Navigator* impl = V8Navigator::toImpl(holder);

  // [CachedAttribute]
  V8PrivateProperty::Symbol propertySymbol =
      V8PrivateProperty::GetSymbol(info.GetIsolate(),
          "Navigator#Languages");
  if (!static_cast<const Navigator*>(impl)->hasLanguagesChanged()) {
    v8::Local<v8::Value> v8Value = propertySymbol.GetOrUndefined(holder);
    if (!v8Value->IsUndefined()) {
      V8SetReturnValue(info, v8Value);
      return;
    }
  }

  Vector<String> cppValue(impl->languages());

  // [CachedAttribute]
  v8::Local<v8::Value> v8Value(FreezeV8Object(ToV8(cppValue, holder, info.GetIsolate()), info.GetIsolate()));
  propertySymbol.Set(holder, v8Value);

  V8SetReturnValue(info, v8Value);
}

static void onLineAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  Navigator* impl = V8Navigator::toImpl(holder);

  V8SetReturnValueBool(info, impl->onLine());
}

} // namespace NavigatorV8Internal

void V8Navigator::vendorSubAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  UseCounter::Count(CurrentExecutionContext(info.GetIsolate()), WebFeature::kNavigatorVendorSub);

  NavigatorV8Internal::vendorSubAttributeGetter(info);
}

void V8Navigator::productSubAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  UseCounter::Count(CurrentExecutionContext(info.GetIsolate()), WebFeature::kNavigatorProductSub);

  NavigatorV8Internal::productSubAttributeGetter(info);
}

void V8Navigator::vendorAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  UseCounter::Count(CurrentExecutionContext(info.GetIsolate()), WebFeature::kNavigatorVendor);

  NavigatorV8Internal::vendorAttributeGetter(info);
}

void V8Navigator::maxTouchPointsAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  NavigatorV8Internal::maxTouchPointsAttributeGetter(info);
}

void V8Navigator::clipboardAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  NavigatorV8Internal::clipboardAttributeGetter(info);
}

void V8Navigator::hardwareConcurrencyAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  NavigatorV8Internal::hardwareConcurrencyAttributeGetter(info);
}

void V8Navigator::cookieEnabledAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  NavigatorV8Internal::cookieEnabledAttributeGetter(info);
}

void V8Navigator::appCodeNameAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  NavigatorV8Internal::appCodeNameAttributeGetter(info);
}

void V8Navigator::appNameAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  NavigatorV8Internal::appNameAttributeGetter(info);
}

void V8Navigator::appVersionAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  NavigatorV8Internal::appVersionAttributeGetter(info);
}

void V8Navigator::platformAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  NavigatorV8Internal::platformAttributeGetter(info);
}

void V8Navigator::productAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  NavigatorV8Internal::productAttributeGetter(info);
}

void V8Navigator::userAgentAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  NavigatorV8Internal::userAgentAttributeGetter(info);
}

void V8Navigator::languageAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  NavigatorV8Internal::languageAttributeGetter(info);
}

void V8Navigator::languagesAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  NavigatorV8Internal::languagesAttributeGetter(info);
}

void V8Navigator::onLineAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  NavigatorV8Internal::onLineAttributeGetter(info);
}

static const V8DOMConfiguration::AccessorConfiguration V8NavigatorAccessors[] = {
    { "vendorSub", V8Navigator::vendorSubAttributeGetterCallback, nullptr, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "productSub", V8Navigator::productSubAttributeGetterCallback, nullptr, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "vendor", V8Navigator::vendorAttributeGetterCallback, nullptr, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "maxTouchPoints", V8Navigator::maxTouchPointsAttributeGetterCallback, nullptr, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "hardwareConcurrency", V8Navigator::hardwareConcurrencyAttributeGetterCallback, nullptr, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "cookieEnabled", V8Navigator::cookieEnabledAttributeGetterCallback, nullptr, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "appCodeName", V8Navigator::appCodeNameAttributeGetterCallback, nullptr, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "appName", V8Navigator::appNameAttributeGetterCallback, nullptr, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "appVersion", V8Navigator::appVersionAttributeGetterCallback, nullptr, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "platform", V8Navigator::platformAttributeGetterCallback, nullptr, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "product", V8Navigator::productAttributeGetterCallback, nullptr, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "userAgent", V8Navigator::userAgentAttributeGetterCallback, nullptr, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "language", V8Navigator::languageAttributeGetterCallback, nullptr, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "languages", V8Navigator::languagesAttributeGetterCallback, nullptr, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "onLine", V8Navigator::onLineAttributeGetterCallback, nullptr, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },
};

void V8Navigator::installV8NavigatorTemplate(
    v8::Isolate* isolate,
    const DOMWrapperWorld& world,
    v8::Local<v8::FunctionTemplate> interfaceTemplate) {
  // Initialize the interface object's template.
  V8DOMConfiguration::InitializeDOMInterfaceTemplate(isolate, interfaceTemplate, V8Navigator::wrapperTypeInfo.interface_name, v8::Local<v8::FunctionTemplate>(), V8Navigator::internalFieldCount);

  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interfaceTemplate);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instanceTemplate = interfaceTemplate->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instanceTemplate);
  v8::Local<v8::ObjectTemplate> prototypeTemplate = interfaceTemplate->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototypeTemplate);

  // Register IDL constants, attributes and operations.
  V8DOMConfiguration::InstallAccessors(
      isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate,
      signature, V8NavigatorAccessors, WTF_ARRAY_LENGTH(V8NavigatorAccessors));

  // Custom signature
}

void V8Navigator::InstallRuntimeEnabledFeaturesOnTemplate(
    v8::Isolate* isolate,
    const DOMWrapperWorld& world,
    v8::Local<v8::FunctionTemplate> interface_template) {
  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interface_template);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instance_template = interface_template->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instance_template);
  v8::Local<v8::ObjectTemplate> prototype_template = interface_template->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototype_template);

  // Register IDL constants, attributes and operations.

  // Custom signature
}

v8::Local<v8::FunctionTemplate> V8Navigator::domTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world) {
  return V8DOMConfiguration::DomClassTemplate(isolate, world, const_cast<WrapperTypeInfo*>(&wrapperTypeInfo), V8Navigator::installV8NavigatorTemplateFunction);
}

bool V8Navigator::hasInstance(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->HasInstance(&wrapperTypeInfo, v8Value);
}

v8::Local<v8::Object> V8Navigator::findInstanceInPrototypeChain(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindInstanceInPrototypeChain(&wrapperTypeInfo, v8Value);
}

Navigator* V8Navigator::toImplWithTypeCheck(v8::Isolate* isolate, v8::Local<v8::Value> value) {
  return hasInstance(value, isolate) ? toImpl(v8::Local<v8::Object>::Cast(value)) : nullptr;
}

Navigator* NativeValueTraits<Navigator>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  Navigator* nativeValue = V8Navigator::toImplWithTypeCheck(isolate, value);
  if (!nativeValue) {
    exceptionState.ThrowTypeError(ExceptionMessages::FailedToConvertJSValue(
        "Navigator"));
  }
  return nativeValue;
}

void V8Navigator::preparePrototypeAndInterfaceObject(v8::Local<v8::Context> context, const DOMWrapperWorld& world, v8::Local<v8::Object> prototypeObject, v8::Local<v8::Function> interfaceObject, v8::Local<v8::FunctionTemplate> interfaceTemplate) {
  v8::Isolate* isolate = context->GetIsolate();
  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interfaceTemplate);
  ExecutionContext* executionContext = ToExecutionContext(context);
  DCHECK(executionContext);

  if (executionContext && (executionContext->IsSecureContext())) {
    if (RuntimeEnabledFeatures::AsyncClipboardEnabled()) {
      static const V8DOMConfiguration::AccessorConfiguration accessorConfiguration[] = {
          { "clipboard", V8Navigator::clipboardAttributeGetterCallback, nullptr, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds }
      };
      for (const auto& accessorConfig : accessorConfiguration)
        V8DOMConfiguration::InstallAccessor(isolate, world, v8::Local<v8::Object>(), prototypeObject, interfaceObject, signature, accessorConfig);
    }
  }
}

InstallRuntimeEnabledFeaturesOnTemplateFunction
V8Navigator::install_runtime_enabled_features_on_template_function_ =
    &V8Navigator::InstallRuntimeEnabledFeaturesOnTemplate;

InstallTemplateFunction V8Navigator::installV8NavigatorTemplateFunction =
    &V8Navigator::installV8NavigatorTemplate;

void V8Navigator::UpdateWrapperTypeInfo(
    InstallTemplateFunction install_template_function,
    InstallRuntimeEnabledFeaturesFunction install_runtime_enabled_features_function,
    InstallRuntimeEnabledFeaturesOnTemplateFunction install_runtime_enabled_features_on_template_function,
    PreparePrototypeAndInterfaceObjectFunction prepare_prototype_and_interface_object_function) {
  V8Navigator::installV8NavigatorTemplateFunction =
      install_template_function;

  CHECK(install_runtime_enabled_features_on_template_function);
  V8Navigator::install_runtime_enabled_features_on_template_function_ =
      install_runtime_enabled_features_on_template_function;

  if (prepare_prototype_and_interface_object_function) {
    V8Navigator::wrapperTypeInfo.prepare_prototype_and_interface_object_function =
        prepare_prototype_and_interface_object_function;
  }
}

}  // namespace blink
