// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// This file has been generated from the Jinja2 template in
// third_party/WebKit/Source/bindings/templates/legacy_callback_interface.cpp.tmpl

// clang-format off
#include "V8NodeFilter.h"

#include "bindings/core/v8/ScriptController.h"
#include "bindings/core/v8/V8BindingForCore.h"
#include "bindings/core/v8/V8DOMConfiguration.h"
#include "core/dom/ExecutionContext.h"
#include "platform/wtf/Assertions.h"

namespace blink {

// Suppress warning: global constructors, because struct WrapperTypeInfo is
// trivial and does not depend on another global objects.
#if defined(COMPONENT_BUILD) && defined(WIN32) && defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wglobal-constructors"
#endif
const WrapperTypeInfo V8NodeFilter::wrapperTypeInfo = {
    gin::kEmbedderBlink,
    V8NodeFilter::DomTemplate,
    nullptr,
    nullptr,
    nullptr,
    "NodeFilter",
    nullptr,
    WrapperTypeInfo::kWrapperTypeNoPrototype,
    WrapperTypeInfo::kObjectClassId,
    WrapperTypeInfo::kNotInheritFromActiveScriptWrappable,
    WrapperTypeInfo::kDependent,
};
#if defined(COMPONENT_BUILD) && defined(WIN32) && defined(__clang__)
#pragma clang diagnostic pop
#endif

void V8NodeFilter::TypeErrorConstructorCallback(
    const v8::FunctionCallbackInfo<v8::Value>& info) {
  V8ThrowException::ThrowTypeError(info.GetIsolate(),
      "Illegal constructor: NodeFilter");
}

static void InstallV8NodeFilterTemplate(
    v8::Isolate* isolate,
    const DOMWrapperWorld& world,
    v8::Local<v8::FunctionTemplate> interfaceTemplate) {
  // Legacy callback interface must not have a prototype object.
  interfaceTemplate->RemovePrototype();

  // Initialize the interface object's template.
  V8DOMConfiguration::InitializeDOMInterfaceTemplate(isolate, interfaceTemplate,
      V8NodeFilter::wrapperTypeInfo.interface_name, v8::Local<v8::FunctionTemplate>(),
      kV8DefaultWrapperInternalFieldCount);
  interfaceTemplate->SetCallHandler(V8NodeFilter::TypeErrorConstructorCallback);
  interfaceTemplate->SetLength(0);

  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interfaceTemplate);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instanceTemplate = interfaceTemplate->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instanceTemplate);
  v8::Local<v8::ObjectTemplate> prototypeTemplate = interfaceTemplate->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototypeTemplate);

  // Register DOM constants.
  const V8DOMConfiguration::ConstantConfiguration V8NodeFilterConstants[] = {
      {"FILTER_ACCEPT", 1, 0, V8DOMConfiguration::kConstantTypeUnsignedShort},
      {"FILTER_REJECT", 2, 0, V8DOMConfiguration::kConstantTypeUnsignedShort},
      {"FILTER_SKIP", 3, 0, V8DOMConfiguration::kConstantTypeUnsignedShort},
      {"SHOW_ALL", 0xFFFFFFFF, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"SHOW_ELEMENT", 0x1, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"SHOW_ATTRIBUTE", 0x2, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"SHOW_TEXT", 0x4, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"SHOW_CDATA_SECTION", 0x8, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"SHOW_ENTITY_REFERENCE", 0x10, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"SHOW_ENTITY", 0x20, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"SHOW_PROCESSING_INSTRUCTION", 0x40, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"SHOW_COMMENT", 0x80, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"SHOW_DOCUMENT", 0x100, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"SHOW_DOCUMENT_TYPE", 0x200, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"SHOW_DOCUMENT_FRAGMENT", 0x400, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
      {"SHOW_NOTATION", 0x800, 0, V8DOMConfiguration::kConstantTypeUnsignedLong},
  };
  V8DOMConfiguration::InstallConstants(
      isolate, interfaceTemplate, prototypeTemplate,
      V8NodeFilterConstants, WTF_ARRAY_LENGTH(V8NodeFilterConstants));
  static_assert(1 == NodeFilter::kFilterAccept, "the value of NodeFilter_kFilterAccept does not match with implementation");
  static_assert(2 == NodeFilter::kFilterReject, "the value of NodeFilter_kFilterReject does not match with implementation");
  static_assert(3 == NodeFilter::kFilterSkip, "the value of NodeFilter_kFilterSkip does not match with implementation");
  static_assert(0xFFFFFFFF == NodeFilter::kShowAll, "the value of NodeFilter_kShowAll does not match with implementation");
  static_assert(0x1 == NodeFilter::kShowElement, "the value of NodeFilter_kShowElement does not match with implementation");
  static_assert(0x2 == NodeFilter::kShowAttribute, "the value of NodeFilter_kShowAttribute does not match with implementation");
  static_assert(0x4 == NodeFilter::kShowText, "the value of NodeFilter_kShowText does not match with implementation");
  static_assert(0x8 == NodeFilter::kShowCdataSection, "the value of NodeFilter_kShowCdataSection does not match with implementation");
  static_assert(0x10 == NodeFilter::kShowEntityReference, "the value of NodeFilter_kShowEntityReference does not match with implementation");
  static_assert(0x20 == NodeFilter::kShowEntity, "the value of NodeFilter_kShowEntity does not match with implementation");
  static_assert(0x40 == NodeFilter::kShowProcessingInstruction, "the value of NodeFilter_kShowProcessingInstruction does not match with implementation");
  static_assert(0x80 == NodeFilter::kShowComment, "the value of NodeFilter_kShowComment does not match with implementation");
  static_assert(0x100 == NodeFilter::kShowDocument, "the value of NodeFilter_kShowDocument does not match with implementation");
  static_assert(0x200 == NodeFilter::kShowDocumentType, "the value of NodeFilter_kShowDocumentType does not match with implementation");
  static_assert(0x400 == NodeFilter::kShowDocumentFragment, "the value of NodeFilter_kShowDocumentFragment does not match with implementation");
  static_assert(0x800 == NodeFilter::kShowNotation, "the value of NodeFilter_kShowNotation does not match with implementation");
}

v8::Local<v8::FunctionTemplate> V8NodeFilter::DomTemplate(v8::Isolate* isolate,
    const DOMWrapperWorld& world) {
  return V8DOMConfiguration::DomClassTemplate(
      isolate,
      world,
      const_cast<WrapperTypeInfo*>(&wrapperTypeInfo),
      InstallV8NodeFilterTemplate);
}

}  // namespace blink
