// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// This file has been generated from the Jinja2 template in
// third_party/WebKit/Source/bindings/templates/interface.cpp.tmpl

// clang-format off
#include "V8Performance.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/IDLTypes.h"
#include "bindings/core/v8/NativeValueTraitsImpl.h"
#include "bindings/core/v8/ScriptValue.h"
#include "bindings/core/v8/V8AbstractEventListener.h"
#include "bindings/core/v8/V8DOMConfiguration.h"
#include "bindings/core/v8/V8EventListenerHelper.h"
#include "bindings/core/v8/V8MemoryInfo.h"
#include "bindings/core/v8/V8PerformanceEntry.h"
#include "bindings/core/v8/V8PerformanceNavigation.h"
#include "bindings/core/v8/V8PerformanceTiming.h"
#include "core/dom/ExecutionContext.h"
#include "core/frame/UseCounter.h"
#include "platform/bindings/ScriptState.h"
#include "platform/bindings/V8ObjectConstructor.h"
#include "platform/bindings/V8PrivateProperty.h"
#include "platform/wtf/GetPtr.h"
#include "platform/wtf/RefPtr.h"

namespace blink {

// Suppress warning: global constructors, because struct WrapperTypeInfo is trivial
// and does not depend on another global objects.
#if defined(COMPONENT_BUILD) && defined(WIN32) && defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wglobal-constructors"
#endif
const WrapperTypeInfo V8Performance::wrapperTypeInfo = {
    gin::kEmbedderBlink,
    V8Performance::domTemplate,
    V8Performance::Trace,
    V8Performance::TraceWrappers,
    nullptr,
    "Performance",
    &V8EventTarget::wrapperTypeInfo,
    WrapperTypeInfo::kWrapperTypeObjectPrototype,
    WrapperTypeInfo::kObjectClassId,
    WrapperTypeInfo::kNotInheritFromActiveScriptWrappable,
    WrapperTypeInfo::kIndependent,
};
#if defined(COMPONENT_BUILD) && defined(WIN32) && defined(__clang__)
#pragma clang diagnostic pop
#endif

// This static member must be declared by DEFINE_WRAPPERTYPEINFO in Performance.h.
// For details, see the comment of DEFINE_WRAPPERTYPEINFO in
// platform/bindings/ScriptWrappable.h.
const WrapperTypeInfo& Performance::wrapper_type_info_ = V8Performance::wrapperTypeInfo;

// not [ActiveScriptWrappable]
static_assert(
    !std::is_base_of<ActiveScriptWrappableBase, Performance>::value,
    "Performance inherits from ActiveScriptWrappable<>, but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");
static_assert(
    std::is_same<decltype(&Performance::HasPendingActivity),
                 decltype(&ScriptWrappable::HasPendingActivity)>::value,
    "Performance is overriding hasPendingActivity(), but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");

namespace PerformanceV8Internal {

static void onresourcetimingbufferfullAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  Performance* impl = V8Performance::toImpl(holder);

  EventListener* cppValue(WTF::GetPtr(impl->onresourcetimingbufferfull()));

  V8SetReturnValue(info, cppValue ? V8AbstractEventListener::Cast(cppValue)->GetListenerOrNull(info.GetIsolate(), impl->GetExecutionContext()) : v8::Null(info.GetIsolate()).As<v8::Value>());
}

static void onresourcetimingbufferfullAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  Performance* impl = V8Performance::toImpl(holder);

  // Prepare the value to be set.
  MoveEventListenerToNewWrapper(isolate, holder, impl->onresourcetimingbufferfull(), v8Value, V8Performance::eventListenerCacheIndex);

  impl->setOnresourcetimingbufferfull(V8EventListenerHelper::GetEventListener(ScriptState::ForReceiverObject(info), v8Value, true, kListenerFindOrCreate));
}

static void timingAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  Performance* impl = V8Performance::toImpl(holder);

  PerformanceTiming* cppValue(WTF::GetPtr(impl->timing()));

  // Keep the wrapper object for the return value alive as long as |this|
  // object is alive in order to save creation time of the wrapper object.
  if (cppValue && DOMDataStore::SetReturnValue(info.GetReturnValue(), cppValue))
    return;
  v8::Local<v8::Value> v8Value(ToV8(cppValue, holder, info.GetIsolate()));
  V8PrivateProperty::GetSymbol(
      info.GetIsolate(), "KeepAlive#Performance#timing")
      .Set(holder, v8Value);

  V8SetReturnValue(info, v8Value);
}

static void navigationAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  Performance* impl = V8Performance::toImpl(holder);

  PerformanceNavigation* cppValue(WTF::GetPtr(impl->navigation()));

  // Keep the wrapper object for the return value alive as long as |this|
  // object is alive in order to save creation time of the wrapper object.
  if (cppValue && DOMDataStore::SetReturnValue(info.GetReturnValue(), cppValue))
    return;
  v8::Local<v8::Value> v8Value(ToV8(cppValue, holder, info.GetIsolate()));
  V8PrivateProperty::GetSymbol(
      info.GetIsolate(), "KeepAlive#Performance#navigation")
      .Set(holder, v8Value);

  V8SetReturnValue(info, v8Value);
}

static void memoryAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  Performance* impl = V8Performance::toImpl(holder);

  MemoryInfo* cppValue(WTF::GetPtr(impl->memory()));

  // Keep the wrapper object for the return value alive as long as |this|
  // object is alive in order to save creation time of the wrapper object.
  if (cppValue && DOMDataStore::SetReturnValue(info.GetReturnValue(), cppValue))
    return;
  v8::Local<v8::Value> v8Value(ToV8(cppValue, holder, info.GetIsolate()));
  V8PrivateProperty::GetSymbol(
      info.GetIsolate(), "KeepAlive#Performance#memory")
      .Set(holder, v8Value);

  V8SetReturnValue(info, v8Value);
}

static void nowMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  Performance* impl = V8Performance::toImpl(info.Holder());

  V8SetReturnValue(info, impl->now());
}

static void getEntriesMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  Performance* impl = V8Performance::toImpl(info.Holder());

  V8SetReturnValue(info, ToV8(impl->getEntries(), info.Holder(), info.GetIsolate()));
}

static void getEntriesByTypeMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  Performance* impl = V8Performance::toImpl(info.Holder());

  if (UNLIKELY(info.Length() < 1)) {
    V8ThrowException::ThrowTypeError(info.GetIsolate(), ExceptionMessages::FailedToExecute("getEntriesByType", "Performance", ExceptionMessages::NotEnoughArguments(1, info.Length())));
    return;
  }

  V8StringResource<> entryType;
  entryType = info[0];
  if (!entryType.Prepare())
    return;

  V8SetReturnValue(info, ToV8(impl->getEntriesByType(entryType), info.Holder(), info.GetIsolate()));
}

static void getEntriesByNameMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  Performance* impl = V8Performance::toImpl(info.Holder());

  if (UNLIKELY(info.Length() < 1)) {
    V8ThrowException::ThrowTypeError(info.GetIsolate(), ExceptionMessages::FailedToExecute("getEntriesByName", "Performance", ExceptionMessages::NotEnoughArguments(1, info.Length())));
    return;
  }

  V8StringResource<> name;
  V8StringResource<> entryType;
  name = info[0];
  if (!name.Prepare())
    return;

  if (!info[1]->IsUndefined()) {
    entryType = info[1];
    if (!entryType.Prepare())
      return;
  } else {
    entryType = nullptr;
  }

  V8SetReturnValue(info, ToV8(impl->getEntriesByName(name, entryType), info.Holder(), info.GetIsolate()));
}

static void clearResourceTimingsMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  Performance* impl = V8Performance::toImpl(info.Holder());

  impl->clearResourceTimings();
}

static void setResourceTimingBufferSizeMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::kExecutionContext, "Performance", "setResourceTimingBufferSize");

  Performance* impl = V8Performance::toImpl(info.Holder());

  if (UNLIKELY(info.Length() < 1)) {
    exceptionState.ThrowTypeError(ExceptionMessages::NotEnoughArguments(1, info.Length()));
    return;
  }

  uint32_t maxSize;
  maxSize = NativeValueTraits<IDLUnsignedLong>::NativeValue(info.GetIsolate(), info[0], exceptionState, kNormalConversion);
  if (exceptionState.HadException())
    return;

  impl->setResourceTimingBufferSize(maxSize);
}

static void markMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::kExecutionContext, "Performance", "mark");

  Performance* impl = V8Performance::toImpl(info.Holder());

  if (UNLIKELY(info.Length() < 1)) {
    exceptionState.ThrowTypeError(ExceptionMessages::NotEnoughArguments(1, info.Length()));
    return;
  }

  V8StringResource<> markName;
  markName = info[0];
  if (!markName.Prepare())
    return;

  impl->mark(markName, exceptionState);
  if (exceptionState.HadException()) {
    return;
  }
}

static void clearMarksMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  Performance* impl = V8Performance::toImpl(info.Holder());

  V8StringResource<> markName;
  if (!info[0]->IsUndefined()) {
    markName = info[0];
    if (!markName.Prepare())
      return;
  } else {
    markName = nullptr;
  }

  impl->clearMarks(markName);
}

static void measureMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::kExecutionContext, "Performance", "measure");

  Performance* impl = V8Performance::toImpl(info.Holder());

  if (UNLIKELY(info.Length() < 1)) {
    exceptionState.ThrowTypeError(ExceptionMessages::NotEnoughArguments(1, info.Length()));
    return;
  }

  V8StringResource<> measureName;
  V8StringResource<> startMark;
  V8StringResource<> endMark;
  measureName = info[0];
  if (!measureName.Prepare())
    return;

  if (!info[1]->IsUndefined()) {
    startMark = info[1];
    if (!startMark.Prepare())
      return;
  } else {
    startMark = nullptr;
  }
  if (!info[2]->IsUndefined()) {
    endMark = info[2];
    if (!endMark.Prepare())
      return;
  } else {
    endMark = nullptr;
  }

  impl->measure(measureName, startMark, endMark, exceptionState);
  if (exceptionState.HadException()) {
    return;
  }
}

static void clearMeasuresMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  Performance* impl = V8Performance::toImpl(info.Holder());

  V8StringResource<> measureName;
  if (!info[0]->IsUndefined()) {
    measureName = info[0];
    if (!measureName.Prepare())
      return;
  } else {
    measureName = nullptr;
  }

  impl->clearMeasures(measureName);
}

static void toJSONMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  Performance* impl = V8Performance::toImpl(info.Holder());

  ScriptState* scriptState = ScriptState::ForReceiverObject(info);

  ScriptValue result = impl->toJSONForBinding(scriptState);
  V8SetReturnValue(info, result.V8Value());
}

} // namespace PerformanceV8Internal

void V8Performance::onresourcetimingbufferfullAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  PerformanceV8Internal::onresourcetimingbufferfullAttributeGetter(info);
}

void V8Performance::onresourcetimingbufferfullAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  PerformanceV8Internal::onresourcetimingbufferfullAttributeSetter(v8Value, info);
}

void V8Performance::timingAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  UseCounter::Count(CurrentExecutionContext(info.GetIsolate()), WebFeature::kV8Performance_Timing_AttributeGetter);

  PerformanceV8Internal::timingAttributeGetter(info);
}

void V8Performance::navigationAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  UseCounter::Count(CurrentExecutionContext(info.GetIsolate()), WebFeature::kV8Performance_Navigation_AttributeGetter);

  PerformanceV8Internal::navigationAttributeGetter(info);
}

void V8Performance::memoryAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  UseCounter::Count(CurrentExecutionContext(info.GetIsolate()), WebFeature::kV8Performance_Memory_AttributeGetter);

  PerformanceV8Internal::memoryAttributeGetter(info);
}

void V8Performance::nowMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  PerformanceV8Internal::nowMethod(info);
}

void V8Performance::getEntriesMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  UseCounter::Count(CurrentExecutionContext(info.GetIsolate()), WebFeature::kUnprefixedPerformanceTimeline);
  PerformanceV8Internal::getEntriesMethod(info);
}

void V8Performance::getEntriesByTypeMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  UseCounter::Count(CurrentExecutionContext(info.GetIsolate()), WebFeature::kUnprefixedPerformanceTimeline);
  PerformanceV8Internal::getEntriesByTypeMethod(info);
}

void V8Performance::getEntriesByNameMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  UseCounter::Count(CurrentExecutionContext(info.GetIsolate()), WebFeature::kUnprefixedPerformanceTimeline);
  PerformanceV8Internal::getEntriesByNameMethod(info);
}

void V8Performance::clearResourceTimingsMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  PerformanceV8Internal::clearResourceTimingsMethod(info);
}

void V8Performance::setResourceTimingBufferSizeMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  PerformanceV8Internal::setResourceTimingBufferSizeMethod(info);
}

void V8Performance::markMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  UseCounter::Count(CurrentExecutionContext(info.GetIsolate()), WebFeature::kUnprefixedUserTiming);
  PerformanceV8Internal::markMethod(info);
}

void V8Performance::clearMarksMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  UseCounter::Count(CurrentExecutionContext(info.GetIsolate()), WebFeature::kUnprefixedUserTiming);
  PerformanceV8Internal::clearMarksMethod(info);
}

void V8Performance::measureMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  UseCounter::Count(CurrentExecutionContext(info.GetIsolate()), WebFeature::kUnprefixedUserTiming);
  PerformanceV8Internal::measureMethod(info);
}

void V8Performance::clearMeasuresMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  UseCounter::Count(CurrentExecutionContext(info.GetIsolate()), WebFeature::kUnprefixedUserTiming);
  PerformanceV8Internal::clearMeasuresMethod(info);
}

void V8Performance::toJSONMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  PerformanceV8Internal::toJSONMethod(info);
}

static const V8DOMConfiguration::AccessorConfiguration V8PerformanceAccessors[] = {
    { "onresourcetimingbufferfull", V8Performance::onresourcetimingbufferfullAttributeGetterCallback, V8Performance::onresourcetimingbufferfullAttributeSetterCallback, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "timing", V8Performance::timingAttributeGetterCallback, nullptr, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "navigation", V8Performance::navigationAttributeGetterCallback, nullptr, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "memory", V8Performance::memoryAttributeGetterCallback, nullptr, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },
};

static const V8DOMConfiguration::MethodConfiguration V8PerformanceMethods[] = {
    {"now", V8Performance::nowMethodCallback, 0, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
    {"getEntries", V8Performance::getEntriesMethodCallback, 0, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
    {"getEntriesByType", V8Performance::getEntriesByTypeMethodCallback, 1, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
    {"getEntriesByName", V8Performance::getEntriesByNameMethodCallback, 1, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
    {"clearResourceTimings", V8Performance::clearResourceTimingsMethodCallback, 0, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
    {"setResourceTimingBufferSize", V8Performance::setResourceTimingBufferSizeMethodCallback, 1, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
    {"mark", V8Performance::markMethodCallback, 1, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
    {"clearMarks", V8Performance::clearMarksMethodCallback, 0, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
    {"measure", V8Performance::measureMethodCallback, 1, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
    {"clearMeasures", V8Performance::clearMeasuresMethodCallback, 0, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
    {"toJSON", V8Performance::toJSONMethodCallback, 0, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
};

static void installV8PerformanceTemplate(
    v8::Isolate* isolate,
    const DOMWrapperWorld& world,
    v8::Local<v8::FunctionTemplate> interfaceTemplate) {
  // Initialize the interface object's template.
  V8DOMConfiguration::InitializeDOMInterfaceTemplate(isolate, interfaceTemplate, V8Performance::wrapperTypeInfo.interface_name, V8EventTarget::domTemplate(isolate, world), V8Performance::internalFieldCount);

  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interfaceTemplate);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instanceTemplate = interfaceTemplate->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instanceTemplate);
  v8::Local<v8::ObjectTemplate> prototypeTemplate = interfaceTemplate->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototypeTemplate);

  // Register IDL constants, attributes and operations.
  V8DOMConfiguration::InstallAccessors(
      isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate,
      signature, V8PerformanceAccessors, WTF_ARRAY_LENGTH(V8PerformanceAccessors));
  V8DOMConfiguration::InstallMethods(
      isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate,
      signature, V8PerformanceMethods, WTF_ARRAY_LENGTH(V8PerformanceMethods));

  // Custom signature

  V8Performance::InstallRuntimeEnabledFeaturesOnTemplate(
      isolate, world, interfaceTemplate);
}

void V8Performance::InstallRuntimeEnabledFeaturesOnTemplate(
    v8::Isolate* isolate,
    const DOMWrapperWorld& world,
    v8::Local<v8::FunctionTemplate> interface_template) {
  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interface_template);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instance_template = interface_template->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instance_template);
  v8::Local<v8::ObjectTemplate> prototype_template = interface_template->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototype_template);

  // Register IDL constants, attributes and operations.

  // Custom signature
}

v8::Local<v8::FunctionTemplate> V8Performance::domTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world) {
  return V8DOMConfiguration::DomClassTemplate(isolate, world, const_cast<WrapperTypeInfo*>(&wrapperTypeInfo), installV8PerformanceTemplate);
}

bool V8Performance::hasInstance(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->HasInstance(&wrapperTypeInfo, v8Value);
}

v8::Local<v8::Object> V8Performance::findInstanceInPrototypeChain(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindInstanceInPrototypeChain(&wrapperTypeInfo, v8Value);
}

Performance* V8Performance::toImplWithTypeCheck(v8::Isolate* isolate, v8::Local<v8::Value> value) {
  return hasInstance(value, isolate) ? toImpl(v8::Local<v8::Object>::Cast(value)) : nullptr;
}

Performance* NativeValueTraits<Performance>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  Performance* nativeValue = V8Performance::toImplWithTypeCheck(isolate, value);
  if (!nativeValue) {
    exceptionState.ThrowTypeError(ExceptionMessages::FailedToConvertJSValue(
        "Performance"));
  }
  return nativeValue;
}

}  // namespace blink
