// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// This file has been generated from the Jinja2 template in
// third_party/WebKit/Source/bindings/templates/union_container.cpp.tmpl

// clang-format off
#include "DictionaryOrString.h"

#include "bindings/core/v8/Dictionary.h"
#include "bindings/core/v8/IDLTypes.h"
#include "bindings/core/v8/NativeValueTraitsImpl.h"
#include "bindings/core/v8/ToV8ForCore.h"

namespace blink {

DictionaryOrString::DictionaryOrString() : m_type(SpecificTypeNone) {}

Dictionary DictionaryOrString::getAsDictionary() const {
  DCHECK(isDictionary());
  return m_dictionary;
}

void DictionaryOrString::setDictionary(Dictionary value) {
  DCHECK(isNull());
  m_dictionary = value;
  m_type = SpecificTypeDictionary;
}

DictionaryOrString DictionaryOrString::fromDictionary(Dictionary value) {
  DictionaryOrString container;
  container.setDictionary(value);
  return container;
}

const String& DictionaryOrString::getAsString() const {
  DCHECK(isString());
  return m_string;
}

void DictionaryOrString::setString(const String& value) {
  DCHECK(isNull());
  m_string = value;
  m_type = SpecificTypeString;
}

DictionaryOrString DictionaryOrString::fromString(const String& value) {
  DictionaryOrString container;
  container.setString(value);
  return container;
}

DictionaryOrString::DictionaryOrString(const DictionaryOrString&) = default;
DictionaryOrString::~DictionaryOrString() = default;
DictionaryOrString& DictionaryOrString::operator=(const DictionaryOrString&) = default;

DEFINE_TRACE(DictionaryOrString) {
}

void V8DictionaryOrString::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, DictionaryOrString& impl, UnionTypeConversionMode conversionMode, ExceptionState& exceptionState) {
  if (v8Value.IsEmpty())
    return;

  if (conversionMode == UnionTypeConversionMode::kNullable && IsUndefinedOrNull(v8Value))
    return;

  if (IsUndefinedOrNull(v8Value) || v8Value->IsObject()) {
    Dictionary cppValue = NativeValueTraits<Dictionary>::NativeValue(isolate, v8Value, exceptionState);
    if (exceptionState.HadException())
      return;
    impl.setDictionary(cppValue);
    return;
  }

  {
    V8StringResource<> cppValue = v8Value;
    if (!cppValue.Prepare(exceptionState))
      return;
    impl.setString(cppValue);
    return;
  }
}

v8::Local<v8::Value> ToV8(const DictionaryOrString& impl, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  switch (impl.m_type) {
    case DictionaryOrString::SpecificTypeNone:
      return v8::Null(isolate);
    case DictionaryOrString::SpecificTypeDictionary:
      return impl.getAsDictionary().V8Value();
    case DictionaryOrString::SpecificTypeString:
      return V8String(isolate, impl.getAsString());
    default:
      NOTREACHED();
  }
  return v8::Local<v8::Value>();
}

DictionaryOrString NativeValueTraits<DictionaryOrString>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  DictionaryOrString impl;
  V8DictionaryOrString::toImpl(isolate, value, impl, UnionTypeConversionMode::kNotNullable, exceptionState);
  return impl;
}

}  // namespace blink
