// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// This file has been generated from the Jinja2 template in
// third_party/WebKit/Source/bindings/templates/union_container.cpp.tmpl

// clang-format off
#include "Float32ArrayOrFloat64ArrayOrDOMMatrix.h"

#include "bindings/core/v8/ToV8ForCore.h"
#include "bindings/core/v8/V8DOMMatrix.h"

namespace blink {

Float32ArrayOrFloat64ArrayOrDOMMatrix::Float32ArrayOrFloat64ArrayOrDOMMatrix() : m_type(SpecificTypeNone) {}

DOMMatrix* Float32ArrayOrFloat64ArrayOrDOMMatrix::getAsDOMMatrix() const {
  DCHECK(isDOMMatrix());
  return m_dOMMatrix;
}

void Float32ArrayOrFloat64ArrayOrDOMMatrix::setDOMMatrix(DOMMatrix* value) {
  DCHECK(isNull());
  m_dOMMatrix = value;
  m_type = SpecificTypeDOMMatrix;
}

Float32ArrayOrFloat64ArrayOrDOMMatrix Float32ArrayOrFloat64ArrayOrDOMMatrix::fromDOMMatrix(DOMMatrix* value) {
  Float32ArrayOrFloat64ArrayOrDOMMatrix container;
  container.setDOMMatrix(value);
  return container;
}

NotShared<DOMFloat32Array> Float32ArrayOrFloat64ArrayOrDOMMatrix::getAsFloat32Array() const {
  DCHECK(isFloat32Array());
  return m_float32Array;
}

void Float32ArrayOrFloat64ArrayOrDOMMatrix::setFloat32Array(NotShared<DOMFloat32Array> value) {
  DCHECK(isNull());
  m_float32Array = Member<DOMFloat32Array>(value.View());
  m_type = SpecificTypeFloat32Array;
}

Float32ArrayOrFloat64ArrayOrDOMMatrix Float32ArrayOrFloat64ArrayOrDOMMatrix::fromFloat32Array(NotShared<DOMFloat32Array> value) {
  Float32ArrayOrFloat64ArrayOrDOMMatrix container;
  container.setFloat32Array(value);
  return container;
}

NotShared<DOMFloat64Array> Float32ArrayOrFloat64ArrayOrDOMMatrix::getAsFloat64Array() const {
  DCHECK(isFloat64Array());
  return m_float64Array;
}

void Float32ArrayOrFloat64ArrayOrDOMMatrix::setFloat64Array(NotShared<DOMFloat64Array> value) {
  DCHECK(isNull());
  m_float64Array = Member<DOMFloat64Array>(value.View());
  m_type = SpecificTypeFloat64Array;
}

Float32ArrayOrFloat64ArrayOrDOMMatrix Float32ArrayOrFloat64ArrayOrDOMMatrix::fromFloat64Array(NotShared<DOMFloat64Array> value) {
  Float32ArrayOrFloat64ArrayOrDOMMatrix container;
  container.setFloat64Array(value);
  return container;
}

Float32ArrayOrFloat64ArrayOrDOMMatrix::Float32ArrayOrFloat64ArrayOrDOMMatrix(const Float32ArrayOrFloat64ArrayOrDOMMatrix&) = default;
Float32ArrayOrFloat64ArrayOrDOMMatrix::~Float32ArrayOrFloat64ArrayOrDOMMatrix() = default;
Float32ArrayOrFloat64ArrayOrDOMMatrix& Float32ArrayOrFloat64ArrayOrDOMMatrix::operator=(const Float32ArrayOrFloat64ArrayOrDOMMatrix&) = default;

DEFINE_TRACE(Float32ArrayOrFloat64ArrayOrDOMMatrix) {
  visitor->Trace(m_dOMMatrix);
  visitor->Trace(m_float32Array);
  visitor->Trace(m_float64Array);
}

void V8Float32ArrayOrFloat64ArrayOrDOMMatrix::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, Float32ArrayOrFloat64ArrayOrDOMMatrix& impl, UnionTypeConversionMode conversionMode, ExceptionState& exceptionState) {
  if (v8Value.IsEmpty())
    return;

  if (conversionMode == UnionTypeConversionMode::kNullable && IsUndefinedOrNull(v8Value))
    return;

  if (V8DOMMatrix::hasInstance(v8Value, isolate)) {
    DOMMatrix* cppValue = V8DOMMatrix::toImpl(v8::Local<v8::Object>::Cast(v8Value));
    impl.setDOMMatrix(cppValue);
    return;
  }

  if (v8Value->IsFloat32Array()) {
    NotShared<DOMFloat32Array> cppValue = ToNotShared<NotShared<DOMFloat32Array>>(isolate, v8Value, exceptionState);
    if (exceptionState.HadException())
      return;
    impl.setFloat32Array(cppValue);
    return;
  }

  if (v8Value->IsFloat64Array()) {
    NotShared<DOMFloat64Array> cppValue = ToNotShared<NotShared<DOMFloat64Array>>(isolate, v8Value, exceptionState);
    if (exceptionState.HadException())
      return;
    impl.setFloat64Array(cppValue);
    return;
  }

  exceptionState.ThrowTypeError("The provided value is not of type '(Float32Array or Float64Array or DOMMatrix)'");
}

v8::Local<v8::Value> ToV8(const Float32ArrayOrFloat64ArrayOrDOMMatrix& impl, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  switch (impl.m_type) {
    case Float32ArrayOrFloat64ArrayOrDOMMatrix::SpecificTypeNone:
      return v8::Null(isolate);
    case Float32ArrayOrFloat64ArrayOrDOMMatrix::SpecificTypeDOMMatrix:
      return ToV8(impl.getAsDOMMatrix(), creationContext, isolate);
    case Float32ArrayOrFloat64ArrayOrDOMMatrix::SpecificTypeFloat32Array:
      return ToV8(impl.getAsFloat32Array(), creationContext, isolate);
    case Float32ArrayOrFloat64ArrayOrDOMMatrix::SpecificTypeFloat64Array:
      return ToV8(impl.getAsFloat64Array(), creationContext, isolate);
    default:
      NOTREACHED();
  }
  return v8::Local<v8::Value>();
}

Float32ArrayOrFloat64ArrayOrDOMMatrix NativeValueTraits<Float32ArrayOrFloat64ArrayOrDOMMatrix>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  Float32ArrayOrFloat64ArrayOrDOMMatrix impl;
  V8Float32ArrayOrFloat64ArrayOrDOMMatrix::toImpl(isolate, value, impl, UnionTypeConversionMode::kNotNullable, exceptionState);
  return impl;
}

}  // namespace blink
