// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// This file has been generated from the Jinja2 template in
// third_party/WebKit/Source/bindings/templates/interface.cpp.tmpl

// clang-format off
#include "V8CredentialsContainer.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/ScriptPromise.h"
#include "bindings/core/v8/V8DOMConfiguration.h"
#include "bindings/modules/v8/V8Credential.h"
#include "bindings/modules/v8/V8CredentialCreationOptions.h"
#include "bindings/modules/v8/V8CredentialRequestOptions.h"
#include "core/dom/ExecutionContext.h"
#include "core/frame/Deprecation.h"
#include "core/frame/UseCounter.h"
#include "platform/bindings/ScriptState.h"
#include "platform/bindings/V8ObjectConstructor.h"
#include "platform/wtf/GetPtr.h"
#include "platform/wtf/RefPtr.h"

namespace blink {

// Suppress warning: global constructors, because struct WrapperTypeInfo is trivial
// and does not depend on another global objects.
#if defined(COMPONENT_BUILD) && defined(WIN32) && defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wglobal-constructors"
#endif
const WrapperTypeInfo V8CredentialsContainer::wrapperTypeInfo = {
    gin::kEmbedderBlink,
    V8CredentialsContainer::domTemplate,
    V8CredentialsContainer::Trace,
    V8CredentialsContainer::TraceWrappers,
    V8CredentialsContainer::preparePrototypeAndInterfaceObject,
    "CredentialsContainer",
    nullptr,
    WrapperTypeInfo::kWrapperTypeObjectPrototype,
    WrapperTypeInfo::kObjectClassId,
    WrapperTypeInfo::kNotInheritFromActiveScriptWrappable,
    WrapperTypeInfo::kIndependent,
};
#if defined(COMPONENT_BUILD) && defined(WIN32) && defined(__clang__)
#pragma clang diagnostic pop
#endif

// This static member must be declared by DEFINE_WRAPPERTYPEINFO in CredentialsContainer.h.
// For details, see the comment of DEFINE_WRAPPERTYPEINFO in
// platform/bindings/ScriptWrappable.h.
const WrapperTypeInfo& CredentialsContainer::wrapper_type_info_ = V8CredentialsContainer::wrapperTypeInfo;

// not [ActiveScriptWrappable]
static_assert(
    !std::is_base_of<ActiveScriptWrappableBase, CredentialsContainer>::value,
    "CredentialsContainer inherits from ActiveScriptWrappable<>, but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");
static_assert(
    std::is_same<decltype(&CredentialsContainer::HasPendingActivity),
                 decltype(&ScriptWrappable::HasPendingActivity)>::value,
    "CredentialsContainer is overriding hasPendingActivity(), but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");

namespace CredentialsContainerV8Internal {

static void getMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::kExecutionContext, "CredentialsContainer", "get");
  ExceptionToRejectPromiseScope rejectPromiseScope(info, exceptionState);

  // V8DOMConfiguration::kDoNotCheckHolder
  // Make sure that info.Holder() really points to an instance of the type.
  if (!V8CredentialsContainer::hasInstance(info.Holder(), info.GetIsolate())) {
    exceptionState.ThrowTypeError("Illegal invocation");
    return;
  }
  CredentialsContainer* impl = V8CredentialsContainer::toImpl(info.Holder());

  ScriptState* scriptState = ScriptState::ForReceiverObject(info);

  CredentialRequestOptions options;
  if (!IsUndefinedOrNull(info[0]) && !info[0]->IsObject()) {
    exceptionState.ThrowTypeError("parameter 1 ('options') is not an object.");

    return;
  }
  V8CredentialRequestOptions::toImpl(info.GetIsolate(), info[0], options, exceptionState);
  if (exceptionState.HadException())
    return;

  ScriptPromise result = impl->get(scriptState, options);
  V8SetReturnValue(info, result.V8Value());
}

static void storeMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::kExecutionContext, "CredentialsContainer", "store");
  ExceptionToRejectPromiseScope rejectPromiseScope(info, exceptionState);

  // V8DOMConfiguration::kDoNotCheckHolder
  // Make sure that info.Holder() really points to an instance of the type.
  if (!V8CredentialsContainer::hasInstance(info.Holder(), info.GetIsolate())) {
    exceptionState.ThrowTypeError("Illegal invocation");
    return;
  }
  CredentialsContainer* impl = V8CredentialsContainer::toImpl(info.Holder());

  ScriptState* scriptState = ScriptState::ForReceiverObject(info);

  if (UNLIKELY(info.Length() < 1)) {
    exceptionState.ThrowTypeError(ExceptionMessages::NotEnoughArguments(1, info.Length()));
    return;
  }

  Credential* credential;
  credential = V8Credential::toImplWithTypeCheck(info.GetIsolate(), info[0]);
  if (!credential) {
    exceptionState.ThrowTypeError("parameter 1 is not of type 'Credential'.");

    return;
  }

  ScriptPromise result = impl->store(scriptState, credential);
  V8SetReturnValue(info, result.V8Value());
}

static void createMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::kExecutionContext, "CredentialsContainer", "create");
  ExceptionToRejectPromiseScope rejectPromiseScope(info, exceptionState);

  // V8DOMConfiguration::kDoNotCheckHolder
  // Make sure that info.Holder() really points to an instance of the type.
  if (!V8CredentialsContainer::hasInstance(info.Holder(), info.GetIsolate())) {
    exceptionState.ThrowTypeError("Illegal invocation");
    return;
  }
  CredentialsContainer* impl = V8CredentialsContainer::toImpl(info.Holder());

  ScriptState* scriptState = ScriptState::ForReceiverObject(info);

  CredentialCreationOptions options;
  if (!IsUndefinedOrNull(info[0]) && !info[0]->IsObject()) {
    exceptionState.ThrowTypeError("parameter 1 ('options') is not an object.");

    return;
  }
  V8CredentialCreationOptions::toImpl(info.GetIsolate(), info[0], options, exceptionState);
  if (exceptionState.HadException())
    return;

  ScriptPromise result = impl->create(scriptState, options, exceptionState);
  if (exceptionState.HadException()) {
    return;
  }
  V8SetReturnValue(info, result.V8Value());
}

static void preventSilentAccessMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::kExecutionContext, "CredentialsContainer", "preventSilentAccess");
  ExceptionToRejectPromiseScope rejectPromiseScope(info, exceptionState);

  // V8DOMConfiguration::kDoNotCheckHolder
  // Make sure that info.Holder() really points to an instance of the type.
  if (!V8CredentialsContainer::hasInstance(info.Holder(), info.GetIsolate())) {
    exceptionState.ThrowTypeError("Illegal invocation");
    return;
  }
  CredentialsContainer* impl = V8CredentialsContainer::toImpl(info.Holder());

  ScriptState* scriptState = ScriptState::ForReceiverObject(info);

  ScriptPromise result = impl->preventSilentAccess(scriptState);
  V8SetReturnValue(info, result.V8Value());
}

static void requireUserMediationMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::kExecutionContext, "CredentialsContainer", "requireUserMediation");
  ExceptionToRejectPromiseScope rejectPromiseScope(info, exceptionState);

  // V8DOMConfiguration::kDoNotCheckHolder
  // Make sure that info.Holder() really points to an instance of the type.
  if (!V8CredentialsContainer::hasInstance(info.Holder(), info.GetIsolate())) {
    exceptionState.ThrowTypeError("Illegal invocation");
    return;
  }
  CredentialsContainer* impl = V8CredentialsContainer::toImpl(info.Holder());

  ScriptState* scriptState = ScriptState::ForReceiverObject(info);

  ScriptPromise result = impl->requireUserMediation(scriptState);
  V8SetReturnValue(info, result.V8Value());
}

} // namespace CredentialsContainerV8Internal

void V8CredentialsContainer::getMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  UseCounter::Count(CurrentExecutionContext(info.GetIsolate()), WebFeature::kCredentialManagerGet);
  CredentialsContainerV8Internal::getMethod(info);
}

void V8CredentialsContainer::storeMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  UseCounter::Count(CurrentExecutionContext(info.GetIsolate()), WebFeature::kCredentialManagerStore);
  CredentialsContainerV8Internal::storeMethod(info);
}

void V8CredentialsContainer::createMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  UseCounter::Count(CurrentExecutionContext(info.GetIsolate()), WebFeature::kCredentialManagerCreate);
  CredentialsContainerV8Internal::createMethod(info);
}

void V8CredentialsContainer::preventSilentAccessMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  UseCounter::Count(CurrentExecutionContext(info.GetIsolate()), WebFeature::kCredentialManagerPreventSilentAccess);
  CredentialsContainerV8Internal::preventSilentAccessMethod(info);
}

void V8CredentialsContainer::requireUserMediationMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  Deprecation::CountDeprecation(CurrentExecutionContext(info.GetIsolate()), WebFeature::kCredentialManagerRequireUserMediation);
  CredentialsContainerV8Internal::requireUserMediationMethod(info);
}

static void installV8CredentialsContainerTemplate(
    v8::Isolate* isolate,
    const DOMWrapperWorld& world,
    v8::Local<v8::FunctionTemplate> interfaceTemplate) {
  // Initialize the interface object's template.
  V8DOMConfiguration::InitializeDOMInterfaceTemplate(isolate, interfaceTemplate, V8CredentialsContainer::wrapperTypeInfo.interface_name, v8::Local<v8::FunctionTemplate>(), V8CredentialsContainer::internalFieldCount);

  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interfaceTemplate);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instanceTemplate = interfaceTemplate->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instanceTemplate);
  v8::Local<v8::ObjectTemplate> prototypeTemplate = interfaceTemplate->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototypeTemplate);

  // Register IDL constants, attributes and operations.

  // Custom signature

  V8CredentialsContainer::InstallRuntimeEnabledFeaturesOnTemplate(
      isolate, world, interfaceTemplate);
}

void V8CredentialsContainer::InstallRuntimeEnabledFeaturesOnTemplate(
    v8::Isolate* isolate,
    const DOMWrapperWorld& world,
    v8::Local<v8::FunctionTemplate> interface_template) {
  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interface_template);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instance_template = interface_template->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instance_template);
  v8::Local<v8::ObjectTemplate> prototype_template = interface_template->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototype_template);

  // Register IDL constants, attributes and operations.

  // Custom signature
}

v8::Local<v8::FunctionTemplate> V8CredentialsContainer::domTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world) {
  return V8DOMConfiguration::DomClassTemplate(isolate, world, const_cast<WrapperTypeInfo*>(&wrapperTypeInfo), installV8CredentialsContainerTemplate);
}

bool V8CredentialsContainer::hasInstance(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->HasInstance(&wrapperTypeInfo, v8Value);
}

v8::Local<v8::Object> V8CredentialsContainer::findInstanceInPrototypeChain(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindInstanceInPrototypeChain(&wrapperTypeInfo, v8Value);
}

CredentialsContainer* V8CredentialsContainer::toImplWithTypeCheck(v8::Isolate* isolate, v8::Local<v8::Value> value) {
  return hasInstance(value, isolate) ? toImpl(v8::Local<v8::Object>::Cast(value)) : nullptr;
}

CredentialsContainer* NativeValueTraits<CredentialsContainer>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  CredentialsContainer* nativeValue = V8CredentialsContainer::toImplWithTypeCheck(isolate, value);
  if (!nativeValue) {
    exceptionState.ThrowTypeError(ExceptionMessages::FailedToConvertJSValue(
        "CredentialsContainer"));
  }
  return nativeValue;
}

void V8CredentialsContainer::preparePrototypeAndInterfaceObject(v8::Local<v8::Context> context, const DOMWrapperWorld& world, v8::Local<v8::Object> prototypeObject, v8::Local<v8::Function> interfaceObject, v8::Local<v8::FunctionTemplate> interfaceTemplate) {
  v8::Isolate* isolate = context->GetIsolate();
  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interfaceTemplate);
  ExecutionContext* executionContext = ToExecutionContext(context);
  DCHECK(executionContext);

  if (executionContext && (executionContext->IsSecureContext())) {
    const V8DOMConfiguration::MethodConfiguration getMethodConfiguration[] = {
      {"get", V8CredentialsContainer::getMethodCallback, 0, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kDoNotCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds}
    };
    for (const auto& methodConfig : getMethodConfiguration)
      V8DOMConfiguration::InstallMethod(isolate, world, v8::Local<v8::Object>(), prototypeObject, interfaceObject, signature, methodConfig);
  }
  if (executionContext && (executionContext->IsSecureContext())) {
    const V8DOMConfiguration::MethodConfiguration storeMethodConfiguration[] = {
      {"store", V8CredentialsContainer::storeMethodCallback, 1, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kDoNotCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds}
    };
    for (const auto& methodConfig : storeMethodConfiguration)
      V8DOMConfiguration::InstallMethod(isolate, world, v8::Local<v8::Object>(), prototypeObject, interfaceObject, signature, methodConfig);
  }
  if (executionContext && (executionContext->IsSecureContext())) {
    const V8DOMConfiguration::MethodConfiguration createMethodConfiguration[] = {
      {"create", V8CredentialsContainer::createMethodCallback, 0, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kDoNotCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds}
    };
    for (const auto& methodConfig : createMethodConfiguration)
      V8DOMConfiguration::InstallMethod(isolate, world, v8::Local<v8::Object>(), prototypeObject, interfaceObject, signature, methodConfig);
  }
  if (executionContext && (executionContext->IsSecureContext())) {
    const V8DOMConfiguration::MethodConfiguration preventSilentAccessMethodConfiguration[] = {
      {"preventSilentAccess", V8CredentialsContainer::preventSilentAccessMethodCallback, 0, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kDoNotCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds}
    };
    for (const auto& methodConfig : preventSilentAccessMethodConfiguration)
      V8DOMConfiguration::InstallMethod(isolate, world, v8::Local<v8::Object>(), prototypeObject, interfaceObject, signature, methodConfig);
  }
  if (executionContext && (executionContext->IsSecureContext())) {
    const V8DOMConfiguration::MethodConfiguration requireUserMediationMethodConfiguration[] = {
      {"requireUserMediation", V8CredentialsContainer::requireUserMediationMethodCallback, 0, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kDoNotCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds}
    };
    for (const auto& methodConfig : requireUserMediationMethodConfiguration)
      V8DOMConfiguration::InstallMethod(isolate, world, v8::Local<v8::Object>(), prototypeObject, interfaceObject, signature, methodConfig);
  }
}

}  // namespace blink
