// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// This file has been generated from the Jinja2 template in
// third_party/WebKit/Source/bindings/templates/dictionary_v8.cpp.tmpl

// clang-format off
#include "V8ForeignFetchEventInit.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/IDLTypes.h"
#include "bindings/core/v8/NativeValueTraitsImpl.h"
#include "bindings/modules/v8/V8ExtendableEventInit.h"
#include "bindings/modules/v8/V8Request.h"

namespace blink {

static const v8::Eternal<v8::Name>* eternalV8ForeignFetchEventInitKeys(v8::Isolate* isolate) {
  static const char* const kKeys[] = {
    "origin",
    "request",
  };
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(
      kKeys, kKeys, WTF_ARRAY_LENGTH(kKeys));
}

void V8ForeignFetchEventInit::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, ForeignFetchEventInit& impl, ExceptionState& exceptionState) {
  if (IsUndefinedOrNull(v8Value)) {
    exceptionState.ThrowTypeError("Missing required member(s): request.");
    return;
  }
  if (!v8Value->IsObject()) {
    exceptionState.ThrowTypeError("cannot convert to dictionary.");
    return;
  }
  v8::Local<v8::Object> v8Object = v8Value.As<v8::Object>();
  ALLOW_UNUSED_LOCAL(v8Object);

  V8ExtendableEventInit::toImpl(isolate, v8Value, impl, exceptionState);
  if (exceptionState.HadException())
    return;

  const v8::Eternal<v8::Name>* keys = eternalV8ForeignFetchEventInitKeys(isolate);
  v8::TryCatch block(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> originValue;
  if (!v8Object->Get(context, keys[0].Get(isolate)).ToLocal(&originValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (originValue.IsEmpty() || originValue->IsUndefined()) {
    // Do nothing.
  } else {
    V8StringResource<> originCppValue = NativeValueTraits<IDLUSVString>::NativeValue(isolate, originValue, exceptionState);
    if (exceptionState.HadException())
      return;
    impl.setOrigin(originCppValue);
  }

  v8::Local<v8::Value> requestValue;
  if (!v8Object->Get(context, keys[1].Get(isolate)).ToLocal(&requestValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (requestValue.IsEmpty() || requestValue->IsUndefined()) {
    exceptionState.ThrowTypeError("required member request is undefined.");
    return;
  } else {
    Request* requestCppValue = V8Request::toImplWithTypeCheck(isolate, requestValue);
    if (!requestCppValue) {
      exceptionState.ThrowTypeError("member request is not of type Request.");
      return;
    }
    impl.setRequest(requestCppValue);
  }
}

v8::Local<v8::Value> ForeignFetchEventInit::ToV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8ForeignFetchEventInit(*this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8ForeignFetchEventInit(const ForeignFetchEventInit& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  if (!toV8ExtendableEventInit(impl, dictionary, creationContext, isolate))
    return false;

  const v8::Eternal<v8::Name>* keys = eternalV8ForeignFetchEventInitKeys(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> originValue;
  bool originHasValueOrDefault = false;
  if (impl.hasOrigin()) {
    originValue = V8String(isolate, impl.origin());
    originHasValueOrDefault = true;
  } else {
    originValue = V8String(isolate, "null");
    originHasValueOrDefault = true;
  }
  if (originHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[0].Get(isolate), originValue))) {
    return false;
  }

  v8::Local<v8::Value> requestValue;
  bool requestHasValueOrDefault = false;
  if (impl.hasRequest()) {
    requestValue = ToV8(impl.request(), creationContext, isolate);
    requestHasValueOrDefault = true;
  } else {
    NOTREACHED();
  }
  if (requestHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[1].Get(isolate), requestValue))) {
    return false;
  }

  return true;
}

ForeignFetchEventInit NativeValueTraits<ForeignFetchEventInit>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  ForeignFetchEventInit impl;
  V8ForeignFetchEventInit::toImpl(isolate, value, impl, exceptionState);
  return impl;
}

}  // namespace blink
