// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// This file has been generated from the Jinja2 template in
// third_party/WebKit/Source/bindings/templates/dictionary_v8.cpp.tmpl

// clang-format off
#include "V8ForeignFetchOptions.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/IDLTypes.h"
#include "bindings/core/v8/NativeValueTraitsImpl.h"

namespace blink {

static const v8::Eternal<v8::Name>* eternalV8ForeignFetchOptionsKeys(v8::Isolate* isolate) {
  static const char* const kKeys[] = {
    "origins",
    "scopes",
  };
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(
      kKeys, kKeys, WTF_ARRAY_LENGTH(kKeys));
}

void V8ForeignFetchOptions::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, ForeignFetchOptions& impl, ExceptionState& exceptionState) {
  if (IsUndefinedOrNull(v8Value)) {
    exceptionState.ThrowTypeError("Missing required member(s): origins, scopes.");
    return;
  }
  if (!v8Value->IsObject()) {
    exceptionState.ThrowTypeError("cannot convert to dictionary.");
    return;
  }
  v8::Local<v8::Object> v8Object = v8Value.As<v8::Object>();
  ALLOW_UNUSED_LOCAL(v8Object);

  const v8::Eternal<v8::Name>* keys = eternalV8ForeignFetchOptionsKeys(isolate);
  v8::TryCatch block(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> originsValue;
  if (!v8Object->Get(context, keys[0].Get(isolate)).ToLocal(&originsValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (originsValue.IsEmpty() || originsValue->IsUndefined()) {
    exceptionState.ThrowTypeError("required member origins is undefined.");
    return;
  } else {
    Vector<String> originsCppValue = NativeValueTraits<IDLSequence<IDLUSVString>>::NativeValue(isolate, originsValue, exceptionState);
    if (exceptionState.HadException())
      return;
    impl.setOrigins(originsCppValue);
  }

  v8::Local<v8::Value> scopesValue;
  if (!v8Object->Get(context, keys[1].Get(isolate)).ToLocal(&scopesValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (scopesValue.IsEmpty() || scopesValue->IsUndefined()) {
    exceptionState.ThrowTypeError("required member scopes is undefined.");
    return;
  } else {
    Vector<String> scopesCppValue = NativeValueTraits<IDLSequence<IDLUSVString>>::NativeValue(isolate, scopesValue, exceptionState);
    if (exceptionState.HadException())
      return;
    impl.setScopes(scopesCppValue);
  }
}

v8::Local<v8::Value> ForeignFetchOptions::ToV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8ForeignFetchOptions(*this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8ForeignFetchOptions(const ForeignFetchOptions& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  const v8::Eternal<v8::Name>* keys = eternalV8ForeignFetchOptionsKeys(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> originsValue;
  bool originsHasValueOrDefault = false;
  if (impl.hasOrigins()) {
    originsValue = ToV8(impl.origins(), creationContext, isolate);
    originsHasValueOrDefault = true;
  } else {
    NOTREACHED();
  }
  if (originsHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[0].Get(isolate), originsValue))) {
    return false;
  }

  v8::Local<v8::Value> scopesValue;
  bool scopesHasValueOrDefault = false;
  if (impl.hasScopes()) {
    scopesValue = ToV8(impl.scopes(), creationContext, isolate);
    scopesHasValueOrDefault = true;
  } else {
    NOTREACHED();
  }
  if (scopesHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[1].Get(isolate), scopesValue))) {
    return false;
  }

  return true;
}

ForeignFetchOptions NativeValueTraits<ForeignFetchOptions>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  ForeignFetchOptions impl;
  V8ForeignFetchOptions::toImpl(isolate, value, impl, exceptionState);
  return impl;
}

}  // namespace blink
