// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// This file has been generated from the Jinja2 template in
// third_party/WebKit/Source/bindings/templates/dictionary_v8.cpp.tmpl

// clang-format off
#include "V8ForeignFetchResponse.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/IDLTypes.h"
#include "bindings/core/v8/NativeValueTraitsImpl.h"
#include "bindings/modules/v8/V8Response.h"

namespace blink {

static const v8::Eternal<v8::Name>* eternalV8ForeignFetchResponseKeys(v8::Isolate* isolate) {
  static const char* const kKeys[] = {
    "headers",
    "origin",
    "response",
  };
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(
      kKeys, kKeys, WTF_ARRAY_LENGTH(kKeys));
}

void V8ForeignFetchResponse::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, ForeignFetchResponse& impl, ExceptionState& exceptionState) {
  if (IsUndefinedOrNull(v8Value)) {
    exceptionState.ThrowTypeError("Missing required member(s): response.");
    return;
  }
  if (!v8Value->IsObject()) {
    exceptionState.ThrowTypeError("cannot convert to dictionary.");
    return;
  }
  v8::Local<v8::Object> v8Object = v8Value.As<v8::Object>();
  ALLOW_UNUSED_LOCAL(v8Object);

  const v8::Eternal<v8::Name>* keys = eternalV8ForeignFetchResponseKeys(isolate);
  v8::TryCatch block(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> headersValue;
  if (!v8Object->Get(context, keys[0].Get(isolate)).ToLocal(&headersValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (headersValue.IsEmpty() || headersValue->IsUndefined()) {
    // Do nothing.
  } else {
    Vector<String> headersCppValue = NativeValueTraits<IDLSequence<IDLByteString>>::NativeValue(isolate, headersValue, exceptionState);
    if (exceptionState.HadException())
      return;
    impl.setHeaders(headersCppValue);
  }

  v8::Local<v8::Value> originValue;
  if (!v8Object->Get(context, keys[1].Get(isolate)).ToLocal(&originValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (originValue.IsEmpty() || originValue->IsUndefined()) {
    // Do nothing.
  } else {
    V8StringResource<> originCppValue = NativeValueTraits<IDLUSVString>::NativeValue(isolate, originValue, exceptionState);
    if (exceptionState.HadException())
      return;
    impl.setOrigin(originCppValue);
  }

  v8::Local<v8::Value> responseValue;
  if (!v8Object->Get(context, keys[2].Get(isolate)).ToLocal(&responseValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (responseValue.IsEmpty() || responseValue->IsUndefined()) {
    exceptionState.ThrowTypeError("required member response is undefined.");
    return;
  } else {
    Response* responseCppValue = V8Response::toImplWithTypeCheck(isolate, responseValue);
    if (!responseCppValue) {
      exceptionState.ThrowTypeError("member response is not of type Response.");
      return;
    }
    impl.setResponse(responseCppValue);
  }
}

v8::Local<v8::Value> ForeignFetchResponse::ToV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8ForeignFetchResponse(*this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8ForeignFetchResponse(const ForeignFetchResponse& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  const v8::Eternal<v8::Name>* keys = eternalV8ForeignFetchResponseKeys(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> headersValue;
  bool headersHasValueOrDefault = false;
  if (impl.hasHeaders()) {
    headersValue = ToV8(impl.headers(), creationContext, isolate);
    headersHasValueOrDefault = true;
  }
  if (headersHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[0].Get(isolate), headersValue))) {
    return false;
  }

  v8::Local<v8::Value> originValue;
  bool originHasValueOrDefault = false;
  if (impl.hasOrigin()) {
    originValue = V8String(isolate, impl.origin());
    originHasValueOrDefault = true;
  }
  if (originHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[1].Get(isolate), originValue))) {
    return false;
  }

  v8::Local<v8::Value> responseValue;
  bool responseHasValueOrDefault = false;
  if (impl.hasResponse()) {
    responseValue = ToV8(impl.response(), creationContext, isolate);
    responseHasValueOrDefault = true;
  } else {
    NOTREACHED();
  }
  if (responseHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[2].Get(isolate), responseValue))) {
    return false;
  }

  return true;
}

ForeignFetchResponse NativeValueTraits<ForeignFetchResponse>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  ForeignFetchResponse impl;
  V8ForeignFetchResponse::toImpl(isolate, value, impl, exceptionState);
  return impl;
}

}  // namespace blink
