// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// This file has been generated from the Jinja2 template in
// third_party/WebKit/Source/bindings/templates/interface.cpp.tmpl

// clang-format off
#include "V8Geolocation.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/IDLTypes.h"
#include "bindings/core/v8/NativeValueTraitsImpl.h"
#include "bindings/core/v8/V8DOMActivityLogger.h"
#include "bindings/core/v8/V8DOMConfiguration.h"
#include "bindings/modules/v8/V8PositionCallback.h"
#include "bindings/modules/v8/V8PositionErrorCallback.h"
#include "bindings/modules/v8/V8PositionOptions.h"
#include "core/dom/ExecutionContext.h"
#include "platform/bindings/V8ObjectConstructor.h"
#include "platform/wtf/GetPtr.h"
#include "platform/wtf/RefPtr.h"

namespace blink {

// Suppress warning: global constructors, because struct WrapperTypeInfo is trivial
// and does not depend on another global objects.
#if defined(COMPONENT_BUILD) && defined(WIN32) && defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wglobal-constructors"
#endif
const WrapperTypeInfo V8Geolocation::wrapperTypeInfo = {
    gin::kEmbedderBlink,
    V8Geolocation::domTemplate,
    V8Geolocation::Trace,
    V8Geolocation::TraceWrappers,
    nullptr,
    "Geolocation",
    nullptr,
    WrapperTypeInfo::kWrapperTypeObjectPrototype,
    WrapperTypeInfo::kObjectClassId,
    WrapperTypeInfo::kNotInheritFromActiveScriptWrappable,
    WrapperTypeInfo::kIndependent,
};
#if defined(COMPONENT_BUILD) && defined(WIN32) && defined(__clang__)
#pragma clang diagnostic pop
#endif

// This static member must be declared by DEFINE_WRAPPERTYPEINFO in Geolocation.h.
// For details, see the comment of DEFINE_WRAPPERTYPEINFO in
// platform/bindings/ScriptWrappable.h.
const WrapperTypeInfo& Geolocation::wrapper_type_info_ = V8Geolocation::wrapperTypeInfo;

// not [ActiveScriptWrappable]
static_assert(
    !std::is_base_of<ActiveScriptWrappableBase, Geolocation>::value,
    "Geolocation inherits from ActiveScriptWrappable<>, but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");
static_assert(
    std::is_same<decltype(&Geolocation::HasPendingActivity),
                 decltype(&ScriptWrappable::HasPendingActivity)>::value,
    "Geolocation is overriding hasPendingActivity(), but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");

namespace GeolocationV8Internal {

static void getCurrentPositionMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::kExecutionContext, "Geolocation", "getCurrentPosition");

  Geolocation* impl = V8Geolocation::toImpl(info.Holder());

  if (UNLIKELY(info.Length() < 1)) {
    exceptionState.ThrowTypeError(ExceptionMessages::NotEnoughArguments(1, info.Length()));
    return;
  }

  PositionCallback* successCallback;
  PositionErrorCallback* errorCallback;
  PositionOptions options;
  if (info.Length() <= 0 || !info[0]->IsFunction()) {
    exceptionState.ThrowTypeError("The callback provided as parameter 1 is not a function.");

    return;
  }
  successCallback = V8PositionCallback::Create(v8::Local<v8::Function>::Cast(info[0]), ScriptState::Current(info.GetIsolate()));

  if (!IsUndefinedOrNull(info[1])) {
    if (!info[1]->IsFunction()) {
      exceptionState.ThrowTypeError("The callback provided as parameter 2 is not a function.");

      return;
    }
    errorCallback = V8PositionErrorCallback::Create(v8::Local<v8::Function>::Cast(info[1]), ScriptState::Current(info.GetIsolate()));
  } else {
    errorCallback = nullptr;
  }

  if (!IsUndefinedOrNull(info[2]) && !info[2]->IsObject()) {
    exceptionState.ThrowTypeError("parameter 3 ('options') is not an object.");

    return;
  }
  V8PositionOptions::toImpl(info.GetIsolate(), info[2], options, exceptionState);
  if (exceptionState.HadException())
    return;

  impl->getCurrentPosition(successCallback, errorCallback, options);
}

static void watchPositionMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::kExecutionContext, "Geolocation", "watchPosition");

  Geolocation* impl = V8Geolocation::toImpl(info.Holder());

  if (UNLIKELY(info.Length() < 1)) {
    exceptionState.ThrowTypeError(ExceptionMessages::NotEnoughArguments(1, info.Length()));
    return;
  }

  PositionCallback* successCallback;
  PositionErrorCallback* errorCallback;
  PositionOptions options;
  if (info.Length() <= 0 || !info[0]->IsFunction()) {
    exceptionState.ThrowTypeError("The callback provided as parameter 1 is not a function.");

    return;
  }
  successCallback = V8PositionCallback::Create(v8::Local<v8::Function>::Cast(info[0]), ScriptState::Current(info.GetIsolate()));

  if (!IsUndefinedOrNull(info[1])) {
    if (!info[1]->IsFunction()) {
      exceptionState.ThrowTypeError("The callback provided as parameter 2 is not a function.");

      return;
    }
    errorCallback = V8PositionErrorCallback::Create(v8::Local<v8::Function>::Cast(info[1]), ScriptState::Current(info.GetIsolate()));
  } else {
    errorCallback = nullptr;
  }

  if (!IsUndefinedOrNull(info[2]) && !info[2]->IsObject()) {
    exceptionState.ThrowTypeError("parameter 3 ('options') is not an object.");

    return;
  }
  V8PositionOptions::toImpl(info.GetIsolate(), info[2], options, exceptionState);
  if (exceptionState.HadException())
    return;

  V8SetReturnValueInt(info, impl->watchPosition(successCallback, errorCallback, options));
}

static void clearWatchMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::kExecutionContext, "Geolocation", "clearWatch");

  Geolocation* impl = V8Geolocation::toImpl(info.Holder());

  if (UNLIKELY(info.Length() < 1)) {
    exceptionState.ThrowTypeError(ExceptionMessages::NotEnoughArguments(1, info.Length()));
    return;
  }

  int32_t watchID;
  watchID = NativeValueTraits<IDLLong>::NativeValue(info.GetIsolate(), info[0], exceptionState, kNormalConversion);
  if (exceptionState.HadException())
    return;

  impl->clearWatch(watchID);
}

} // namespace GeolocationV8Internal

void V8Geolocation::getCurrentPositionMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ScriptState* scriptState = ScriptState::ForReceiverObject(info);
  V8PerContextData* contextData = scriptState->PerContextData();
  if (contextData && contextData->ActivityLogger()) {
    ExceptionState exceptionState(info.GetIsolate(), ExceptionState::kExecutionContext, "Geolocation", "getCurrentPosition");
    Vector<v8::Local<v8::Value>> loggerArgs = ToImplArguments<Vector<v8::Local<v8::Value>>>(info, 0, exceptionState);
    contextData->ActivityLogger()->LogMethod("Geolocation.getCurrentPosition", info.Length(), loggerArgs.data());
  }
  GeolocationV8Internal::getCurrentPositionMethod(info);
}

void V8Geolocation::watchPositionMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ScriptState* scriptState = ScriptState::ForReceiverObject(info);
  V8PerContextData* contextData = scriptState->PerContextData();
  if (contextData && contextData->ActivityLogger()) {
    ExceptionState exceptionState(info.GetIsolate(), ExceptionState::kExecutionContext, "Geolocation", "watchPosition");
    Vector<v8::Local<v8::Value>> loggerArgs = ToImplArguments<Vector<v8::Local<v8::Value>>>(info, 0, exceptionState);
    contextData->ActivityLogger()->LogMethod("Geolocation.watchPosition", info.Length(), loggerArgs.data());
  }
  GeolocationV8Internal::watchPositionMethod(info);
}

void V8Geolocation::clearWatchMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  GeolocationV8Internal::clearWatchMethod(info);
}

static const V8DOMConfiguration::MethodConfiguration V8GeolocationMethods[] = {
    {"getCurrentPosition", V8Geolocation::getCurrentPositionMethodCallback, 1, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
    {"watchPosition", V8Geolocation::watchPositionMethodCallback, 1, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
    {"clearWatch", V8Geolocation::clearWatchMethodCallback, 1, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
};

static void installV8GeolocationTemplate(
    v8::Isolate* isolate,
    const DOMWrapperWorld& world,
    v8::Local<v8::FunctionTemplate> interfaceTemplate) {
  // Initialize the interface object's template.
  V8DOMConfiguration::InitializeDOMInterfaceTemplate(isolate, interfaceTemplate, V8Geolocation::wrapperTypeInfo.interface_name, v8::Local<v8::FunctionTemplate>(), V8Geolocation::internalFieldCount);

  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interfaceTemplate);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instanceTemplate = interfaceTemplate->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instanceTemplate);
  v8::Local<v8::ObjectTemplate> prototypeTemplate = interfaceTemplate->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototypeTemplate);

  // Register IDL constants, attributes and operations.
  V8DOMConfiguration::InstallMethods(
      isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate,
      signature, V8GeolocationMethods, WTF_ARRAY_LENGTH(V8GeolocationMethods));

  // Custom signature

  V8Geolocation::InstallRuntimeEnabledFeaturesOnTemplate(
      isolate, world, interfaceTemplate);
}

void V8Geolocation::InstallRuntimeEnabledFeaturesOnTemplate(
    v8::Isolate* isolate,
    const DOMWrapperWorld& world,
    v8::Local<v8::FunctionTemplate> interface_template) {
  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interface_template);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instance_template = interface_template->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instance_template);
  v8::Local<v8::ObjectTemplate> prototype_template = interface_template->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototype_template);

  // Register IDL constants, attributes and operations.

  // Custom signature
}

v8::Local<v8::FunctionTemplate> V8Geolocation::domTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world) {
  return V8DOMConfiguration::DomClassTemplate(isolate, world, const_cast<WrapperTypeInfo*>(&wrapperTypeInfo), installV8GeolocationTemplate);
}

bool V8Geolocation::hasInstance(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->HasInstance(&wrapperTypeInfo, v8Value);
}

v8::Local<v8::Object> V8Geolocation::findInstanceInPrototypeChain(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindInstanceInPrototypeChain(&wrapperTypeInfo, v8Value);
}

Geolocation* V8Geolocation::toImplWithTypeCheck(v8::Isolate* isolate, v8::Local<v8::Value> value) {
  return hasInstance(value, isolate) ? toImpl(v8::Local<v8::Object>::Cast(value)) : nullptr;
}

Geolocation* NativeValueTraits<Geolocation>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  Geolocation* nativeValue = V8Geolocation::toImplWithTypeCheck(isolate, value);
  if (!nativeValue) {
    exceptionState.ThrowTypeError(ExceptionMessages::FailedToConvertJSValue(
        "Geolocation"));
  }
  return nativeValue;
}

}  // namespace blink
