// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// This file has been generated from the Jinja2 template in
// third_party/WebKit/Source/bindings/templates/interface.cpp.tmpl

// clang-format off
#include "V8MediaRecorder.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/IDLTypes.h"
#include "bindings/core/v8/NativeValueTraitsImpl.h"
#include "bindings/core/v8/V8AbstractEventListener.h"
#include "bindings/core/v8/V8DOMConfiguration.h"
#include "bindings/core/v8/V8EventListenerHelper.h"
#include "bindings/modules/v8/V8MediaRecorderOptions.h"
#include "bindings/modules/v8/V8MediaStream.h"
#include "core/dom/ExecutionContext.h"
#include "core/frame/LocalDOMWindow.h"
#include "core/frame/UseCounter.h"
#include "core/inspector/ConsoleMessage.h"
#include "platform/bindings/V8ObjectConstructor.h"
#include "platform/bindings/V8PrivateProperty.h"
#include "platform/wtf/GetPtr.h"
#include "platform/wtf/RefPtr.h"

namespace blink {

// Suppress warning: global constructors, because struct WrapperTypeInfo is trivial
// and does not depend on another global objects.
#if defined(COMPONENT_BUILD) && defined(WIN32) && defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wglobal-constructors"
#endif
const WrapperTypeInfo V8MediaRecorder::wrapperTypeInfo = {
    gin::kEmbedderBlink,
    V8MediaRecorder::domTemplate,
    V8MediaRecorder::Trace,
    V8MediaRecorder::TraceWrappers,
    nullptr,
    "MediaRecorder",
    &V8EventTarget::wrapperTypeInfo,
    WrapperTypeInfo::kWrapperTypeObjectPrototype,
    WrapperTypeInfo::kObjectClassId,
    WrapperTypeInfo::kInheritFromActiveScriptWrappable,
    WrapperTypeInfo::kDependent,
};
#if defined(COMPONENT_BUILD) && defined(WIN32) && defined(__clang__)
#pragma clang diagnostic pop
#endif

// This static member must be declared by DEFINE_WRAPPERTYPEINFO in MediaRecorder.h.
// For details, see the comment of DEFINE_WRAPPERTYPEINFO in
// platform/bindings/ScriptWrappable.h.
const WrapperTypeInfo& MediaRecorder::wrapper_type_info_ = V8MediaRecorder::wrapperTypeInfo;

// [ActiveScriptWrappable]
static_assert(
    std::is_base_of<ActiveScriptWrappableBase, MediaRecorder>::value,
    "MediaRecorder does not inherit from ActiveScriptWrappable<>, but specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");
static_assert(
    !std::is_same<decltype(&MediaRecorder::HasPendingActivity),
                  decltype(&ScriptWrappable::HasPendingActivity)>::value,
    "MediaRecorder is not overriding hasPendingActivity(), but is specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");

namespace MediaRecorderV8Internal {

static void streamAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  MediaRecorder* impl = V8MediaRecorder::toImpl(holder);

  MediaStream* cppValue(WTF::GetPtr(impl->stream()));

  // Keep the wrapper object for the return value alive as long as |this|
  // object is alive in order to save creation time of the wrapper object.
  if (cppValue && DOMDataStore::SetReturnValue(info.GetReturnValue(), cppValue))
    return;
  v8::Local<v8::Value> v8Value(ToV8(cppValue, holder, info.GetIsolate()));
  V8PrivateProperty::GetSymbol(
      info.GetIsolate(), "KeepAlive#MediaRecorder#stream")
      .Set(holder, v8Value);

  V8SetReturnValue(info, v8Value);
}

static void mimeTypeAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  MediaRecorder* impl = V8MediaRecorder::toImpl(holder);

  V8SetReturnValueString(info, impl->mimeType(), info.GetIsolate());
}

static void stateAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  MediaRecorder* impl = V8MediaRecorder::toImpl(holder);

  V8SetReturnValueString(info, impl->state(), info.GetIsolate());
}

static void onstartAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  MediaRecorder* impl = V8MediaRecorder::toImpl(holder);

  EventListener* cppValue(WTF::GetPtr(impl->onstart()));

  V8SetReturnValue(info, cppValue ? V8AbstractEventListener::Cast(cppValue)->GetListenerOrNull(info.GetIsolate(), impl->GetExecutionContext()) : v8::Null(info.GetIsolate()).As<v8::Value>());
}

static void onstartAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  MediaRecorder* impl = V8MediaRecorder::toImpl(holder);

  // Prepare the value to be set.
  MoveEventListenerToNewWrapper(isolate, holder, impl->onstart(), v8Value, V8MediaRecorder::eventListenerCacheIndex);

  impl->setOnstart(V8EventListenerHelper::GetEventListener(ScriptState::ForReceiverObject(info), v8Value, true, kListenerFindOrCreate));
}

static void onstopAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  MediaRecorder* impl = V8MediaRecorder::toImpl(holder);

  EventListener* cppValue(WTF::GetPtr(impl->onstop()));

  V8SetReturnValue(info, cppValue ? V8AbstractEventListener::Cast(cppValue)->GetListenerOrNull(info.GetIsolate(), impl->GetExecutionContext()) : v8::Null(info.GetIsolate()).As<v8::Value>());
}

static void onstopAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  MediaRecorder* impl = V8MediaRecorder::toImpl(holder);

  // Prepare the value to be set.
  MoveEventListenerToNewWrapper(isolate, holder, impl->onstop(), v8Value, V8MediaRecorder::eventListenerCacheIndex);

  impl->setOnstop(V8EventListenerHelper::GetEventListener(ScriptState::ForReceiverObject(info), v8Value, true, kListenerFindOrCreate));
}

static void ondataavailableAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  MediaRecorder* impl = V8MediaRecorder::toImpl(holder);

  EventListener* cppValue(WTF::GetPtr(impl->ondataavailable()));

  V8SetReturnValue(info, cppValue ? V8AbstractEventListener::Cast(cppValue)->GetListenerOrNull(info.GetIsolate(), impl->GetExecutionContext()) : v8::Null(info.GetIsolate()).As<v8::Value>());
}

static void ondataavailableAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  MediaRecorder* impl = V8MediaRecorder::toImpl(holder);

  // Prepare the value to be set.
  MoveEventListenerToNewWrapper(isolate, holder, impl->ondataavailable(), v8Value, V8MediaRecorder::eventListenerCacheIndex);

  impl->setOndataavailable(V8EventListenerHelper::GetEventListener(ScriptState::ForReceiverObject(info), v8Value, true, kListenerFindOrCreate));
}

static void onpauseAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  MediaRecorder* impl = V8MediaRecorder::toImpl(holder);

  EventListener* cppValue(WTF::GetPtr(impl->onpause()));

  V8SetReturnValue(info, cppValue ? V8AbstractEventListener::Cast(cppValue)->GetListenerOrNull(info.GetIsolate(), impl->GetExecutionContext()) : v8::Null(info.GetIsolate()).As<v8::Value>());
}

static void onpauseAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  MediaRecorder* impl = V8MediaRecorder::toImpl(holder);

  // Prepare the value to be set.
  MoveEventListenerToNewWrapper(isolate, holder, impl->onpause(), v8Value, V8MediaRecorder::eventListenerCacheIndex);

  impl->setOnpause(V8EventListenerHelper::GetEventListener(ScriptState::ForReceiverObject(info), v8Value, true, kListenerFindOrCreate));
}

static void onresumeAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  MediaRecorder* impl = V8MediaRecorder::toImpl(holder);

  EventListener* cppValue(WTF::GetPtr(impl->onresume()));

  V8SetReturnValue(info, cppValue ? V8AbstractEventListener::Cast(cppValue)->GetListenerOrNull(info.GetIsolate(), impl->GetExecutionContext()) : v8::Null(info.GetIsolate()).As<v8::Value>());
}

static void onresumeAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  MediaRecorder* impl = V8MediaRecorder::toImpl(holder);

  // Prepare the value to be set.
  MoveEventListenerToNewWrapper(isolate, holder, impl->onresume(), v8Value, V8MediaRecorder::eventListenerCacheIndex);

  impl->setOnresume(V8EventListenerHelper::GetEventListener(ScriptState::ForReceiverObject(info), v8Value, true, kListenerFindOrCreate));
}

static void onerrorAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  MediaRecorder* impl = V8MediaRecorder::toImpl(holder);

  EventListener* cppValue(WTF::GetPtr(impl->onerror()));

  V8SetReturnValue(info, cppValue ? V8AbstractEventListener::Cast(cppValue)->GetListenerOrNull(info.GetIsolate(), impl->GetExecutionContext()) : v8::Null(info.GetIsolate()).As<v8::Value>());
}

static void onerrorAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  MediaRecorder* impl = V8MediaRecorder::toImpl(holder);

  // Prepare the value to be set.
  MoveEventListenerToNewWrapper(isolate, holder, impl->onerror(), v8Value, V8MediaRecorder::eventListenerCacheIndex);

  impl->setOnerror(V8EventListenerHelper::GetEventListener(ScriptState::ForReceiverObject(info), v8Value, true, kListenerFindOrCreate));
}

static void videoBitsPerSecondAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  MediaRecorder* impl = V8MediaRecorder::toImpl(holder);

  V8SetReturnValueUnsigned(info, impl->videoBitsPerSecond());
}

static void audioBitsPerSecondAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  MediaRecorder* impl = V8MediaRecorder::toImpl(holder);

  V8SetReturnValueUnsigned(info, impl->audioBitsPerSecond());
}

static void startMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::kExecutionContext, "MediaRecorder", "start");

  MediaRecorder* impl = V8MediaRecorder::toImpl(info.Holder());

  int32_t timeslice;
  int numArgsPassed = info.Length();
  while (numArgsPassed > 0) {
    if (!info[numArgsPassed - 1]->IsUndefined())
      break;
    --numArgsPassed;
  }
  if (UNLIKELY(numArgsPassed <= 0)) {
    impl->start(exceptionState);
    if (exceptionState.HadException()) {
      return;
    }
    return;
  }
  timeslice = NativeValueTraits<IDLLong>::NativeValue(info.GetIsolate(), info[0], exceptionState, kNormalConversion);
  if (exceptionState.HadException())
    return;

  impl->start(timeslice, exceptionState);
  if (exceptionState.HadException()) {
    return;
  }
}

static void stopMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::kExecutionContext, "MediaRecorder", "stop");

  MediaRecorder* impl = V8MediaRecorder::toImpl(info.Holder());

  impl->stop(exceptionState);
  if (exceptionState.HadException()) {
    return;
  }
}

static void pauseMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::kExecutionContext, "MediaRecorder", "pause");

  MediaRecorder* impl = V8MediaRecorder::toImpl(info.Holder());

  impl->pause(exceptionState);
  if (exceptionState.HadException()) {
    return;
  }
}

static void resumeMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::kExecutionContext, "MediaRecorder", "resume");

  MediaRecorder* impl = V8MediaRecorder::toImpl(info.Holder());

  impl->resume(exceptionState);
  if (exceptionState.HadException()) {
    return;
  }
}

static void requestDataMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::kExecutionContext, "MediaRecorder", "requestData");

  MediaRecorder* impl = V8MediaRecorder::toImpl(info.Holder());

  impl->requestData(exceptionState);
  if (exceptionState.HadException()) {
    return;
  }
}

static void isTypeSupportedMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  if (UNLIKELY(info.Length() < 1)) {
    V8ThrowException::ThrowTypeError(info.GetIsolate(), ExceptionMessages::FailedToExecute("isTypeSupported", "MediaRecorder", ExceptionMessages::NotEnoughArguments(1, info.Length())));
    return;
  }

  V8StringResource<> type;
  type = info[0];
  if (!type.Prepare())
    return;

  V8SetReturnValueBool(info, MediaRecorder::isTypeSupported(type));
}

static void constructor(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::kConstructionContext, "MediaRecorder");

  if (UNLIKELY(info.Length() < 1)) {
    exceptionState.ThrowTypeError(ExceptionMessages::NotEnoughArguments(1, info.Length()));
    return;
  }

  MediaStream* stream;
  MediaRecorderOptions options;
  stream = V8MediaStream::toImplWithTypeCheck(info.GetIsolate(), info[0]);
  if (!stream) {
    exceptionState.ThrowTypeError("parameter 1 is not of type 'MediaStream'.");

    return;
  }

  if (!IsUndefinedOrNull(info[1]) && !info[1]->IsObject()) {
    exceptionState.ThrowTypeError("parameter 2 ('options') is not an object.");

    return;
  }
  V8MediaRecorderOptions::toImpl(info.GetIsolate(), info[1], options, exceptionState);
  if (exceptionState.HadException())
    return;

  ExecutionContext* executionContext = CurrentExecutionContext(info.GetIsolate());
  MediaRecorder* impl = MediaRecorder::Create(executionContext, stream, options, exceptionState);
  if (exceptionState.HadException()) {
    return;
  }
  v8::Local<v8::Object> wrapper = info.Holder();
  wrapper = impl->AssociateWithWrapper(info.GetIsolate(), &V8MediaRecorder::wrapperTypeInfo, wrapper);
  V8SetReturnValue(info, wrapper);
}

} // namespace MediaRecorderV8Internal

void V8MediaRecorder::streamAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  MediaRecorderV8Internal::streamAttributeGetter(info);
}

void V8MediaRecorder::mimeTypeAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  MediaRecorderV8Internal::mimeTypeAttributeGetter(info);
}

void V8MediaRecorder::stateAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  MediaRecorderV8Internal::stateAttributeGetter(info);
}

void V8MediaRecorder::onstartAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  MediaRecorderV8Internal::onstartAttributeGetter(info);
}

void V8MediaRecorder::onstartAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  MediaRecorderV8Internal::onstartAttributeSetter(v8Value, info);
}

void V8MediaRecorder::onstopAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  MediaRecorderV8Internal::onstopAttributeGetter(info);
}

void V8MediaRecorder::onstopAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  MediaRecorderV8Internal::onstopAttributeSetter(v8Value, info);
}

void V8MediaRecorder::ondataavailableAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  MediaRecorderV8Internal::ondataavailableAttributeGetter(info);
}

void V8MediaRecorder::ondataavailableAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  MediaRecorderV8Internal::ondataavailableAttributeSetter(v8Value, info);
}

void V8MediaRecorder::onpauseAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  MediaRecorderV8Internal::onpauseAttributeGetter(info);
}

void V8MediaRecorder::onpauseAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  MediaRecorderV8Internal::onpauseAttributeSetter(v8Value, info);
}

void V8MediaRecorder::onresumeAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  MediaRecorderV8Internal::onresumeAttributeGetter(info);
}

void V8MediaRecorder::onresumeAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  MediaRecorderV8Internal::onresumeAttributeSetter(v8Value, info);
}

void V8MediaRecorder::onerrorAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  MediaRecorderV8Internal::onerrorAttributeGetter(info);
}

void V8MediaRecorder::onerrorAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  MediaRecorderV8Internal::onerrorAttributeSetter(v8Value, info);
}

void V8MediaRecorder::videoBitsPerSecondAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  MediaRecorderV8Internal::videoBitsPerSecondAttributeGetter(info);
}

void V8MediaRecorder::audioBitsPerSecondAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  MediaRecorderV8Internal::audioBitsPerSecondAttributeGetter(info);
}

void V8MediaRecorder::startMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  UseCounter::Count(CurrentExecutionContext(info.GetIsolate()), WebFeature::kV8MediaRecorder_Start_Method);
  MediaRecorderV8Internal::startMethod(info);
}

void V8MediaRecorder::stopMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  MediaRecorderV8Internal::stopMethod(info);
}

void V8MediaRecorder::pauseMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  MediaRecorderV8Internal::pauseMethod(info);
}

void V8MediaRecorder::resumeMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  MediaRecorderV8Internal::resumeMethod(info);
}

void V8MediaRecorder::requestDataMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  MediaRecorderV8Internal::requestDataMethod(info);
}

void V8MediaRecorder::isTypeSupportedMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  MediaRecorderV8Internal::isTypeSupportedMethod(info);
}

static const V8DOMConfiguration::AccessorConfiguration V8MediaRecorderAccessors[] = {
    { "stream", V8MediaRecorder::streamAttributeGetterCallback, nullptr, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "mimeType", V8MediaRecorder::mimeTypeAttributeGetterCallback, nullptr, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "state", V8MediaRecorder::stateAttributeGetterCallback, nullptr, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "onstart", V8MediaRecorder::onstartAttributeGetterCallback, V8MediaRecorder::onstartAttributeSetterCallback, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "onstop", V8MediaRecorder::onstopAttributeGetterCallback, V8MediaRecorder::onstopAttributeSetterCallback, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "ondataavailable", V8MediaRecorder::ondataavailableAttributeGetterCallback, V8MediaRecorder::ondataavailableAttributeSetterCallback, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "onpause", V8MediaRecorder::onpauseAttributeGetterCallback, V8MediaRecorder::onpauseAttributeSetterCallback, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "onresume", V8MediaRecorder::onresumeAttributeGetterCallback, V8MediaRecorder::onresumeAttributeSetterCallback, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "onerror", V8MediaRecorder::onerrorAttributeGetterCallback, V8MediaRecorder::onerrorAttributeSetterCallback, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "videoBitsPerSecond", V8MediaRecorder::videoBitsPerSecondAttributeGetterCallback, nullptr, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "audioBitsPerSecond", V8MediaRecorder::audioBitsPerSecondAttributeGetterCallback, nullptr, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },
};

static const V8DOMConfiguration::MethodConfiguration V8MediaRecorderMethods[] = {
    {"start", V8MediaRecorder::startMethodCallback, 0, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
    {"stop", V8MediaRecorder::stopMethodCallback, 0, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
    {"pause", V8MediaRecorder::pauseMethodCallback, 0, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
    {"resume", V8MediaRecorder::resumeMethodCallback, 0, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
    {"requestData", V8MediaRecorder::requestDataMethodCallback, 0, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
    {"isTypeSupported", V8MediaRecorder::isTypeSupportedMethodCallback, 1, v8::None, V8DOMConfiguration::kOnInterface, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
};

void V8MediaRecorder::constructorCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  if (!info.IsConstructCall()) {
    V8ThrowException::ThrowTypeError(info.GetIsolate(), ExceptionMessages::ConstructorNotCallableAsFunction("MediaRecorder"));
    return;
  }

  if (ConstructorMode::Current(info.GetIsolate()) == ConstructorMode::kWrapExistingObject) {
    V8SetReturnValue(info, info.Holder());
    return;
  }

  MediaRecorderV8Internal::constructor(info);
}

static void installV8MediaRecorderTemplate(
    v8::Isolate* isolate,
    const DOMWrapperWorld& world,
    v8::Local<v8::FunctionTemplate> interfaceTemplate) {
  // Initialize the interface object's template.
  V8DOMConfiguration::InitializeDOMInterfaceTemplate(isolate, interfaceTemplate, V8MediaRecorder::wrapperTypeInfo.interface_name, V8EventTarget::domTemplate(isolate, world), V8MediaRecorder::internalFieldCount);
  interfaceTemplate->SetCallHandler(V8MediaRecorder::constructorCallback);
  interfaceTemplate->SetLength(1);

  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interfaceTemplate);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instanceTemplate = interfaceTemplate->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instanceTemplate);
  v8::Local<v8::ObjectTemplate> prototypeTemplate = interfaceTemplate->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototypeTemplate);

  // Register IDL constants, attributes and operations.
  V8DOMConfiguration::InstallAccessors(
      isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate,
      signature, V8MediaRecorderAccessors, WTF_ARRAY_LENGTH(V8MediaRecorderAccessors));
  V8DOMConfiguration::InstallMethods(
      isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate,
      signature, V8MediaRecorderMethods, WTF_ARRAY_LENGTH(V8MediaRecorderMethods));

  // Custom signature

  V8MediaRecorder::InstallRuntimeEnabledFeaturesOnTemplate(
      isolate, world, interfaceTemplate);
}

void V8MediaRecorder::InstallRuntimeEnabledFeaturesOnTemplate(
    v8::Isolate* isolate,
    const DOMWrapperWorld& world,
    v8::Local<v8::FunctionTemplate> interface_template) {
  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interface_template);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instance_template = interface_template->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instance_template);
  v8::Local<v8::ObjectTemplate> prototype_template = interface_template->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototype_template);

  // Register IDL constants, attributes and operations.

  // Custom signature
}

v8::Local<v8::FunctionTemplate> V8MediaRecorder::domTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world) {
  return V8DOMConfiguration::DomClassTemplate(isolate, world, const_cast<WrapperTypeInfo*>(&wrapperTypeInfo), installV8MediaRecorderTemplate);
}

bool V8MediaRecorder::hasInstance(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->HasInstance(&wrapperTypeInfo, v8Value);
}

v8::Local<v8::Object> V8MediaRecorder::findInstanceInPrototypeChain(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindInstanceInPrototypeChain(&wrapperTypeInfo, v8Value);
}

MediaRecorder* V8MediaRecorder::toImplWithTypeCheck(v8::Isolate* isolate, v8::Local<v8::Value> value) {
  return hasInstance(value, isolate) ? toImpl(v8::Local<v8::Object>::Cast(value)) : nullptr;
}

MediaRecorder* NativeValueTraits<MediaRecorder>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  MediaRecorder* nativeValue = V8MediaRecorder::toImplWithTypeCheck(isolate, value);
  if (!nativeValue) {
    exceptionState.ThrowTypeError(ExceptionMessages::FailedToConvertJSValue(
        "MediaRecorder"));
  }
  return nativeValue;
}

}  // namespace blink
