// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// This file has been generated from the Jinja2 template in
// third_party/WebKit/Source/bindings/templates/callback_interface.cpp.tmpl

// clang-format off
#include "V8MetadataCallback.h"

#include "bindings/core/v8/IDLTypes.h"
#include "bindings/core/v8/NativeValueTraitsImpl.h"
#include "bindings/core/v8/ScriptController.h"
#include "bindings/core/v8/V8BindingForCore.h"
#include "bindings/modules/v8/V8Metadata.h"
#include "core/dom/ExecutionContext.h"
#include "platform/wtf/Assertions.h"
#include "platform/wtf/GetPtr.h"
#include "platform/wtf/RefPtr.h"

namespace blink {

V8MetadataCallback::V8MetadataCallback(v8::Local<v8::Function> callback, ScriptState* scriptState)
    : script_state_(scriptState) {
  callback_.Set(scriptState->GetIsolate(), callback);
}

V8MetadataCallback::~V8MetadataCallback() {}

DEFINE_TRACE(V8MetadataCallback) {
  MetadataCallback::Trace(visitor);
}

void V8MetadataCallback::handleEvent(Metadata* metadata) {
  if (!script_state_->ContextIsValid())
    return;
  ExecutionContext* executionContext =
      ExecutionContext::From(script_state_.Get());
  DCHECK(!executionContext->IsContextSuspended());
  if (!executionContext || executionContext->IsContextDestroyed())
    return;

  ScriptState::Scope scope(script_state_.Get());

  v8::Local<v8::Value> metadataHandle = ToV8(metadata, script_state_->GetContext()->Global(), script_state_->GetIsolate());
  v8::Local<v8::Value> argv[] = { metadataHandle };

  v8::Isolate* isolate = script_state_->GetIsolate();
  V8ScriptRunner::CallFunction(callback_.NewLocal(isolate),
                               ExecutionContext::From(script_state_.Get()),
                               v8::Undefined(isolate),
                               1,
                               argv,
                               isolate);
}

}  // namespace blink
