// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// This file has been generated from the Jinja2 template in
// third_party/WebKit/Source/bindings/templates/interface.cpp.tmpl

// clang-format off
#include "V8Notification.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/IDLTypes.h"
#include "bindings/core/v8/NativeValueTraitsImpl.h"
#include "bindings/core/v8/ScriptPromise.h"
#include "bindings/core/v8/ScriptValue.h"
#include "bindings/core/v8/V8AbstractEventListener.h"
#include "bindings/core/v8/V8DOMConfiguration.h"
#include "bindings/core/v8/V8EventListenerHelper.h"
#include "bindings/modules/v8/V8NotificationAction.h"
#include "bindings/modules/v8/V8NotificationOptions.h"
#include "bindings/modules/v8/V8NotificationPermissionCallback.h"
#include "core/dom/ExecutionContext.h"
#include "core/frame/LocalDOMWindow.h"
#include "core/frame/UseCounter.h"
#include "core/inspector/ConsoleMessage.h"
#include "platform/RuntimeEnabledFeatures.h"
#include "platform/bindings/ScriptState.h"
#include "platform/bindings/V8ObjectConstructor.h"
#include "platform/bindings/V8PrivateProperty.h"
#include "platform/wtf/GetPtr.h"
#include "platform/wtf/RefPtr.h"

namespace blink {

// Suppress warning: global constructors, because struct WrapperTypeInfo is trivial
// and does not depend on another global objects.
#if defined(COMPONENT_BUILD) && defined(WIN32) && defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wglobal-constructors"
#endif
const WrapperTypeInfo V8Notification::wrapperTypeInfo = {
    gin::kEmbedderBlink,
    V8Notification::domTemplate,
    V8Notification::Trace,
    V8Notification::TraceWrappers,
    V8Notification::preparePrototypeAndInterfaceObject,
    "Notification",
    &V8EventTarget::wrapperTypeInfo,
    WrapperTypeInfo::kWrapperTypeObjectPrototype,
    WrapperTypeInfo::kObjectClassId,
    WrapperTypeInfo::kInheritFromActiveScriptWrappable,
    WrapperTypeInfo::kDependent,
};
#if defined(COMPONENT_BUILD) && defined(WIN32) && defined(__clang__)
#pragma clang diagnostic pop
#endif

// This static member must be declared by DEFINE_WRAPPERTYPEINFO in Notification.h.
// For details, see the comment of DEFINE_WRAPPERTYPEINFO in
// platform/bindings/ScriptWrappable.h.
const WrapperTypeInfo& Notification::wrapper_type_info_ = V8Notification::wrapperTypeInfo;

// [ActiveScriptWrappable]
static_assert(
    std::is_base_of<ActiveScriptWrappableBase, Notification>::value,
    "Notification does not inherit from ActiveScriptWrappable<>, but specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");
static_assert(
    !std::is_same<decltype(&Notification::HasPendingActivity),
                  decltype(&ScriptWrappable::HasPendingActivity)>::value,
    "Notification is not overriding hasPendingActivity(), but is specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");

namespace NotificationV8Internal {

static void permissionAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ScriptState* scriptState = ScriptState::ForFunctionObject(info);

  V8SetReturnValueString(info, Notification::permission(scriptState), info.GetIsolate());
}

static void maxActionsAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  V8SetReturnValueUnsigned(info, Notification::maxActions());
}

static void onclickAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  Notification* impl = V8Notification::toImpl(holder);

  EventListener* cppValue(WTF::GetPtr(impl->onclick()));

  V8SetReturnValue(info, cppValue ? V8AbstractEventListener::Cast(cppValue)->GetListenerOrNull(info.GetIsolate(), impl->GetExecutionContext()) : v8::Null(info.GetIsolate()).As<v8::Value>());
}

static void onclickAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  Notification* impl = V8Notification::toImpl(holder);

  // Prepare the value to be set.
  MoveEventListenerToNewWrapper(isolate, holder, impl->onclick(), v8Value, V8Notification::eventListenerCacheIndex);

  impl->setOnclick(V8EventListenerHelper::GetEventListener(ScriptState::ForReceiverObject(info), v8Value, true, kListenerFindOrCreate));
}

static void onshowAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  Notification* impl = V8Notification::toImpl(holder);

  EventListener* cppValue(WTF::GetPtr(impl->onshow()));

  V8SetReturnValue(info, cppValue ? V8AbstractEventListener::Cast(cppValue)->GetListenerOrNull(info.GetIsolate(), impl->GetExecutionContext()) : v8::Null(info.GetIsolate()).As<v8::Value>());
}

static void onshowAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  Notification* impl = V8Notification::toImpl(holder);

  // Prepare the value to be set.
  MoveEventListenerToNewWrapper(isolate, holder, impl->onshow(), v8Value, V8Notification::eventListenerCacheIndex);

  impl->setOnshow(V8EventListenerHelper::GetEventListener(ScriptState::ForReceiverObject(info), v8Value, true, kListenerFindOrCreate));
}

static void onerrorAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  Notification* impl = V8Notification::toImpl(holder);

  EventListener* cppValue(WTF::GetPtr(impl->onerror()));

  V8SetReturnValue(info, cppValue ? V8AbstractEventListener::Cast(cppValue)->GetListenerOrNull(info.GetIsolate(), impl->GetExecutionContext()) : v8::Null(info.GetIsolate()).As<v8::Value>());
}

static void onerrorAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  Notification* impl = V8Notification::toImpl(holder);

  // Prepare the value to be set.
  MoveEventListenerToNewWrapper(isolate, holder, impl->onerror(), v8Value, V8Notification::eventListenerCacheIndex);

  impl->setOnerror(V8EventListenerHelper::GetEventListener(ScriptState::ForReceiverObject(info), v8Value, true, kListenerFindOrCreate));
}

static void oncloseAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  Notification* impl = V8Notification::toImpl(holder);

  EventListener* cppValue(WTF::GetPtr(impl->onclose()));

  V8SetReturnValue(info, cppValue ? V8AbstractEventListener::Cast(cppValue)->GetListenerOrNull(info.GetIsolate(), impl->GetExecutionContext()) : v8::Null(info.GetIsolate()).As<v8::Value>());
}

static void oncloseAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  Notification* impl = V8Notification::toImpl(holder);

  // Prepare the value to be set.
  MoveEventListenerToNewWrapper(isolate, holder, impl->onclose(), v8Value, V8Notification::eventListenerCacheIndex);

  impl->setOnclose(V8EventListenerHelper::GetEventListener(ScriptState::ForReceiverObject(info), v8Value, true, kListenerFindOrCreate));
}

static void titleAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  Notification* impl = V8Notification::toImpl(holder);

  V8SetReturnValueString(info, impl->title(), info.GetIsolate());
}

static void dirAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  Notification* impl = V8Notification::toImpl(holder);

  V8SetReturnValueString(info, impl->dir(), info.GetIsolate());
}

static void langAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  Notification* impl = V8Notification::toImpl(holder);

  V8SetReturnValueString(info, impl->lang(), info.GetIsolate());
}

static void bodyAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  Notification* impl = V8Notification::toImpl(holder);

  V8SetReturnValueString(info, impl->body(), info.GetIsolate());
}

static void tagAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  Notification* impl = V8Notification::toImpl(holder);

  V8SetReturnValueString(info, impl->tag(), info.GetIsolate());
}

static void imageAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  Notification* impl = V8Notification::toImpl(holder);

  V8SetReturnValueString(info, impl->image(), info.GetIsolate());
}

static void iconAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  Notification* impl = V8Notification::toImpl(holder);

  V8SetReturnValueString(info, impl->icon(), info.GetIsolate());
}

static void badgeAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  Notification* impl = V8Notification::toImpl(holder);

  V8SetReturnValueString(info, impl->badge(), info.GetIsolate());
}

static void vibrateAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  // [SaveSameObject]
  // If you see a compile error that
  //   V8PrivateProperty::GetSameObjectNotificationVibrate
  // is not defined, then you need to register your attribute at
  // V8_PRIVATE_PROPERTY_FOR_EACH defined in V8PrivateProperty.h as
  //   X(SameObject, NotificationVibrate)
  auto privateSameObject = V8PrivateProperty::GetSameObjectNotificationVibrate(info.GetIsolate());
  {
    v8::Local<v8::Value> v8Value = privateSameObject.GetOrEmpty(holder);
    if (!v8Value.IsEmpty()) {
      V8SetReturnValue(info, v8Value);
      return;
    }
  }

  Notification* impl = V8Notification::toImpl(holder);

  V8SetReturnValue(info, FreezeV8Object(ToV8(impl->vibrate(), info.Holder(), info.GetIsolate()), info.GetIsolate()));

  // [SaveSameObject]
  privateSameObject.Set(holder, info.GetReturnValue().Get());
}

static void timestampAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  Notification* impl = V8Notification::toImpl(holder);

  V8SetReturnValue(info, static_cast<double>(impl->timestamp()));
}

static void renotifyAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  Notification* impl = V8Notification::toImpl(holder);

  V8SetReturnValueBool(info, impl->renotify());
}

static void silentAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  Notification* impl = V8Notification::toImpl(holder);

  V8SetReturnValueBool(info, impl->silent());
}

static void requireInteractionAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  Notification* impl = V8Notification::toImpl(holder);

  V8SetReturnValueBool(info, impl->requireInteraction());
}

static void dataAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  // [SaveSameObject]
  // If you see a compile error that
  //   V8PrivateProperty::GetSameObjectNotificationData
  // is not defined, then you need to register your attribute at
  // V8_PRIVATE_PROPERTY_FOR_EACH defined in V8PrivateProperty.h as
  //   X(SameObject, NotificationData)
  auto privateSameObject = V8PrivateProperty::GetSameObjectNotificationData(info.GetIsolate());
  {
    v8::Local<v8::Value> v8Value = privateSameObject.GetOrEmpty(holder);
    if (!v8Value.IsEmpty()) {
      V8SetReturnValue(info, v8Value);
      return;
    }
  }

  Notification* impl = V8Notification::toImpl(holder);

  ScriptState* scriptState = ScriptState::ForReceiverObject(info);

  V8SetReturnValue(info, impl->data(scriptState).V8Value());

  // [SaveSameObject]
  privateSameObject.Set(holder, info.GetReturnValue().Get());
}

static void actionsAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  // [SaveSameObject]
  // If you see a compile error that
  //   V8PrivateProperty::GetSameObjectNotificationActions
  // is not defined, then you need to register your attribute at
  // V8_PRIVATE_PROPERTY_FOR_EACH defined in V8PrivateProperty.h as
  //   X(SameObject, NotificationActions)
  auto privateSameObject = V8PrivateProperty::GetSameObjectNotificationActions(info.GetIsolate());
  {
    v8::Local<v8::Value> v8Value = privateSameObject.GetOrEmpty(holder);
    if (!v8Value.IsEmpty()) {
      V8SetReturnValue(info, v8Value);
      return;
    }
  }

  Notification* impl = V8Notification::toImpl(holder);

  ScriptState* scriptState = ScriptState::ForReceiverObject(info);

  V8SetReturnValue(info, FreezeV8Object(ToV8(impl->actions(scriptState), info.Holder(), info.GetIsolate()), info.GetIsolate()));

  // [SaveSameObject]
  privateSameObject.Set(holder, info.GetReturnValue().Get());
}

static void requestPermissionMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::kExecutionContext, "Notification", "requestPermission");
  ExceptionToRejectPromiseScope rejectPromiseScope(info, exceptionState);

  ScriptState* scriptState = ScriptState::ForFunctionObject(info);

  NotificationPermissionCallback* deprecatedCallback;
  if (!IsUndefinedOrNull(info[0])) {
    if (!info[0]->IsFunction()) {
      exceptionState.ThrowTypeError("The callback provided as parameter 1 is not a function.");

      return;
    }
    deprecatedCallback = V8NotificationPermissionCallback::Create(v8::Local<v8::Function>::Cast(info[0]), ScriptState::Current(info.GetIsolate()));
  } else {
    deprecatedCallback = nullptr;
  }

  ScriptPromise result = Notification::requestPermission(scriptState, deprecatedCallback);
  V8SetReturnValue(info, result.V8Value());
}

static void closeMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  Notification* impl = V8Notification::toImpl(info.Holder());

  impl->close();
}

static void constructor(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::kConstructionContext, "Notification");

  if (UNLIKELY(info.Length() < 1)) {
    exceptionState.ThrowTypeError(ExceptionMessages::NotEnoughArguments(1, info.Length()));
    return;
  }

  V8StringResource<> title;
  NotificationOptions options;
  title = info[0];
  if (!title.Prepare())
    return;

  if (!IsUndefinedOrNull(info[1]) && !info[1]->IsObject()) {
    exceptionState.ThrowTypeError("parameter 2 ('options') is not an object.");

    return;
  }
  V8NotificationOptions::toImpl(info.GetIsolate(), info[1], options, exceptionState);
  if (exceptionState.HadException())
    return;

  ExecutionContext* executionContext = CurrentExecutionContext(info.GetIsolate());
  Notification* impl = Notification::Create(executionContext, title, options, exceptionState);
  if (exceptionState.HadException()) {
    return;
  }
  v8::Local<v8::Object> wrapper = info.Holder();
  wrapper = impl->AssociateWithWrapper(info.GetIsolate(), &V8Notification::wrapperTypeInfo, wrapper);
  V8SetReturnValue(info, wrapper);
}

} // namespace NotificationV8Internal

void V8Notification::permissionAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  UseCounter::Count(CurrentExecutionContext(info.GetIsolate()), WebFeature::kNotificationPermission);

  NotificationV8Internal::permissionAttributeGetter(info);
}

void V8Notification::maxActionsAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  NotificationV8Internal::maxActionsAttributeGetter(info);
}

void V8Notification::onclickAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  NotificationV8Internal::onclickAttributeGetter(info);
}

void V8Notification::onclickAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  NotificationV8Internal::onclickAttributeSetter(v8Value, info);
}

void V8Notification::onshowAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  UseCounter::Count(CurrentExecutionContext(info.GetIsolate()), WebFeature::kNotificationShowEvent);

  NotificationV8Internal::onshowAttributeGetter(info);
}

void V8Notification::onshowAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  UseCounter::Count(CurrentExecutionContext(info.GetIsolate()), WebFeature::kNotificationShowEvent);

  NotificationV8Internal::onshowAttributeSetter(v8Value, info);
}

void V8Notification::onerrorAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  NotificationV8Internal::onerrorAttributeGetter(info);
}

void V8Notification::onerrorAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  NotificationV8Internal::onerrorAttributeSetter(v8Value, info);
}

void V8Notification::oncloseAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  UseCounter::Count(CurrentExecutionContext(info.GetIsolate()), WebFeature::kNotificationCloseEvent);

  NotificationV8Internal::oncloseAttributeGetter(info);
}

void V8Notification::oncloseAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  UseCounter::Count(CurrentExecutionContext(info.GetIsolate()), WebFeature::kNotificationCloseEvent);

  NotificationV8Internal::oncloseAttributeSetter(v8Value, info);
}

void V8Notification::titleAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  NotificationV8Internal::titleAttributeGetter(info);
}

void V8Notification::dirAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  NotificationV8Internal::dirAttributeGetter(info);
}

void V8Notification::langAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  NotificationV8Internal::langAttributeGetter(info);
}

void V8Notification::bodyAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  NotificationV8Internal::bodyAttributeGetter(info);
}

void V8Notification::tagAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  NotificationV8Internal::tagAttributeGetter(info);
}

void V8Notification::imageAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  NotificationV8Internal::imageAttributeGetter(info);
}

void V8Notification::iconAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  NotificationV8Internal::iconAttributeGetter(info);
}

void V8Notification::badgeAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  NotificationV8Internal::badgeAttributeGetter(info);
}

void V8Notification::vibrateAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  NotificationV8Internal::vibrateAttributeGetter(info);
}

void V8Notification::timestampAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  NotificationV8Internal::timestampAttributeGetter(info);
}

void V8Notification::renotifyAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  NotificationV8Internal::renotifyAttributeGetter(info);
}

void V8Notification::silentAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  NotificationV8Internal::silentAttributeGetter(info);
}

void V8Notification::requireInteractionAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  NotificationV8Internal::requireInteractionAttributeGetter(info);
}

void V8Notification::dataAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  NotificationV8Internal::dataAttributeGetter(info);
}

void V8Notification::actionsAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  NotificationV8Internal::actionsAttributeGetter(info);
}

void V8Notification::requestPermissionMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  UseCounter::Count(CurrentExecutionContext(info.GetIsolate()), WebFeature::kNotificationPermissionRequested);
  NotificationV8Internal::requestPermissionMethod(info);
}

void V8Notification::closeMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  UseCounter::Count(CurrentExecutionContext(info.GetIsolate()), WebFeature::kNotificationClosed);
  NotificationV8Internal::closeMethod(info);
}

static const V8DOMConfiguration::AccessorConfiguration V8NotificationAccessors[] = {
    { "permission", V8Notification::permissionAttributeGetterCallback, nullptr, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnInterface, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "maxActions", V8Notification::maxActionsAttributeGetterCallback, nullptr, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnInterface, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "onclick", V8Notification::onclickAttributeGetterCallback, V8Notification::onclickAttributeSetterCallback, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "onshow", V8Notification::onshowAttributeGetterCallback, V8Notification::onshowAttributeSetterCallback, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "onerror", V8Notification::onerrorAttributeGetterCallback, V8Notification::onerrorAttributeSetterCallback, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "onclose", V8Notification::oncloseAttributeGetterCallback, V8Notification::oncloseAttributeSetterCallback, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "title", V8Notification::titleAttributeGetterCallback, nullptr, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "dir", V8Notification::dirAttributeGetterCallback, nullptr, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "lang", V8Notification::langAttributeGetterCallback, nullptr, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "body", V8Notification::bodyAttributeGetterCallback, nullptr, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "tag", V8Notification::tagAttributeGetterCallback, nullptr, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "icon", V8Notification::iconAttributeGetterCallback, nullptr, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "vibrate", V8Notification::vibrateAttributeGetterCallback, nullptr, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "timestamp", V8Notification::timestampAttributeGetterCallback, nullptr, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "renotify", V8Notification::renotifyAttributeGetterCallback, nullptr, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "silent", V8Notification::silentAttributeGetterCallback, nullptr, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "requireInteraction", V8Notification::requireInteractionAttributeGetterCallback, nullptr, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "data", V8Notification::dataAttributeGetterCallback, nullptr, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "actions", V8Notification::actionsAttributeGetterCallback, nullptr, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },
};

static const V8DOMConfiguration::MethodConfiguration V8NotificationMethods[] = {
    {"close", V8Notification::closeMethodCallback, 0, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
};

void V8Notification::constructorCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  UseCounter::Count(CurrentExecutionContext(info.GetIsolate()), WebFeature::kNotificationCreated);
  if (!info.IsConstructCall()) {
    V8ThrowException::ThrowTypeError(info.GetIsolate(), ExceptionMessages::ConstructorNotCallableAsFunction("Notification"));
    return;
  }

  if (ConstructorMode::Current(info.GetIsolate()) == ConstructorMode::kWrapExistingObject) {
    V8SetReturnValue(info, info.Holder());
    return;
  }

  NotificationV8Internal::constructor(info);
}

static void installV8NotificationTemplate(
    v8::Isolate* isolate,
    const DOMWrapperWorld& world,
    v8::Local<v8::FunctionTemplate> interfaceTemplate) {
  // Initialize the interface object's template.
  V8DOMConfiguration::InitializeDOMInterfaceTemplate(isolate, interfaceTemplate, V8Notification::wrapperTypeInfo.interface_name, V8EventTarget::domTemplate(isolate, world), V8Notification::internalFieldCount);
  interfaceTemplate->SetCallHandler(V8Notification::constructorCallback);
  interfaceTemplate->SetLength(1);

  if (!RuntimeEnabledFeatures::NotificationsEnabled()) {
    return;
  }

  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interfaceTemplate);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instanceTemplate = interfaceTemplate->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instanceTemplate);
  v8::Local<v8::ObjectTemplate> prototypeTemplate = interfaceTemplate->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototypeTemplate);

  // Register IDL constants, attributes and operations.
  V8DOMConfiguration::InstallAccessors(
      isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate,
      signature, V8NotificationAccessors, WTF_ARRAY_LENGTH(V8NotificationAccessors));
  V8DOMConfiguration::InstallMethods(
      isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate,
      signature, V8NotificationMethods, WTF_ARRAY_LENGTH(V8NotificationMethods));

  // Custom signature

  V8Notification::InstallRuntimeEnabledFeaturesOnTemplate(
      isolate, world, interfaceTemplate);
}

void V8Notification::InstallRuntimeEnabledFeaturesOnTemplate(
    v8::Isolate* isolate,
    const DOMWrapperWorld& world,
    v8::Local<v8::FunctionTemplate> interface_template) {
  if (!RuntimeEnabledFeatures::NotificationsEnabled()) {
    return;
  }

  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interface_template);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instance_template = interface_template->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instance_template);
  v8::Local<v8::ObjectTemplate> prototype_template = interface_template->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototype_template);

  // Register IDL constants, attributes and operations.

  if (RuntimeEnabledFeatures::NotificationBadgeEnabled()) {
    static const V8DOMConfiguration::AccessorConfiguration accessor_configurations[] = {
        { "badge", V8Notification::badgeAttributeGetterCallback, nullptr, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },
    };
    V8DOMConfiguration::InstallAccessors(
        isolate, world, instance_template, prototype_template, interface_template,
        signature, accessor_configurations,
        WTF_ARRAY_LENGTH(accessor_configurations));
  }
  if (RuntimeEnabledFeatures::NotificationContentImageEnabled()) {
    static const V8DOMConfiguration::AccessorConfiguration accessor_configurations[] = {
        { "image", V8Notification::imageAttributeGetterCallback, nullptr, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },
    };
    V8DOMConfiguration::InstallAccessors(
        isolate, world, instance_template, prototype_template, interface_template,
        signature, accessor_configurations,
        WTF_ARRAY_LENGTH(accessor_configurations));
  }

  // Custom signature
}

v8::Local<v8::FunctionTemplate> V8Notification::domTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world) {
  return V8DOMConfiguration::DomClassTemplate(isolate, world, const_cast<WrapperTypeInfo*>(&wrapperTypeInfo), installV8NotificationTemplate);
}

bool V8Notification::hasInstance(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->HasInstance(&wrapperTypeInfo, v8Value);
}

v8::Local<v8::Object> V8Notification::findInstanceInPrototypeChain(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindInstanceInPrototypeChain(&wrapperTypeInfo, v8Value);
}

Notification* V8Notification::toImplWithTypeCheck(v8::Isolate* isolate, v8::Local<v8::Value> value) {
  return hasInstance(value, isolate) ? toImpl(v8::Local<v8::Object>::Cast(value)) : nullptr;
}

Notification* NativeValueTraits<Notification>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  Notification* nativeValue = V8Notification::toImplWithTypeCheck(isolate, value);
  if (!nativeValue) {
    exceptionState.ThrowTypeError(ExceptionMessages::FailedToConvertJSValue(
        "Notification"));
  }
  return nativeValue;
}

void V8Notification::preparePrototypeAndInterfaceObject(v8::Local<v8::Context> context, const DOMWrapperWorld& world, v8::Local<v8::Object> prototypeObject, v8::Local<v8::Function> interfaceObject, v8::Local<v8::FunctionTemplate> interfaceTemplate) {
  v8::Isolate* isolate = context->GetIsolate();
  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interfaceTemplate);
  ExecutionContext* executionContext = ToExecutionContext(context);
  DCHECK(executionContext);

  if (executionContext && (executionContext->IsDocument())) {
    const V8DOMConfiguration::MethodConfiguration requestPermissionMethodConfiguration[] = {
      {"requestPermission", V8Notification::requestPermissionMethodCallback, 0, v8::None, V8DOMConfiguration::kOnInterface, V8DOMConfiguration::kDoNotCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds}
    };
    for (const auto& methodConfig : requestPermissionMethodConfiguration)
      V8DOMConfiguration::InstallMethod(isolate, world, v8::Local<v8::Object>(), prototypeObject, interfaceObject, signature, methodConfig);
  }
}

}  // namespace blink
