// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// This file has been generated from the Jinja2 template in
// third_party/WebKit/Source/bindings/templates/interface.cpp.tmpl

// clang-format off
#include "V8RemotePlayback.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/IDLTypes.h"
#include "bindings/core/v8/NativeValueTraitsImpl.h"
#include "bindings/core/v8/ScriptPromise.h"
#include "bindings/core/v8/V8AbstractEventListener.h"
#include "bindings/core/v8/V8DOMConfiguration.h"
#include "bindings/core/v8/V8EventListenerHelper.h"
#include "bindings/modules/v8/RemotePlaybackAvailabilityCallback.h"
#include "core/dom/ExecutionContext.h"
#include "core/inspector/ConsoleMessage.h"
#include "platform/RuntimeEnabledFeatures.h"
#include "platform/bindings/ScriptState.h"
#include "platform/bindings/V8ObjectConstructor.h"
#include "platform/wtf/GetPtr.h"
#include "platform/wtf/RefPtr.h"

namespace blink {

// Suppress warning: global constructors, because struct WrapperTypeInfo is trivial
// and does not depend on another global objects.
#if defined(COMPONENT_BUILD) && defined(WIN32) && defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wglobal-constructors"
#endif
const WrapperTypeInfo V8RemotePlayback::wrapperTypeInfo = {
    gin::kEmbedderBlink,
    V8RemotePlayback::domTemplate,
    V8RemotePlayback::Trace,
    V8RemotePlayback::TraceWrappers,
    nullptr,
    "RemotePlayback",
    &V8EventTarget::wrapperTypeInfo,
    WrapperTypeInfo::kWrapperTypeObjectPrototype,
    WrapperTypeInfo::kObjectClassId,
    WrapperTypeInfo::kInheritFromActiveScriptWrappable,
    WrapperTypeInfo::kDependent,
};
#if defined(COMPONENT_BUILD) && defined(WIN32) && defined(__clang__)
#pragma clang diagnostic pop
#endif

// This static member must be declared by DEFINE_WRAPPERTYPEINFO in RemotePlayback.h.
// For details, see the comment of DEFINE_WRAPPERTYPEINFO in
// platform/bindings/ScriptWrappable.h.
const WrapperTypeInfo& RemotePlayback::wrapper_type_info_ = V8RemotePlayback::wrapperTypeInfo;

// [ActiveScriptWrappable]
static_assert(
    std::is_base_of<ActiveScriptWrappableBase, RemotePlayback>::value,
    "RemotePlayback does not inherit from ActiveScriptWrappable<>, but specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");
static_assert(
    !std::is_same<decltype(&RemotePlayback::HasPendingActivity),
                  decltype(&ScriptWrappable::HasPendingActivity)>::value,
    "RemotePlayback is not overriding hasPendingActivity(), but is specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");

namespace RemotePlaybackV8Internal {

static void stateAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  RemotePlayback* impl = V8RemotePlayback::toImpl(holder);

  V8SetReturnValueString(info, impl->state(), info.GetIsolate());
}

static void onconnectingAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  RemotePlayback* impl = V8RemotePlayback::toImpl(holder);

  EventListener* cppValue(WTF::GetPtr(impl->onconnecting()));

  V8SetReturnValue(info, cppValue ? V8AbstractEventListener::Cast(cppValue)->GetListenerOrNull(info.GetIsolate(), impl->GetExecutionContext()) : v8::Null(info.GetIsolate()).As<v8::Value>());
}

static void onconnectingAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  RemotePlayback* impl = V8RemotePlayback::toImpl(holder);

  // Prepare the value to be set.
  MoveEventListenerToNewWrapper(isolate, holder, impl->onconnecting(), v8Value, V8RemotePlayback::eventListenerCacheIndex);

  impl->setOnconnecting(V8EventListenerHelper::GetEventListener(ScriptState::ForReceiverObject(info), v8Value, true, kListenerFindOrCreate));
}

static void onconnectAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  RemotePlayback* impl = V8RemotePlayback::toImpl(holder);

  EventListener* cppValue(WTF::GetPtr(impl->onconnect()));

  V8SetReturnValue(info, cppValue ? V8AbstractEventListener::Cast(cppValue)->GetListenerOrNull(info.GetIsolate(), impl->GetExecutionContext()) : v8::Null(info.GetIsolate()).As<v8::Value>());
}

static void onconnectAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  RemotePlayback* impl = V8RemotePlayback::toImpl(holder);

  // Prepare the value to be set.
  MoveEventListenerToNewWrapper(isolate, holder, impl->onconnect(), v8Value, V8RemotePlayback::eventListenerCacheIndex);

  impl->setOnconnect(V8EventListenerHelper::GetEventListener(ScriptState::ForReceiverObject(info), v8Value, true, kListenerFindOrCreate));
}

static void ondisconnectAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  RemotePlayback* impl = V8RemotePlayback::toImpl(holder);

  EventListener* cppValue(WTF::GetPtr(impl->ondisconnect()));

  V8SetReturnValue(info, cppValue ? V8AbstractEventListener::Cast(cppValue)->GetListenerOrNull(info.GetIsolate(), impl->GetExecutionContext()) : v8::Null(info.GetIsolate()).As<v8::Value>());
}

static void ondisconnectAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  RemotePlayback* impl = V8RemotePlayback::toImpl(holder);

  // Prepare the value to be set.
  MoveEventListenerToNewWrapper(isolate, holder, impl->ondisconnect(), v8Value, V8RemotePlayback::eventListenerCacheIndex);

  impl->setOndisconnect(V8EventListenerHelper::GetEventListener(ScriptState::ForReceiverObject(info), v8Value, true, kListenerFindOrCreate));
}

static void watchAvailabilityMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::kExecutionContext, "RemotePlayback", "watchAvailability");
  ExceptionToRejectPromiseScope rejectPromiseScope(info, exceptionState);

  // V8DOMConfiguration::kDoNotCheckHolder
  // Make sure that info.Holder() really points to an instance of the type.
  if (!V8RemotePlayback::hasInstance(info.Holder(), info.GetIsolate())) {
    exceptionState.ThrowTypeError("Illegal invocation");
    return;
  }
  RemotePlayback* impl = V8RemotePlayback::toImpl(info.Holder());

  ScriptState* scriptState = ScriptState::ForReceiverObject(info);

  if (UNLIKELY(info.Length() < 1)) {
    exceptionState.ThrowTypeError(ExceptionMessages::NotEnoughArguments(1, info.Length()));
    return;
  }

  RemotePlaybackAvailabilityCallback* callback;
  if (!(info[0]->IsObject() && v8::Local<v8::Object>::Cast(info[0])->IsCallable())) {
    exceptionState.ThrowTypeError("The callback provided as parameter 1 is not a function.");

    return;
  }
  callback = RemotePlaybackAvailabilityCallback::Create(ScriptState::Current(info.GetIsolate()), info[0]);

  ScriptPromise result = impl->watchAvailability(scriptState, callback);
  V8SetReturnValue(info, result.V8Value());
}

static void cancelWatchAvailabilityMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::kExecutionContext, "RemotePlayback", "cancelWatchAvailability");
  ExceptionToRejectPromiseScope rejectPromiseScope(info, exceptionState);

  // V8DOMConfiguration::kDoNotCheckHolder
  // Make sure that info.Holder() really points to an instance of the type.
  if (!V8RemotePlayback::hasInstance(info.Holder(), info.GetIsolate())) {
    exceptionState.ThrowTypeError("Illegal invocation");
    return;
  }
  RemotePlayback* impl = V8RemotePlayback::toImpl(info.Holder());

  ScriptState* scriptState = ScriptState::ForReceiverObject(info);

  int32_t id;
  int numArgsPassed = info.Length();
  while (numArgsPassed > 0) {
    if (!info[numArgsPassed - 1]->IsUndefined())
      break;
    --numArgsPassed;
  }
  if (UNLIKELY(numArgsPassed <= 0)) {
    ScriptPromise result = impl->cancelWatchAvailability(scriptState);
    V8SetReturnValue(info, result.V8Value());
    return;
  }
  id = NativeValueTraits<IDLLong>::NativeValue(info.GetIsolate(), info[0], exceptionState, kNormalConversion);
  if (exceptionState.HadException())
    return;

  ScriptPromise result = impl->cancelWatchAvailability(scriptState, id);
  V8SetReturnValue(info, result.V8Value());
}

static void promptMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::kExecutionContext, "RemotePlayback", "prompt");
  ExceptionToRejectPromiseScope rejectPromiseScope(info, exceptionState);

  // V8DOMConfiguration::kDoNotCheckHolder
  // Make sure that info.Holder() really points to an instance of the type.
  if (!V8RemotePlayback::hasInstance(info.Holder(), info.GetIsolate())) {
    exceptionState.ThrowTypeError("Illegal invocation");
    return;
  }
  RemotePlayback* impl = V8RemotePlayback::toImpl(info.Holder());

  ScriptState* scriptState = ScriptState::ForReceiverObject(info);

  ScriptPromise result = impl->prompt(scriptState);
  V8SetReturnValue(info, result.V8Value());
}

} // namespace RemotePlaybackV8Internal

void V8RemotePlayback::stateAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  RemotePlaybackV8Internal::stateAttributeGetter(info);
}

void V8RemotePlayback::onconnectingAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  RemotePlaybackV8Internal::onconnectingAttributeGetter(info);
}

void V8RemotePlayback::onconnectingAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  RemotePlaybackV8Internal::onconnectingAttributeSetter(v8Value, info);
}

void V8RemotePlayback::onconnectAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  RemotePlaybackV8Internal::onconnectAttributeGetter(info);
}

void V8RemotePlayback::onconnectAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  RemotePlaybackV8Internal::onconnectAttributeSetter(v8Value, info);
}

void V8RemotePlayback::ondisconnectAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  RemotePlaybackV8Internal::ondisconnectAttributeGetter(info);
}

void V8RemotePlayback::ondisconnectAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Value> v8Value = info[0];

  RemotePlaybackV8Internal::ondisconnectAttributeSetter(v8Value, info);
}

void V8RemotePlayback::watchAvailabilityMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  RemotePlaybackV8Internal::watchAvailabilityMethod(info);
}

void V8RemotePlayback::cancelWatchAvailabilityMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  RemotePlaybackV8Internal::cancelWatchAvailabilityMethod(info);
}

void V8RemotePlayback::promptMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  RemotePlaybackV8Internal::promptMethod(info);
}

static const V8DOMConfiguration::AccessorConfiguration V8RemotePlaybackAccessors[] = {
    { "state", V8RemotePlayback::stateAttributeGetterCallback, nullptr, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "onconnecting", V8RemotePlayback::onconnectingAttributeGetterCallback, V8RemotePlayback::onconnectingAttributeSetterCallback, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "onconnect", V8RemotePlayback::onconnectAttributeGetterCallback, V8RemotePlayback::onconnectAttributeSetterCallback, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "ondisconnect", V8RemotePlayback::ondisconnectAttributeGetterCallback, V8RemotePlayback::ondisconnectAttributeSetterCallback, nullptr, nullptr, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },
};

static const V8DOMConfiguration::MethodConfiguration V8RemotePlaybackMethods[] = {
    {"watchAvailability", V8RemotePlayback::watchAvailabilityMethodCallback, 1, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kDoNotCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
    {"cancelWatchAvailability", V8RemotePlayback::cancelWatchAvailabilityMethodCallback, 0, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kDoNotCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
    {"prompt", V8RemotePlayback::promptMethodCallback, 0, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kDoNotCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
};

static void installV8RemotePlaybackTemplate(
    v8::Isolate* isolate,
    const DOMWrapperWorld& world,
    v8::Local<v8::FunctionTemplate> interfaceTemplate) {
  // Initialize the interface object's template.
  V8DOMConfiguration::InitializeDOMInterfaceTemplate(isolate, interfaceTemplate, V8RemotePlayback::wrapperTypeInfo.interface_name, V8EventTarget::domTemplate(isolate, world), V8RemotePlayback::internalFieldCount);

  if (!RuntimeEnabledFeatures::RemotePlaybackEnabled()) {
    return;
  }

  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interfaceTemplate);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instanceTemplate = interfaceTemplate->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instanceTemplate);
  v8::Local<v8::ObjectTemplate> prototypeTemplate = interfaceTemplate->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototypeTemplate);

  // Register IDL constants, attributes and operations.
  V8DOMConfiguration::InstallAccessors(
      isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate,
      signature, V8RemotePlaybackAccessors, WTF_ARRAY_LENGTH(V8RemotePlaybackAccessors));
  V8DOMConfiguration::InstallMethods(
      isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate,
      signature, V8RemotePlaybackMethods, WTF_ARRAY_LENGTH(V8RemotePlaybackMethods));

  // Custom signature

  V8RemotePlayback::InstallRuntimeEnabledFeaturesOnTemplate(
      isolate, world, interfaceTemplate);
}

void V8RemotePlayback::InstallRuntimeEnabledFeaturesOnTemplate(
    v8::Isolate* isolate,
    const DOMWrapperWorld& world,
    v8::Local<v8::FunctionTemplate> interface_template) {
  if (!RuntimeEnabledFeatures::RemotePlaybackEnabled()) {
    return;
  }

  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interface_template);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instance_template = interface_template->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instance_template);
  v8::Local<v8::ObjectTemplate> prototype_template = interface_template->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototype_template);

  // Register IDL constants, attributes and operations.

  // Custom signature
}

v8::Local<v8::FunctionTemplate> V8RemotePlayback::domTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world) {
  return V8DOMConfiguration::DomClassTemplate(isolate, world, const_cast<WrapperTypeInfo*>(&wrapperTypeInfo), installV8RemotePlaybackTemplate);
}

bool V8RemotePlayback::hasInstance(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->HasInstance(&wrapperTypeInfo, v8Value);
}

v8::Local<v8::Object> V8RemotePlayback::findInstanceInPrototypeChain(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindInstanceInPrototypeChain(&wrapperTypeInfo, v8Value);
}

RemotePlayback* V8RemotePlayback::toImplWithTypeCheck(v8::Isolate* isolate, v8::Local<v8::Value> value) {
  return hasInstance(value, isolate) ? toImpl(v8::Local<v8::Object>::Cast(value)) : nullptr;
}

RemotePlayback* NativeValueTraits<RemotePlayback>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  RemotePlayback* nativeValue = V8RemotePlayback::toImplWithTypeCheck(isolate, value);
  if (!nativeValue) {
    exceptionState.ThrowTypeError(ExceptionMessages::FailedToConvertJSValue(
        "RemotePlayback"));
  }
  return nativeValue;
}

}  // namespace blink
