// Copyright 2017 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Generated from template:
//   /ProbeSink.h.tmpl
// and input files:
//   CoreProbes.pidl



#ifndef CoreProbeSink_h
#define CoreProbeSink_h

#include "platform/heap/HeapAllocator.h"

namespace blink {

class InspectorApplicationCacheAgent;
class InspectorLogAgent;
class InspectorDOMAgent;
class InspectorTracingAgent;
class InspectorTraceEvents;
class InspectorWorkerAgent;
class InspectorLayerTreeAgent;
class InspectorAnimationAgent;
class PerformanceMonitor;
class InspectorDOMDebuggerAgent;
class InspectorPageAgent;
class InspectorCSSAgent;
class InspectorNetworkAgent;

class CORE_EXPORT CoreProbeSink : public GarbageCollected<CoreProbeSink> {
  WTF_MAKE_NONCOPYABLE(CoreProbeSink);

 public:
  CoreProbeSink();
  DECLARE_TRACE();

  bool hasInspectorApplicationCacheAgents() const { return m_hasInspectorApplicationCacheAgents; }
  const HeapHashSet<Member<InspectorApplicationCacheAgent>>& inspectorApplicationCacheAgents() const { return m_inspectorApplicationCacheAgents; }
  void addInspectorApplicationCacheAgent(InspectorApplicationCacheAgent* agent);
  void removeInspectorApplicationCacheAgent(InspectorApplicationCacheAgent* agent);

  bool hasInspectorLogAgents() const { return m_hasInspectorLogAgents; }
  const HeapHashSet<Member<InspectorLogAgent>>& inspectorLogAgents() const { return m_inspectorLogAgents; }
  void addInspectorLogAgent(InspectorLogAgent* agent);
  void removeInspectorLogAgent(InspectorLogAgent* agent);

  bool hasInspectorDOMAgents() const { return m_hasInspectorDOMAgents; }
  const HeapHashSet<Member<InspectorDOMAgent>>& inspectorDOMAgents() const { return m_inspectorDOMAgents; }
  void addInspectorDOMAgent(InspectorDOMAgent* agent);
  void removeInspectorDOMAgent(InspectorDOMAgent* agent);

  bool hasInspectorTracingAgents() const { return m_hasInspectorTracingAgents; }
  const HeapHashSet<Member<InspectorTracingAgent>>& inspectorTracingAgents() const { return m_inspectorTracingAgents; }
  void addInspectorTracingAgent(InspectorTracingAgent* agent);
  void removeInspectorTracingAgent(InspectorTracingAgent* agent);

  bool hasInspectorTraceEventss() const { return m_hasInspectorTraceEventss; }
  const HeapHashSet<Member<InspectorTraceEvents>>& inspectorTraceEventss() const { return m_inspectorTraceEventss; }
  void addInspectorTraceEvents(InspectorTraceEvents* agent);
  void removeInspectorTraceEvents(InspectorTraceEvents* agent);

  bool hasInspectorWorkerAgents() const { return m_hasInspectorWorkerAgents; }
  const HeapHashSet<Member<InspectorWorkerAgent>>& inspectorWorkerAgents() const { return m_inspectorWorkerAgents; }
  void addInspectorWorkerAgent(InspectorWorkerAgent* agent);
  void removeInspectorWorkerAgent(InspectorWorkerAgent* agent);

  bool hasInspectorLayerTreeAgents() const { return m_hasInspectorLayerTreeAgents; }
  const HeapHashSet<Member<InspectorLayerTreeAgent>>& inspectorLayerTreeAgents() const { return m_inspectorLayerTreeAgents; }
  void addInspectorLayerTreeAgent(InspectorLayerTreeAgent* agent);
  void removeInspectorLayerTreeAgent(InspectorLayerTreeAgent* agent);

  bool hasInspectorAnimationAgents() const { return m_hasInspectorAnimationAgents; }
  const HeapHashSet<Member<InspectorAnimationAgent>>& inspectorAnimationAgents() const { return m_inspectorAnimationAgents; }
  void addInspectorAnimationAgent(InspectorAnimationAgent* agent);
  void removeInspectorAnimationAgent(InspectorAnimationAgent* agent);

  bool hasPerformanceMonitors() const { return m_hasPerformanceMonitors; }
  const HeapHashSet<Member<PerformanceMonitor>>& performanceMonitors() const { return m_performanceMonitors; }
  void addPerformanceMonitor(PerformanceMonitor* agent);
  void removePerformanceMonitor(PerformanceMonitor* agent);

  bool hasInspectorDOMDebuggerAgents() const { return m_hasInspectorDOMDebuggerAgents; }
  const HeapHashSet<Member<InspectorDOMDebuggerAgent>>& inspectorDOMDebuggerAgents() const { return m_inspectorDOMDebuggerAgents; }
  void addInspectorDOMDebuggerAgent(InspectorDOMDebuggerAgent* agent);
  void removeInspectorDOMDebuggerAgent(InspectorDOMDebuggerAgent* agent);

  bool hasInspectorPageAgents() const { return m_hasInspectorPageAgents; }
  const HeapHashSet<Member<InspectorPageAgent>>& inspectorPageAgents() const { return m_inspectorPageAgents; }
  void addInspectorPageAgent(InspectorPageAgent* agent);
  void removeInspectorPageAgent(InspectorPageAgent* agent);

  bool hasInspectorCSSAgents() const { return m_hasInspectorCSSAgents; }
  const HeapHashSet<Member<InspectorCSSAgent>>& inspectorCSSAgents() const { return m_inspectorCSSAgents; }
  void addInspectorCSSAgent(InspectorCSSAgent* agent);
  void removeInspectorCSSAgent(InspectorCSSAgent* agent);

  bool hasInspectorNetworkAgents() const { return m_hasInspectorNetworkAgents; }
  const HeapHashSet<Member<InspectorNetworkAgent>>& inspectorNetworkAgents() const { return m_inspectorNetworkAgents; }
  void addInspectorNetworkAgent(InspectorNetworkAgent* agent);
  void removeInspectorNetworkAgent(InspectorNetworkAgent* agent);

 private:
  HeapHashSet<Member<InspectorApplicationCacheAgent>> m_inspectorApplicationCacheAgents;
  bool m_hasInspectorApplicationCacheAgents = false;
  HeapHashSet<Member<InspectorLogAgent>> m_inspectorLogAgents;
  bool m_hasInspectorLogAgents = false;
  HeapHashSet<Member<InspectorDOMAgent>> m_inspectorDOMAgents;
  bool m_hasInspectorDOMAgents = false;
  HeapHashSet<Member<InspectorTracingAgent>> m_inspectorTracingAgents;
  bool m_hasInspectorTracingAgents = false;
  HeapHashSet<Member<InspectorTraceEvents>> m_inspectorTraceEventss;
  bool m_hasInspectorTraceEventss = false;
  HeapHashSet<Member<InspectorWorkerAgent>> m_inspectorWorkerAgents;
  bool m_hasInspectorWorkerAgents = false;
  HeapHashSet<Member<InspectorLayerTreeAgent>> m_inspectorLayerTreeAgents;
  bool m_hasInspectorLayerTreeAgents = false;
  HeapHashSet<Member<InspectorAnimationAgent>> m_inspectorAnimationAgents;
  bool m_hasInspectorAnimationAgents = false;
  HeapHashSet<Member<PerformanceMonitor>> m_performanceMonitors;
  bool m_hasPerformanceMonitors = false;
  HeapHashSet<Member<InspectorDOMDebuggerAgent>> m_inspectorDOMDebuggerAgents;
  bool m_hasInspectorDOMDebuggerAgents = false;
  HeapHashSet<Member<InspectorPageAgent>> m_inspectorPageAgents;
  bool m_hasInspectorPageAgents = false;
  HeapHashSet<Member<InspectorCSSAgent>> m_inspectorCSSAgents;
  bool m_hasInspectorCSSAgents = false;
  HeapHashSet<Member<InspectorNetworkAgent>> m_inspectorNetworkAgents;
  bool m_hasInspectorNetworkAgents = false;
};

} // namespace blink

#endif // !defined(CoreProbeSink_h)
