// Copyright 2017 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Generated from template:
//   /InstrumentingProbesImpl.cpp.tmpl
// and input files:
//   CoreProbes.pidl


#include "CoreProbesInl.h"
#include "CoreProbeSink.h"
#include "core/inspector/InspectorApplicationCacheAgent.h"
#include "core/inspector/InspectorLogAgent.h"
#include "core/inspector/InspectorDOMAgent.h"
#include "core/inspector/InspectorTracingAgent.h"
#include "core/inspector/InspectorTraceEvents.h"
#include "core/inspector/InspectorWorkerAgent.h"
#include "core/inspector/InspectorLayerTreeAgent.h"
#include "core/inspector/InspectorAnimationAgent.h"
#include "core/frame/PerformanceMonitor.h"
#include "core/inspector/InspectorDOMDebuggerAgent.h"
#include "core/inspector/InspectorPageAgent.h"
#include "core/inspector/InspectorCSSAgent.h"
#include "core/inspector/InspectorNetworkAgent.h"

namespace blink {

CoreProbeSink::CoreProbeSink() {}

void CoreProbeSink::addInspectorApplicationCacheAgent(InspectorApplicationCacheAgent* agent) {
  m_inspectorApplicationCacheAgents.insert(agent);
  m_hasInspectorApplicationCacheAgents = true;
}

void CoreProbeSink::removeInspectorApplicationCacheAgent(InspectorApplicationCacheAgent* agent) {
  m_inspectorApplicationCacheAgents.erase(agent);
  m_hasInspectorApplicationCacheAgents = !m_inspectorApplicationCacheAgents.IsEmpty();
}

void CoreProbeSink::addInspectorLogAgent(InspectorLogAgent* agent) {
  m_inspectorLogAgents.insert(agent);
  m_hasInspectorLogAgents = true;
}

void CoreProbeSink::removeInspectorLogAgent(InspectorLogAgent* agent) {
  m_inspectorLogAgents.erase(agent);
  m_hasInspectorLogAgents = !m_inspectorLogAgents.IsEmpty();
}

void CoreProbeSink::addInspectorDOMAgent(InspectorDOMAgent* agent) {
  m_inspectorDOMAgents.insert(agent);
  m_hasInspectorDOMAgents = true;
}

void CoreProbeSink::removeInspectorDOMAgent(InspectorDOMAgent* agent) {
  m_inspectorDOMAgents.erase(agent);
  m_hasInspectorDOMAgents = !m_inspectorDOMAgents.IsEmpty();
}

void CoreProbeSink::addInspectorTracingAgent(InspectorTracingAgent* agent) {
  m_inspectorTracingAgents.insert(agent);
  m_hasInspectorTracingAgents = true;
}

void CoreProbeSink::removeInspectorTracingAgent(InspectorTracingAgent* agent) {
  m_inspectorTracingAgents.erase(agent);
  m_hasInspectorTracingAgents = !m_inspectorTracingAgents.IsEmpty();
}

void CoreProbeSink::addInspectorTraceEvents(InspectorTraceEvents* agent) {
  m_inspectorTraceEventss.insert(agent);
  m_hasInspectorTraceEventss = true;
}

void CoreProbeSink::removeInspectorTraceEvents(InspectorTraceEvents* agent) {
  m_inspectorTraceEventss.erase(agent);
  m_hasInspectorTraceEventss = !m_inspectorTraceEventss.IsEmpty();
}

void CoreProbeSink::addInspectorWorkerAgent(InspectorWorkerAgent* agent) {
  m_inspectorWorkerAgents.insert(agent);
  m_hasInspectorWorkerAgents = true;
}

void CoreProbeSink::removeInspectorWorkerAgent(InspectorWorkerAgent* agent) {
  m_inspectorWorkerAgents.erase(agent);
  m_hasInspectorWorkerAgents = !m_inspectorWorkerAgents.IsEmpty();
}

void CoreProbeSink::addInspectorLayerTreeAgent(InspectorLayerTreeAgent* agent) {
  m_inspectorLayerTreeAgents.insert(agent);
  m_hasInspectorLayerTreeAgents = true;
}

void CoreProbeSink::removeInspectorLayerTreeAgent(InspectorLayerTreeAgent* agent) {
  m_inspectorLayerTreeAgents.erase(agent);
  m_hasInspectorLayerTreeAgents = !m_inspectorLayerTreeAgents.IsEmpty();
}

void CoreProbeSink::addInspectorAnimationAgent(InspectorAnimationAgent* agent) {
  m_inspectorAnimationAgents.insert(agent);
  m_hasInspectorAnimationAgents = true;
}

void CoreProbeSink::removeInspectorAnimationAgent(InspectorAnimationAgent* agent) {
  m_inspectorAnimationAgents.erase(agent);
  m_hasInspectorAnimationAgents = !m_inspectorAnimationAgents.IsEmpty();
}

void CoreProbeSink::addPerformanceMonitor(PerformanceMonitor* agent) {
  m_performanceMonitors.insert(agent);
  m_hasPerformanceMonitors = true;
}

void CoreProbeSink::removePerformanceMonitor(PerformanceMonitor* agent) {
  m_performanceMonitors.erase(agent);
  m_hasPerformanceMonitors = !m_performanceMonitors.IsEmpty();
}

void CoreProbeSink::addInspectorDOMDebuggerAgent(InspectorDOMDebuggerAgent* agent) {
  m_inspectorDOMDebuggerAgents.insert(agent);
  m_hasInspectorDOMDebuggerAgents = true;
}

void CoreProbeSink::removeInspectorDOMDebuggerAgent(InspectorDOMDebuggerAgent* agent) {
  m_inspectorDOMDebuggerAgents.erase(agent);
  m_hasInspectorDOMDebuggerAgents = !m_inspectorDOMDebuggerAgents.IsEmpty();
}

void CoreProbeSink::addInspectorPageAgent(InspectorPageAgent* agent) {
  m_inspectorPageAgents.insert(agent);
  m_hasInspectorPageAgents = true;
}

void CoreProbeSink::removeInspectorPageAgent(InspectorPageAgent* agent) {
  m_inspectorPageAgents.erase(agent);
  m_hasInspectorPageAgents = !m_inspectorPageAgents.IsEmpty();
}

void CoreProbeSink::addInspectorCSSAgent(InspectorCSSAgent* agent) {
  m_inspectorCSSAgents.insert(agent);
  m_hasInspectorCSSAgents = true;
}

void CoreProbeSink::removeInspectorCSSAgent(InspectorCSSAgent* agent) {
  m_inspectorCSSAgents.erase(agent);
  m_hasInspectorCSSAgents = !m_inspectorCSSAgents.IsEmpty();
}

void CoreProbeSink::addInspectorNetworkAgent(InspectorNetworkAgent* agent) {
  m_inspectorNetworkAgents.insert(agent);
  m_hasInspectorNetworkAgents = true;
}

void CoreProbeSink::removeInspectorNetworkAgent(InspectorNetworkAgent* agent) {
  m_inspectorNetworkAgents.erase(agent);
  m_hasInspectorNetworkAgents = !m_inspectorNetworkAgents.IsEmpty();
}

DEFINE_TRACE(CoreProbeSink)
{
  visitor->Trace(m_inspectorApplicationCacheAgents);
  visitor->Trace(m_inspectorLogAgents);
  visitor->Trace(m_inspectorDOMAgents);
  visitor->Trace(m_inspectorTracingAgents);
  visitor->Trace(m_inspectorTraceEventss);
  visitor->Trace(m_inspectorWorkerAgents);
  visitor->Trace(m_inspectorLayerTreeAgents);
  visitor->Trace(m_inspectorAnimationAgents);
  visitor->Trace(m_performanceMonitors);
  visitor->Trace(m_inspectorDOMDebuggerAgents);
  visitor->Trace(m_inspectorPageAgents);
  visitor->Trace(m_inspectorCSSAgents);
  visitor->Trace(m_inspectorNetworkAgents);
}

namespace probe {

CORE_EXPORT void didClearDocumentOfWindowObject(LocalFrame* paramLocalFrame) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramLocalFrame);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorAnimationAgents()) {
    for (InspectorAnimationAgent* agent : probe_sink->inspectorAnimationAgents())
      agent->DidClearDocumentOfWindowObject(paramLocalFrame);
  }
  if (probe_sink->hasInspectorPageAgents()) {
    for (InspectorPageAgent* agent : probe_sink->inspectorPageAgents())
      agent->DidClearDocumentOfWindowObject(paramLocalFrame);
  }
}

CORE_EXPORT void willInsertDOMNode(Node* parent) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(parent);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorDOMDebuggerAgents()) {
    for (InspectorDOMDebuggerAgent* agent : probe_sink->inspectorDOMDebuggerAgents())
      agent->WillInsertDOMNode(parent);
  }
}

CORE_EXPORT void didInsertDOMNode(Node* paramNode) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramNode);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorDOMDebuggerAgents()) {
    for (InspectorDOMDebuggerAgent* agent : probe_sink->inspectorDOMDebuggerAgents())
      agent->DidInsertDOMNode(paramNode);
  }
  if (probe_sink->hasInspectorDOMAgents()) {
    for (InspectorDOMAgent* agent : probe_sink->inspectorDOMAgents())
      agent->DidInsertDOMNode(paramNode);
  }
}

CORE_EXPORT void willRemoveDOMNode(Node* paramNode) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramNode);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorDOMDebuggerAgents()) {
    for (InspectorDOMDebuggerAgent* agent : probe_sink->inspectorDOMDebuggerAgents())
      agent->WillRemoveDOMNode(paramNode);
  }
  if (probe_sink->hasInspectorDOMAgents()) {
    for (InspectorDOMAgent* agent : probe_sink->inspectorDOMAgents())
      agent->WillRemoveDOMNode(paramNode);
  }
}

CORE_EXPORT void willModifyDOMAttr(Element* paramElement, const AtomicString& oldValue, const AtomicString& newValue) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramElement);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorDOMDebuggerAgents()) {
    for (InspectorDOMDebuggerAgent* agent : probe_sink->inspectorDOMDebuggerAgents())
      agent->WillModifyDOMAttr(paramElement, oldValue, newValue);
  }
  if (probe_sink->hasInspectorDOMAgents()) {
    for (InspectorDOMAgent* agent : probe_sink->inspectorDOMAgents())
      agent->WillModifyDOMAttr(paramElement, oldValue, newValue);
  }
}

CORE_EXPORT void didModifyDOMAttr(Element* paramElement, const QualifiedName& name, const AtomicString& value) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramElement);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorDOMAgents()) {
    for (InspectorDOMAgent* agent : probe_sink->inspectorDOMAgents())
      agent->DidModifyDOMAttr(paramElement, name, value);
  }
}

CORE_EXPORT void didRemoveDOMAttr(Element* paramElement, const QualifiedName& name) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramElement);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorDOMAgents()) {
    for (InspectorDOMAgent* agent : probe_sink->inspectorDOMAgents())
      agent->DidRemoveDOMAttr(paramElement, name);
  }
}

CORE_EXPORT void characterDataModified(CharacterData* paramCharacterData) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramCharacterData);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorDOMAgents()) {
    for (InspectorDOMAgent* agent : probe_sink->inspectorDOMAgents())
      agent->CharacterDataModified(paramCharacterData);
  }
}

CORE_EXPORT void didInvalidateStyleAttr(Node* paramNode) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramNode);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorDOMDebuggerAgents()) {
    for (InspectorDOMDebuggerAgent* agent : probe_sink->inspectorDOMDebuggerAgents())
      agent->DidInvalidateStyleAttr(paramNode);
  }
  if (probe_sink->hasInspectorDOMAgents()) {
    for (InspectorDOMAgent* agent : probe_sink->inspectorDOMAgents())
      agent->DidInvalidateStyleAttr(paramNode);
  }
}

CORE_EXPORT void didPerformElementShadowDistribution(Element* paramElement) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramElement);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorDOMAgents()) {
    for (InspectorDOMAgent* agent : probe_sink->inspectorDOMAgents())
      agent->DidPerformElementShadowDistribution(paramElement);
  }
}

CORE_EXPORT void didPerformSlotDistribution(HTMLSlotElement* paramHTMLSlotElement) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramHTMLSlotElement);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorDOMAgents()) {
    for (InspectorDOMAgent* agent : probe_sink->inspectorDOMAgents())
      agent->DidPerformSlotDistribution(paramHTMLSlotElement);
  }
}

CORE_EXPORT void documentDetached(Document* paramDocument) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramDocument);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorCSSAgents()) {
    for (InspectorCSSAgent* agent : probe_sink->inspectorCSSAgents())
      agent->DocumentDetached(paramDocument);
  }
}

CORE_EXPORT void activeStyleSheetsUpdated(Document* paramDocument) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramDocument);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorCSSAgents()) {
    for (InspectorCSSAgent* agent : probe_sink->inspectorCSSAgents())
      agent->ActiveStyleSheetsUpdated(paramDocument);
  }
}

CORE_EXPORT void fontsUpdated(Document* paramDocument) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramDocument);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorCSSAgents()) {
    for (InspectorCSSAgent* agent : probe_sink->inspectorCSSAgents())
      agent->FontsUpdated();
  }
}

CORE_EXPORT void mediaQueryResultChanged(Document* paramDocument) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramDocument);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorCSSAgents()) {
    for (InspectorCSSAgent* agent : probe_sink->inspectorCSSAgents())
      agent->MediaQueryResultChanged();
  }
}

CORE_EXPORT void didPushShadowRoot(Element* host, ShadowRoot* paramShadowRoot) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(host);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorDOMAgents()) {
    for (InspectorDOMAgent* agent : probe_sink->inspectorDOMAgents())
      agent->DidPushShadowRoot(host, paramShadowRoot);
  }
}

CORE_EXPORT void willPopShadowRoot(Element* host, ShadowRoot* paramShadowRoot) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(host);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorDOMAgents()) {
    for (InspectorDOMAgent* agent : probe_sink->inspectorDOMAgents())
      agent->WillPopShadowRoot(host, paramShadowRoot);
  }
}

CORE_EXPORT void willSendXMLHttpOrFetchNetworkRequest(ExecutionContext* paramExecutionContext, const String& url) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramExecutionContext);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorDOMDebuggerAgents()) {
    for (InspectorDOMDebuggerAgent* agent : probe_sink->inspectorDOMDebuggerAgents())
      agent->WillSendXMLHttpOrFetchNetworkRequest(url);
  }
}

CORE_EXPORT void didCreateCanvasContext(Document* paramDocument) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramDocument);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorDOMDebuggerAgents()) {
    for (InspectorDOMDebuggerAgent* agent : probe_sink->inspectorDOMDebuggerAgents())
      agent->DidCreateCanvasContext();
  }
}

CORE_EXPORT void didFireWebGLError(Element* paramElement, const String& errorName) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramElement);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorDOMDebuggerAgents()) {
    for (InspectorDOMDebuggerAgent* agent : probe_sink->inspectorDOMDebuggerAgents())
      agent->DidFireWebGLError(errorName);
  }
}

CORE_EXPORT void didFireWebGLWarning(Element* paramElement) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramElement);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorDOMDebuggerAgents()) {
    for (InspectorDOMDebuggerAgent* agent : probe_sink->inspectorDOMDebuggerAgents())
      agent->DidFireWebGLWarning();
  }
}

CORE_EXPORT void didFireWebGLErrorOrWarning(Element* paramElement, const String& message) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramElement);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorDOMDebuggerAgents()) {
    for (InspectorDOMDebuggerAgent* agent : probe_sink->inspectorDOMDebuggerAgents())
      agent->DidFireWebGLErrorOrWarning(message);
  }
}

CORE_EXPORT void didResizeMainFrame(LocalFrame* paramLocalFrame) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramLocalFrame);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorPageAgents()) {
    for (InspectorPageAgent* agent : probe_sink->inspectorPageAgents())
      agent->DidResizeMainFrame();
  }
}

CORE_EXPORT void didPaint(LocalFrame* paramLocalFrame, const GraphicsLayer* paramGraphicsLayer, GraphicsContext& paramGraphicsContext, const LayoutRect& paramLayoutRect) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramLocalFrame);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorLayerTreeAgents()) {
    for (InspectorLayerTreeAgent* agent : probe_sink->inspectorLayerTreeAgents())
      agent->DidPaint(paramGraphicsLayer, paramGraphicsContext, paramLayoutRect);
  }
}

CORE_EXPORT void applyUserAgentOverride(ExecutionContext* paramExecutionContext, String* userAgent) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramExecutionContext);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorNetworkAgents()) {
    for (InspectorNetworkAgent* agent : probe_sink->inspectorNetworkAgents())
      agent->ApplyUserAgentOverride(userAgent);
  }
}

CORE_EXPORT void didBlockRequest(ExecutionContext* paramExecutionContext, const ResourceRequest& paramResourceRequest, DocumentLoader* paramDocumentLoader, const FetchInitiatorInfo& paramFetchInitiatorInfo, ResourceRequestBlockedReason paramResourceRequestBlockedReason) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramExecutionContext);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorNetworkAgents()) {
    for (InspectorNetworkAgent* agent : probe_sink->inspectorNetworkAgents())
      agent->DidBlockRequest(paramExecutionContext, paramResourceRequest, paramDocumentLoader, paramFetchInitiatorInfo, paramResourceRequestBlockedReason);
  }
}

CORE_EXPORT void didChangeResourcePriority(LocalFrame* paramLocalFrame, unsigned long identifier, ResourceLoadPriority loadPriority) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramLocalFrame);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorNetworkAgents()) {
    for (InspectorNetworkAgent* agent : probe_sink->inspectorNetworkAgents())
      agent->DidChangeResourcePriority(identifier, loadPriority);
  }
}

CORE_EXPORT void willSendRequest(ExecutionContext* paramExecutionContext, unsigned long identifier, DocumentLoader* paramDocumentLoader, ResourceRequest& paramResourceRequest, const ResourceResponse& redirectResponse, const FetchInitiatorInfo& paramFetchInitiatorInfo) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramExecutionContext);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorTraceEventss()) {
    for (InspectorTraceEvents* agent : probe_sink->inspectorTraceEventss())
      agent->WillSendRequest(paramExecutionContext, identifier, paramDocumentLoader, paramResourceRequest, redirectResponse, paramFetchInitiatorInfo);
  }
  if (probe_sink->hasInspectorNetworkAgents()) {
    for (InspectorNetworkAgent* agent : probe_sink->inspectorNetworkAgents())
      agent->WillSendRequest(paramExecutionContext, identifier, paramDocumentLoader, paramResourceRequest, redirectResponse, paramFetchInitiatorInfo);
  }
}

CORE_EXPORT void markResourceAsCached(LocalFrame* paramLocalFrame, unsigned long identifier) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramLocalFrame);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorNetworkAgents()) {
    for (InspectorNetworkAgent* agent : probe_sink->inspectorNetworkAgents())
      agent->MarkResourceAsCached(identifier);
  }
}

CORE_EXPORT void didReceiveResourceResponse(ExecutionContext* paramExecutionContext, unsigned long identifier, DocumentLoader* paramDocumentLoader, const ResourceResponse& paramResourceResponse, Resource* paramResource) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramExecutionContext);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorTraceEventss()) {
    for (InspectorTraceEvents* agent : probe_sink->inspectorTraceEventss())
      agent->DidReceiveResourceResponse(identifier, paramDocumentLoader, paramResourceResponse, paramResource);
  }
  if (probe_sink->hasInspectorNetworkAgents()) {
    for (InspectorNetworkAgent* agent : probe_sink->inspectorNetworkAgents())
      agent->DidReceiveResourceResponse(identifier, paramDocumentLoader, paramResourceResponse, paramResource);
  }
}

CORE_EXPORT void didReceiveData(ExecutionContext* paramExecutionContext, unsigned long identifier, DocumentLoader* paramDocumentLoader, const char* data, int dataLength) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramExecutionContext);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorTraceEventss()) {
    for (InspectorTraceEvents* agent : probe_sink->inspectorTraceEventss())
      agent->DidReceiveData(identifier, paramDocumentLoader, data, dataLength);
  }
  if (probe_sink->hasInspectorNetworkAgents()) {
    for (InspectorNetworkAgent* agent : probe_sink->inspectorNetworkAgents())
      agent->DidReceiveData(identifier, paramDocumentLoader, data, dataLength);
  }
}

CORE_EXPORT void didReceiveEncodedDataLength(ExecutionContext* paramExecutionContext, unsigned long identifier, int encodedDataLength) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramExecutionContext);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorNetworkAgents()) {
    for (InspectorNetworkAgent* agent : probe_sink->inspectorNetworkAgents())
      agent->DidReceiveEncodedDataLength(identifier, encodedDataLength);
  }
}

CORE_EXPORT void didFinishLoading(ExecutionContext* paramExecutionContext, unsigned long identifier, DocumentLoader* paramDocumentLoader, double finishTime, int64_t encodedDataLength, int64_t decodedBodyLength) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramExecutionContext);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorTraceEventss()) {
    for (InspectorTraceEvents* agent : probe_sink->inspectorTraceEventss())
      agent->DidFinishLoading(identifier, paramDocumentLoader, finishTime, encodedDataLength, decodedBodyLength);
  }
  if (probe_sink->hasInspectorNetworkAgents()) {
    for (InspectorNetworkAgent* agent : probe_sink->inspectorNetworkAgents())
      agent->DidFinishLoading(identifier, paramDocumentLoader, finishTime, encodedDataLength, decodedBodyLength);
  }
}

CORE_EXPORT void didReceiveCORSRedirectResponse(LocalFrame* paramLocalFrame, unsigned long identifier, DocumentLoader* paramDocumentLoader, const ResourceResponse& paramResourceResponse, Resource* paramResource) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramLocalFrame);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorNetworkAgents()) {
    for (InspectorNetworkAgent* agent : probe_sink->inspectorNetworkAgents())
      agent->DidReceiveCORSRedirectResponse(paramLocalFrame, identifier, paramDocumentLoader, paramResourceResponse, paramResource);
  }
}

CORE_EXPORT void didFailLoading(ExecutionContext* paramExecutionContext, unsigned long identifier, const ResourceError& paramResourceError) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramExecutionContext);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorTraceEventss()) {
    for (InspectorTraceEvents* agent : probe_sink->inspectorTraceEventss())
      agent->DidFailLoading(identifier, paramResourceError);
  }
  if (probe_sink->hasInspectorNetworkAgents()) {
    for (InspectorNetworkAgent* agent : probe_sink->inspectorNetworkAgents())
      agent->DidFailLoading(identifier, paramResourceError);
  }
}

CORE_EXPORT void documentThreadableLoaderStartedLoadingForClient(ExecutionContext* paramExecutionContext, unsigned long identifier, ThreadableLoaderClient* client) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramExecutionContext);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorNetworkAgents()) {
    for (InspectorNetworkAgent* agent : probe_sink->inspectorNetworkAgents())
      agent->DocumentThreadableLoaderStartedLoadingForClient(identifier, client);
  }
}

CORE_EXPORT void documentThreadableLoaderFailedToStartLoadingForClient(ExecutionContext* paramExecutionContext, ThreadableLoaderClient* client) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramExecutionContext);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorNetworkAgents()) {
    for (InspectorNetworkAgent* agent : probe_sink->inspectorNetworkAgents())
      agent->DocumentThreadableLoaderFailedToStartLoadingForClient(client);
  }
}

CORE_EXPORT void willSendEventSourceRequest(ExecutionContext* paramExecutionContext, ThreadableLoaderClient* eventSource) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramExecutionContext);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorNetworkAgents()) {
    for (InspectorNetworkAgent* agent : probe_sink->inspectorNetworkAgents())
      agent->WillSendEventSourceRequest(eventSource);
  }
}

CORE_EXPORT void willDispatchEventSourceEvent(ExecutionContext* paramExecutionContext, ThreadableLoaderClient* eventSource, const AtomicString& eventName, const AtomicString& eventId, const String& data) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramExecutionContext);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorNetworkAgents()) {
    for (InspectorNetworkAgent* agent : probe_sink->inspectorNetworkAgents())
      agent->WillDispatchEventSourceEvent(eventSource, eventName, eventId, data);
  }
}

CORE_EXPORT void didFinishEventSourceRequest(ExecutionContext* paramExecutionContext, ThreadableLoaderClient* eventSource) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramExecutionContext);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorNetworkAgents()) {
    for (InspectorNetworkAgent* agent : probe_sink->inspectorNetworkAgents())
      agent->DidFinishEventSourceRequest(eventSource);
  }
}

CORE_EXPORT void willLoadXHR(ExecutionContext* paramExecutionContext, XMLHttpRequest* xhr, ThreadableLoaderClient* client, const AtomicString& method, const KURL& url, bool async, RefPtr<EncodedFormData> paramEncodedFormData, const HTTPHeaderMap& headers, bool includeCredentials) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramExecutionContext);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorNetworkAgents()) {
    for (InspectorNetworkAgent* agent : probe_sink->inspectorNetworkAgents())
      agent->WillLoadXHR(xhr, client, method, url, async, paramEncodedFormData, headers, includeCredentials);
  }
}

CORE_EXPORT void didFailXHRLoading(ExecutionContext* paramExecutionContext, XMLHttpRequest* xhr, ThreadableLoaderClient* client, const AtomicString& method, const String& url) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramExecutionContext);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorNetworkAgents()) {
    for (InspectorNetworkAgent* agent : probe_sink->inspectorNetworkAgents())
      agent->DidFailXHRLoading(paramExecutionContext, xhr, client, method, url);
  }
}

CORE_EXPORT void didFinishXHRLoading(ExecutionContext* paramExecutionContext, XMLHttpRequest* xhr, ThreadableLoaderClient* client, const AtomicString& method, const String& url) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramExecutionContext);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorNetworkAgents()) {
    for (InspectorNetworkAgent* agent : probe_sink->inspectorNetworkAgents())
      agent->DidFinishXHRLoading(paramExecutionContext, xhr, client, method, url);
  }
}

CORE_EXPORT void willStartFetch(ExecutionContext* paramExecutionContext, ThreadableLoaderClient* paramThreadableLoaderClient) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramExecutionContext);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorNetworkAgents()) {
    for (InspectorNetworkAgent* agent : probe_sink->inspectorNetworkAgents())
      agent->WillStartFetch(paramThreadableLoaderClient);
  }
}

CORE_EXPORT void didFailFetch(ExecutionContext* paramExecutionContext, ThreadableLoaderClient* paramThreadableLoaderClient) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramExecutionContext);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorNetworkAgents()) {
    for (InspectorNetworkAgent* agent : probe_sink->inspectorNetworkAgents())
      agent->DidFailFetch(paramThreadableLoaderClient);
  }
}

CORE_EXPORT void didFinishFetch(ExecutionContext* paramExecutionContext, ThreadableLoaderClient* paramThreadableLoaderClient, const AtomicString& method, const String& url) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramExecutionContext);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorNetworkAgents()) {
    for (InspectorNetworkAgent* agent : probe_sink->inspectorNetworkAgents())
      agent->DidFinishFetch(paramExecutionContext, paramThreadableLoaderClient, method, url);
  }
}

CORE_EXPORT void detachClientRequest(ExecutionContext* paramExecutionContext, ThreadableLoaderClient* paramThreadableLoaderClient) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramExecutionContext);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorNetworkAgents()) {
    for (InspectorNetworkAgent* agent : probe_sink->inspectorNetworkAgents())
      agent->DetachClientRequest(paramThreadableLoaderClient);
  }
}

CORE_EXPORT void scriptImported(ExecutionContext* paramExecutionContext, unsigned long identifier, const String& sourceString) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramExecutionContext);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorNetworkAgents()) {
    for (InspectorNetworkAgent* agent : probe_sink->inspectorNetworkAgents())
      agent->ScriptImported(identifier, sourceString);
  }
}

CORE_EXPORT void scriptExecutionBlockedByCSP(ExecutionContext* paramExecutionContext, const String& directiveText) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramExecutionContext);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorDOMDebuggerAgents()) {
    for (InspectorDOMDebuggerAgent* agent : probe_sink->inspectorDOMDebuggerAgents())
      agent->ScriptExecutionBlockedByCSP(directiveText);
  }
}

CORE_EXPORT void didReceiveScriptResponse(ExecutionContext* paramExecutionContext, unsigned long identifier) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramExecutionContext);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorNetworkAgents()) {
    for (InspectorNetworkAgent* agent : probe_sink->inspectorNetworkAgents())
      agent->DidReceiveScriptResponse(identifier);
  }
}

CORE_EXPORT void domContentLoadedEventFired(LocalFrame* paramLocalFrame) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramLocalFrame);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorPageAgents()) {
    for (InspectorPageAgent* agent : probe_sink->inspectorPageAgents())
      agent->DomContentLoadedEventFired(paramLocalFrame);
  }
  if (probe_sink->hasInspectorDOMAgents()) {
    for (InspectorDOMAgent* agent : probe_sink->inspectorDOMAgents())
      agent->DomContentLoadedEventFired(paramLocalFrame);
  }
}

CORE_EXPORT void loadEventFired(LocalFrame* paramLocalFrame) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramLocalFrame);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorPageAgents()) {
    for (InspectorPageAgent* agent : probe_sink->inspectorPageAgents())
      agent->LoadEventFired(paramLocalFrame);
  }
}

CORE_EXPORT void frameAttachedToParent(LocalFrame* paramLocalFrame) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramLocalFrame);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorPageAgents()) {
    for (InspectorPageAgent* agent : probe_sink->inspectorPageAgents())
      agent->FrameAttachedToParent(paramLocalFrame);
  }
}

CORE_EXPORT void frameDetachedFromParent(LocalFrame* paramLocalFrame) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramLocalFrame);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorPageAgents()) {
    for (InspectorPageAgent* agent : probe_sink->inspectorPageAgents())
      agent->FrameDetachedFromParent(paramLocalFrame);
  }
}

CORE_EXPORT void didCommitLoad(LocalFrame* paramLocalFrame, DocumentLoader* paramDocumentLoader) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramLocalFrame);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorNetworkAgents()) {
    for (InspectorNetworkAgent* agent : probe_sink->inspectorNetworkAgents())
      agent->DidCommitLoad(paramLocalFrame, paramDocumentLoader);
  }
  if (probe_sink->hasInspectorPageAgents()) {
    for (InspectorPageAgent* agent : probe_sink->inspectorPageAgents())
      agent->DidCommitLoad(paramLocalFrame, paramDocumentLoader);
  }
  if (probe_sink->hasInspectorDOMAgents()) {
    for (InspectorDOMAgent* agent : probe_sink->inspectorDOMAgents())
      agent->DidCommitLoad(paramLocalFrame, paramDocumentLoader);
  }
}

CORE_EXPORT void frameDocumentUpdated(LocalFrame* paramLocalFrame) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramLocalFrame);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorDOMAgents()) {
    for (InspectorDOMAgent* agent : probe_sink->inspectorDOMAgents())
      agent->FrameDocumentUpdated(paramLocalFrame);
  }
}

CORE_EXPORT void frameStartedLoading(LocalFrame* paramLocalFrame, FrameLoadType paramFrameLoadType) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramLocalFrame);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorTracingAgents()) {
    for (InspectorTracingAgent* agent : probe_sink->inspectorTracingAgents())
      agent->FrameStartedLoading(paramLocalFrame, paramFrameLoadType);
  }
  if (probe_sink->hasInspectorPageAgents()) {
    for (InspectorPageAgent* agent : probe_sink->inspectorPageAgents())
      agent->FrameStartedLoading(paramLocalFrame, paramFrameLoadType);
  }
}

CORE_EXPORT void frameStoppedLoading(LocalFrame* paramLocalFrame) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramLocalFrame);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorTracingAgents()) {
    for (InspectorTracingAgent* agent : probe_sink->inspectorTracingAgents())
      agent->FrameStoppedLoading(paramLocalFrame);
  }
  if (probe_sink->hasInspectorPageAgents()) {
    for (InspectorPageAgent* agent : probe_sink->inspectorPageAgents())
      agent->FrameStoppedLoading(paramLocalFrame);
  }
}

CORE_EXPORT void frameScheduledNavigation(LocalFrame* paramLocalFrame, double delay) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramLocalFrame);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorPageAgents()) {
    for (InspectorPageAgent* agent : probe_sink->inspectorPageAgents())
      agent->FrameScheduledNavigation(paramLocalFrame, delay);
  }
  if (probe_sink->hasInspectorNetworkAgents()) {
    for (InspectorNetworkAgent* agent : probe_sink->inspectorNetworkAgents())
      agent->FrameScheduledNavigation(paramLocalFrame, delay);
  }
}

CORE_EXPORT void frameClearedScheduledNavigation(LocalFrame* paramLocalFrame) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramLocalFrame);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorPageAgents()) {
    for (InspectorPageAgent* agent : probe_sink->inspectorPageAgents())
      agent->FrameClearedScheduledNavigation(paramLocalFrame);
  }
  if (probe_sink->hasInspectorNetworkAgents()) {
    for (InspectorNetworkAgent* agent : probe_sink->inspectorNetworkAgents())
      agent->FrameClearedScheduledNavigation(paramLocalFrame);
  }
}

CORE_EXPORT void frameScheduledClientNavigation(LocalFrame* paramLocalFrame) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramLocalFrame);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorNetworkAgents()) {
    for (InspectorNetworkAgent* agent : probe_sink->inspectorNetworkAgents())
      agent->FrameScheduledClientNavigation(paramLocalFrame);
  }
}

CORE_EXPORT void frameClearedScheduledClientNavigation(LocalFrame* paramLocalFrame) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramLocalFrame);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorNetworkAgents()) {
    for (InspectorNetworkAgent* agent : probe_sink->inspectorNetworkAgents())
      agent->FrameClearedScheduledClientNavigation(paramLocalFrame);
  }
}

CORE_EXPORT void didStartWorker(ExecutionContext* paramExecutionContext, WorkerInspectorProxy* proxy, bool waitingForDebugger) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramExecutionContext);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorWorkerAgents()) {
    for (InspectorWorkerAgent* agent : probe_sink->inspectorWorkerAgents())
      agent->DidStartWorker(proxy, waitingForDebugger);
  }
}

CORE_EXPORT void workerTerminated(ExecutionContext* paramExecutionContext, WorkerInspectorProxy* proxy) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramExecutionContext);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorWorkerAgents()) {
    for (InspectorWorkerAgent* agent : probe_sink->inspectorWorkerAgents())
      agent->WorkerTerminated(proxy);
  }
}

CORE_EXPORT void didCreateWebSocket(Document* paramDocument, unsigned long identifier, const KURL& requestURL, const String& protocol) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramDocument);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorNetworkAgents()) {
    for (InspectorNetworkAgent* agent : probe_sink->inspectorNetworkAgents())
      agent->DidCreateWebSocket(paramDocument, identifier, requestURL, protocol);
  }
}

CORE_EXPORT void willSendWebSocketHandshakeRequest(Document* paramDocument, unsigned long identifier, const WebSocketHandshakeRequest* request) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramDocument);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorNetworkAgents()) {
    for (InspectorNetworkAgent* agent : probe_sink->inspectorNetworkAgents())
      agent->WillSendWebSocketHandshakeRequest(paramDocument, identifier, request);
  }
}

CORE_EXPORT void didReceiveWebSocketHandshakeResponse(Document* paramDocument, unsigned long identifier, const WebSocketHandshakeRequest* request, const WebSocketHandshakeResponse* response) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramDocument);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorNetworkAgents()) {
    for (InspectorNetworkAgent* agent : probe_sink->inspectorNetworkAgents())
      agent->DidReceiveWebSocketHandshakeResponse(paramDocument, identifier, request, response);
  }
}

CORE_EXPORT void didCloseWebSocket(Document* paramDocument, unsigned long identifier) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramDocument);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorNetworkAgents()) {
    for (InspectorNetworkAgent* agent : probe_sink->inspectorNetworkAgents())
      agent->DidCloseWebSocket(paramDocument, identifier);
  }
}

CORE_EXPORT void didReceiveWebSocketFrame(Document* paramDocument, unsigned long identifier, int opCode, bool masked, const char* payload, size_t payloadLength) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramDocument);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorNetworkAgents()) {
    for (InspectorNetworkAgent* agent : probe_sink->inspectorNetworkAgents())
      agent->DidReceiveWebSocketFrame(identifier, opCode, masked, payload, payloadLength);
  }
}

CORE_EXPORT void didSendWebSocketFrame(Document* paramDocument, unsigned long identifier, int opCode, bool masked, const char* payload, size_t payloadLength) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramDocument);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorNetworkAgents()) {
    for (InspectorNetworkAgent* agent : probe_sink->inspectorNetworkAgents())
      agent->DidSendWebSocketFrame(identifier, opCode, masked, payload, payloadLength);
  }
}

CORE_EXPORT void didReceiveWebSocketFrameError(Document* paramDocument, unsigned long identifier, const String& errorMessage) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramDocument);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorNetworkAgents()) {
    for (InspectorNetworkAgent* agent : probe_sink->inspectorNetworkAgents())
      agent->DidReceiveWebSocketFrameError(identifier, errorMessage);
  }
}

CORE_EXPORT void networkStateChanged(LocalFrame* paramLocalFrame, bool online) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramLocalFrame);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorApplicationCacheAgents()) {
    for (InspectorApplicationCacheAgent* agent : probe_sink->inspectorApplicationCacheAgents())
      agent->NetworkStateChanged(paramLocalFrame, online);
  }
}

CORE_EXPORT void updateApplicationCacheStatus(LocalFrame* paramLocalFrame) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramLocalFrame);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorApplicationCacheAgents()) {
    for (InspectorApplicationCacheAgent* agent : probe_sink->inspectorApplicationCacheAgents())
      agent->UpdateApplicationCacheStatus(paramLocalFrame);
  }
}

CORE_EXPORT void layerTreeDidChange(LocalFrame* paramLocalFrame) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramLocalFrame);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorLayerTreeAgents()) {
    for (InspectorLayerTreeAgent* agent : probe_sink->inspectorLayerTreeAgents())
      agent->LayerTreeDidChange();
  }
}

CORE_EXPORT void pseudoElementCreated(PseudoElement* paramPseudoElement) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramPseudoElement);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorDOMAgents()) {
    for (InspectorDOMAgent* agent : probe_sink->inspectorDOMAgents())
      agent->PseudoElementCreated(paramPseudoElement);
  }
}

CORE_EXPORT void pseudoElementDestroyed(PseudoElement* paramPseudoElement) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramPseudoElement);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorDOMAgents()) {
    for (InspectorDOMAgent* agent : probe_sink->inspectorDOMAgents())
      agent->PseudoElementDestroyed(paramPseudoElement);
  }
}

CORE_EXPORT void didCreateAnimation(Document* paramDocument, unsigned paramunsigned) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramDocument);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorAnimationAgents()) {
    for (InspectorAnimationAgent* agent : probe_sink->inspectorAnimationAgents())
      agent->DidCreateAnimation(paramunsigned);
  }
}

CORE_EXPORT void animationPlayStateChanged(Document* paramDocument, Animation* paramAnimation, Animation::AnimationPlayState oldPlayState, Animation::AnimationPlayState newPlayState) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramDocument);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorAnimationAgents()) {
    for (InspectorAnimationAgent* agent : probe_sink->inspectorAnimationAgents())
      agent->AnimationPlayStateChanged(paramAnimation, oldPlayState, newPlayState);
  }
}

CORE_EXPORT void windowCreated(LocalFrame* opener, LocalFrame* created) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(opener);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorPageAgents()) {
    for (InspectorPageAgent* agent : probe_sink->inspectorPageAgents())
      agent->WindowCreated(created);
  }
}

CORE_EXPORT void consoleMessageAdded(ExecutionContext* paramExecutionContext, ConsoleMessage* paramConsoleMessage) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramExecutionContext);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorLogAgents()) {
    for (InspectorLogAgent* agent : probe_sink->inspectorLogAgents())
      agent->ConsoleMessageAdded(paramConsoleMessage);
  }
}

CORE_EXPORT void willRunJavaScriptDialog(LocalFrame* frame, const String& message, ChromeClient::DialogType dialogType) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(frame);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorPageAgents()) {
    for (InspectorPageAgent* agent : probe_sink->inspectorPageAgents())
      agent->WillRunJavaScriptDialog(message, dialogType);
  }
}

CORE_EXPORT void didRunJavaScriptDialog(LocalFrame* frame, bool result) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(frame);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorPageAgents()) {
    for (InspectorPageAgent* agent : probe_sink->inspectorPageAgents())
      agent->DidRunJavaScriptDialog(result);
  }
}

CORE_EXPORT void documentWriteFetchScript(Document* paramDocument) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramDocument);
  if (!probe_sink)
    return;
  if (probe_sink->hasPerformanceMonitors()) {
    for (PerformanceMonitor* agent : probe_sink->performanceMonitors())
      agent->DocumentWriteFetchScript(paramDocument);
  }
}

CORE_EXPORT void didChangeViewport(LocalFrame* document) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(document);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorPageAgents()) {
    for (InspectorPageAgent* agent : probe_sink->inspectorPageAgents())
      agent->DidChangeViewport();
  }
}

CORE_EXPORT void breakableLocation(ExecutionContext* context, const char* name) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(context);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorDOMDebuggerAgents()) {
    for (InspectorDOMDebuggerAgent* agent : probe_sink->inspectorDOMDebuggerAgents())
      agent->BreakableLocation(name);
  }
}

RecalculateStyle::RecalculateStyle(Document* document) :
    document(document) {
  probe_sink = ToCoreProbeSink(document);
  if (!probe_sink)
    return;
  if (probe_sink->hasPerformanceMonitors()) {
    for (PerformanceMonitor* agent : probe_sink->performanceMonitors())
      agent->Will(*this);
  }
  if (probe_sink->hasInspectorPageAgents()) {
    for (InspectorPageAgent* agent : probe_sink->inspectorPageAgents())
      agent->Will(*this);
  }
}

RecalculateStyle::~RecalculateStyle() {
  if (!probe_sink)
    return;
  if (probe_sink->hasPerformanceMonitors()) {
    for (PerformanceMonitor* agent : probe_sink->performanceMonitors())
      agent->Did(*this);
  }
  if (probe_sink->hasInspectorPageAgents()) {
    for (InspectorPageAgent* agent : probe_sink->inspectorPageAgents())
      agent->Did(*this);
  }
}

UpdateLayout::UpdateLayout(Document* paramDocument) :
    paramDocument(paramDocument) {
  probe_sink = ToCoreProbeSink(paramDocument);
  if (!probe_sink)
    return;
  if (probe_sink->hasPerformanceMonitors()) {
    for (PerformanceMonitor* agent : probe_sink->performanceMonitors())
      agent->Will(*this);
  }
  if (probe_sink->hasInspectorPageAgents()) {
    for (InspectorPageAgent* agent : probe_sink->inspectorPageAgents())
      agent->Will(*this);
  }
}

UpdateLayout::~UpdateLayout() {
  if (!probe_sink)
    return;
  if (probe_sink->hasPerformanceMonitors()) {
    for (PerformanceMonitor* agent : probe_sink->performanceMonitors())
      agent->Did(*this);
  }
  if (probe_sink->hasInspectorPageAgents()) {
    for (InspectorPageAgent* agent : probe_sink->inspectorPageAgents())
      agent->Did(*this);
  }
}

ExecuteScript::ExecuteScript(ExecutionContext* context) :
    context(context) {
  probe_sink = ToCoreProbeSink(context);
  if (!probe_sink)
    return;
  if (probe_sink->hasPerformanceMonitors()) {
    for (PerformanceMonitor* agent : probe_sink->performanceMonitors())
      agent->Will(*this);
  }
  if (probe_sink->hasInspectorDOMDebuggerAgents()) {
    for (InspectorDOMDebuggerAgent* agent : probe_sink->inspectorDOMDebuggerAgents())
      agent->Will(*this);
  }
}

ExecuteScript::~ExecuteScript() {
  if (!probe_sink)
    return;
  if (probe_sink->hasPerformanceMonitors()) {
    for (PerformanceMonitor* agent : probe_sink->performanceMonitors())
      agent->Did(*this);
  }
  if (probe_sink->hasInspectorDOMDebuggerAgents()) {
    for (InspectorDOMDebuggerAgent* agent : probe_sink->inspectorDOMDebuggerAgents())
      agent->Did(*this);
  }
}

CallFunction::CallFunction(ExecutionContext* context, v8::Local<v8::Function> function, int depth) :
    context(context),
    function(function),
    depth(depth) {
  probe_sink = ToCoreProbeSink(context);
  if (!probe_sink)
    return;
  if (probe_sink->hasPerformanceMonitors()) {
    for (PerformanceMonitor* agent : probe_sink->performanceMonitors())
      agent->Will(*this);
  }
  if (probe_sink->hasInspectorTraceEventss()) {
    for (InspectorTraceEvents* agent : probe_sink->inspectorTraceEventss())
      agent->Will(*this);
  }
}

CallFunction::~CallFunction() {
  if (!probe_sink)
    return;
  if (probe_sink->hasPerformanceMonitors()) {
    for (PerformanceMonitor* agent : probe_sink->performanceMonitors())
      agent->Did(*this);
  }
  if (probe_sink->hasInspectorTraceEventss()) {
    for (InspectorTraceEvents* agent : probe_sink->inspectorTraceEventss())
      agent->Did(*this);
  }
}

UserCallback::UserCallback(ExecutionContext* context, const char* name, const AtomicString& atomicName, bool recurring, EventTarget* eventTarget) :
    context(context),
    name(name),
    atomicName(atomicName),
    recurring(recurring),
    eventTarget(eventTarget) {
  probe_sink = ToCoreProbeSink(context);
  if (!probe_sink)
    return;
  if (probe_sink->hasPerformanceMonitors()) {
    for (PerformanceMonitor* agent : probe_sink->performanceMonitors())
      agent->Will(*this);
  }
  if (probe_sink->hasInspectorDOMDebuggerAgents()) {
    for (InspectorDOMDebuggerAgent* agent : probe_sink->inspectorDOMDebuggerAgents())
      agent->Will(*this);
  }
}

UserCallback::~UserCallback() {
  if (!probe_sink)
    return;
  if (probe_sink->hasPerformanceMonitors()) {
    for (PerformanceMonitor* agent : probe_sink->performanceMonitors())
      agent->Did(*this);
  }
  if (probe_sink->hasInspectorDOMDebuggerAgents()) {
    for (InspectorDOMDebuggerAgent* agent : probe_sink->inspectorDOMDebuggerAgents())
      agent->Did(*this);
  }
}

V8Compile::V8Compile(ExecutionContext* context, const String& file_name, int line, int column) :
    context(context),
    file_name(file_name),
    line(line),
    column(column) {
  probe_sink = ToCoreProbeSink(context);
  if (!probe_sink)
    return;
  if (probe_sink->hasPerformanceMonitors()) {
    for (PerformanceMonitor* agent : probe_sink->performanceMonitors())
      agent->Will(*this);
  }
}

V8Compile::~V8Compile() {
  if (!probe_sink)
    return;
  if (probe_sink->hasPerformanceMonitors()) {
    for (PerformanceMonitor* agent : probe_sink->performanceMonitors())
      agent->Did(*this);
  }
}

ParseHTML::ParseHTML(Document* document, HTMLDocumentParser* parser) :
    document(document),
    parser(parser) {
  probe_sink = ToCoreProbeSink(document);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorTraceEventss()) {
    for (InspectorTraceEvents* agent : probe_sink->inspectorTraceEventss())
      agent->Will(*this);
  }
}

ParseHTML::~ParseHTML() {
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorTraceEventss()) {
    for (InspectorTraceEvents* agent : probe_sink->inspectorTraceEventss())
      agent->Did(*this);
  }
}

CORE_EXPORT void forcePseudoState(Element* element, CSSSelector::PseudoType pseudoState, bool* result) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(element);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorCSSAgents()) {
    for (InspectorCSSAgent* agent : probe_sink->inspectorCSSAgents())
      agent->ForcePseudoState(element, pseudoState, result);
  }
}

CORE_EXPORT void shouldWaitForDebuggerOnWorkerStart(ExecutionContext* context, bool* result) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(context);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorWorkerAgents()) {
    for (InspectorWorkerAgent* agent : probe_sink->inspectorWorkerAgents())
      agent->ShouldWaitForDebuggerOnWorkerStart(result);
  }
}

CORE_EXPORT void shouldForceCORSPreflight(Document* paramDocument, bool* result) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramDocument);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorNetworkAgents()) {
    for (InspectorNetworkAgent* agent : probe_sink->inspectorNetworkAgents())
      agent->ShouldForceCORSPreflight(result);
  }
}

CORE_EXPORT void shouldBlockRequest(ExecutionContext* paramExecutionContext, const ResourceRequest& paramResourceRequest, bool* result) {
  CoreProbeSink* probe_sink = ToCoreProbeSink(paramExecutionContext);
  if (!probe_sink)
    return;
  if (probe_sink->hasInspectorNetworkAgents()) {
    for (InspectorNetworkAgent* agent : probe_sink->inspectorNetworkAgents())
      agent->ShouldBlockRequest(paramResourceRequest, result);
  }
}


} // namespace probe
} // namespace blink
