// Copyright (c) 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Generated from template:
//   templates/EventFactory.cpp.tmpl
// and input files:
//   gen/blink/EventModulesInterfaces.json5


#include "modules/EventModulesFactory.h"

#include "EventModulesHeaders.h"
#include "core/frame/Deprecation.h"
#include "platform/RuntimeEnabledFeatures.h"

namespace blink {

Event* EventModulesFactory::Create(ExecutionContext* executionContext, const String& type) {
  if (DeprecatedEqualIgnoringCase(type, "DeviceMotionEvent")) {
    UseCounter::Count(executionContext, WebFeature::kDocumentCreateEventDeviceMotionEvent);
    return DeviceMotionEvent::Create();
  }
  if (DeprecatedEqualIgnoringCase(type, "DeviceOrientationEvent")) {
    UseCounter::Count(executionContext, WebFeature::kDocumentCreateEventDeviceOrientationEvent);
    return DeviceOrientationEvent::Create();
  }
  if (DeprecatedEqualIgnoringCase(type, "IDBVersionChangeEvent")) {
    UseCounter::Count(executionContext, WebFeature::kDocumentCreateEventIDBVersionChangeEvent);
    return IDBVersionChangeEvent::Create();
  }
  if (DeprecatedEqualIgnoringCase(type, "StorageEvent")) {
    UseCounter::Count(executionContext, WebFeature::kDocumentCreateEventStorageEvent);
    return StorageEvent::Create();
  }
  if (DeprecatedEqualIgnoringCase(type, "WebGLContextEvent")) {
    UseCounter::Count(executionContext, WebFeature::kDocumentCreateEventWebGLContextEvent);
    return WebGLContextEvent::Create();
  }
  if (DeprecatedEqualIgnoringCase(type, "CloseEvent")) {
    UseCounter::Count(executionContext, WebFeature::kDocumentCreateEventCloseEvent);
    return CloseEvent::Create();
  }
  return nullptr;
}

} // namespace blink
