// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py.
// DO NOT MODIFY!

// This file has been generated from the Jinja2 template in
// third_party/WebKit/Source/bindings/templates/dictionary_impl.h.tmpl

// clang-format off
#ifndef MediaTrackSettings_h
#define MediaTrackSettings_h

#include "bindings/core/v8/IDLDictionaryBase.h"
#include "modules/ModulesExport.h"
#include "modules/imagecapture/Point2D.h"
#include "platform/heap/Handle.h"
#include "platform/wtf/Vector.h"
#include "platform/wtf/text/WTFString.h"

namespace blink {

class MODULES_EXPORT MediaTrackSettings : public IDLDictionaryBase {
  DISALLOW_NEW_EXCEPT_PLACEMENT_NEW();
 public:
  MediaTrackSettings();
  virtual ~MediaTrackSettings();
  MediaTrackSettings(const MediaTrackSettings&);
  MediaTrackSettings& operator=(const MediaTrackSettings&);

  bool hasAspectRatio() const;
  double aspectRatio() const;
  void setAspectRatio(double);

  bool hasBrightness() const;
  double brightness() const;
  void setBrightness(double);

  bool hasColorTemperature() const;
  double colorTemperature() const;
  void setColorTemperature(double);

  bool hasContrast() const;
  double contrast() const;
  void setContrast(double);

  bool hasDepthFar() const;
  double depthFar() const;
  void setDepthFar(double);

  bool hasDepthNear() const;
  double depthNear() const;
  void setDepthNear(double);

  bool hasDeviceId() const;
  const String& deviceId() const;
  void setDeviceId(const String&);

  bool hasEchoCancellation() const;
  bool echoCancellation() const;
  void setEchoCancellation(bool);

  bool hasExposureCompensation() const;
  double exposureCompensation() const;
  void setExposureCompensation(double);

  bool hasExposureMode() const;
  const String& exposureMode() const;
  void setExposureMode(const String&);

  bool hasFacingMode() const;
  const String& facingMode() const;
  void setFacingMode(const String&);

  bool hasFocalLengthX() const;
  double focalLengthX() const;
  void setFocalLengthX(double);

  bool hasFocalLengthY() const;
  double focalLengthY() const;
  void setFocalLengthY(double);

  bool hasFocusMode() const;
  const String& focusMode() const;
  void setFocusMode(const String&);

  bool hasFrameRate() const;
  double frameRate() const;
  void setFrameRate(double);

  bool hasHeight() const;
  int32_t height() const;
  void setHeight(int32_t);

  bool hasIso() const;
  double iso() const;
  void setIso(double);

  bool hasPointsOfInterest() const;
  const HeapVector<Point2D>& pointsOfInterest() const;
  void setPointsOfInterest(const HeapVector<Point2D>&);

  bool hasSaturation() const;
  double saturation() const;
  void setSaturation(double);

  bool hasSharpness() const;
  double sharpness() const;
  void setSharpness(double);

  bool hasTorch() const;
  bool torch() const;
  void setTorch(bool);

  bool hasVideoKind() const;
  const String& videoKind() const;
  void setVideoKind(const String&);

  bool hasWhiteBalanceMode() const;
  const String& whiteBalanceMode() const;
  void setWhiteBalanceMode(const String&);

  bool hasWidth() const;
  int32_t width() const;
  void setWidth(int32_t);

  bool hasZoom() const;
  double zoom() const;
  void setZoom(double);

  v8::Local<v8::Value> ToV8Impl(v8::Local<v8::Object>, v8::Isolate*) const override;
  DECLARE_VIRTUAL_TRACE();

 private:
  bool m_hasAspectRatio = false;
  bool m_hasBrightness = false;
  bool m_hasColorTemperature = false;
  bool m_hasContrast = false;
  bool m_hasDepthFar = false;
  bool m_hasDepthNear = false;
  bool m_hasEchoCancellation = false;
  bool m_hasExposureCompensation = false;
  bool m_hasFocalLengthX = false;
  bool m_hasFocalLengthY = false;
  bool m_hasFrameRate = false;
  bool m_hasHeight = false;
  bool m_hasIso = false;
  bool m_hasPointsOfInterest = false;
  bool m_hasSaturation = false;
  bool m_hasSharpness = false;
  bool m_hasTorch = false;
  bool m_hasWidth = false;
  bool m_hasZoom = false;

  double m_aspectRatio;
  double m_brightness;
  double m_colorTemperature;
  double m_contrast;
  double m_depthFar;
  double m_depthNear;
  String m_deviceId;
  bool m_echoCancellation;
  double m_exposureCompensation;
  String m_exposureMode;
  String m_facingMode;
  double m_focalLengthX;
  double m_focalLengthY;
  String m_focusMode;
  double m_frameRate;
  int32_t m_height;
  double m_iso;
  HeapVector<Point2D> m_pointsOfInterest;
  double m_saturation;
  double m_sharpness;
  bool m_torch;
  String m_videoKind;
  String m_whiteBalanceMode;
  int32_t m_width;
  double m_zoom;

  friend class V8MediaTrackSettings;
};

}  // namespace blink

#endif  // MediaTrackSettings_h
