// Copyright (c) 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Generated from template:
//   templates/RuntimeEnabledFeatures.cpp.tmpl
// and input files:
//   ../../../../src/3rdparty/chromium/third_party/WebKit/Source/platform/RuntimeEnabledFeatures.json5


#include "platform/RuntimeEnabledFeatures.h"

#include "platform/wtf/Assertions.h"
#include "platform/wtf/text/WTFString.h"

namespace blink {

RuntimeEnabledFeatures::Backup::Backup()
  : accelerated2dCanvas_(RuntimeEnabledFeatures::Accelerated2dCanvasEnabled()),
    accessibilityObjectModel_(RuntimeEnabledFeatures::AccessibilityObjectModelEnabled()),
    allowContentInitiatedDataUrlNavigations_(RuntimeEnabledFeatures::AllowContentInitiatedDataUrlNavigationsEnabled()),
    asyncClipboard_(RuntimeEnabledFeatures::AsyncClipboardEnabled()),
    audioOutputDevices_(RuntimeEnabledFeatures::AudioOutputDevicesEnabled()),
    audioVideoTracks_(RuntimeEnabledFeatures::AudioVideoTracksEnabled()),
    audioWorklet_(RuntimeEnabledFeatures::AudioWorkletEnabled()),
    autoplayMutedVideos_(RuntimeEnabledFeatures::AutoplayMutedVideosEnabled()),
    auxclick_(RuntimeEnabledFeatures::AuxclickEnabled()),
    backgroundFetch_(RuntimeEnabledFeatures::BackgroundFetchEnabled()),
    backgroundSync_(RuntimeEnabledFeatures::BackgroundSyncEnabled()),
    backgroundVideoTrackOptimization_(RuntimeEnabledFeatures::BackgroundVideoTrackOptimizationEnabled()),
    blinkRuntimeCallStats_(RuntimeEnabledFeatures::BlinkRuntimeCallStatsEnabled()),
    blockCredentialedSubresources_(RuntimeEnabledFeatures::BlockCredentialedSubresourcesEnabled()),
    blockLegacySubresources_(RuntimeEnabledFeatures::BlockLegacySubresourcesEnabled()),
    broadcastChannel_(RuntimeEnabledFeatures::BroadcastChannelEnabled()),
    budget_(RuntimeEnabledFeatures::BudgetEnabled()),
    budgetQuery_(RuntimeEnabledFeatures::BudgetQueryEnabled()),
    canMakePayment_(RuntimeEnabledFeatures::CanMakePaymentEnabled()),
    canvas2dFixedRenderingMode_(RuntimeEnabledFeatures::Canvas2dFixedRenderingModeEnabled()),
    canvas2dImageChromium_(RuntimeEnabledFeatures::Canvas2dImageChromiumEnabled()),
    clickRetargetting_(RuntimeEnabledFeatures::ClickRetargettingEnabled()),
    clientHints_(RuntimeEnabledFeatures::ClientHintsEnabled()),
    clientPlaceholdersForServerLoFi_(RuntimeEnabledFeatures::ClientPlaceholdersForServerLoFiEnabled()),
    coalescedEvents_(RuntimeEnabledFeatures::CoalescedEventsEnabled()),
    colorCanvasExtensions_(RuntimeEnabledFeatures::ColorCanvasExtensionsEnabled()),
    colorCorrectRendering_(RuntimeEnabledFeatures::ColorCorrectRenderingEnabled()),
    compositedSelectionUpdate_(RuntimeEnabledFeatures::CompositedSelectionUpdateEnabled()),
    compositeOpaqueFixedPosition_(RuntimeEnabledFeatures::CompositeOpaqueFixedPositionEnabled()),
    compositeOpaqueScrollers_(RuntimeEnabledFeatures::CompositeOpaqueScrollersEnabled()),
    compositorTouchAction_(RuntimeEnabledFeatures::CompositorTouchActionEnabled()),
    compositorWorker_(RuntimeEnabledFeatures::CompositorWorkerEnabled()),
    computedAccessibilityInfo_(RuntimeEnabledFeatures::ComputedAccessibilityInfoEnabled()),
    conicGradient_(RuntimeEnabledFeatures::ConicGradientEnabled()),
    contextMenu_(RuntimeEnabledFeatures::ContextMenuEnabled()),
    corsRFC1918_(RuntimeEnabledFeatures::CorsRFC1918Enabled()),
    css3Text_(RuntimeEnabledFeatures::CSS3TextEnabled()),
    css3TextDecorations_(RuntimeEnabledFeatures::CSS3TextDecorationsEnabled()),
    cssAdditiveAnimations_(RuntimeEnabledFeatures::CSSAdditiveAnimationsEnabled()),
    cssApplyAtRules_(RuntimeEnabledFeatures::CSSApplyAtRulesEnabled()),
    cssBackdropFilter_(RuntimeEnabledFeatures::CSSBackdropFilterEnabled()),
    cssContainment_(RuntimeEnabledFeatures::CSSContainmentEnabled()),
    cssDisplayContents_(RuntimeEnabledFeatures::CSSDisplayContentsEnabled()),
    cssFontDisplay_(RuntimeEnabledFeatures::CSSFontDisplayEnabled()),
    cssFontSizeAdjust_(RuntimeEnabledFeatures::CSSFontSizeAdjustEnabled()),
    cssGridLayout_(RuntimeEnabledFeatures::CSSGridLayoutEnabled()),
    cssHexAlphaColor_(RuntimeEnabledFeatures::CSSHexAlphaColorEnabled()),
    cssHyphens_(RuntimeEnabledFeatures::CSSHyphensEnabled()),
    cssInBodyDoesNotBlockPaint_(RuntimeEnabledFeatures::CSSInBodyDoesNotBlockPaintEnabled()),
    cssIndependentTransformProperties_(RuntimeEnabledFeatures::CSSIndependentTransformPropertiesEnabled()),
    cssLineBreak_(RuntimeEnabledFeatures::CSSLineBreakEnabled()),
    cssMaskSourceType_(RuntimeEnabledFeatures::CSSMaskSourceTypeEnabled()),
    cssOffsetPathRay_(RuntimeEnabledFeatures::CSSOffsetPathRayEnabled()),
    cssOffsetPathRayContain_(RuntimeEnabledFeatures::CSSOffsetPathRayContainEnabled()),
    cssOffsetPositionAnchor_(RuntimeEnabledFeatures::CSSOffsetPositionAnchorEnabled()),
    cssomSmoothScroll_(RuntimeEnabledFeatures::CSSOMSmoothScrollEnabled()),
    cssPaintAPI_(RuntimeEnabledFeatures::CSSPaintAPIEnabled()),
    cssPaintAPIArguments_(RuntimeEnabledFeatures::CSSPaintAPIArgumentsEnabled()),
    cssScrollBoundaryBehavior_(RuntimeEnabledFeatures::CSSScrollBoundaryBehaviorEnabled()),
    cssScrollSnapPoints_(RuntimeEnabledFeatures::CSSScrollSnapPointsEnabled()),
    cssSelectorsFocusWithin_(RuntimeEnabledFeatures::CSSSelectorsFocusWithinEnabled()),
    cssSnapSize_(RuntimeEnabledFeatures::CSSSnapSizeEnabled()),
    cssStickyPosition_(RuntimeEnabledFeatures::CSSStickyPositionEnabled()),
    cssTransformBox_(RuntimeEnabledFeatures::CSSTransformBoxEnabled()),
    cssTypedOM_(RuntimeEnabledFeatures::CSSTypedOMEnabled()),
    cssVariableFonts_(RuntimeEnabledFeatures::CSSVariableFontsEnabled()),
    cssVariables2_(RuntimeEnabledFeatures::CSSVariables2Enabled()),
    cssViewport_(RuntimeEnabledFeatures::CSSViewportEnabled()),
    customElementsBuiltin_(RuntimeEnabledFeatures::CustomElementsBuiltinEnabled()),
    customSchemeHandler_(RuntimeEnabledFeatures::CustomSchemeHandlerEnabled()),
    database_(RuntimeEnabledFeatures::DatabaseEnabled()),
    decodeToYUV_(RuntimeEnabledFeatures::DecodeToYUVEnabled()),
    desktopCaptureDisableLocalEchoControl_(RuntimeEnabledFeatures::DesktopCaptureDisableLocalEchoControlEnabled()),
    deviceMemoryHeader_(RuntimeEnabledFeatures::DeviceMemoryHeaderEnabled()),
    displayList2dCanvas_(RuntimeEnabledFeatures::DisplayList2dCanvasEnabled()),
    displayNoneIFrameCreatesNoLayoutObject_(RuntimeEnabledFeatures::DisplayNoneIFrameCreatesNoLayoutObjectEnabled()),
    documentCookie_(RuntimeEnabledFeatures::DocumentCookieEnabled()),
    documentDomain_(RuntimeEnabledFeatures::DocumentDomainEnabled()),
    documentWrite_(RuntimeEnabledFeatures::DocumentWriteEnabled()),
    documentWriteEvaluator_(RuntimeEnabledFeatures::DocumentWriteEvaluatorEnabled()),
    dOMConvenienceAPI_(RuntimeEnabledFeatures::DOMConvenienceAPIEnabled()),
    durableStorage_(RuntimeEnabledFeatures::DurableStorageEnabled()),
    embedderCSPEnforcement_(RuntimeEnabledFeatures::EmbedderCSPEnforcementEnabled()),
    encryptedMediaHdcpPolicyCheck_(RuntimeEnabledFeatures::EncryptedMediaHdcpPolicyCheckEnabled()),
    execCommandInJavaScript_(RuntimeEnabledFeatures::ExecCommandInJavaScriptEnabled()),
    expensiveBackgroundTimerThrottling_(RuntimeEnabledFeatures::ExpensiveBackgroundTimerThrottlingEnabled()),
    experimentalCanvasFeatures_(RuntimeEnabledFeatures::ExperimentalCanvasFeaturesEnabled()),
    experimentalContentSecurityPolicyFeatures_(RuntimeEnabledFeatures::ExperimentalContentSecurityPolicyFeaturesEnabled()),
    experimentalV8Extras_(RuntimeEnabledFeatures::ExperimentalV8ExtrasEnabled()),
    fastMobileScrolling_(RuntimeEnabledFeatures::FastMobileScrollingEnabled()),
    featurePolicy_(RuntimeEnabledFeatures::FeaturePolicyEnabled()),
    featurePolicyExperimentalFeatures_(RuntimeEnabledFeatures::FeaturePolicyExperimentalFeaturesEnabled()),
    fetchRequestCache_(RuntimeEnabledFeatures::FetchRequestCacheEnabled()),
    fileAPIBlobClose_(RuntimeEnabledFeatures::FileAPIBlobCloseEnabled()),
    fileSystem_(RuntimeEnabledFeatures::FileSystemEnabled()),
    fontCacheScaling_(RuntimeEnabledFeatures::FontCacheScalingEnabled()),
    forceDisable2dCanvasCopyOnWrite_(RuntimeEnabledFeatures::ForceDisable2dCanvasCopyOnWriteEnabled()),
    forceDisplayList2dCanvas_(RuntimeEnabledFeatures::ForceDisplayList2dCanvasEnabled()),
    forceOverlayFullscreenVideo_(RuntimeEnabledFeatures::ForceOverlayFullscreenVideoEnabled()),
    forceTallerSelectPopup_(RuntimeEnabledFeatures::ForceTallerSelectPopupEnabled()),
    foreignFetch_(RuntimeEnabledFeatures::ForeignFetchEnabled()),
    fractionalScrollOffsets_(RuntimeEnabledFeatures::FractionalScrollOffsetsEnabled()),
    framebustingNeedsSameOriginOrUserGesture_(RuntimeEnabledFeatures::FramebustingNeedsSameOriginOrUserGestureEnabled()),
    framesTimingFunction_(RuntimeEnabledFeatures::FramesTimingFunctionEnabled()),
    frameTimingSupport_(RuntimeEnabledFeatures::FrameTimingSupportEnabled()),
    fullscreenUnprefixed_(RuntimeEnabledFeatures::FullscreenUnprefixedEnabled()),
    gamepadExtensions_(RuntimeEnabledFeatures::GamepadExtensionsEnabled()),
    geometryInterfaces_(RuntimeEnabledFeatures::GeometryInterfacesEnabled()),
    getUserMedia_(RuntimeEnabledFeatures::GetUserMediaEnabled()),
    globalCacheStorage_(RuntimeEnabledFeatures::GlobalCacheStorageEnabled()),
    heapCompaction_(RuntimeEnabledFeatures::HeapCompactionEnabled()),
    hideNonceContentAttribute_(RuntimeEnabledFeatures::HideNonceContentAttributeEnabled()),
    htmlImportsStyleApplication_(RuntimeEnabledFeatures::HTMLImportsStyleApplicationEnabled()),
    iDBObserver_(RuntimeEnabledFeatures::IDBObserverEnabled()),
    idleTimeColdModeSpellChecking_(RuntimeEnabledFeatures::IdleTimeColdModeSpellCheckingEnabled()),
    idleTimeSpellChecking_(RuntimeEnabledFeatures::IdleTimeSpellCheckingEnabled()),
    imageCapture_(RuntimeEnabledFeatures::ImageCaptureEnabled()),
    imageOrientation_(RuntimeEnabledFeatures::ImageOrientationEnabled()),
    inertAttribute_(RuntimeEnabledFeatures::InertAttributeEnabled()),
    inputEvent_(RuntimeEnabledFeatures::InputEventEnabled()),
    inputModeAttribute_(RuntimeEnabledFeatures::InputModeAttributeEnabled()),
    inputMultipleFieldsUI_(RuntimeEnabledFeatures::InputMultipleFieldsUIEnabled()),
    installedApp_(RuntimeEnabledFeatures::InstalledAppEnabled()),
    intersectionObserver_(RuntimeEnabledFeatures::IntersectionObserverEnabled()),
    jsImageDecode_(RuntimeEnabledFeatures::JSImageDecodeEnabled()),
    keyboardLock_(RuntimeEnabledFeatures::KeyboardLockEnabled()),
    langAttributeAwareFormControlUI_(RuntimeEnabledFeatures::LangAttributeAwareFormControlUIEnabled()),
    layoutNG_(RuntimeEnabledFeatures::LayoutNGEnabled()),
    lazyInitializeMediaControls_(RuntimeEnabledFeatures::LazyInitializeMediaControlsEnabled()),
    lazyParseCSS_(RuntimeEnabledFeatures::LazyParseCSSEnabled()),
    linkServiceWorker_(RuntimeEnabledFeatures::LinkServiceWorkerEnabled()),
    loadingWithMojo_(RuntimeEnabledFeatures::LoadingWithMojoEnabled()),
    longTaskObserver_(RuntimeEnabledFeatures::LongTaskObserverEnabled()),
    mediaCapabilities_(RuntimeEnabledFeatures::MediaCapabilitiesEnabled()),
    mediaCapture_(RuntimeEnabledFeatures::MediaCaptureEnabled()),
    mediaCaptureDepth_(RuntimeEnabledFeatures::MediaCaptureDepthEnabled()),
    mediaCaptureFromCanvas_(RuntimeEnabledFeatures::MediaCaptureFromCanvasEnabled()),
    mediaCaptureFromVideo_(RuntimeEnabledFeatures::MediaCaptureFromVideoEnabled()),
    mediaCastOverlayButton_(RuntimeEnabledFeatures::MediaCastOverlayButtonEnabled()),
    mediaControlsOverlayPlayButton_(RuntimeEnabledFeatures::MediaControlsOverlayPlayButtonEnabled()),
    mediaDocumentDownloadButton_(RuntimeEnabledFeatures::MediaDocumentDownloadButtonEnabled()),
    mediaQueryShape_(RuntimeEnabledFeatures::MediaQueryShapeEnabled()),
    mediaSession_(RuntimeEnabledFeatures::MediaSessionEnabled()),
    mediaSourceExperimental_(RuntimeEnabledFeatures::MediaSourceExperimentalEnabled()),
    mediaSourceNewAbortAndDuration_(RuntimeEnabledFeatures::MediaSourceNewAbortAndDurationEnabled()),
    mediaStreamSpeech_(RuntimeEnabledFeatures::MediaStreamSpeechEnabled()),
    mediaStreamTrackContentHint_(RuntimeEnabledFeatures::MediaStreamTrackContentHintEnabled()),
    mediaTrackApplyConstraints_(RuntimeEnabledFeatures::MediaTrackApplyConstraintsEnabled()),
    mediaTrackCapabilities_(RuntimeEnabledFeatures::MediaTrackCapabilitiesEnabled()),
    memoryInfoInWorkers_(RuntimeEnabledFeatures::MemoryInfoInWorkersEnabled()),
    middleClickAutoscroll_(RuntimeEnabledFeatures::MiddleClickAutoscrollEnabled()),
    mobileLayoutTheme_(RuntimeEnabledFeatures::MobileLayoutThemeEnabled()),
    moduleScripts_(RuntimeEnabledFeatures::ModuleScriptsEnabled()),
    mojoBlobs_(RuntimeEnabledFeatures::MojoBlobsEnabled()),
    mojoJS_(RuntimeEnabledFeatures::MojoJSEnabled()),
    mojoJSTest_(RuntimeEnabledFeatures::MojoJSTestEnabled()),
    multipleColorStopPositions_(RuntimeEnabledFeatures::MultipleColorStopPositionsEnabled()),
    navigatorContentUtils_(RuntimeEnabledFeatures::NavigatorContentUtilsEnabled()),
    netInfoDownlink_(RuntimeEnabledFeatures::NetInfoDownlinkEnabled()),
    netInfoDownlinkMax_(RuntimeEnabledFeatures::NetInfoDownlinkMaxEnabled()),
    netInfoEffectiveType_(RuntimeEnabledFeatures::NetInfoEffectiveTypeEnabled()),
    netInfoRtt_(RuntimeEnabledFeatures::NetInfoRttEnabled()),
    newRemotePlaybackPipeline_(RuntimeEnabledFeatures::NewRemotePlaybackPipelineEnabled()),
    notificationBadge_(RuntimeEnabledFeatures::NotificationBadgeEnabled()),
    notificationConstructor_(RuntimeEnabledFeatures::NotificationConstructorEnabled()),
    notificationContentImage_(RuntimeEnabledFeatures::NotificationContentImageEnabled()),
    notificationInlineReplies_(RuntimeEnabledFeatures::NotificationInlineRepliesEnabled()),
    notifications_(RuntimeEnabledFeatures::NotificationsEnabled()),
    nullableDocumentDomain_(RuntimeEnabledFeatures::NullableDocumentDomainEnabled()),
    offMainThreadFetch_(RuntimeEnabledFeatures::OffMainThreadFetchEnabled()),
    onDeviceChange_(RuntimeEnabledFeatures::OnDeviceChangeEnabled()),
    orientationEvent_(RuntimeEnabledFeatures::OrientationEventEnabled()),
    originTrials_(RuntimeEnabledFeatures::OriginTrialsEnabled()),
    originTrialsSampleAPI_(RuntimeEnabledFeatures::OriginTrialsSampleAPIEnabled()),
    outOfBlinkCORS_(RuntimeEnabledFeatures::OutOfBlinkCORSEnabled()),
    overlayScrollbars_(RuntimeEnabledFeatures::OverlayScrollbarsEnabled()),
    pagePopup_(RuntimeEnabledFeatures::PagePopupEnabled()),
    paintUnderInvalidationChecking_(RuntimeEnabledFeatures::PaintUnderInvalidationCheckingEnabled()),
    passiveDocumentEventListeners_(RuntimeEnabledFeatures::PassiveDocumentEventListenersEnabled()),
    passPaintVisualRectToCompositor_(RuntimeEnabledFeatures::PassPaintVisualRectToCompositorEnabled()),
    paymentApp_(RuntimeEnabledFeatures::PaymentAppEnabled()),
    paymentDetailsModifierData_(RuntimeEnabledFeatures::PaymentDetailsModifierDataEnabled()),
    paymentRequest_(RuntimeEnabledFeatures::PaymentRequestEnabled()),
    paymentRequestBasicCard_(RuntimeEnabledFeatures::PaymentRequestBasicCardEnabled()),
    performanceNavigationTiming2_(RuntimeEnabledFeatures::PerformanceNavigationTiming2Enabled()),
    performanceObserver_(RuntimeEnabledFeatures::PerformanceObserverEnabled()),
    performancePaintTiming_(RuntimeEnabledFeatures::PerformancePaintTimingEnabled()),
    permissionDelegation_(RuntimeEnabledFeatures::PermissionDelegationEnabled()),
    permissions_(RuntimeEnabledFeatures::PermissionsEnabled()),
    permissionsRequestRevoke_(RuntimeEnabledFeatures::PermissionsRequestRevokeEnabled()),
    preciseMemoryInfo_(RuntimeEnabledFeatures::PreciseMemoryInfoEnabled()),
    preferredImageRasterBounds_(RuntimeEnabledFeatures::PreferredImageRasterBoundsEnabled()),
    prefixedVideoFullscreen_(RuntimeEnabledFeatures::PrefixedVideoFullscreenEnabled()),
    presentation_(RuntimeEnabledFeatures::PresentationEnabled()),
    presentationReceiver_(RuntimeEnabledFeatures::PresentationReceiverEnabled()),
    printBrowser_(RuntimeEnabledFeatures::PrintBrowserEnabled()),
    pushMessaging_(RuntimeEnabledFeatures::PushMessagingEnabled()),
    reducedReferrerGranularity_(RuntimeEnabledFeatures::ReducedReferrerGranularityEnabled()),
    remotePlayback_(RuntimeEnabledFeatures::RemotePlaybackEnabled()),
    remotePlaybackBackend_(RuntimeEnabledFeatures::RemotePlaybackBackendEnabled()),
    renderingPipelineThrottling_(RuntimeEnabledFeatures::RenderingPipelineThrottlingEnabled()),
    renderingPipelineThrottlingLoadingIframes_(RuntimeEnabledFeatures::RenderingPipelineThrottlingLoadingIframesEnabled()),
    renderUnicodeControlCharacters_(RuntimeEnabledFeatures::RenderUnicodeControlCharactersEnabled()),
    resizeObserver_(RuntimeEnabledFeatures::ResizeObserverEnabled()),
    resourceLoadScheduler_(RuntimeEnabledFeatures::ResourceLoadSchedulerEnabled()),
    restrictCanRequestURLCharacterSet_(RuntimeEnabledFeatures::RestrictCanRequestURLCharacterSetEnabled()),
    rootLayerScrolling_(RuntimeEnabledFeatures::RootLayerScrollingEnabled()),
    rTCRtpSender_(RuntimeEnabledFeatures::RTCRtpSenderEnabled()),
    scriptedSpeech_(RuntimeEnabledFeatures::ScriptedSpeechEnabled()),
    scrollAnchoring_(RuntimeEnabledFeatures::ScrollAnchoringEnabled()),
    scrollCustomization_(RuntimeEnabledFeatures::ScrollCustomizationEnabled()),
    scrollTopLeftInterop_(RuntimeEnabledFeatures::ScrollTopLeftInteropEnabled()),
    sendBeaconThrowForBlobWithNonSimpleType_(RuntimeEnabledFeatures::SendBeaconThrowForBlobWithNonSimpleTypeEnabled()),
    sendMouseEventsDisabledFormControls_(RuntimeEnabledFeatures::SendMouseEventsDisabledFormControlsEnabled()),
    sensor_(RuntimeEnabledFeatures::SensorEnabled()),
    serverTiming_(RuntimeEnabledFeatures::ServerTimingEnabled()),
    serviceWorkerNavigationPreload_(RuntimeEnabledFeatures::ServiceWorkerNavigationPreloadEnabled()),
    serviceWorkerScriptStreaming_(RuntimeEnabledFeatures::ServiceWorkerScriptStreamingEnabled()),
    setRootScroller_(RuntimeEnabledFeatures::SetRootScrollerEnabled()),
    shadowPiercingDescendantCombinator_(RuntimeEnabledFeatures::ShadowPiercingDescendantCombinatorEnabled()),
    shapeDetection_(RuntimeEnabledFeatures::ShapeDetectionEnabled()),
    sharedArrayBuffer_(RuntimeEnabledFeatures::SharedArrayBufferEnabled()),
    sharedWorker_(RuntimeEnabledFeatures::SharedWorkerEnabled()),
    skipCompositingSmallScrollers_(RuntimeEnabledFeatures::SkipCompositingSmallScrollersEnabled()),
    slimmingPaintStrictCullRectClipping_(RuntimeEnabledFeatures::SlimmingPaintStrictCullRectClippingEnabled()),
    slimmingPaintV2_(RuntimeEnabledFeatures::SlimmingPaintV2Enabled()),
    smil_(RuntimeEnabledFeatures::SMILEnabled()),
    smoothScrollJSIntervention_(RuntimeEnabledFeatures::SmoothScrollJSInterventionEnabled()),
    stableBlinkFeatures_(RuntimeEnabledFeatures::StableBlinkFeaturesEnabled()),
    stackedCSSPropertyAnimations_(RuntimeEnabledFeatures::StackedCSSPropertyAnimationsEnabled()),
    storageEstimate_(RuntimeEnabledFeatures::StorageEstimateEnabled()),
    styleSharing_(RuntimeEnabledFeatures::StyleSharingEnabled()),
    suborigins_(RuntimeEnabledFeatures::SuboriginsEnabled()),
    timerThrottlingForBackgroundTabs_(RuntimeEnabledFeatures::TimerThrottlingForBackgroundTabsEnabled()),
    timerThrottlingForHiddenFrames_(RuntimeEnabledFeatures::TimerThrottlingForHiddenFramesEnabled()),
    topNavByUserActivationInSandbox_(RuntimeEnabledFeatures::TopNavByUserActivationInSandboxEnabled()),
    touchEventFeatureDetection_(RuntimeEnabledFeatures::TouchEventFeatureDetectionEnabled()),
    touchpadAndWheelScrollLatching_(RuntimeEnabledFeatures::TouchpadAndWheelScrollLatchingEnabled()),
    trustedEventsDefaultAction_(RuntimeEnabledFeatures::TrustedEventsDefaultActionEnabled()),
    unclosedFormControlIsInvalid_(RuntimeEnabledFeatures::UnclosedFormControlIsInvalidEnabled()),
    updateHoverPostLayout_(RuntimeEnabledFeatures::UpdateHoverPostLayoutEnabled()),
    v8IdleTasks_(RuntimeEnabledFeatures::V8IdleTasksEnabled()),
    validationBubbleInRenderer_(RuntimeEnabledFeatures::ValidationBubbleInRendererEnabled()),
    vibrateRequiresUserGesture_(RuntimeEnabledFeatures::VibrateRequiresUserGestureEnabled()),
    videoFullscreenDetection_(RuntimeEnabledFeatures::VideoFullscreenDetectionEnabled()),
    videoFullscreenOrientationLock_(RuntimeEnabledFeatures::VideoFullscreenOrientationLockEnabled()),
    videoRotateToFullscreen_(RuntimeEnabledFeatures::VideoRotateToFullscreenEnabled()),
    visualViewportAPI_(RuntimeEnabledFeatures::VisualViewportAPIEnabled()),
    wakeLock_(RuntimeEnabledFeatures::WakeLockEnabled()),
    webAnimationsAPI_(RuntimeEnabledFeatures::WebAnimationsAPIEnabled()),
    webAnimationsSVG_(RuntimeEnabledFeatures::WebAnimationsSVGEnabled()),
    webAssemblyStreaming_(RuntimeEnabledFeatures::WebAssemblyStreamingEnabled()),
    webAuth_(RuntimeEnabledFeatures::WebAuthEnabled()),
    webBluetooth_(RuntimeEnabledFeatures::WebBluetoothEnabled()),
    webFontsCacheAwareTimeoutAdaptation_(RuntimeEnabledFeatures::WebFontsCacheAwareTimeoutAdaptationEnabled()),
    webFontsInterventionTrigger_(RuntimeEnabledFeatures::WebFontsInterventionTriggerEnabled()),
    webFontsInterventionV2With2G_(RuntimeEnabledFeatures::WebFontsInterventionV2With2GEnabled()),
    webFontsInterventionV2With3G_(RuntimeEnabledFeatures::WebFontsInterventionV2With3GEnabled()),
    webFontsInterventionV2WithSlow2G_(RuntimeEnabledFeatures::WebFontsInterventionV2WithSlow2GEnabled()),
    webGLDraftExtensions_(RuntimeEnabledFeatures::WebGLDraftExtensionsEnabled()),
    webGLImageChromium_(RuntimeEnabledFeatures::WebGLImageChromiumEnabled()),
    webNFC_(RuntimeEnabledFeatures::WebNFCEnabled()),
    webShare_(RuntimeEnabledFeatures::WebShareEnabled()),
    webUSB_(RuntimeEnabledFeatures::WebUSBEnabled()),
    webVR_(RuntimeEnabledFeatures::WebVREnabled()),
    webVRExperimentalRendering_(RuntimeEnabledFeatures::WebVRExperimentalRenderingEnabled()),
    webVTTRegions_(RuntimeEnabledFeatures::WebVTTRegionsEnabled()),
    worklet_(RuntimeEnabledFeatures::WorkletEnabled()),
    xslt_(RuntimeEnabledFeatures::XSLTEnabled()) {}

void RuntimeEnabledFeatures::Backup::Restore() {
  RuntimeEnabledFeatures::SetAccelerated2dCanvasEnabled(accelerated2dCanvas_);
  RuntimeEnabledFeatures::SetAccessibilityObjectModelEnabled(accessibilityObjectModel_);
  RuntimeEnabledFeatures::SetAllowContentInitiatedDataUrlNavigationsEnabled(allowContentInitiatedDataUrlNavigations_);
  RuntimeEnabledFeatures::SetAsyncClipboardEnabled(asyncClipboard_);
  RuntimeEnabledFeatures::SetAudioOutputDevicesEnabled(audioOutputDevices_);
  RuntimeEnabledFeatures::SetAudioVideoTracksEnabled(audioVideoTracks_);
  RuntimeEnabledFeatures::SetAudioWorkletEnabled(audioWorklet_);
  RuntimeEnabledFeatures::SetAutoplayMutedVideosEnabled(autoplayMutedVideos_);
  RuntimeEnabledFeatures::SetAuxclickEnabled(auxclick_);
  RuntimeEnabledFeatures::SetBackgroundFetchEnabled(backgroundFetch_);
  RuntimeEnabledFeatures::SetBackgroundSyncEnabled(backgroundSync_);
  RuntimeEnabledFeatures::SetBackgroundVideoTrackOptimizationEnabled(backgroundVideoTrackOptimization_);
  RuntimeEnabledFeatures::SetBlinkRuntimeCallStatsEnabled(blinkRuntimeCallStats_);
  RuntimeEnabledFeatures::SetBlockCredentialedSubresourcesEnabled(blockCredentialedSubresources_);
  RuntimeEnabledFeatures::SetBlockLegacySubresourcesEnabled(blockLegacySubresources_);
  RuntimeEnabledFeatures::SetBroadcastChannelEnabled(broadcastChannel_);
  RuntimeEnabledFeatures::SetBudgetEnabled(budget_);
  RuntimeEnabledFeatures::SetBudgetQueryEnabled(budgetQuery_);
  RuntimeEnabledFeatures::SetCanMakePaymentEnabled(canMakePayment_);
  RuntimeEnabledFeatures::SetCanvas2dFixedRenderingModeEnabled(canvas2dFixedRenderingMode_);
  RuntimeEnabledFeatures::SetCanvas2dImageChromiumEnabled(canvas2dImageChromium_);
  RuntimeEnabledFeatures::SetClickRetargettingEnabled(clickRetargetting_);
  RuntimeEnabledFeatures::SetClientHintsEnabled(clientHints_);
  RuntimeEnabledFeatures::SetClientPlaceholdersForServerLoFiEnabled(clientPlaceholdersForServerLoFi_);
  RuntimeEnabledFeatures::SetCoalescedEventsEnabled(coalescedEvents_);
  RuntimeEnabledFeatures::SetColorCanvasExtensionsEnabled(colorCanvasExtensions_);
  RuntimeEnabledFeatures::SetColorCorrectRenderingEnabled(colorCorrectRendering_);
  RuntimeEnabledFeatures::SetCompositedSelectionUpdateEnabled(compositedSelectionUpdate_);
  RuntimeEnabledFeatures::SetCompositeOpaqueFixedPositionEnabled(compositeOpaqueFixedPosition_);
  RuntimeEnabledFeatures::SetCompositeOpaqueScrollersEnabled(compositeOpaqueScrollers_);
  RuntimeEnabledFeatures::SetCompositorTouchActionEnabled(compositorTouchAction_);
  RuntimeEnabledFeatures::SetCompositorWorkerEnabled(compositorWorker_);
  RuntimeEnabledFeatures::SetComputedAccessibilityInfoEnabled(computedAccessibilityInfo_);
  RuntimeEnabledFeatures::SetConicGradientEnabled(conicGradient_);
  RuntimeEnabledFeatures::SetContextMenuEnabled(contextMenu_);
  RuntimeEnabledFeatures::SetCorsRFC1918Enabled(corsRFC1918_);
  RuntimeEnabledFeatures::SetCSS3TextEnabled(css3Text_);
  RuntimeEnabledFeatures::SetCSS3TextDecorationsEnabled(css3TextDecorations_);
  RuntimeEnabledFeatures::SetCSSAdditiveAnimationsEnabled(cssAdditiveAnimations_);
  RuntimeEnabledFeatures::SetCSSApplyAtRulesEnabled(cssApplyAtRules_);
  RuntimeEnabledFeatures::SetCSSBackdropFilterEnabled(cssBackdropFilter_);
  RuntimeEnabledFeatures::SetCSSContainmentEnabled(cssContainment_);
  RuntimeEnabledFeatures::SetCSSDisplayContentsEnabled(cssDisplayContents_);
  RuntimeEnabledFeatures::SetCSSFontDisplayEnabled(cssFontDisplay_);
  RuntimeEnabledFeatures::SetCSSFontSizeAdjustEnabled(cssFontSizeAdjust_);
  RuntimeEnabledFeatures::SetCSSGridLayoutEnabled(cssGridLayout_);
  RuntimeEnabledFeatures::SetCSSHexAlphaColorEnabled(cssHexAlphaColor_);
  RuntimeEnabledFeatures::SetCSSHyphensEnabled(cssHyphens_);
  RuntimeEnabledFeatures::SetCSSInBodyDoesNotBlockPaintEnabled(cssInBodyDoesNotBlockPaint_);
  RuntimeEnabledFeatures::SetCSSIndependentTransformPropertiesEnabled(cssIndependentTransformProperties_);
  RuntimeEnabledFeatures::SetCSSLineBreakEnabled(cssLineBreak_);
  RuntimeEnabledFeatures::SetCSSMaskSourceTypeEnabled(cssMaskSourceType_);
  RuntimeEnabledFeatures::SetCSSOffsetPathRayEnabled(cssOffsetPathRay_);
  RuntimeEnabledFeatures::SetCSSOffsetPathRayContainEnabled(cssOffsetPathRayContain_);
  RuntimeEnabledFeatures::SetCSSOffsetPositionAnchorEnabled(cssOffsetPositionAnchor_);
  RuntimeEnabledFeatures::SetCSSOMSmoothScrollEnabled(cssomSmoothScroll_);
  RuntimeEnabledFeatures::SetCSSPaintAPIEnabled(cssPaintAPI_);
  RuntimeEnabledFeatures::SetCSSPaintAPIArgumentsEnabled(cssPaintAPIArguments_);
  RuntimeEnabledFeatures::SetCSSScrollBoundaryBehaviorEnabled(cssScrollBoundaryBehavior_);
  RuntimeEnabledFeatures::SetCSSScrollSnapPointsEnabled(cssScrollSnapPoints_);
  RuntimeEnabledFeatures::SetCSSSelectorsFocusWithinEnabled(cssSelectorsFocusWithin_);
  RuntimeEnabledFeatures::SetCSSSnapSizeEnabled(cssSnapSize_);
  RuntimeEnabledFeatures::SetCSSStickyPositionEnabled(cssStickyPosition_);
  RuntimeEnabledFeatures::SetCSSTransformBoxEnabled(cssTransformBox_);
  RuntimeEnabledFeatures::SetCSSTypedOMEnabled(cssTypedOM_);
  RuntimeEnabledFeatures::SetCSSVariableFontsEnabled(cssVariableFonts_);
  RuntimeEnabledFeatures::SetCSSVariables2Enabled(cssVariables2_);
  RuntimeEnabledFeatures::SetCSSViewportEnabled(cssViewport_);
  RuntimeEnabledFeatures::SetCustomElementsBuiltinEnabled(customElementsBuiltin_);
  RuntimeEnabledFeatures::SetCustomSchemeHandlerEnabled(customSchemeHandler_);
  RuntimeEnabledFeatures::SetDatabaseEnabled(database_);
  RuntimeEnabledFeatures::SetDecodeToYUVEnabled(decodeToYUV_);
  RuntimeEnabledFeatures::SetDesktopCaptureDisableLocalEchoControlEnabled(desktopCaptureDisableLocalEchoControl_);
  RuntimeEnabledFeatures::SetDeviceMemoryHeaderEnabled(deviceMemoryHeader_);
  RuntimeEnabledFeatures::SetDisplayList2dCanvasEnabled(displayList2dCanvas_);
  RuntimeEnabledFeatures::SetDisplayNoneIFrameCreatesNoLayoutObjectEnabled(displayNoneIFrameCreatesNoLayoutObject_);
  RuntimeEnabledFeatures::SetDocumentCookieEnabled(documentCookie_);
  RuntimeEnabledFeatures::SetDocumentDomainEnabled(documentDomain_);
  RuntimeEnabledFeatures::SetDocumentWriteEnabled(documentWrite_);
  RuntimeEnabledFeatures::SetDocumentWriteEvaluatorEnabled(documentWriteEvaluator_);
  RuntimeEnabledFeatures::SetDOMConvenienceAPIEnabled(dOMConvenienceAPI_);
  RuntimeEnabledFeatures::SetDurableStorageEnabled(durableStorage_);
  RuntimeEnabledFeatures::SetEmbedderCSPEnforcementEnabled(embedderCSPEnforcement_);
  RuntimeEnabledFeatures::SetEncryptedMediaHdcpPolicyCheckEnabled(encryptedMediaHdcpPolicyCheck_);
  RuntimeEnabledFeatures::SetExecCommandInJavaScriptEnabled(execCommandInJavaScript_);
  RuntimeEnabledFeatures::SetExpensiveBackgroundTimerThrottlingEnabled(expensiveBackgroundTimerThrottling_);
  RuntimeEnabledFeatures::SetExperimentalCanvasFeaturesEnabled(experimentalCanvasFeatures_);
  RuntimeEnabledFeatures::SetExperimentalContentSecurityPolicyFeaturesEnabled(experimentalContentSecurityPolicyFeatures_);
  RuntimeEnabledFeatures::SetExperimentalV8ExtrasEnabled(experimentalV8Extras_);
  RuntimeEnabledFeatures::SetFastMobileScrollingEnabled(fastMobileScrolling_);
  RuntimeEnabledFeatures::SetFeaturePolicyEnabled(featurePolicy_);
  RuntimeEnabledFeatures::SetFeaturePolicyExperimentalFeaturesEnabled(featurePolicyExperimentalFeatures_);
  RuntimeEnabledFeatures::SetFetchRequestCacheEnabled(fetchRequestCache_);
  RuntimeEnabledFeatures::SetFileAPIBlobCloseEnabled(fileAPIBlobClose_);
  RuntimeEnabledFeatures::SetFileSystemEnabled(fileSystem_);
  RuntimeEnabledFeatures::SetFontCacheScalingEnabled(fontCacheScaling_);
  RuntimeEnabledFeatures::SetForceDisable2dCanvasCopyOnWriteEnabled(forceDisable2dCanvasCopyOnWrite_);
  RuntimeEnabledFeatures::SetForceDisplayList2dCanvasEnabled(forceDisplayList2dCanvas_);
  RuntimeEnabledFeatures::SetForceOverlayFullscreenVideoEnabled(forceOverlayFullscreenVideo_);
  RuntimeEnabledFeatures::SetForceTallerSelectPopupEnabled(forceTallerSelectPopup_);
  RuntimeEnabledFeatures::SetForeignFetchEnabled(foreignFetch_);
  RuntimeEnabledFeatures::SetFractionalScrollOffsetsEnabled(fractionalScrollOffsets_);
  RuntimeEnabledFeatures::SetFramebustingNeedsSameOriginOrUserGestureEnabled(framebustingNeedsSameOriginOrUserGesture_);
  RuntimeEnabledFeatures::SetFramesTimingFunctionEnabled(framesTimingFunction_);
  RuntimeEnabledFeatures::SetFrameTimingSupportEnabled(frameTimingSupport_);
  RuntimeEnabledFeatures::SetFullscreenUnprefixedEnabled(fullscreenUnprefixed_);
  RuntimeEnabledFeatures::SetGamepadExtensionsEnabled(gamepadExtensions_);
  RuntimeEnabledFeatures::SetGeometryInterfacesEnabled(geometryInterfaces_);
  RuntimeEnabledFeatures::SetGetUserMediaEnabled(getUserMedia_);
  RuntimeEnabledFeatures::SetGlobalCacheStorageEnabled(globalCacheStorage_);
  RuntimeEnabledFeatures::SetHeapCompactionEnabled(heapCompaction_);
  RuntimeEnabledFeatures::SetHideNonceContentAttributeEnabled(hideNonceContentAttribute_);
  RuntimeEnabledFeatures::SetHTMLImportsStyleApplicationEnabled(htmlImportsStyleApplication_);
  RuntimeEnabledFeatures::SetIDBObserverEnabled(iDBObserver_);
  RuntimeEnabledFeatures::SetIdleTimeColdModeSpellCheckingEnabled(idleTimeColdModeSpellChecking_);
  RuntimeEnabledFeatures::SetIdleTimeSpellCheckingEnabled(idleTimeSpellChecking_);
  RuntimeEnabledFeatures::SetImageCaptureEnabled(imageCapture_);
  RuntimeEnabledFeatures::SetImageOrientationEnabled(imageOrientation_);
  RuntimeEnabledFeatures::SetInertAttributeEnabled(inertAttribute_);
  RuntimeEnabledFeatures::SetInputEventEnabled(inputEvent_);
  RuntimeEnabledFeatures::SetInputModeAttributeEnabled(inputModeAttribute_);
  RuntimeEnabledFeatures::SetInputMultipleFieldsUIEnabled(inputMultipleFieldsUI_);
  RuntimeEnabledFeatures::SetInstalledAppEnabled(installedApp_);
  RuntimeEnabledFeatures::SetIntersectionObserverEnabled(intersectionObserver_);
  RuntimeEnabledFeatures::SetJSImageDecodeEnabled(jsImageDecode_);
  RuntimeEnabledFeatures::SetKeyboardLockEnabled(keyboardLock_);
  RuntimeEnabledFeatures::SetLangAttributeAwareFormControlUIEnabled(langAttributeAwareFormControlUI_);
  RuntimeEnabledFeatures::SetLayoutNGEnabled(layoutNG_);
  RuntimeEnabledFeatures::SetLazyInitializeMediaControlsEnabled(lazyInitializeMediaControls_);
  RuntimeEnabledFeatures::SetLazyParseCSSEnabled(lazyParseCSS_);
  RuntimeEnabledFeatures::SetLinkServiceWorkerEnabled(linkServiceWorker_);
  RuntimeEnabledFeatures::SetLoadingWithMojoEnabled(loadingWithMojo_);
  RuntimeEnabledFeatures::SetLongTaskObserverEnabled(longTaskObserver_);
  RuntimeEnabledFeatures::SetMediaCapabilitiesEnabled(mediaCapabilities_);
  RuntimeEnabledFeatures::SetMediaCaptureEnabled(mediaCapture_);
  RuntimeEnabledFeatures::SetMediaCaptureDepthEnabled(mediaCaptureDepth_);
  RuntimeEnabledFeatures::SetMediaCaptureFromCanvasEnabled(mediaCaptureFromCanvas_);
  RuntimeEnabledFeatures::SetMediaCaptureFromVideoEnabled(mediaCaptureFromVideo_);
  RuntimeEnabledFeatures::SetMediaCastOverlayButtonEnabled(mediaCastOverlayButton_);
  RuntimeEnabledFeatures::SetMediaControlsOverlayPlayButtonEnabled(mediaControlsOverlayPlayButton_);
  RuntimeEnabledFeatures::SetMediaDocumentDownloadButtonEnabled(mediaDocumentDownloadButton_);
  RuntimeEnabledFeatures::SetMediaQueryShapeEnabled(mediaQueryShape_);
  RuntimeEnabledFeatures::SetMediaSessionEnabled(mediaSession_);
  RuntimeEnabledFeatures::SetMediaSourceExperimentalEnabled(mediaSourceExperimental_);
  RuntimeEnabledFeatures::SetMediaSourceNewAbortAndDurationEnabled(mediaSourceNewAbortAndDuration_);
  RuntimeEnabledFeatures::SetMediaStreamSpeechEnabled(mediaStreamSpeech_);
  RuntimeEnabledFeatures::SetMediaStreamTrackContentHintEnabled(mediaStreamTrackContentHint_);
  RuntimeEnabledFeatures::SetMediaTrackApplyConstraintsEnabled(mediaTrackApplyConstraints_);
  RuntimeEnabledFeatures::SetMediaTrackCapabilitiesEnabled(mediaTrackCapabilities_);
  RuntimeEnabledFeatures::SetMemoryInfoInWorkersEnabled(memoryInfoInWorkers_);
  RuntimeEnabledFeatures::SetMiddleClickAutoscrollEnabled(middleClickAutoscroll_);
  RuntimeEnabledFeatures::SetMobileLayoutThemeEnabled(mobileLayoutTheme_);
  RuntimeEnabledFeatures::SetModuleScriptsEnabled(moduleScripts_);
  RuntimeEnabledFeatures::SetMojoBlobsEnabled(mojoBlobs_);
  RuntimeEnabledFeatures::SetMojoJSEnabled(mojoJS_);
  RuntimeEnabledFeatures::SetMojoJSTestEnabled(mojoJSTest_);
  RuntimeEnabledFeatures::SetMultipleColorStopPositionsEnabled(multipleColorStopPositions_);
  RuntimeEnabledFeatures::SetNavigatorContentUtilsEnabled(navigatorContentUtils_);
  RuntimeEnabledFeatures::SetNetInfoDownlinkEnabled(netInfoDownlink_);
  RuntimeEnabledFeatures::SetNetInfoDownlinkMaxEnabled(netInfoDownlinkMax_);
  RuntimeEnabledFeatures::SetNetInfoEffectiveTypeEnabled(netInfoEffectiveType_);
  RuntimeEnabledFeatures::SetNetInfoRttEnabled(netInfoRtt_);
  RuntimeEnabledFeatures::SetNewRemotePlaybackPipelineEnabled(newRemotePlaybackPipeline_);
  RuntimeEnabledFeatures::SetNotificationBadgeEnabled(notificationBadge_);
  RuntimeEnabledFeatures::SetNotificationConstructorEnabled(notificationConstructor_);
  RuntimeEnabledFeatures::SetNotificationContentImageEnabled(notificationContentImage_);
  RuntimeEnabledFeatures::SetNotificationInlineRepliesEnabled(notificationInlineReplies_);
  RuntimeEnabledFeatures::SetNotificationsEnabled(notifications_);
  RuntimeEnabledFeatures::SetNullableDocumentDomainEnabled(nullableDocumentDomain_);
  RuntimeEnabledFeatures::SetOffMainThreadFetchEnabled(offMainThreadFetch_);
  RuntimeEnabledFeatures::SetOnDeviceChangeEnabled(onDeviceChange_);
  RuntimeEnabledFeatures::SetOrientationEventEnabled(orientationEvent_);
  RuntimeEnabledFeatures::SetOriginTrialsEnabled(originTrials_);
  RuntimeEnabledFeatures::SetOriginTrialsSampleAPIEnabled(originTrialsSampleAPI_);
  RuntimeEnabledFeatures::SetOutOfBlinkCORSEnabled(outOfBlinkCORS_);
  RuntimeEnabledFeatures::SetOverlayScrollbarsEnabled(overlayScrollbars_);
  RuntimeEnabledFeatures::SetPagePopupEnabled(pagePopup_);
  RuntimeEnabledFeatures::SetPaintUnderInvalidationCheckingEnabled(paintUnderInvalidationChecking_);
  RuntimeEnabledFeatures::SetPassiveDocumentEventListenersEnabled(passiveDocumentEventListeners_);
  RuntimeEnabledFeatures::SetPassPaintVisualRectToCompositorEnabled(passPaintVisualRectToCompositor_);
  RuntimeEnabledFeatures::SetPaymentAppEnabled(paymentApp_);
  RuntimeEnabledFeatures::SetPaymentDetailsModifierDataEnabled(paymentDetailsModifierData_);
  RuntimeEnabledFeatures::SetPaymentRequestEnabled(paymentRequest_);
  RuntimeEnabledFeatures::SetPaymentRequestBasicCardEnabled(paymentRequestBasicCard_);
  RuntimeEnabledFeatures::SetPerformanceNavigationTiming2Enabled(performanceNavigationTiming2_);
  RuntimeEnabledFeatures::SetPerformanceObserverEnabled(performanceObserver_);
  RuntimeEnabledFeatures::SetPerformancePaintTimingEnabled(performancePaintTiming_);
  RuntimeEnabledFeatures::SetPermissionDelegationEnabled(permissionDelegation_);
  RuntimeEnabledFeatures::SetPermissionsEnabled(permissions_);
  RuntimeEnabledFeatures::SetPermissionsRequestRevokeEnabled(permissionsRequestRevoke_);
  RuntimeEnabledFeatures::SetPreciseMemoryInfoEnabled(preciseMemoryInfo_);
  RuntimeEnabledFeatures::SetPreferredImageRasterBoundsEnabled(preferredImageRasterBounds_);
  RuntimeEnabledFeatures::SetPrefixedVideoFullscreenEnabled(prefixedVideoFullscreen_);
  RuntimeEnabledFeatures::SetPresentationEnabled(presentation_);
  RuntimeEnabledFeatures::SetPresentationReceiverEnabled(presentationReceiver_);
  RuntimeEnabledFeatures::SetPrintBrowserEnabled(printBrowser_);
  RuntimeEnabledFeatures::SetPushMessagingEnabled(pushMessaging_);
  RuntimeEnabledFeatures::SetReducedReferrerGranularityEnabled(reducedReferrerGranularity_);
  RuntimeEnabledFeatures::SetRemotePlaybackEnabled(remotePlayback_);
  RuntimeEnabledFeatures::SetRemotePlaybackBackendEnabled(remotePlaybackBackend_);
  RuntimeEnabledFeatures::SetRenderingPipelineThrottlingEnabled(renderingPipelineThrottling_);
  RuntimeEnabledFeatures::SetRenderingPipelineThrottlingLoadingIframesEnabled(renderingPipelineThrottlingLoadingIframes_);
  RuntimeEnabledFeatures::SetRenderUnicodeControlCharactersEnabled(renderUnicodeControlCharacters_);
  RuntimeEnabledFeatures::SetResizeObserverEnabled(resizeObserver_);
  RuntimeEnabledFeatures::SetResourceLoadSchedulerEnabled(resourceLoadScheduler_);
  RuntimeEnabledFeatures::SetRestrictCanRequestURLCharacterSetEnabled(restrictCanRequestURLCharacterSet_);
  RuntimeEnabledFeatures::SetRootLayerScrollingEnabled(rootLayerScrolling_);
  RuntimeEnabledFeatures::SetRTCRtpSenderEnabled(rTCRtpSender_);
  RuntimeEnabledFeatures::SetScriptedSpeechEnabled(scriptedSpeech_);
  RuntimeEnabledFeatures::SetScrollAnchoringEnabled(scrollAnchoring_);
  RuntimeEnabledFeatures::SetScrollCustomizationEnabled(scrollCustomization_);
  RuntimeEnabledFeatures::SetScrollTopLeftInteropEnabled(scrollTopLeftInterop_);
  RuntimeEnabledFeatures::SetSendBeaconThrowForBlobWithNonSimpleTypeEnabled(sendBeaconThrowForBlobWithNonSimpleType_);
  RuntimeEnabledFeatures::SetSendMouseEventsDisabledFormControlsEnabled(sendMouseEventsDisabledFormControls_);
  RuntimeEnabledFeatures::SetSensorEnabled(sensor_);
  RuntimeEnabledFeatures::SetServerTimingEnabled(serverTiming_);
  RuntimeEnabledFeatures::SetServiceWorkerNavigationPreloadEnabled(serviceWorkerNavigationPreload_);
  RuntimeEnabledFeatures::SetServiceWorkerScriptStreamingEnabled(serviceWorkerScriptStreaming_);
  RuntimeEnabledFeatures::SetSetRootScrollerEnabled(setRootScroller_);
  RuntimeEnabledFeatures::SetShadowPiercingDescendantCombinatorEnabled(shadowPiercingDescendantCombinator_);
  RuntimeEnabledFeatures::SetShapeDetectionEnabled(shapeDetection_);
  RuntimeEnabledFeatures::SetSharedArrayBufferEnabled(sharedArrayBuffer_);
  RuntimeEnabledFeatures::SetSharedWorkerEnabled(sharedWorker_);
  RuntimeEnabledFeatures::SetSkipCompositingSmallScrollersEnabled(skipCompositingSmallScrollers_);
  RuntimeEnabledFeatures::SetSlimmingPaintStrictCullRectClippingEnabled(slimmingPaintStrictCullRectClipping_);
  RuntimeEnabledFeatures::SetSlimmingPaintV2Enabled(slimmingPaintV2_);
  RuntimeEnabledFeatures::SetSMILEnabled(smil_);
  RuntimeEnabledFeatures::SetSmoothScrollJSInterventionEnabled(smoothScrollJSIntervention_);
  RuntimeEnabledFeatures::SetStableBlinkFeaturesEnabled(stableBlinkFeatures_);
  RuntimeEnabledFeatures::SetStackedCSSPropertyAnimationsEnabled(stackedCSSPropertyAnimations_);
  RuntimeEnabledFeatures::SetStorageEstimateEnabled(storageEstimate_);
  RuntimeEnabledFeatures::SetStyleSharingEnabled(styleSharing_);
  RuntimeEnabledFeatures::SetSuboriginsEnabled(suborigins_);
  RuntimeEnabledFeatures::SetTimerThrottlingForBackgroundTabsEnabled(timerThrottlingForBackgroundTabs_);
  RuntimeEnabledFeatures::SetTimerThrottlingForHiddenFramesEnabled(timerThrottlingForHiddenFrames_);
  RuntimeEnabledFeatures::SetTopNavByUserActivationInSandboxEnabled(topNavByUserActivationInSandbox_);
  RuntimeEnabledFeatures::SetTouchEventFeatureDetectionEnabled(touchEventFeatureDetection_);
  RuntimeEnabledFeatures::SetTouchpadAndWheelScrollLatchingEnabled(touchpadAndWheelScrollLatching_);
  RuntimeEnabledFeatures::SetTrustedEventsDefaultActionEnabled(trustedEventsDefaultAction_);
  RuntimeEnabledFeatures::SetUnclosedFormControlIsInvalidEnabled(unclosedFormControlIsInvalid_);
  RuntimeEnabledFeatures::SetUpdateHoverPostLayoutEnabled(updateHoverPostLayout_);
  RuntimeEnabledFeatures::SetV8IdleTasksEnabled(v8IdleTasks_);
  RuntimeEnabledFeatures::SetValidationBubbleInRendererEnabled(validationBubbleInRenderer_);
  RuntimeEnabledFeatures::SetVibrateRequiresUserGestureEnabled(vibrateRequiresUserGesture_);
  RuntimeEnabledFeatures::SetVideoFullscreenDetectionEnabled(videoFullscreenDetection_);
  RuntimeEnabledFeatures::SetVideoFullscreenOrientationLockEnabled(videoFullscreenOrientationLock_);
  RuntimeEnabledFeatures::SetVideoRotateToFullscreenEnabled(videoRotateToFullscreen_);
  RuntimeEnabledFeatures::SetVisualViewportAPIEnabled(visualViewportAPI_);
  RuntimeEnabledFeatures::SetWakeLockEnabled(wakeLock_);
  RuntimeEnabledFeatures::SetWebAnimationsAPIEnabled(webAnimationsAPI_);
  RuntimeEnabledFeatures::SetWebAnimationsSVGEnabled(webAnimationsSVG_);
  RuntimeEnabledFeatures::SetWebAssemblyStreamingEnabled(webAssemblyStreaming_);
  RuntimeEnabledFeatures::SetWebAuthEnabled(webAuth_);
  RuntimeEnabledFeatures::SetWebBluetoothEnabled(webBluetooth_);
  RuntimeEnabledFeatures::SetWebFontsCacheAwareTimeoutAdaptationEnabled(webFontsCacheAwareTimeoutAdaptation_);
  RuntimeEnabledFeatures::SetWebFontsInterventionTriggerEnabled(webFontsInterventionTrigger_);
  RuntimeEnabledFeatures::SetWebFontsInterventionV2With2GEnabled(webFontsInterventionV2With2G_);
  RuntimeEnabledFeatures::SetWebFontsInterventionV2With3GEnabled(webFontsInterventionV2With3G_);
  RuntimeEnabledFeatures::SetWebFontsInterventionV2WithSlow2GEnabled(webFontsInterventionV2WithSlow2G_);
  RuntimeEnabledFeatures::SetWebGLDraftExtensionsEnabled(webGLDraftExtensions_);
  RuntimeEnabledFeatures::SetWebGLImageChromiumEnabled(webGLImageChromium_);
  RuntimeEnabledFeatures::SetWebNFCEnabled(webNFC_);
  RuntimeEnabledFeatures::SetWebShareEnabled(webShare_);
  RuntimeEnabledFeatures::SetWebUSBEnabled(webUSB_);
  RuntimeEnabledFeatures::SetWebVREnabled(webVR_);
  RuntimeEnabledFeatures::SetWebVRExperimentalRenderingEnabled(webVRExperimentalRendering_);
  RuntimeEnabledFeatures::SetWebVTTRegionsEnabled(webVTTRegions_);
  RuntimeEnabledFeatures::SetWorkletEnabled(worklet_);
  RuntimeEnabledFeatures::SetXSLTEnabled(xslt_);
}

void RuntimeEnabledFeatures::SetStableFeaturesEnabled(bool enable) {
  SetAccelerated2dCanvasEnabled(enable);
  SetAllowContentInitiatedDataUrlNavigationsEnabled(enable);
  SetAudioOutputDevicesEnabled(enable);
  SetAuxclickEnabled(enable);
  SetBackgroundSyncEnabled(enable);
  SetBackgroundVideoTrackOptimizationEnabled(enable);
  SetBlockCredentialedSubresourcesEnabled(enable);
  SetBlockLegacySubresourcesEnabled(enable);
  SetBroadcastChannelEnabled(enable);
  SetBudgetEnabled(enable);
  SetCanMakePaymentEnabled(enable);
  SetClientHintsEnabled(enable);
  SetCoalescedEventsEnabled(enable);
  SetCompositeOpaqueScrollersEnabled(enable);
  SetCSS3TextDecorationsEnabled(enable);
  SetCSSContainmentEnabled(enable);
  SetCSSFontDisplayEnabled(enable);
  SetCSSGridLayoutEnabled(enable);
  SetCSSHyphensEnabled(enable);
  SetCSSOMSmoothScrollEnabled(enable);
  SetCSSSelectorsFocusWithinEnabled(enable);
  SetCSSStickyPositionEnabled(enable);
  SetDatabaseEnabled(enable);
  SetDeviceMemoryHeaderEnabled(enable);
  SetDisplayList2dCanvasEnabled(enable);
  SetDOMConvenienceAPIEnabled(enable);
  SetDurableStorageEnabled(enable);
  SetEmbedderCSPEnforcementEnabled(enable);
  SetExpensiveBackgroundTimerThrottlingEnabled(enable);
  SetFeaturePolicyEnabled(enable);
  SetFileSystemEnabled(enable);
  SetGeometryInterfacesEnabled(enable);
  SetGetUserMediaEnabled(enable);
  SetGlobalCacheStorageEnabled(enable);
  SetHeapCompactionEnabled(enable);
  SetHideNonceContentAttributeEnabled(enable);
  SetHTMLImportsStyleApplicationEnabled(enable);
  SetImageCaptureEnabled(enable);
  SetInputEventEnabled(enable);
  SetInputMultipleFieldsUIEnabled(enable);
  SetIntersectionObserverEnabled(enable);
  SetLongTaskObserverEnabled(enable);
  SetMediaCaptureFromCanvasEnabled(enable);
  SetModuleScriptsEnabled(enable);
  SetNetInfoDownlinkEnabled(enable);
  SetNetInfoDownlinkMaxEnabled(enable);
  SetNetInfoEffectiveTypeEnabled(enable);
  SetNetInfoRttEnabled(enable);
  SetNotificationBadgeEnabled(enable);
  SetNotificationConstructorEnabled(enable);
  SetNotificationsEnabled(enable);
  SetOnDeviceChangeEnabled(enable);
  SetOriginTrialsEnabled(enable);
  SetPagePopupEnabled(enable);
  SetPassiveDocumentEventListenersEnabled(enable);
  SetPaymentRequestBasicCardEnabled(enable);
  SetPerformanceNavigationTiming2Enabled(enable);
  SetPerformanceObserverEnabled(enable);
  SetPerformancePaintTimingEnabled(enable);
  SetPermissionsEnabled(enable);
  SetPrefixedVideoFullscreenEnabled(enable);
  SetPresentationEnabled(enable);
  SetPresentationReceiverEnabled(enable);
  SetPushMessagingEnabled(enable);
  SetRemotePlaybackEnabled(enable);
  SetRenderingPipelineThrottlingEnabled(enable);
  SetRenderingPipelineThrottlingLoadingIframesEnabled(enable);
  SetRenderUnicodeControlCharactersEnabled(enable);
  SetRestrictCanRequestURLCharacterSetEnabled(enable);
  SetScriptedSpeechEnabled(enable);
  SetScrollTopLeftInteropEnabled(enable);
  SetSendBeaconThrowForBlobWithNonSimpleTypeEnabled(enable);
  SetServiceWorkerNavigationPreloadEnabled(enable);
  SetSharedArrayBufferEnabled(enable);
  SetSharedWorkerEnabled(enable);
  SetSMILEnabled(enable);
  SetSmoothScrollJSInterventionEnabled(enable);
  SetStableBlinkFeaturesEnabled(enable);
  SetStorageEstimateEnabled(enable);
  SetTimerThrottlingForBackgroundTabsEnabled(enable);
  SetTimerThrottlingForHiddenFramesEnabled(enable);
  SetTopNavByUserActivationInSandboxEnabled(enable);
  SetTouchEventFeatureDetectionEnabled(enable);
  SetTrustedEventsDefaultActionEnabled(enable);
  SetVibrateRequiresUserGestureEnabled(enable);
  SetVisualViewportAPIEnabled(enable);
  SetWebUSBEnabled(enable);
  SetXSLTEnabled(enable);
}

void RuntimeEnabledFeatures::SetExperimentalFeaturesEnabled(bool enable) {
  SetAccessibilityObjectModelEnabled(enable);
  SetAsyncClipboardEnabled(enable);
  SetAudioVideoTracksEnabled(enable);
  SetAudioWorkletEnabled(enable);
  SetBackgroundFetchEnabled(enable);
  SetBudgetQueryEnabled(enable);
  SetCanvas2dImageChromiumEnabled(enable);
  SetClickRetargettingEnabled(enable);
  SetColorCorrectRenderingEnabled(enable);
  SetCompositorWorkerEnabled(enable);
  SetComputedAccessibilityInfoEnabled(enable);
  SetConicGradientEnabled(enable);
  SetContextMenuEnabled(enable);
  SetCSS3TextEnabled(enable);
  SetCSSAdditiveAnimationsEnabled(enable);
  SetCSSApplyAtRulesEnabled(enable);
  SetCSSBackdropFilterEnabled(enable);
  SetCSSDisplayContentsEnabled(enable);
  SetCSSFontSizeAdjustEnabled(enable);
  SetCSSHexAlphaColorEnabled(enable);
  SetCSSInBodyDoesNotBlockPaintEnabled(enable);
  SetCSSIndependentTransformPropertiesEnabled(enable);
  SetCSSMaskSourceTypeEnabled(enable);
  SetCSSOffsetPathRayEnabled(enable);
  SetCSSOffsetPathRayContainEnabled(enable);
  SetCSSOffsetPositionAnchorEnabled(enable);
  SetCSSPaintAPIEnabled(enable);
  SetCSSPaintAPIArgumentsEnabled(enable);
  SetCSSScrollBoundaryBehaviorEnabled(enable);
  SetCSSSnapSizeEnabled(enable);
  SetCSSTransformBoxEnabled(enable);
  SetCSSTypedOMEnabled(enable);
  SetCSSVariableFontsEnabled(enable);
  SetCSSVariables2Enabled(enable);
  SetCSSViewportEnabled(enable);
  SetCustomSchemeHandlerEnabled(enable);
  SetDecodeToYUVEnabled(enable);
  SetDesktopCaptureDisableLocalEchoControlEnabled(enable);
  SetDisplayNoneIFrameCreatesNoLayoutObjectEnabled(enable);
  SetExperimentalContentSecurityPolicyFeaturesEnabled(enable);
  SetExperimentalV8ExtrasEnabled(enable);
  SetFetchRequestCacheEnabled(enable);
  SetFileAPIBlobCloseEnabled(enable);
  SetForeignFetchEnabled(enable);
  SetFramebustingNeedsSameOriginOrUserGestureEnabled(enable);
  SetFramesTimingFunctionEnabled(enable);
  SetFrameTimingSupportEnabled(enable);
  SetFullscreenUnprefixedEnabled(enable);
  SetIDBObserverEnabled(enable);
  SetInertAttributeEnabled(enable);
  SetInputModeAttributeEnabled(enable);
  SetInstalledAppEnabled(enable);
  SetLazyParseCSSEnabled(enable);
  SetLinkServiceWorkerEnabled(enable);
  SetMediaCaptureDepthEnabled(enable);
  SetMediaCaptureFromVideoEnabled(enable);
  SetMediaQueryShapeEnabled(enable);
  SetMediaSourceExperimentalEnabled(enable);
  SetMediaSourceNewAbortAndDurationEnabled(enable);
  SetMediaStreamSpeechEnabled(enable);
  SetMediaStreamTrackContentHintEnabled(enable);
  SetMediaTrackApplyConstraintsEnabled(enable);
  SetMediaTrackCapabilitiesEnabled(enable);
  SetMemoryInfoInWorkersEnabled(enable);
  SetMultipleColorStopPositionsEnabled(enable);
  SetNotificationInlineRepliesEnabled(enable);
  SetNullableDocumentDomainEnabled(enable);
  SetPaymentAppEnabled(enable);
  SetPaymentDetailsModifierDataEnabled(enable);
  SetPaymentRequestEnabled(enable);
  SetPermissionsRequestRevokeEnabled(enable);
  SetResizeObserverEnabled(enable);
  SetResourceLoadSchedulerEnabled(enable);
  SetRTCRtpSenderEnabled(enable);
  SetScrollAnchoringEnabled(enable);
  SetSendMouseEventsDisabledFormControlsEnabled(enable);
  SetSensorEnabled(enable);
  SetServerTimingEnabled(enable);
  SetSetRootScrollerEnabled(enable);
  SetShadowPiercingDescendantCombinatorEnabled(enable);
  SetShapeDetectionEnabled(enable);
  SetStackedCSSPropertyAnimationsEnabled(enable);
  SetStyleSharingEnabled(enable);
  SetSuboriginsEnabled(enable);
  SetUnclosedFormControlIsInvalidEnabled(enable);
  SetUpdateHoverPostLayoutEnabled(enable);
  SetValidationBubbleInRendererEnabled(enable);
  SetWakeLockEnabled(enable);
  SetWebAnimationsAPIEnabled(enable);
  SetWebAnimationsSVGEnabled(enable);
  SetWebAssemblyStreamingEnabled(enable);
  SetWebAuthEnabled(enable);
  SetWebBluetoothEnabled(enable);
  SetWebFontsCacheAwareTimeoutAdaptationEnabled(enable);
  SetWebGLDraftExtensionsEnabled(enable);
  SetWebNFCEnabled(enable);
  SetWebShareEnabled(enable);
  SetWebVTTRegionsEnabled(enable);
  SetWorkletEnabled(enable);
}

void RuntimeEnabledFeatures::SetTestFeaturesEnabled(bool enable) {
  SetCanvas2dFixedRenderingModeEnabled(enable);
  SetCompositeOpaqueFixedPositionEnabled(enable);
  SetCompositorTouchActionEnabled(enable);
  SetCorsRFC1918Enabled(enable);
  SetCSSLineBreakEnabled(enable);
  SetCSSScrollSnapPointsEnabled(enable);
  SetCustomElementsBuiltinEnabled(enable);
  SetEncryptedMediaHdcpPolicyCheckEnabled(enable);
  SetExecCommandInJavaScriptEnabled(enable);
  SetExperimentalCanvasFeaturesEnabled(enable);
  SetFontCacheScalingEnabled(enable);
  SetGamepadExtensionsEnabled(enable);
  SetIdleTimeColdModeSpellCheckingEnabled(enable);
  SetIdleTimeSpellCheckingEnabled(enable);
  SetImageOrientationEnabled(enable);
  SetJSImageDecodeEnabled(enable);
  SetKeyboardLockEnabled(enable);
  SetMediaCapabilitiesEnabled(enable);
  SetMediaSessionEnabled(enable);
  SetMiddleClickAutoscrollEnabled(enable);
  SetMojoJSEnabled(enable);
  SetMojoJSTestEnabled(enable);
  SetNotificationContentImageEnabled(enable);
  SetPermissionDelegationEnabled(enable);
  SetSkipCompositingSmallScrollersEnabled(enable);
  SetWebVREnabled(enable);
  SetWebVRExperimentalRenderingEnabled(enable);
}


void RuntimeEnabledFeatures::SetOriginTrialControlledFeaturesEnabled(bool enable) {
  SetBudgetQueryEnabled(enable);
  SetForeignFetchEnabled(enable);
  SetGamepadExtensionsEnabled(enable);
  SetInstalledAppEnabled(enable);
  SetLinkServiceWorkerEnabled(enable);
  SetOriginTrialsSampleAPIEnabled(enable);
  SetWebVREnabled(enable);
}

void RuntimeEnabledFeatures::SetFeatureEnabledFromString(
    const std::string& name, bool enable) {
  if (name == "Accelerated2dCanvas") {
    SetAccelerated2dCanvasEnabled(enable);
    return;
  }
  if (name == "AccessibilityObjectModel") {
    SetAccessibilityObjectModelEnabled(enable);
    return;
  }
  if (name == "AllowContentInitiatedDataUrlNavigations") {
    SetAllowContentInitiatedDataUrlNavigationsEnabled(enable);
    return;
  }
  if (name == "AsyncClipboard") {
    SetAsyncClipboardEnabled(enable);
    return;
  }
  if (name == "AudioOutputDevices") {
    SetAudioOutputDevicesEnabled(enable);
    return;
  }
  if (name == "AudioVideoTracks") {
    SetAudioVideoTracksEnabled(enable);
    return;
  }
  if (name == "AudioWorklet") {
    SetAudioWorkletEnabled(enable);
    return;
  }
  if (name == "AutoplayMutedVideos") {
    SetAutoplayMutedVideosEnabled(enable);
    return;
  }
  if (name == "Auxclick") {
    SetAuxclickEnabled(enable);
    return;
  }
  if (name == "BackgroundFetch") {
    SetBackgroundFetchEnabled(enable);
    return;
  }
  if (name == "BackgroundSync") {
    SetBackgroundSyncEnabled(enable);
    return;
  }
  if (name == "BackgroundVideoTrackOptimization") {
    SetBackgroundVideoTrackOptimizationEnabled(enable);
    return;
  }
  if (name == "BlinkRuntimeCallStats") {
    SetBlinkRuntimeCallStatsEnabled(enable);
    return;
  }
  if (name == "BlockCredentialedSubresources") {
    SetBlockCredentialedSubresourcesEnabled(enable);
    return;
  }
  if (name == "BlockLegacySubresources") {
    SetBlockLegacySubresourcesEnabled(enable);
    return;
  }
  if (name == "BroadcastChannel") {
    SetBroadcastChannelEnabled(enable);
    return;
  }
  if (name == "Budget") {
    SetBudgetEnabled(enable);
    return;
  }
  if (name == "BudgetQuery") {
    SetBudgetQueryEnabled(enable);
    return;
  }
  if (name == "CanMakePayment") {
    SetCanMakePaymentEnabled(enable);
    return;
  }
  if (name == "Canvas2dFixedRenderingMode") {
    SetCanvas2dFixedRenderingModeEnabled(enable);
    return;
  }
  if (name == "Canvas2dImageChromium") {
    SetCanvas2dImageChromiumEnabled(enable);
    return;
  }
  if (name == "ClickRetargetting") {
    SetClickRetargettingEnabled(enable);
    return;
  }
  if (name == "ClientHints") {
    SetClientHintsEnabled(enable);
    return;
  }
  if (name == "ClientPlaceholdersForServerLoFi") {
    SetClientPlaceholdersForServerLoFiEnabled(enable);
    return;
  }
  if (name == "CoalescedEvents") {
    SetCoalescedEventsEnabled(enable);
    return;
  }
  if (name == "ColorCanvasExtensions") {
    SetColorCanvasExtensionsEnabled(enable);
    return;
  }
  if (name == "ColorCorrectRendering") {
    SetColorCorrectRenderingEnabled(enable);
    return;
  }
  if (name == "CompositedSelectionUpdate") {
    SetCompositedSelectionUpdateEnabled(enable);
    return;
  }
  if (name == "CompositeOpaqueFixedPosition") {
    SetCompositeOpaqueFixedPositionEnabled(enable);
    return;
  }
  if (name == "CompositeOpaqueScrollers") {
    SetCompositeOpaqueScrollersEnabled(enable);
    return;
  }
  if (name == "CompositorTouchAction") {
    SetCompositorTouchActionEnabled(enable);
    return;
  }
  if (name == "CompositorWorker") {
    SetCompositorWorkerEnabled(enable);
    return;
  }
  if (name == "ComputedAccessibilityInfo") {
    SetComputedAccessibilityInfoEnabled(enable);
    return;
  }
  if (name == "ConicGradient") {
    SetConicGradientEnabled(enable);
    return;
  }
  if (name == "ContextMenu") {
    SetContextMenuEnabled(enable);
    return;
  }
  if (name == "CorsRFC1918") {
    SetCorsRFC1918Enabled(enable);
    return;
  }
  if (name == "CSS3Text") {
    SetCSS3TextEnabled(enable);
    return;
  }
  if (name == "CSS3TextDecorations") {
    SetCSS3TextDecorationsEnabled(enable);
    return;
  }
  if (name == "CSSAdditiveAnimations") {
    SetCSSAdditiveAnimationsEnabled(enable);
    return;
  }
  if (name == "CSSApplyAtRules") {
    SetCSSApplyAtRulesEnabled(enable);
    return;
  }
  if (name == "CSSBackdropFilter") {
    SetCSSBackdropFilterEnabled(enable);
    return;
  }
  if (name == "CSSContainment") {
    SetCSSContainmentEnabled(enable);
    return;
  }
  if (name == "CSSDisplayContents") {
    SetCSSDisplayContentsEnabled(enable);
    return;
  }
  if (name == "CSSFontDisplay") {
    SetCSSFontDisplayEnabled(enable);
    return;
  }
  if (name == "CSSFontSizeAdjust") {
    SetCSSFontSizeAdjustEnabled(enable);
    return;
  }
  if (name == "CSSGridLayout") {
    SetCSSGridLayoutEnabled(enable);
    return;
  }
  if (name == "CSSHexAlphaColor") {
    SetCSSHexAlphaColorEnabled(enable);
    return;
  }
  if (name == "CSSHyphens") {
    SetCSSHyphensEnabled(enable);
    return;
  }
  if (name == "CSSInBodyDoesNotBlockPaint") {
    SetCSSInBodyDoesNotBlockPaintEnabled(enable);
    return;
  }
  if (name == "CSSIndependentTransformProperties") {
    SetCSSIndependentTransformPropertiesEnabled(enable);
    return;
  }
  if (name == "CSSLineBreak") {
    SetCSSLineBreakEnabled(enable);
    return;
  }
  if (name == "CSSMaskSourceType") {
    SetCSSMaskSourceTypeEnabled(enable);
    return;
  }
  if (name == "CSSOffsetPathRay") {
    SetCSSOffsetPathRayEnabled(enable);
    return;
  }
  if (name == "CSSOffsetPathRayContain") {
    SetCSSOffsetPathRayContainEnabled(enable);
    return;
  }
  if (name == "CSSOffsetPositionAnchor") {
    SetCSSOffsetPositionAnchorEnabled(enable);
    return;
  }
  if (name == "CSSOMSmoothScroll") {
    SetCSSOMSmoothScrollEnabled(enable);
    return;
  }
  if (name == "CSSPaintAPI") {
    SetCSSPaintAPIEnabled(enable);
    return;
  }
  if (name == "CSSPaintAPIArguments") {
    SetCSSPaintAPIArgumentsEnabled(enable);
    return;
  }
  if (name == "CSSScrollBoundaryBehavior") {
    SetCSSScrollBoundaryBehaviorEnabled(enable);
    return;
  }
  if (name == "CSSScrollSnapPoints") {
    SetCSSScrollSnapPointsEnabled(enable);
    return;
  }
  if (name == "CSSSelectorsFocusWithin") {
    SetCSSSelectorsFocusWithinEnabled(enable);
    return;
  }
  if (name == "CSSSnapSize") {
    SetCSSSnapSizeEnabled(enable);
    return;
  }
  if (name == "CSSStickyPosition") {
    SetCSSStickyPositionEnabled(enable);
    return;
  }
  if (name == "CSSTransformBox") {
    SetCSSTransformBoxEnabled(enable);
    return;
  }
  if (name == "CSSTypedOM") {
    SetCSSTypedOMEnabled(enable);
    return;
  }
  if (name == "CSSVariableFonts") {
    SetCSSVariableFontsEnabled(enable);
    return;
  }
  if (name == "CSSVariables2") {
    SetCSSVariables2Enabled(enable);
    return;
  }
  if (name == "CSSViewport") {
    SetCSSViewportEnabled(enable);
    return;
  }
  if (name == "CustomElementsBuiltin") {
    SetCustomElementsBuiltinEnabled(enable);
    return;
  }
  if (name == "CustomSchemeHandler") {
    SetCustomSchemeHandlerEnabled(enable);
    return;
  }
  if (name == "Database") {
    SetDatabaseEnabled(enable);
    return;
  }
  if (name == "DecodeToYUV") {
    SetDecodeToYUVEnabled(enable);
    return;
  }
  if (name == "DesktopCaptureDisableLocalEchoControl") {
    SetDesktopCaptureDisableLocalEchoControlEnabled(enable);
    return;
  }
  if (name == "DeviceMemoryHeader") {
    SetDeviceMemoryHeaderEnabled(enable);
    return;
  }
  if (name == "DisplayList2dCanvas") {
    SetDisplayList2dCanvasEnabled(enable);
    return;
  }
  if (name == "DisplayNoneIFrameCreatesNoLayoutObject") {
    SetDisplayNoneIFrameCreatesNoLayoutObjectEnabled(enable);
    return;
  }
  if (name == "DocumentCookie") {
    SetDocumentCookieEnabled(enable);
    return;
  }
  if (name == "DocumentDomain") {
    SetDocumentDomainEnabled(enable);
    return;
  }
  if (name == "DocumentWrite") {
    SetDocumentWriteEnabled(enable);
    return;
  }
  if (name == "DocumentWriteEvaluator") {
    SetDocumentWriteEvaluatorEnabled(enable);
    return;
  }
  if (name == "DOMConvenienceAPI") {
    SetDOMConvenienceAPIEnabled(enable);
    return;
  }
  if (name == "DurableStorage") {
    SetDurableStorageEnabled(enable);
    return;
  }
  if (name == "EmbedderCSPEnforcement") {
    SetEmbedderCSPEnforcementEnabled(enable);
    return;
  }
  if (name == "EncryptedMediaHdcpPolicyCheck") {
    SetEncryptedMediaHdcpPolicyCheckEnabled(enable);
    return;
  }
  if (name == "ExecCommandInJavaScript") {
    SetExecCommandInJavaScriptEnabled(enable);
    return;
  }
  if (name == "ExpensiveBackgroundTimerThrottling") {
    SetExpensiveBackgroundTimerThrottlingEnabled(enable);
    return;
  }
  if (name == "ExperimentalCanvasFeatures") {
    SetExperimentalCanvasFeaturesEnabled(enable);
    return;
  }
  if (name == "ExperimentalContentSecurityPolicyFeatures") {
    SetExperimentalContentSecurityPolicyFeaturesEnabled(enable);
    return;
  }
  if (name == "ExperimentalV8Extras") {
    SetExperimentalV8ExtrasEnabled(enable);
    return;
  }
  if (name == "FastMobileScrolling") {
    SetFastMobileScrollingEnabled(enable);
    return;
  }
  if (name == "FeaturePolicy") {
    SetFeaturePolicyEnabled(enable);
    return;
  }
  if (name == "FeaturePolicyExperimentalFeatures") {
    SetFeaturePolicyExperimentalFeaturesEnabled(enable);
    return;
  }
  if (name == "FetchRequestCache") {
    SetFetchRequestCacheEnabled(enable);
    return;
  }
  if (name == "FileAPIBlobClose") {
    SetFileAPIBlobCloseEnabled(enable);
    return;
  }
  if (name == "FileSystem") {
    SetFileSystemEnabled(enable);
    return;
  }
  if (name == "FontCacheScaling") {
    SetFontCacheScalingEnabled(enable);
    return;
  }
  if (name == "ForceDisable2dCanvasCopyOnWrite") {
    SetForceDisable2dCanvasCopyOnWriteEnabled(enable);
    return;
  }
  if (name == "ForceDisplayList2dCanvas") {
    SetForceDisplayList2dCanvasEnabled(enable);
    return;
  }
  if (name == "ForceOverlayFullscreenVideo") {
    SetForceOverlayFullscreenVideoEnabled(enable);
    return;
  }
  if (name == "ForceTallerSelectPopup") {
    SetForceTallerSelectPopupEnabled(enable);
    return;
  }
  if (name == "ForeignFetch") {
    SetForeignFetchEnabled(enable);
    return;
  }
  if (name == "FractionalScrollOffsets") {
    SetFractionalScrollOffsetsEnabled(enable);
    return;
  }
  if (name == "FramebustingNeedsSameOriginOrUserGesture") {
    SetFramebustingNeedsSameOriginOrUserGestureEnabled(enable);
    return;
  }
  if (name == "FramesTimingFunction") {
    SetFramesTimingFunctionEnabled(enable);
    return;
  }
  if (name == "FrameTimingSupport") {
    SetFrameTimingSupportEnabled(enable);
    return;
  }
  if (name == "FullscreenUnprefixed") {
    SetFullscreenUnprefixedEnabled(enable);
    return;
  }
  if (name == "GamepadExtensions") {
    SetGamepadExtensionsEnabled(enable);
    return;
  }
  if (name == "GeometryInterfaces") {
    SetGeometryInterfacesEnabled(enable);
    return;
  }
  if (name == "GetUserMedia") {
    SetGetUserMediaEnabled(enable);
    return;
  }
  if (name == "GlobalCacheStorage") {
    SetGlobalCacheStorageEnabled(enable);
    return;
  }
  if (name == "HeapCompaction") {
    SetHeapCompactionEnabled(enable);
    return;
  }
  if (name == "HideNonceContentAttribute") {
    SetHideNonceContentAttributeEnabled(enable);
    return;
  }
  if (name == "HTMLImportsStyleApplication") {
    SetHTMLImportsStyleApplicationEnabled(enable);
    return;
  }
  if (name == "IDBObserver") {
    SetIDBObserverEnabled(enable);
    return;
  }
  if (name == "IdleTimeColdModeSpellChecking") {
    SetIdleTimeColdModeSpellCheckingEnabled(enable);
    return;
  }
  if (name == "IdleTimeSpellChecking") {
    SetIdleTimeSpellCheckingEnabled(enable);
    return;
  }
  if (name == "ImageCapture") {
    SetImageCaptureEnabled(enable);
    return;
  }
  if (name == "ImageOrientation") {
    SetImageOrientationEnabled(enable);
    return;
  }
  if (name == "InertAttribute") {
    SetInertAttributeEnabled(enable);
    return;
  }
  if (name == "InputEvent") {
    SetInputEventEnabled(enable);
    return;
  }
  if (name == "InputModeAttribute") {
    SetInputModeAttributeEnabled(enable);
    return;
  }
  if (name == "InputMultipleFieldsUI") {
    SetInputMultipleFieldsUIEnabled(enable);
    return;
  }
  if (name == "InstalledApp") {
    SetInstalledAppEnabled(enable);
    return;
  }
  if (name == "IntersectionObserver") {
    SetIntersectionObserverEnabled(enable);
    return;
  }
  if (name == "JSImageDecode") {
    SetJSImageDecodeEnabled(enable);
    return;
  }
  if (name == "KeyboardLock") {
    SetKeyboardLockEnabled(enable);
    return;
  }
  if (name == "LangAttributeAwareFormControlUI") {
    SetLangAttributeAwareFormControlUIEnabled(enable);
    return;
  }
  if (name == "LayoutNG") {
    SetLayoutNGEnabled(enable);
    return;
  }
  if (name == "LazyInitializeMediaControls") {
    SetLazyInitializeMediaControlsEnabled(enable);
    return;
  }
  if (name == "LazyParseCSS") {
    SetLazyParseCSSEnabled(enable);
    return;
  }
  if (name == "LinkServiceWorker") {
    SetLinkServiceWorkerEnabled(enable);
    return;
  }
  if (name == "LoadingWithMojo") {
    SetLoadingWithMojoEnabled(enable);
    return;
  }
  if (name == "LongTaskObserver") {
    SetLongTaskObserverEnabled(enable);
    return;
  }
  if (name == "MediaCapabilities") {
    SetMediaCapabilitiesEnabled(enable);
    return;
  }
  if (name == "MediaCapture") {
    SetMediaCaptureEnabled(enable);
    return;
  }
  if (name == "MediaCaptureDepth") {
    SetMediaCaptureDepthEnabled(enable);
    return;
  }
  if (name == "MediaCaptureFromCanvas") {
    SetMediaCaptureFromCanvasEnabled(enable);
    return;
  }
  if (name == "MediaCaptureFromVideo") {
    SetMediaCaptureFromVideoEnabled(enable);
    return;
  }
  if (name == "MediaCastOverlayButton") {
    SetMediaCastOverlayButtonEnabled(enable);
    return;
  }
  if (name == "MediaControlsOverlayPlayButton") {
    SetMediaControlsOverlayPlayButtonEnabled(enable);
    return;
  }
  if (name == "MediaDocumentDownloadButton") {
    SetMediaDocumentDownloadButtonEnabled(enable);
    return;
  }
  if (name == "MediaQueryShape") {
    SetMediaQueryShapeEnabled(enable);
    return;
  }
  if (name == "MediaSession") {
    SetMediaSessionEnabled(enable);
    return;
  }
  if (name == "MediaSourceExperimental") {
    SetMediaSourceExperimentalEnabled(enable);
    return;
  }
  if (name == "MediaSourceNewAbortAndDuration") {
    SetMediaSourceNewAbortAndDurationEnabled(enable);
    return;
  }
  if (name == "MediaStreamSpeech") {
    SetMediaStreamSpeechEnabled(enable);
    return;
  }
  if (name == "MediaStreamTrackContentHint") {
    SetMediaStreamTrackContentHintEnabled(enable);
    return;
  }
  if (name == "MediaTrackApplyConstraints") {
    SetMediaTrackApplyConstraintsEnabled(enable);
    return;
  }
  if (name == "MediaTrackCapabilities") {
    SetMediaTrackCapabilitiesEnabled(enable);
    return;
  }
  if (name == "MemoryInfoInWorkers") {
    SetMemoryInfoInWorkersEnabled(enable);
    return;
  }
  if (name == "MiddleClickAutoscroll") {
    SetMiddleClickAutoscrollEnabled(enable);
    return;
  }
  if (name == "MobileLayoutTheme") {
    SetMobileLayoutThemeEnabled(enable);
    return;
  }
  if (name == "ModuleScripts") {
    SetModuleScriptsEnabled(enable);
    return;
  }
  if (name == "MojoBlobs") {
    SetMojoBlobsEnabled(enable);
    return;
  }
  if (name == "MojoJS") {
    SetMojoJSEnabled(enable);
    return;
  }
  if (name == "MojoJSTest") {
    SetMojoJSTestEnabled(enable);
    return;
  }
  if (name == "MultipleColorStopPositions") {
    SetMultipleColorStopPositionsEnabled(enable);
    return;
  }
  if (name == "NavigatorContentUtils") {
    SetNavigatorContentUtilsEnabled(enable);
    return;
  }
  if (name == "NetInfoDownlink") {
    SetNetInfoDownlinkEnabled(enable);
    return;
  }
  if (name == "NetInfoDownlinkMax") {
    SetNetInfoDownlinkMaxEnabled(enable);
    return;
  }
  if (name == "NetInfoEffectiveType") {
    SetNetInfoEffectiveTypeEnabled(enable);
    return;
  }
  if (name == "NetInfoRtt") {
    SetNetInfoRttEnabled(enable);
    return;
  }
  if (name == "NewRemotePlaybackPipeline") {
    SetNewRemotePlaybackPipelineEnabled(enable);
    return;
  }
  if (name == "NotificationBadge") {
    SetNotificationBadgeEnabled(enable);
    return;
  }
  if (name == "NotificationConstructor") {
    SetNotificationConstructorEnabled(enable);
    return;
  }
  if (name == "NotificationContentImage") {
    SetNotificationContentImageEnabled(enable);
    return;
  }
  if (name == "NotificationInlineReplies") {
    SetNotificationInlineRepliesEnabled(enable);
    return;
  }
  if (name == "Notifications") {
    SetNotificationsEnabled(enable);
    return;
  }
  if (name == "NullableDocumentDomain") {
    SetNullableDocumentDomainEnabled(enable);
    return;
  }
  if (name == "OffMainThreadFetch") {
    SetOffMainThreadFetchEnabled(enable);
    return;
  }
  if (name == "OnDeviceChange") {
    SetOnDeviceChangeEnabled(enable);
    return;
  }
  if (name == "OrientationEvent") {
    SetOrientationEventEnabled(enable);
    return;
  }
  if (name == "OriginTrials") {
    SetOriginTrialsEnabled(enable);
    return;
  }
  if (name == "OriginTrialsSampleAPI") {
    SetOriginTrialsSampleAPIEnabled(enable);
    return;
  }
  if (name == "OutOfBlinkCORS") {
    SetOutOfBlinkCORSEnabled(enable);
    return;
  }
  if (name == "OverlayScrollbars") {
    SetOverlayScrollbarsEnabled(enable);
    return;
  }
  if (name == "PagePopup") {
    SetPagePopupEnabled(enable);
    return;
  }
  if (name == "PaintUnderInvalidationChecking") {
    SetPaintUnderInvalidationCheckingEnabled(enable);
    return;
  }
  if (name == "PassiveDocumentEventListeners") {
    SetPassiveDocumentEventListenersEnabled(enable);
    return;
  }
  if (name == "PassPaintVisualRectToCompositor") {
    SetPassPaintVisualRectToCompositorEnabled(enable);
    return;
  }
  if (name == "PaymentApp") {
    SetPaymentAppEnabled(enable);
    return;
  }
  if (name == "PaymentDetailsModifierData") {
    SetPaymentDetailsModifierDataEnabled(enable);
    return;
  }
  if (name == "PaymentRequest") {
    SetPaymentRequestEnabled(enable);
    return;
  }
  if (name == "PaymentRequestBasicCard") {
    SetPaymentRequestBasicCardEnabled(enable);
    return;
  }
  if (name == "PerformanceNavigationTiming2") {
    SetPerformanceNavigationTiming2Enabled(enable);
    return;
  }
  if (name == "PerformanceObserver") {
    SetPerformanceObserverEnabled(enable);
    return;
  }
  if (name == "PerformancePaintTiming") {
    SetPerformancePaintTimingEnabled(enable);
    return;
  }
  if (name == "PermissionDelegation") {
    SetPermissionDelegationEnabled(enable);
    return;
  }
  if (name == "Permissions") {
    SetPermissionsEnabled(enable);
    return;
  }
  if (name == "PermissionsRequestRevoke") {
    SetPermissionsRequestRevokeEnabled(enable);
    return;
  }
  if (name == "PreciseMemoryInfo") {
    SetPreciseMemoryInfoEnabled(enable);
    return;
  }
  if (name == "PreferredImageRasterBounds") {
    SetPreferredImageRasterBoundsEnabled(enable);
    return;
  }
  if (name == "PrefixedVideoFullscreen") {
    SetPrefixedVideoFullscreenEnabled(enable);
    return;
  }
  if (name == "Presentation") {
    SetPresentationEnabled(enable);
    return;
  }
  if (name == "PresentationReceiver") {
    SetPresentationReceiverEnabled(enable);
    return;
  }
  if (name == "PrintBrowser") {
    SetPrintBrowserEnabled(enable);
    return;
  }
  if (name == "PushMessaging") {
    SetPushMessagingEnabled(enable);
    return;
  }
  if (name == "ReducedReferrerGranularity") {
    SetReducedReferrerGranularityEnabled(enable);
    return;
  }
  if (name == "RemotePlayback") {
    SetRemotePlaybackEnabled(enable);
    return;
  }
  if (name == "RemotePlaybackBackend") {
    SetRemotePlaybackBackendEnabled(enable);
    return;
  }
  if (name == "RenderingPipelineThrottling") {
    SetRenderingPipelineThrottlingEnabled(enable);
    return;
  }
  if (name == "RenderingPipelineThrottlingLoadingIframes") {
    SetRenderingPipelineThrottlingLoadingIframesEnabled(enable);
    return;
  }
  if (name == "RenderUnicodeControlCharacters") {
    SetRenderUnicodeControlCharactersEnabled(enable);
    return;
  }
  if (name == "ResizeObserver") {
    SetResizeObserverEnabled(enable);
    return;
  }
  if (name == "ResourceLoadScheduler") {
    SetResourceLoadSchedulerEnabled(enable);
    return;
  }
  if (name == "RestrictCanRequestURLCharacterSet") {
    SetRestrictCanRequestURLCharacterSetEnabled(enable);
    return;
  }
  if (name == "RootLayerScrolling") {
    SetRootLayerScrollingEnabled(enable);
    return;
  }
  if (name == "RTCRtpSender") {
    SetRTCRtpSenderEnabled(enable);
    return;
  }
  if (name == "ScriptedSpeech") {
    SetScriptedSpeechEnabled(enable);
    return;
  }
  if (name == "ScrollAnchoring") {
    SetScrollAnchoringEnabled(enable);
    return;
  }
  if (name == "ScrollCustomization") {
    SetScrollCustomizationEnabled(enable);
    return;
  }
  if (name == "ScrollTopLeftInterop") {
    SetScrollTopLeftInteropEnabled(enable);
    return;
  }
  if (name == "SendBeaconThrowForBlobWithNonSimpleType") {
    SetSendBeaconThrowForBlobWithNonSimpleTypeEnabled(enable);
    return;
  }
  if (name == "SendMouseEventsDisabledFormControls") {
    SetSendMouseEventsDisabledFormControlsEnabled(enable);
    return;
  }
  if (name == "Sensor") {
    SetSensorEnabled(enable);
    return;
  }
  if (name == "ServerTiming") {
    SetServerTimingEnabled(enable);
    return;
  }
  if (name == "ServiceWorkerNavigationPreload") {
    SetServiceWorkerNavigationPreloadEnabled(enable);
    return;
  }
  if (name == "ServiceWorkerScriptStreaming") {
    SetServiceWorkerScriptStreamingEnabled(enable);
    return;
  }
  if (name == "SetRootScroller") {
    SetSetRootScrollerEnabled(enable);
    return;
  }
  if (name == "ShadowPiercingDescendantCombinator") {
    SetShadowPiercingDescendantCombinatorEnabled(enable);
    return;
  }
  if (name == "ShapeDetection") {
    SetShapeDetectionEnabled(enable);
    return;
  }
  if (name == "SharedArrayBuffer") {
    SetSharedArrayBufferEnabled(enable);
    return;
  }
  if (name == "SharedWorker") {
    SetSharedWorkerEnabled(enable);
    return;
  }
  if (name == "SkipCompositingSmallScrollers") {
    SetSkipCompositingSmallScrollersEnabled(enable);
    return;
  }
  if (name == "SlimmingPaintStrictCullRectClipping") {
    SetSlimmingPaintStrictCullRectClippingEnabled(enable);
    return;
  }
  if (name == "SlimmingPaintV2") {
    SetSlimmingPaintV2Enabled(enable);
    return;
  }
  if (name == "SMIL") {
    SetSMILEnabled(enable);
    return;
  }
  if (name == "SmoothScrollJSIntervention") {
    SetSmoothScrollJSInterventionEnabled(enable);
    return;
  }
  if (name == "StableBlinkFeatures") {
    SetStableBlinkFeaturesEnabled(enable);
    return;
  }
  if (name == "StackedCSSPropertyAnimations") {
    SetStackedCSSPropertyAnimationsEnabled(enable);
    return;
  }
  if (name == "StorageEstimate") {
    SetStorageEstimateEnabled(enable);
    return;
  }
  if (name == "StyleSharing") {
    SetStyleSharingEnabled(enable);
    return;
  }
  if (name == "Suborigins") {
    SetSuboriginsEnabled(enable);
    return;
  }
  if (name == "TimerThrottlingForBackgroundTabs") {
    SetTimerThrottlingForBackgroundTabsEnabled(enable);
    return;
  }
  if (name == "TimerThrottlingForHiddenFrames") {
    SetTimerThrottlingForHiddenFramesEnabled(enable);
    return;
  }
  if (name == "TopNavByUserActivationInSandbox") {
    SetTopNavByUserActivationInSandboxEnabled(enable);
    return;
  }
  if (name == "TouchEventFeatureDetection") {
    SetTouchEventFeatureDetectionEnabled(enable);
    return;
  }
  if (name == "TouchpadAndWheelScrollLatching") {
    SetTouchpadAndWheelScrollLatchingEnabled(enable);
    return;
  }
  if (name == "TrustedEventsDefaultAction") {
    SetTrustedEventsDefaultActionEnabled(enable);
    return;
  }
  if (name == "UnclosedFormControlIsInvalid") {
    SetUnclosedFormControlIsInvalidEnabled(enable);
    return;
  }
  if (name == "UpdateHoverPostLayout") {
    SetUpdateHoverPostLayoutEnabled(enable);
    return;
  }
  if (name == "V8IdleTasks") {
    SetV8IdleTasksEnabled(enable);
    return;
  }
  if (name == "ValidationBubbleInRenderer") {
    SetValidationBubbleInRendererEnabled(enable);
    return;
  }
  if (name == "VibrateRequiresUserGesture") {
    SetVibrateRequiresUserGestureEnabled(enable);
    return;
  }
  if (name == "VideoFullscreenDetection") {
    SetVideoFullscreenDetectionEnabled(enable);
    return;
  }
  if (name == "VideoFullscreenOrientationLock") {
    SetVideoFullscreenOrientationLockEnabled(enable);
    return;
  }
  if (name == "VideoRotateToFullscreen") {
    SetVideoRotateToFullscreenEnabled(enable);
    return;
  }
  if (name == "VisualViewportAPI") {
    SetVisualViewportAPIEnabled(enable);
    return;
  }
  if (name == "WakeLock") {
    SetWakeLockEnabled(enable);
    return;
  }
  if (name == "WebAnimationsAPI") {
    SetWebAnimationsAPIEnabled(enable);
    return;
  }
  if (name == "WebAnimationsSVG") {
    SetWebAnimationsSVGEnabled(enable);
    return;
  }
  if (name == "WebAssemblyStreaming") {
    SetWebAssemblyStreamingEnabled(enable);
    return;
  }
  if (name == "WebAuth") {
    SetWebAuthEnabled(enable);
    return;
  }
  if (name == "WebBluetooth") {
    SetWebBluetoothEnabled(enable);
    return;
  }
  if (name == "WebFontsCacheAwareTimeoutAdaptation") {
    SetWebFontsCacheAwareTimeoutAdaptationEnabled(enable);
    return;
  }
  if (name == "WebFontsInterventionTrigger") {
    SetWebFontsInterventionTriggerEnabled(enable);
    return;
  }
  if (name == "WebFontsInterventionV2With2G") {
    SetWebFontsInterventionV2With2GEnabled(enable);
    return;
  }
  if (name == "WebFontsInterventionV2With3G") {
    SetWebFontsInterventionV2With3GEnabled(enable);
    return;
  }
  if (name == "WebFontsInterventionV2WithSlow2G") {
    SetWebFontsInterventionV2WithSlow2GEnabled(enable);
    return;
  }
  if (name == "WebGLDraftExtensions") {
    SetWebGLDraftExtensionsEnabled(enable);
    return;
  }
  if (name == "WebGLImageChromium") {
    SetWebGLImageChromiumEnabled(enable);
    return;
  }
  if (name == "WebNFC") {
    SetWebNFCEnabled(enable);
    return;
  }
  if (name == "WebShare") {
    SetWebShareEnabled(enable);
    return;
  }
  if (name == "WebUSB") {
    SetWebUSBEnabled(enable);
    return;
  }
  if (name == "WebVR") {
    SetWebVREnabled(enable);
    return;
  }
  if (name == "WebVRExperimentalRendering") {
    SetWebVRExperimentalRenderingEnabled(enable);
    return;
  }
  if (name == "WebVTTRegions") {
    SetWebVTTRegionsEnabled(enable);
    return;
  }
  if (name == "Worklet") {
    SetWorkletEnabled(enable);
    return;
  }
  if (name == "XSLT") {
    SetXSLTEnabled(enable);
    return;
  }
  DLOG(ERROR) << "RuntimeEnabledFeature not recognized: " << name;
}

bool RuntimeEnabledFeatures::isAccelerated2dCanvasEnabled = true;
bool RuntimeEnabledFeatures::isAccessibilityObjectModelEnabled = false;
bool RuntimeEnabledFeatures::isAllowContentInitiatedDataUrlNavigationsEnabled = true;
bool RuntimeEnabledFeatures::isAsyncClipboardEnabled = false;
bool RuntimeEnabledFeatures::isAudioOutputDevicesEnabled = true;
bool RuntimeEnabledFeatures::isAudioVideoTracksEnabled = false;
bool RuntimeEnabledFeatures::isAudioWorkletEnabled = false;
bool RuntimeEnabledFeatures::isAutoplayMutedVideosEnabled = false;
bool RuntimeEnabledFeatures::isAuxclickEnabled = true;
bool RuntimeEnabledFeatures::isBackgroundFetchEnabled = false;
bool RuntimeEnabledFeatures::isBackgroundSyncEnabled = true;
bool RuntimeEnabledFeatures::isBackgroundVideoTrackOptimizationEnabled = true;
bool RuntimeEnabledFeatures::isBlinkRuntimeCallStatsEnabled = false;
bool RuntimeEnabledFeatures::isBlockCredentialedSubresourcesEnabled = true;
bool RuntimeEnabledFeatures::isBlockLegacySubresourcesEnabled = true;
bool RuntimeEnabledFeatures::isBroadcastChannelEnabled = true;
bool RuntimeEnabledFeatures::isBudgetEnabled = true;
bool RuntimeEnabledFeatures::isBudgetQueryEnabled = false;
bool RuntimeEnabledFeatures::isCanMakePaymentEnabled = true;
bool RuntimeEnabledFeatures::isCanvas2dFixedRenderingModeEnabled = false;
bool RuntimeEnabledFeatures::isCanvas2dImageChromiumEnabled = false;
bool RuntimeEnabledFeatures::isClickRetargettingEnabled = false;
bool RuntimeEnabledFeatures::isClientHintsEnabled = true;
bool RuntimeEnabledFeatures::isClientPlaceholdersForServerLoFiEnabled = false;
bool RuntimeEnabledFeatures::isCoalescedEventsEnabled = true;
bool RuntimeEnabledFeatures::isColorCanvasExtensionsEnabled = false;
bool RuntimeEnabledFeatures::isColorCorrectRenderingEnabled = false;
bool RuntimeEnabledFeatures::isCompositedSelectionUpdateEnabled = false;
bool RuntimeEnabledFeatures::isCompositeOpaqueFixedPositionEnabled = false;
bool RuntimeEnabledFeatures::isCompositeOpaqueScrollersEnabled = true;
bool RuntimeEnabledFeatures::isCompositorTouchActionEnabled = false;
bool RuntimeEnabledFeatures::isCompositorWorkerEnabled = false;
bool RuntimeEnabledFeatures::isComputedAccessibilityInfoEnabled = false;
bool RuntimeEnabledFeatures::isConicGradientEnabled = false;
bool RuntimeEnabledFeatures::isContextMenuEnabled = false;
bool RuntimeEnabledFeatures::isCorsRFC1918Enabled = false;
bool RuntimeEnabledFeatures::isCSS3TextEnabled = false;
bool RuntimeEnabledFeatures::isCSS3TextDecorationsEnabled = true;
bool RuntimeEnabledFeatures::isCSSAdditiveAnimationsEnabled = false;
bool RuntimeEnabledFeatures::isCSSApplyAtRulesEnabled = false;
bool RuntimeEnabledFeatures::isCSSBackdropFilterEnabled = false;
bool RuntimeEnabledFeatures::isCSSContainmentEnabled = true;
bool RuntimeEnabledFeatures::isCSSDisplayContentsEnabled = false;
bool RuntimeEnabledFeatures::isCSSFontDisplayEnabled = true;
bool RuntimeEnabledFeatures::isCSSFontSizeAdjustEnabled = false;
bool RuntimeEnabledFeatures::isCSSGridLayoutEnabled = true;
bool RuntimeEnabledFeatures::isCSSHexAlphaColorEnabled = false;
bool RuntimeEnabledFeatures::isCSSHyphensEnabled = true;
bool RuntimeEnabledFeatures::isCSSInBodyDoesNotBlockPaintEnabled = false;
bool RuntimeEnabledFeatures::isCSSIndependentTransformPropertiesEnabled = false;
bool RuntimeEnabledFeatures::isCSSLineBreakEnabled = false;
bool RuntimeEnabledFeatures::isCSSMaskSourceTypeEnabled = false;
bool RuntimeEnabledFeatures::isCSSOffsetPathRayEnabled = false;
bool RuntimeEnabledFeatures::isCSSOffsetPathRayContainEnabled = false;
bool RuntimeEnabledFeatures::isCSSOffsetPositionAnchorEnabled = false;
bool RuntimeEnabledFeatures::isCSSOMSmoothScrollEnabled = true;
bool RuntimeEnabledFeatures::isCSSPaintAPIEnabled = false;
bool RuntimeEnabledFeatures::isCSSPaintAPIArgumentsEnabled = false;
bool RuntimeEnabledFeatures::isCSSScrollBoundaryBehaviorEnabled = false;
bool RuntimeEnabledFeatures::isCSSScrollSnapPointsEnabled = false;
bool RuntimeEnabledFeatures::isCSSSelectorsFocusWithinEnabled = true;
bool RuntimeEnabledFeatures::isCSSSnapSizeEnabled = false;
bool RuntimeEnabledFeatures::isCSSStickyPositionEnabled = true;
bool RuntimeEnabledFeatures::isCSSTransformBoxEnabled = false;
bool RuntimeEnabledFeatures::isCSSTypedOMEnabled = false;
bool RuntimeEnabledFeatures::isCSSVariableFontsEnabled = false;
bool RuntimeEnabledFeatures::isCSSVariables2Enabled = false;
bool RuntimeEnabledFeatures::isCSSViewportEnabled = false;
bool RuntimeEnabledFeatures::isCustomElementsBuiltinEnabled = false;
bool RuntimeEnabledFeatures::isCustomSchemeHandlerEnabled = false;
bool RuntimeEnabledFeatures::isDatabaseEnabled = true;
bool RuntimeEnabledFeatures::isDecodeToYUVEnabled = false;
bool RuntimeEnabledFeatures::isDesktopCaptureDisableLocalEchoControlEnabled = false;
bool RuntimeEnabledFeatures::isDeviceMemoryHeaderEnabled = true;
bool RuntimeEnabledFeatures::isDisplayList2dCanvasEnabled = true;
bool RuntimeEnabledFeatures::isDisplayNoneIFrameCreatesNoLayoutObjectEnabled = false;
bool RuntimeEnabledFeatures::isDocumentCookieEnabled = false;
bool RuntimeEnabledFeatures::isDocumentDomainEnabled = false;
bool RuntimeEnabledFeatures::isDocumentWriteEnabled = false;
bool RuntimeEnabledFeatures::isDocumentWriteEvaluatorEnabled = false;
bool RuntimeEnabledFeatures::isDOMConvenienceAPIEnabled = true;
bool RuntimeEnabledFeatures::isDurableStorageEnabled = true;
bool RuntimeEnabledFeatures::isEmbedderCSPEnforcementEnabled = true;
bool RuntimeEnabledFeatures::isEncryptedMediaHdcpPolicyCheckEnabled = false;
bool RuntimeEnabledFeatures::isExecCommandInJavaScriptEnabled = false;
bool RuntimeEnabledFeatures::isExpensiveBackgroundTimerThrottlingEnabled = true;
bool RuntimeEnabledFeatures::isExperimentalCanvasFeaturesEnabled = false;
bool RuntimeEnabledFeatures::isExperimentalContentSecurityPolicyFeaturesEnabled = false;
bool RuntimeEnabledFeatures::isExperimentalV8ExtrasEnabled = false;
bool RuntimeEnabledFeatures::isFastMobileScrollingEnabled = false;
bool RuntimeEnabledFeatures::isFeaturePolicyEnabled = true;
bool RuntimeEnabledFeatures::isFeaturePolicyExperimentalFeaturesEnabled = false;
bool RuntimeEnabledFeatures::isFetchRequestCacheEnabled = false;
bool RuntimeEnabledFeatures::isFileAPIBlobCloseEnabled = false;
bool RuntimeEnabledFeatures::isFileSystemEnabled = true;
bool RuntimeEnabledFeatures::isFontCacheScalingEnabled = false;
bool RuntimeEnabledFeatures::isForceDisable2dCanvasCopyOnWriteEnabled = false;
bool RuntimeEnabledFeatures::isForceDisplayList2dCanvasEnabled = false;
bool RuntimeEnabledFeatures::isForceOverlayFullscreenVideoEnabled = false;
bool RuntimeEnabledFeatures::isForceTallerSelectPopupEnabled = false;
bool RuntimeEnabledFeatures::isForeignFetchEnabled = false;
bool RuntimeEnabledFeatures::isFractionalScrollOffsetsEnabled = false;
bool RuntimeEnabledFeatures::isFramebustingNeedsSameOriginOrUserGestureEnabled = false;
bool RuntimeEnabledFeatures::isFramesTimingFunctionEnabled = false;
bool RuntimeEnabledFeatures::isFrameTimingSupportEnabled = false;
bool RuntimeEnabledFeatures::isFullscreenUnprefixedEnabled = false;
bool RuntimeEnabledFeatures::isGamepadExtensionsEnabled = false;
bool RuntimeEnabledFeatures::isGeometryInterfacesEnabled = true;
bool RuntimeEnabledFeatures::isGetUserMediaEnabled = true;
bool RuntimeEnabledFeatures::isGlobalCacheStorageEnabled = true;
bool RuntimeEnabledFeatures::isHeapCompactionEnabled = true;
bool RuntimeEnabledFeatures::isHideNonceContentAttributeEnabled = true;
bool RuntimeEnabledFeatures::isHTMLImportsStyleApplicationEnabled = true;
bool RuntimeEnabledFeatures::isIDBObserverEnabled = false;
bool RuntimeEnabledFeatures::isIdleTimeColdModeSpellCheckingEnabled = false;
bool RuntimeEnabledFeatures::isIdleTimeSpellCheckingEnabled = false;
bool RuntimeEnabledFeatures::isImageCaptureEnabled = true;
bool RuntimeEnabledFeatures::isImageOrientationEnabled = false;
bool RuntimeEnabledFeatures::isInertAttributeEnabled = false;
bool RuntimeEnabledFeatures::isInputEventEnabled = true;
bool RuntimeEnabledFeatures::isInputModeAttributeEnabled = false;
bool RuntimeEnabledFeatures::isInputMultipleFieldsUIEnabled = true;
bool RuntimeEnabledFeatures::isInstalledAppEnabled = false;
bool RuntimeEnabledFeatures::isIntersectionObserverEnabled = true;
bool RuntimeEnabledFeatures::isJSImageDecodeEnabled = false;
bool RuntimeEnabledFeatures::isKeyboardLockEnabled = false;
bool RuntimeEnabledFeatures::isLangAttributeAwareFormControlUIEnabled = false;
bool RuntimeEnabledFeatures::isLayoutNGEnabled = false;
bool RuntimeEnabledFeatures::isLazyInitializeMediaControlsEnabled = false;
bool RuntimeEnabledFeatures::isLazyParseCSSEnabled = false;
bool RuntimeEnabledFeatures::isLinkServiceWorkerEnabled = false;
bool RuntimeEnabledFeatures::isLoadingWithMojoEnabled = false;
bool RuntimeEnabledFeatures::isLongTaskObserverEnabled = true;
bool RuntimeEnabledFeatures::isMediaCapabilitiesEnabled = false;
bool RuntimeEnabledFeatures::isMediaCaptureEnabled = false;
bool RuntimeEnabledFeatures::isMediaCaptureDepthEnabled = false;
bool RuntimeEnabledFeatures::isMediaCaptureFromCanvasEnabled = true;
bool RuntimeEnabledFeatures::isMediaCaptureFromVideoEnabled = false;
bool RuntimeEnabledFeatures::isMediaCastOverlayButtonEnabled = false;
bool RuntimeEnabledFeatures::isMediaControlsOverlayPlayButtonEnabled = false;
bool RuntimeEnabledFeatures::isMediaDocumentDownloadButtonEnabled = false;
bool RuntimeEnabledFeatures::isMediaQueryShapeEnabled = false;
bool RuntimeEnabledFeatures::isMediaSessionEnabled = false;
bool RuntimeEnabledFeatures::isMediaSourceExperimentalEnabled = false;
bool RuntimeEnabledFeatures::isMediaSourceNewAbortAndDurationEnabled = false;
bool RuntimeEnabledFeatures::isMediaStreamSpeechEnabled = false;
bool RuntimeEnabledFeatures::isMediaStreamTrackContentHintEnabled = false;
bool RuntimeEnabledFeatures::isMediaTrackApplyConstraintsEnabled = false;
bool RuntimeEnabledFeatures::isMediaTrackCapabilitiesEnabled = false;
bool RuntimeEnabledFeatures::isMemoryInfoInWorkersEnabled = false;
bool RuntimeEnabledFeatures::isMiddleClickAutoscrollEnabled = false;
bool RuntimeEnabledFeatures::isMobileLayoutThemeEnabled = false;
bool RuntimeEnabledFeatures::isModuleScriptsEnabled = true;
bool RuntimeEnabledFeatures::isMojoBlobsEnabled = false;
bool RuntimeEnabledFeatures::isMojoJSEnabled = false;
bool RuntimeEnabledFeatures::isMojoJSTestEnabled = false;
bool RuntimeEnabledFeatures::isMultipleColorStopPositionsEnabled = false;
bool RuntimeEnabledFeatures::isNavigatorContentUtilsEnabled = false;
bool RuntimeEnabledFeatures::isNetInfoDownlinkEnabled = true;
bool RuntimeEnabledFeatures::isNetInfoDownlinkMaxEnabled = true;
bool RuntimeEnabledFeatures::isNetInfoEffectiveTypeEnabled = true;
bool RuntimeEnabledFeatures::isNetInfoRttEnabled = true;
bool RuntimeEnabledFeatures::isNewRemotePlaybackPipelineEnabled = false;
bool RuntimeEnabledFeatures::isNotificationBadgeEnabled = true;
bool RuntimeEnabledFeatures::isNotificationConstructorEnabled = true;
bool RuntimeEnabledFeatures::isNotificationContentImageEnabled = false;
bool RuntimeEnabledFeatures::isNotificationInlineRepliesEnabled = false;
bool RuntimeEnabledFeatures::isNotificationsEnabled = true;
bool RuntimeEnabledFeatures::isNullableDocumentDomainEnabled = false;
bool RuntimeEnabledFeatures::isOffMainThreadFetchEnabled = false;
bool RuntimeEnabledFeatures::isOnDeviceChangeEnabled = true;
bool RuntimeEnabledFeatures::isOrientationEventEnabled = false;
bool RuntimeEnabledFeatures::isOriginTrialsEnabled = true;
bool RuntimeEnabledFeatures::isOriginTrialsSampleAPIEnabled = false;
bool RuntimeEnabledFeatures::isOutOfBlinkCORSEnabled = false;
bool RuntimeEnabledFeatures::isOverlayScrollbarsEnabled = false;
bool RuntimeEnabledFeatures::isPagePopupEnabled = true;
bool RuntimeEnabledFeatures::isPaintUnderInvalidationCheckingEnabled = false;
bool RuntimeEnabledFeatures::isPassiveDocumentEventListenersEnabled = true;
bool RuntimeEnabledFeatures::isPassPaintVisualRectToCompositorEnabled = false;
bool RuntimeEnabledFeatures::isPaymentAppEnabled = false;
bool RuntimeEnabledFeatures::isPaymentDetailsModifierDataEnabled = false;
bool RuntimeEnabledFeatures::isPaymentRequestEnabled = false;
bool RuntimeEnabledFeatures::isPaymentRequestBasicCardEnabled = true;
bool RuntimeEnabledFeatures::isPerformanceNavigationTiming2Enabled = true;
bool RuntimeEnabledFeatures::isPerformanceObserverEnabled = true;
bool RuntimeEnabledFeatures::isPerformancePaintTimingEnabled = true;
bool RuntimeEnabledFeatures::isPermissionDelegationEnabled = false;
bool RuntimeEnabledFeatures::isPermissionsEnabled = true;
bool RuntimeEnabledFeatures::isPermissionsRequestRevokeEnabled = false;
bool RuntimeEnabledFeatures::isPreciseMemoryInfoEnabled = false;
bool RuntimeEnabledFeatures::isPreferredImageRasterBoundsEnabled = false;
bool RuntimeEnabledFeatures::isPrefixedVideoFullscreenEnabled = true;
bool RuntimeEnabledFeatures::isPresentationEnabled = true;
bool RuntimeEnabledFeatures::isPresentationReceiverEnabled = true;
bool RuntimeEnabledFeatures::isPrintBrowserEnabled = false;
bool RuntimeEnabledFeatures::isPushMessagingEnabled = true;
bool RuntimeEnabledFeatures::isReducedReferrerGranularityEnabled = false;
bool RuntimeEnabledFeatures::isRemotePlaybackEnabled = true;
bool RuntimeEnabledFeatures::isRemotePlaybackBackendEnabled = false;
bool RuntimeEnabledFeatures::isRenderingPipelineThrottlingEnabled = true;
bool RuntimeEnabledFeatures::isRenderingPipelineThrottlingLoadingIframesEnabled = true;
bool RuntimeEnabledFeatures::isRenderUnicodeControlCharactersEnabled = true;
bool RuntimeEnabledFeatures::isResizeObserverEnabled = false;
bool RuntimeEnabledFeatures::isResourceLoadSchedulerEnabled = false;
bool RuntimeEnabledFeatures::isRestrictCanRequestURLCharacterSetEnabled = true;
bool RuntimeEnabledFeatures::isRootLayerScrollingEnabled = false;
bool RuntimeEnabledFeatures::isRTCRtpSenderEnabled = false;
bool RuntimeEnabledFeatures::isScriptedSpeechEnabled = true;
bool RuntimeEnabledFeatures::isScrollAnchoringEnabled = false;
bool RuntimeEnabledFeatures::isScrollCustomizationEnabled = false;
bool RuntimeEnabledFeatures::isScrollTopLeftInteropEnabled = true;
bool RuntimeEnabledFeatures::isSendBeaconThrowForBlobWithNonSimpleTypeEnabled = true;
bool RuntimeEnabledFeatures::isSendMouseEventsDisabledFormControlsEnabled = false;
bool RuntimeEnabledFeatures::isSensorEnabled = false;
bool RuntimeEnabledFeatures::isServerTimingEnabled = false;
bool RuntimeEnabledFeatures::isServiceWorkerNavigationPreloadEnabled = true;
bool RuntimeEnabledFeatures::isServiceWorkerScriptStreamingEnabled = false;
bool RuntimeEnabledFeatures::isSetRootScrollerEnabled = false;
bool RuntimeEnabledFeatures::isShadowPiercingDescendantCombinatorEnabled = false;
bool RuntimeEnabledFeatures::isShapeDetectionEnabled = false;
bool RuntimeEnabledFeatures::isSharedArrayBufferEnabled = true;
bool RuntimeEnabledFeatures::isSharedWorkerEnabled = true;
bool RuntimeEnabledFeatures::isSkipCompositingSmallScrollersEnabled = false;
bool RuntimeEnabledFeatures::isSlimmingPaintStrictCullRectClippingEnabled = false;
bool RuntimeEnabledFeatures::isSlimmingPaintV2Enabled = false;
bool RuntimeEnabledFeatures::isSMILEnabled = true;
bool RuntimeEnabledFeatures::isSmoothScrollJSInterventionEnabled = true;
bool RuntimeEnabledFeatures::isStableBlinkFeaturesEnabled = true;
bool RuntimeEnabledFeatures::isStackedCSSPropertyAnimationsEnabled = false;
bool RuntimeEnabledFeatures::isStorageEstimateEnabled = true;
bool RuntimeEnabledFeatures::isStyleSharingEnabled = false;
bool RuntimeEnabledFeatures::isSuboriginsEnabled = false;
bool RuntimeEnabledFeatures::isTimerThrottlingForBackgroundTabsEnabled = true;
bool RuntimeEnabledFeatures::isTimerThrottlingForHiddenFramesEnabled = true;
bool RuntimeEnabledFeatures::isTopNavByUserActivationInSandboxEnabled = true;
bool RuntimeEnabledFeatures::isTouchEventFeatureDetectionEnabled = true;
bool RuntimeEnabledFeatures::isTouchpadAndWheelScrollLatchingEnabled = false;
bool RuntimeEnabledFeatures::isTrustedEventsDefaultActionEnabled = true;
bool RuntimeEnabledFeatures::isUnclosedFormControlIsInvalidEnabled = false;
bool RuntimeEnabledFeatures::isUpdateHoverPostLayoutEnabled = false;
bool RuntimeEnabledFeatures::isV8IdleTasksEnabled = false;
bool RuntimeEnabledFeatures::isValidationBubbleInRendererEnabled = false;
bool RuntimeEnabledFeatures::isVibrateRequiresUserGestureEnabled = true;
bool RuntimeEnabledFeatures::isVideoFullscreenDetectionEnabled = false;
bool RuntimeEnabledFeatures::isVideoFullscreenOrientationLockEnabled = false;
bool RuntimeEnabledFeatures::isVideoRotateToFullscreenEnabled = false;
bool RuntimeEnabledFeatures::isVisualViewportAPIEnabled = true;
bool RuntimeEnabledFeatures::isWakeLockEnabled = false;
bool RuntimeEnabledFeatures::isWebAnimationsAPIEnabled = false;
bool RuntimeEnabledFeatures::isWebAnimationsSVGEnabled = false;
bool RuntimeEnabledFeatures::isWebAssemblyStreamingEnabled = false;
bool RuntimeEnabledFeatures::isWebAuthEnabled = false;
bool RuntimeEnabledFeatures::isWebBluetoothEnabled = false;
bool RuntimeEnabledFeatures::isWebFontsCacheAwareTimeoutAdaptationEnabled = false;
bool RuntimeEnabledFeatures::isWebFontsInterventionTriggerEnabled = false;
bool RuntimeEnabledFeatures::isWebFontsInterventionV2With2GEnabled = false;
bool RuntimeEnabledFeatures::isWebFontsInterventionV2With3GEnabled = false;
bool RuntimeEnabledFeatures::isWebFontsInterventionV2WithSlow2GEnabled = false;
bool RuntimeEnabledFeatures::isWebGLDraftExtensionsEnabled = false;
bool RuntimeEnabledFeatures::isWebGLImageChromiumEnabled = false;
bool RuntimeEnabledFeatures::isWebNFCEnabled = false;
bool RuntimeEnabledFeatures::isWebShareEnabled = false;
bool RuntimeEnabledFeatures::isWebUSBEnabled = true;
bool RuntimeEnabledFeatures::isWebVREnabled = false;
bool RuntimeEnabledFeatures::isWebVRExperimentalRenderingEnabled = false;
bool RuntimeEnabledFeatures::isWebVTTRegionsEnabled = false;
bool RuntimeEnabledFeatures::isWorkletEnabled = false;
bool RuntimeEnabledFeatures::isXSLTEnabled = true;

} // namespace blink
