// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CC_IPC_COMPOSITOR_FRAME_SINK_MOJOM_SHARED_INTERNAL_H_
#define CC_IPC_COMPOSITOR_FRAME_SINK_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/native_struct_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "cc/ipc/begin_frame_args.mojom-shared-internal.h"
#include "cc/ipc/compositor_frame.mojom-shared-internal.h"
#include "cc/ipc/copy_output_request.mojom-shared-internal.h"
#include "cc/ipc/frame_sink_id.mojom-shared-internal.h"
#include "cc/ipc/local_surface_id.mojom-shared-internal.h"
#include "cc/ipc/surface_id.mojom-shared-internal.h"
#include "cc/ipc/returned_resource.mojom-shared-internal.h"
#include "cc/ipc/surface_sequence.mojom-shared-internal.h"
#include "ui/gfx/geometry/mojo/geometry.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace cc {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
constexpr uint32_t kCompositorFrameSink_SetNeedsBeginFrame_Name = 0;
class  CompositorFrameSink_SetNeedsBeginFrame_Params_Data {
 public:
  static CompositorFrameSink_SetNeedsBeginFrame_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t needs_begin_frame : 1;
  uint8_t padfinal_[7];

 private:
  CompositorFrameSink_SetNeedsBeginFrame_Params_Data();
  ~CompositorFrameSink_SetNeedsBeginFrame_Params_Data() = delete;
};
static_assert(sizeof(CompositorFrameSink_SetNeedsBeginFrame_Params_Data) == 16,
              "Bad sizeof(CompositorFrameSink_SetNeedsBeginFrame_Params_Data)");
constexpr uint32_t kCompositorFrameSink_SubmitCompositorFrame_Name = 1;
class  CompositorFrameSink_SubmitCompositorFrame_Params_Data {
 public:
  static CompositorFrameSink_SubmitCompositorFrame_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::cc::mojom::internal::LocalSurfaceId_Data> local_surface_id;
  mojo::internal::Pointer<::cc::mojom::internal::CompositorFrame_Data> frame;

 private:
  CompositorFrameSink_SubmitCompositorFrame_Params_Data();
  ~CompositorFrameSink_SubmitCompositorFrame_Params_Data() = delete;
};
static_assert(sizeof(CompositorFrameSink_SubmitCompositorFrame_Params_Data) == 24,
              "Bad sizeof(CompositorFrameSink_SubmitCompositorFrame_Params_Data)");
constexpr uint32_t kCompositorFrameSink_DidNotProduceFrame_Name = 2;
class  CompositorFrameSink_DidNotProduceFrame_Params_Data {
 public:
  static CompositorFrameSink_DidNotProduceFrame_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::cc::mojom::internal::BeginFrameAck_Data> ack;

 private:
  CompositorFrameSink_DidNotProduceFrame_Params_Data();
  ~CompositorFrameSink_DidNotProduceFrame_Params_Data() = delete;
};
static_assert(sizeof(CompositorFrameSink_DidNotProduceFrame_Params_Data) == 16,
              "Bad sizeof(CompositorFrameSink_DidNotProduceFrame_Params_Data)");
constexpr uint32_t kCompositorFrameSinkClient_DidReceiveCompositorFrameAck_Name = 0;
class  CompositorFrameSinkClient_DidReceiveCompositorFrameAck_Params_Data {
 public:
  static CompositorFrameSinkClient_DidReceiveCompositorFrameAck_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::cc::mojom::internal::ReturnedResource_Data>>> resources;

 private:
  CompositorFrameSinkClient_DidReceiveCompositorFrameAck_Params_Data();
  ~CompositorFrameSinkClient_DidReceiveCompositorFrameAck_Params_Data() = delete;
};
static_assert(sizeof(CompositorFrameSinkClient_DidReceiveCompositorFrameAck_Params_Data) == 16,
              "Bad sizeof(CompositorFrameSinkClient_DidReceiveCompositorFrameAck_Params_Data)");
constexpr uint32_t kCompositorFrameSinkClient_OnBeginFrame_Name = 1;
class  CompositorFrameSinkClient_OnBeginFrame_Params_Data {
 public:
  static CompositorFrameSinkClient_OnBeginFrame_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::cc::mojom::internal::BeginFrameArgs_Data> args;

 private:
  CompositorFrameSinkClient_OnBeginFrame_Params_Data();
  ~CompositorFrameSinkClient_OnBeginFrame_Params_Data() = delete;
};
static_assert(sizeof(CompositorFrameSinkClient_OnBeginFrame_Params_Data) == 16,
              "Bad sizeof(CompositorFrameSinkClient_OnBeginFrame_Params_Data)");
constexpr uint32_t kCompositorFrameSinkClient_OnBeginFramePausedChanged_Name = 2;
class  CompositorFrameSinkClient_OnBeginFramePausedChanged_Params_Data {
 public:
  static CompositorFrameSinkClient_OnBeginFramePausedChanged_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t paused : 1;
  uint8_t padfinal_[7];

 private:
  CompositorFrameSinkClient_OnBeginFramePausedChanged_Params_Data();
  ~CompositorFrameSinkClient_OnBeginFramePausedChanged_Params_Data() = delete;
};
static_assert(sizeof(CompositorFrameSinkClient_OnBeginFramePausedChanged_Params_Data) == 16,
              "Bad sizeof(CompositorFrameSinkClient_OnBeginFramePausedChanged_Params_Data)");
constexpr uint32_t kCompositorFrameSinkClient_ReclaimResources_Name = 3;
class  CompositorFrameSinkClient_ReclaimResources_Params_Data {
 public:
  static CompositorFrameSinkClient_ReclaimResources_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::cc::mojom::internal::ReturnedResource_Data>>> resources;

 private:
  CompositorFrameSinkClient_ReclaimResources_Params_Data();
  ~CompositorFrameSinkClient_ReclaimResources_Params_Data() = delete;
};
static_assert(sizeof(CompositorFrameSinkClient_ReclaimResources_Params_Data) == 16,
              "Bad sizeof(CompositorFrameSinkClient_ReclaimResources_Params_Data)");
constexpr uint32_t kCompositorFrameSinkPrivate_ClaimTemporaryReference_Name = 0;
class  CompositorFrameSinkPrivate_ClaimTemporaryReference_Params_Data {
 public:
  static CompositorFrameSinkPrivate_ClaimTemporaryReference_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::cc::mojom::internal::SurfaceId_Data> surface_id;

 private:
  CompositorFrameSinkPrivate_ClaimTemporaryReference_Params_Data();
  ~CompositorFrameSinkPrivate_ClaimTemporaryReference_Params_Data() = delete;
};
static_assert(sizeof(CompositorFrameSinkPrivate_ClaimTemporaryReference_Params_Data) == 16,
              "Bad sizeof(CompositorFrameSinkPrivate_ClaimTemporaryReference_Params_Data)");
constexpr uint32_t kCompositorFrameSinkPrivate_RequestCopyOfSurface_Name = 1;
class  CompositorFrameSinkPrivate_RequestCopyOfSurface_Params_Data {
 public:
  static CompositorFrameSinkPrivate_RequestCopyOfSurface_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::cc::mojom::internal::CopyOutputRequest_Data> request;

 private:
  CompositorFrameSinkPrivate_RequestCopyOfSurface_Params_Data();
  ~CompositorFrameSinkPrivate_RequestCopyOfSurface_Params_Data() = delete;
};
static_assert(sizeof(CompositorFrameSinkPrivate_RequestCopyOfSurface_Params_Data) == 16,
              "Bad sizeof(CompositorFrameSinkPrivate_RequestCopyOfSurface_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace cc

#endif  // CC_IPC_COMPOSITOR_FRAME_SINK_MOJOM_SHARED_INTERNAL_H_