// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4065)
#endif

#include "cc/ipc/compositor_frame_sink.mojom-shared.h"

#include <utility>

#include "base/logging.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"
namespace cc {
namespace mojom {

namespace internal {


// static
CompositorFrameSink_SetNeedsBeginFrame_Params_Data* CompositorFrameSink_SetNeedsBeginFrame_Params_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(CompositorFrameSink_SetNeedsBeginFrame_Params_Data))) CompositorFrameSink_SetNeedsBeginFrame_Params_Data();
}

// static
bool CompositorFrameSink_SetNeedsBeginFrame_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, validation_context))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const CompositorFrameSink_SetNeedsBeginFrame_Params_Data* object = static_cast<const CompositorFrameSink_SetNeedsBeginFrame_Params_Data*>(data);

  static constexpr struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 16 }};

  if (object->header_.version <=
          kVersionSizes[arraysize(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = arraysize(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            validation_context,
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[arraysize(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        validation_context,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  return true;
}

CompositorFrameSink_SetNeedsBeginFrame_Params_Data::CompositorFrameSink_SetNeedsBeginFrame_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
CompositorFrameSink_SubmitCompositorFrame_Params_Data* CompositorFrameSink_SubmitCompositorFrame_Params_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(CompositorFrameSink_SubmitCompositorFrame_Params_Data))) CompositorFrameSink_SubmitCompositorFrame_Params_Data();
}

// static
bool CompositorFrameSink_SubmitCompositorFrame_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, validation_context))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const CompositorFrameSink_SubmitCompositorFrame_Params_Data* object = static_cast<const CompositorFrameSink_SubmitCompositorFrame_Params_Data*>(data);

  static constexpr struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 24 }};

  if (object->header_.version <=
          kVersionSizes[arraysize(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = arraysize(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            validation_context,
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[arraysize(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        validation_context,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->local_surface_id, "null local_surface_id field in CompositorFrameSink_SubmitCompositorFrame_Params",
          validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->local_surface_id, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->frame, "null frame field in CompositorFrameSink_SubmitCompositorFrame_Params",
          validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->frame, validation_context))
    return false;

  return true;
}

CompositorFrameSink_SubmitCompositorFrame_Params_Data::CompositorFrameSink_SubmitCompositorFrame_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
CompositorFrameSink_DidNotProduceFrame_Params_Data* CompositorFrameSink_DidNotProduceFrame_Params_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(CompositorFrameSink_DidNotProduceFrame_Params_Data))) CompositorFrameSink_DidNotProduceFrame_Params_Data();
}

// static
bool CompositorFrameSink_DidNotProduceFrame_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, validation_context))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const CompositorFrameSink_DidNotProduceFrame_Params_Data* object = static_cast<const CompositorFrameSink_DidNotProduceFrame_Params_Data*>(data);

  static constexpr struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 16 }};

  if (object->header_.version <=
          kVersionSizes[arraysize(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = arraysize(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            validation_context,
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[arraysize(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        validation_context,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->ack, "null ack field in CompositorFrameSink_DidNotProduceFrame_Params",
          validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->ack, validation_context))
    return false;

  return true;
}

CompositorFrameSink_DidNotProduceFrame_Params_Data::CompositorFrameSink_DidNotProduceFrame_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
CompositorFrameSinkClient_DidReceiveCompositorFrameAck_Params_Data* CompositorFrameSinkClient_DidReceiveCompositorFrameAck_Params_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(CompositorFrameSinkClient_DidReceiveCompositorFrameAck_Params_Data))) CompositorFrameSinkClient_DidReceiveCompositorFrameAck_Params_Data();
}

// static
bool CompositorFrameSinkClient_DidReceiveCompositorFrameAck_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, validation_context))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const CompositorFrameSinkClient_DidReceiveCompositorFrameAck_Params_Data* object = static_cast<const CompositorFrameSinkClient_DidReceiveCompositorFrameAck_Params_Data*>(data);

  static constexpr struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 16 }};

  if (object->header_.version <=
          kVersionSizes[arraysize(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = arraysize(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            validation_context,
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[arraysize(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        validation_context,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->resources, "null resources field in CompositorFrameSinkClient_DidReceiveCompositorFrameAck_Params",
          validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams resources_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->resources, validation_context,
                                         &resources_validate_params)) {
    return false;
  }

  return true;
}

CompositorFrameSinkClient_DidReceiveCompositorFrameAck_Params_Data::CompositorFrameSinkClient_DidReceiveCompositorFrameAck_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
CompositorFrameSinkClient_OnBeginFrame_Params_Data* CompositorFrameSinkClient_OnBeginFrame_Params_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(CompositorFrameSinkClient_OnBeginFrame_Params_Data))) CompositorFrameSinkClient_OnBeginFrame_Params_Data();
}

// static
bool CompositorFrameSinkClient_OnBeginFrame_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, validation_context))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const CompositorFrameSinkClient_OnBeginFrame_Params_Data* object = static_cast<const CompositorFrameSinkClient_OnBeginFrame_Params_Data*>(data);

  static constexpr struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 16 }};

  if (object->header_.version <=
          kVersionSizes[arraysize(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = arraysize(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            validation_context,
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[arraysize(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        validation_context,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->args, "null args field in CompositorFrameSinkClient_OnBeginFrame_Params",
          validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->args, validation_context))
    return false;

  return true;
}

CompositorFrameSinkClient_OnBeginFrame_Params_Data::CompositorFrameSinkClient_OnBeginFrame_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
CompositorFrameSinkClient_OnBeginFramePausedChanged_Params_Data* CompositorFrameSinkClient_OnBeginFramePausedChanged_Params_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(CompositorFrameSinkClient_OnBeginFramePausedChanged_Params_Data))) CompositorFrameSinkClient_OnBeginFramePausedChanged_Params_Data();
}

// static
bool CompositorFrameSinkClient_OnBeginFramePausedChanged_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, validation_context))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const CompositorFrameSinkClient_OnBeginFramePausedChanged_Params_Data* object = static_cast<const CompositorFrameSinkClient_OnBeginFramePausedChanged_Params_Data*>(data);

  static constexpr struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 16 }};

  if (object->header_.version <=
          kVersionSizes[arraysize(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = arraysize(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            validation_context,
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[arraysize(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        validation_context,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  return true;
}

CompositorFrameSinkClient_OnBeginFramePausedChanged_Params_Data::CompositorFrameSinkClient_OnBeginFramePausedChanged_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
CompositorFrameSinkClient_ReclaimResources_Params_Data* CompositorFrameSinkClient_ReclaimResources_Params_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(CompositorFrameSinkClient_ReclaimResources_Params_Data))) CompositorFrameSinkClient_ReclaimResources_Params_Data();
}

// static
bool CompositorFrameSinkClient_ReclaimResources_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, validation_context))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const CompositorFrameSinkClient_ReclaimResources_Params_Data* object = static_cast<const CompositorFrameSinkClient_ReclaimResources_Params_Data*>(data);

  static constexpr struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 16 }};

  if (object->header_.version <=
          kVersionSizes[arraysize(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = arraysize(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            validation_context,
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[arraysize(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        validation_context,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->resources, "null resources field in CompositorFrameSinkClient_ReclaimResources_Params",
          validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams resources_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->resources, validation_context,
                                         &resources_validate_params)) {
    return false;
  }

  return true;
}

CompositorFrameSinkClient_ReclaimResources_Params_Data::CompositorFrameSinkClient_ReclaimResources_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
CompositorFrameSinkPrivate_ClaimTemporaryReference_Params_Data* CompositorFrameSinkPrivate_ClaimTemporaryReference_Params_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(CompositorFrameSinkPrivate_ClaimTemporaryReference_Params_Data))) CompositorFrameSinkPrivate_ClaimTemporaryReference_Params_Data();
}

// static
bool CompositorFrameSinkPrivate_ClaimTemporaryReference_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, validation_context))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const CompositorFrameSinkPrivate_ClaimTemporaryReference_Params_Data* object = static_cast<const CompositorFrameSinkPrivate_ClaimTemporaryReference_Params_Data*>(data);

  static constexpr struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 16 }};

  if (object->header_.version <=
          kVersionSizes[arraysize(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = arraysize(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            validation_context,
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[arraysize(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        validation_context,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->surface_id, "null surface_id field in CompositorFrameSinkPrivate_ClaimTemporaryReference_Params",
          validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->surface_id, validation_context))
    return false;

  return true;
}

CompositorFrameSinkPrivate_ClaimTemporaryReference_Params_Data::CompositorFrameSinkPrivate_ClaimTemporaryReference_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
CompositorFrameSinkPrivate_RequestCopyOfSurface_Params_Data* CompositorFrameSinkPrivate_RequestCopyOfSurface_Params_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(CompositorFrameSinkPrivate_RequestCopyOfSurface_Params_Data))) CompositorFrameSinkPrivate_RequestCopyOfSurface_Params_Data();
}

// static
bool CompositorFrameSinkPrivate_RequestCopyOfSurface_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, validation_context))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const CompositorFrameSinkPrivate_RequestCopyOfSurface_Params_Data* object = static_cast<const CompositorFrameSinkPrivate_RequestCopyOfSurface_Params_Data*>(data);

  static constexpr struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 16 }};

  if (object->header_.version <=
          kVersionSizes[arraysize(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = arraysize(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            validation_context,
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[arraysize(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        validation_context,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->request, "null request field in CompositorFrameSinkPrivate_RequestCopyOfSurface_Params",
          validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->request, validation_context))
    return false;

  return true;
}

CompositorFrameSinkPrivate_RequestCopyOfSurface_Params_Data::CompositorFrameSinkPrivate_RequestCopyOfSurface_Params_Data()
    : header_({sizeof(*this), 0}) {}

}  // namespace internal
}  // namespace mojom
}  // namespace cc

#if defined(_MSC_VER)
#pragma warning(pop)
#endif
