// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "cc/ipc/frame_sink_manager.mojom-blink.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "mojo/public/cpp/bindings/lib/wtf_serialization.h"
#include "cc/ipc/frame_sink_id_struct_traits.h"
#include "cc/ipc/local_surface_id_struct_traits.h"
#include "cc/ipc/surface_id_struct_traits.h"
#include "cc/ipc/surface_info_struct_traits.h"
#include "third_party/WebKit/Source/platform/mojo/GeometryStructTraits.h"
#include "ui/gfx/geometry/mojo/geometry_struct_traits.h"
namespace cc {
namespace mojom {
namespace blink {
const char DisplayPrivate::Name_[] = "cc::mojom::DisplayPrivate";

DisplayPrivateProxy::DisplayPrivateProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void DisplayPrivateProxy::SetDisplayVisible(
    bool in_visible) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::cc::mojom::internal::DisplayPrivate_SetDisplayVisible_Params_Data);
  serialization_context.PrepareMessage(
      internal::kDisplayPrivate_SetDisplayVisible_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::cc::mojom::internal::DisplayPrivate_SetDisplayVisible_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  params->visible = in_visible;
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void DisplayPrivateProxy::ResizeDisplay(
    const ::blink::WebSize& in_size_in_pixel) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::cc::mojom::internal::DisplayPrivate_ResizeDisplay_Params_Data);
  size += mojo::internal::PrepareToSerialize<::gfx::mojom::SizeDataView>(
      in_size_in_pixel, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kDisplayPrivate_ResizeDisplay_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::cc::mojom::internal::DisplayPrivate_ResizeDisplay_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->size_in_pixel)::BaseType* size_in_pixel_ptr;
  mojo::internal::Serialize<::gfx::mojom::SizeDataView>(
      in_size_in_pixel, buffer, &size_in_pixel_ptr, &serialization_context);
  params->size_in_pixel.Set(size_in_pixel_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->size_in_pixel.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null size_in_pixel in DisplayPrivate.ResizeDisplay request");
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void DisplayPrivateProxy::SetDisplayColorSpace(
    ::gfx::mojom::blink::ColorSpacePtr in_color_space) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::cc::mojom::internal::DisplayPrivate_SetDisplayColorSpace_Params_Data);
  size += mojo::internal::PrepareToSerialize<::gfx::mojom::ColorSpaceDataView>(
      in_color_space, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kDisplayPrivate_SetDisplayColorSpace_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::cc::mojom::internal::DisplayPrivate_SetDisplayColorSpace_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->color_space)::BaseType* color_space_ptr;
  mojo::internal::Serialize<::gfx::mojom::ColorSpaceDataView>(
      in_color_space, buffer, &color_space_ptr, &serialization_context);
  params->color_space.Set(color_space_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->color_space.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null color_space in DisplayPrivate.SetDisplayColorSpace request");
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void DisplayPrivateProxy::SetOutputIsSecure(
    bool in_secure) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::cc::mojom::internal::DisplayPrivate_SetOutputIsSecure_Params_Data);
  serialization_context.PrepareMessage(
      internal::kDisplayPrivate_SetOutputIsSecure_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::cc::mojom::internal::DisplayPrivate_SetOutputIsSecure_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  params->secure = in_secure;
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void DisplayPrivateProxy::SetLocalSurfaceId(
    const viz::LocalSurfaceId& in_local_surface_id, float in_scale_factor) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::cc::mojom::internal::DisplayPrivate_SetLocalSurfaceId_Params_Data);
  size += mojo::internal::PrepareToSerialize<::cc::mojom::LocalSurfaceIdDataView>(
      in_local_surface_id, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kDisplayPrivate_SetLocalSurfaceId_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::cc::mojom::internal::DisplayPrivate_SetLocalSurfaceId_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->local_surface_id)::BaseType* local_surface_id_ptr;
  mojo::internal::Serialize<::cc::mojom::LocalSurfaceIdDataView>(
      in_local_surface_id, buffer, &local_surface_id_ptr, &serialization_context);
  params->local_surface_id.Set(local_surface_id_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->local_surface_id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null local_surface_id in DisplayPrivate.SetLocalSurfaceId request");
  params->scale_factor = in_scale_factor;
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool DisplayPrivateStubDispatch::Accept(
    DisplayPrivate* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kDisplayPrivate_SetDisplayVisible_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::DisplayPrivate_SetDisplayVisible_Params_Data* params =
          reinterpret_cast<internal::DisplayPrivate_SetDisplayVisible_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      bool p_visible{};
      DisplayPrivate_SetDisplayVisible_ParamsDataView input_data_view(params, &serialization_context);
      
      p_visible = input_data_view.visible();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "DisplayPrivate::SetDisplayVisible deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->SetDisplayVisible(
std::move(p_visible));
      return true;
    }
    case internal::kDisplayPrivate_ResizeDisplay_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::DisplayPrivate_ResizeDisplay_Params_Data* params =
          reinterpret_cast<internal::DisplayPrivate_ResizeDisplay_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      ::blink::WebSize p_size_in_pixel{};
      DisplayPrivate_ResizeDisplay_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadSizeInPixel(&p_size_in_pixel))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "DisplayPrivate::ResizeDisplay deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->ResizeDisplay(
std::move(p_size_in_pixel));
      return true;
    }
    case internal::kDisplayPrivate_SetDisplayColorSpace_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::DisplayPrivate_SetDisplayColorSpace_Params_Data* params =
          reinterpret_cast<internal::DisplayPrivate_SetDisplayColorSpace_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      ::gfx::mojom::blink::ColorSpacePtr p_color_space{};
      DisplayPrivate_SetDisplayColorSpace_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadColorSpace(&p_color_space))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "DisplayPrivate::SetDisplayColorSpace deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->SetDisplayColorSpace(
std::move(p_color_space));
      return true;
    }
    case internal::kDisplayPrivate_SetOutputIsSecure_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::DisplayPrivate_SetOutputIsSecure_Params_Data* params =
          reinterpret_cast<internal::DisplayPrivate_SetOutputIsSecure_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      bool p_secure{};
      DisplayPrivate_SetOutputIsSecure_ParamsDataView input_data_view(params, &serialization_context);
      
      p_secure = input_data_view.secure();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "DisplayPrivate::SetOutputIsSecure deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->SetOutputIsSecure(
std::move(p_secure));
      return true;
    }
    case internal::kDisplayPrivate_SetLocalSurfaceId_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::DisplayPrivate_SetLocalSurfaceId_Params_Data* params =
          reinterpret_cast<internal::DisplayPrivate_SetLocalSurfaceId_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      viz::LocalSurfaceId p_local_surface_id{};
      float p_scale_factor{};
      DisplayPrivate_SetLocalSurfaceId_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadLocalSurfaceId(&p_local_surface_id))
        success = false;
      p_scale_factor = input_data_view.scale_factor();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "DisplayPrivate::SetLocalSurfaceId deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->SetLocalSurfaceId(
std::move(p_local_surface_id), 
std::move(p_scale_factor));
      return true;
    }
  }
  return false;
}

// static
bool DisplayPrivateStubDispatch::AcceptWithResponder(
    DisplayPrivate* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kDisplayPrivate_SetDisplayVisible_Name: {
      break;
    }
    case internal::kDisplayPrivate_ResizeDisplay_Name: {
      break;
    }
    case internal::kDisplayPrivate_SetDisplayColorSpace_Name: {
      break;
    }
    case internal::kDisplayPrivate_SetOutputIsSecure_Name: {
      break;
    }
    case internal::kDisplayPrivate_SetLocalSurfaceId_Name: {
      break;
    }
  }
  return false;
}

bool DisplayPrivateRequestValidator::Accept(mojo::Message* message) {
  if (mojo::internal::IsUnserializedOrControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "DisplayPrivate RequestValidator");

  switch (message->header()->name) {
    case internal::kDisplayPrivate_SetDisplayVisible_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::DisplayPrivate_SetDisplayVisible_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kDisplayPrivate_ResizeDisplay_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::DisplayPrivate_ResizeDisplay_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kDisplayPrivate_SetDisplayColorSpace_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::DisplayPrivate_SetDisplayColorSpace_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kDisplayPrivate_SetOutputIsSecure_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::DisplayPrivate_SetOutputIsSecure_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kDisplayPrivate_SetLocalSurfaceId_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::DisplayPrivate_SetLocalSurfaceId_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

const char FrameSinkManager::Name_[] = "cc::mojom::FrameSinkManager";

FrameSinkManagerProxy::FrameSinkManagerProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void FrameSinkManagerProxy::CreateRootCompositorFrameSink(
    const viz::FrameSinkId& in_frame_sink_id, ::gpu::mojom::blink::SurfaceHandlePtr in_widget, ::cc::mojom::blink::CompositorFrameSinkAssociatedRequest in_compositor_frame_sink, ::cc::mojom::blink::CompositorFrameSinkPrivateRequest in_compositor_frame_sink_private, ::cc::mojom::blink::CompositorFrameSinkClientPtr in_compositor_frame_sink_client, DisplayPrivateAssociatedRequest in_display_private) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::cc::mojom::internal::FrameSinkManager_CreateRootCompositorFrameSink_Params_Data);
  size += mojo::internal::PrepareToSerialize<::cc::mojom::FrameSinkIdDataView>(
      in_frame_sink_id, &serialization_context);
  size += mojo::internal::PrepareToSerialize<::gpu::mojom::SurfaceHandleDataView>(
      in_widget, &serialization_context);
  size += mojo::internal::PrepareToSerialize<::cc::mojom::CompositorFrameSinkAssociatedRequestDataView>(
      in_compositor_frame_sink, &serialization_context);
  size += mojo::internal::PrepareToSerialize<::cc::mojom::CompositorFrameSinkPrivateRequestDataView>(
      in_compositor_frame_sink_private, &serialization_context);
  size += mojo::internal::PrepareToSerialize<::cc::mojom::CompositorFrameSinkClientPtrDataView>(
      in_compositor_frame_sink_client, &serialization_context);
  size += mojo::internal::PrepareToSerialize<::cc::mojom::DisplayPrivateAssociatedRequestDataView>(
      in_display_private, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kFrameSinkManager_CreateRootCompositorFrameSink_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::cc::mojom::internal::FrameSinkManager_CreateRootCompositorFrameSink_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->frame_sink_id)::BaseType* frame_sink_id_ptr;
  mojo::internal::Serialize<::cc::mojom::FrameSinkIdDataView>(
      in_frame_sink_id, buffer, &frame_sink_id_ptr, &serialization_context);
  params->frame_sink_id.Set(frame_sink_id_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->frame_sink_id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null frame_sink_id in FrameSinkManager.CreateRootCompositorFrameSink request");
  typename decltype(params->widget)::BaseType* widget_ptr;
  mojo::internal::Serialize<::gpu::mojom::SurfaceHandleDataView>(
      in_widget, buffer, &widget_ptr, &serialization_context);
  params->widget.Set(widget_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->widget.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null widget in FrameSinkManager.CreateRootCompositorFrameSink request");
  mojo::internal::Serialize<::cc::mojom::CompositorFrameSinkAssociatedRequestDataView>(
      in_compositor_frame_sink, &params->compositor_frame_sink, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->compositor_frame_sink),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_INTERFACE_ID,
      "invalid compositor_frame_sink in FrameSinkManager.CreateRootCompositorFrameSink request");
  mojo::internal::Serialize<::cc::mojom::CompositorFrameSinkPrivateRequestDataView>(
      in_compositor_frame_sink_private, &params->compositor_frame_sink_private, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->compositor_frame_sink_private),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid compositor_frame_sink_private in FrameSinkManager.CreateRootCompositorFrameSink request");
  mojo::internal::Serialize<::cc::mojom::CompositorFrameSinkClientPtrDataView>(
      in_compositor_frame_sink_client, &params->compositor_frame_sink_client, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->compositor_frame_sink_client),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid compositor_frame_sink_client in FrameSinkManager.CreateRootCompositorFrameSink request");
  mojo::internal::Serialize<::cc::mojom::DisplayPrivateAssociatedRequestDataView>(
      in_display_private, &params->display_private, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->display_private),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_INTERFACE_ID,
      "invalid display_private in FrameSinkManager.CreateRootCompositorFrameSink request");
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void FrameSinkManagerProxy::CreateCompositorFrameSink(
    const viz::FrameSinkId& in_frame_sink_id, ::cc::mojom::blink::CompositorFrameSinkRequest in_compositor_frame_sink, ::cc::mojom::blink::CompositorFrameSinkPrivateRequest in_compositor_frame_sink_private, ::cc::mojom::blink::CompositorFrameSinkClientPtr in_compositor_frame_sink_client) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::cc::mojom::internal::FrameSinkManager_CreateCompositorFrameSink_Params_Data);
  size += mojo::internal::PrepareToSerialize<::cc::mojom::FrameSinkIdDataView>(
      in_frame_sink_id, &serialization_context);
  size += mojo::internal::PrepareToSerialize<::cc::mojom::CompositorFrameSinkRequestDataView>(
      in_compositor_frame_sink, &serialization_context);
  size += mojo::internal::PrepareToSerialize<::cc::mojom::CompositorFrameSinkPrivateRequestDataView>(
      in_compositor_frame_sink_private, &serialization_context);
  size += mojo::internal::PrepareToSerialize<::cc::mojom::CompositorFrameSinkClientPtrDataView>(
      in_compositor_frame_sink_client, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kFrameSinkManager_CreateCompositorFrameSink_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::cc::mojom::internal::FrameSinkManager_CreateCompositorFrameSink_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->frame_sink_id)::BaseType* frame_sink_id_ptr;
  mojo::internal::Serialize<::cc::mojom::FrameSinkIdDataView>(
      in_frame_sink_id, buffer, &frame_sink_id_ptr, &serialization_context);
  params->frame_sink_id.Set(frame_sink_id_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->frame_sink_id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null frame_sink_id in FrameSinkManager.CreateCompositorFrameSink request");
  mojo::internal::Serialize<::cc::mojom::CompositorFrameSinkRequestDataView>(
      in_compositor_frame_sink, &params->compositor_frame_sink, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->compositor_frame_sink),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid compositor_frame_sink in FrameSinkManager.CreateCompositorFrameSink request");
  mojo::internal::Serialize<::cc::mojom::CompositorFrameSinkPrivateRequestDataView>(
      in_compositor_frame_sink_private, &params->compositor_frame_sink_private, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->compositor_frame_sink_private),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid compositor_frame_sink_private in FrameSinkManager.CreateCompositorFrameSink request");
  mojo::internal::Serialize<::cc::mojom::CompositorFrameSinkClientPtrDataView>(
      in_compositor_frame_sink_client, &params->compositor_frame_sink_client, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->compositor_frame_sink_client),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid compositor_frame_sink_client in FrameSinkManager.CreateCompositorFrameSink request");
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void FrameSinkManagerProxy::RegisterFrameSinkHierarchy(
    const viz::FrameSinkId& in_parent_frame_sink_id, const viz::FrameSinkId& in_child_frame_sink_id) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::cc::mojom::internal::FrameSinkManager_RegisterFrameSinkHierarchy_Params_Data);
  size += mojo::internal::PrepareToSerialize<::cc::mojom::FrameSinkIdDataView>(
      in_parent_frame_sink_id, &serialization_context);
  size += mojo::internal::PrepareToSerialize<::cc::mojom::FrameSinkIdDataView>(
      in_child_frame_sink_id, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kFrameSinkManager_RegisterFrameSinkHierarchy_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::cc::mojom::internal::FrameSinkManager_RegisterFrameSinkHierarchy_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->parent_frame_sink_id)::BaseType* parent_frame_sink_id_ptr;
  mojo::internal::Serialize<::cc::mojom::FrameSinkIdDataView>(
      in_parent_frame_sink_id, buffer, &parent_frame_sink_id_ptr, &serialization_context);
  params->parent_frame_sink_id.Set(parent_frame_sink_id_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->parent_frame_sink_id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null parent_frame_sink_id in FrameSinkManager.RegisterFrameSinkHierarchy request");
  typename decltype(params->child_frame_sink_id)::BaseType* child_frame_sink_id_ptr;
  mojo::internal::Serialize<::cc::mojom::FrameSinkIdDataView>(
      in_child_frame_sink_id, buffer, &child_frame_sink_id_ptr, &serialization_context);
  params->child_frame_sink_id.Set(child_frame_sink_id_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->child_frame_sink_id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null child_frame_sink_id in FrameSinkManager.RegisterFrameSinkHierarchy request");
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void FrameSinkManagerProxy::UnregisterFrameSinkHierarchy(
    const viz::FrameSinkId& in_parent_frame_sink_id, const viz::FrameSinkId& in_child_frame_sink_id) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::cc::mojom::internal::FrameSinkManager_UnregisterFrameSinkHierarchy_Params_Data);
  size += mojo::internal::PrepareToSerialize<::cc::mojom::FrameSinkIdDataView>(
      in_parent_frame_sink_id, &serialization_context);
  size += mojo::internal::PrepareToSerialize<::cc::mojom::FrameSinkIdDataView>(
      in_child_frame_sink_id, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kFrameSinkManager_UnregisterFrameSinkHierarchy_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::cc::mojom::internal::FrameSinkManager_UnregisterFrameSinkHierarchy_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->parent_frame_sink_id)::BaseType* parent_frame_sink_id_ptr;
  mojo::internal::Serialize<::cc::mojom::FrameSinkIdDataView>(
      in_parent_frame_sink_id, buffer, &parent_frame_sink_id_ptr, &serialization_context);
  params->parent_frame_sink_id.Set(parent_frame_sink_id_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->parent_frame_sink_id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null parent_frame_sink_id in FrameSinkManager.UnregisterFrameSinkHierarchy request");
  typename decltype(params->child_frame_sink_id)::BaseType* child_frame_sink_id_ptr;
  mojo::internal::Serialize<::cc::mojom::FrameSinkIdDataView>(
      in_child_frame_sink_id, buffer, &child_frame_sink_id_ptr, &serialization_context);
  params->child_frame_sink_id.Set(child_frame_sink_id_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->child_frame_sink_id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null child_frame_sink_id in FrameSinkManager.UnregisterFrameSinkHierarchy request");
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void FrameSinkManagerProxy::DropTemporaryReference(
    const viz::SurfaceId& in_surface_id) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::cc::mojom::internal::FrameSinkManager_DropTemporaryReference_Params_Data);
  size += mojo::internal::PrepareToSerialize<::cc::mojom::SurfaceIdDataView>(
      in_surface_id, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kFrameSinkManager_DropTemporaryReference_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::cc::mojom::internal::FrameSinkManager_DropTemporaryReference_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->surface_id)::BaseType* surface_id_ptr;
  mojo::internal::Serialize<::cc::mojom::SurfaceIdDataView>(
      in_surface_id, buffer, &surface_id_ptr, &serialization_context);
  params->surface_id.Set(surface_id_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->surface_id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null surface_id in FrameSinkManager.DropTemporaryReference request");
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool FrameSinkManagerStubDispatch::Accept(
    FrameSinkManager* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kFrameSinkManager_CreateRootCompositorFrameSink_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::FrameSinkManager_CreateRootCompositorFrameSink_Params_Data* params =
          reinterpret_cast<internal::FrameSinkManager_CreateRootCompositorFrameSink_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      viz::FrameSinkId p_frame_sink_id{};
      ::gpu::mojom::blink::SurfaceHandlePtr p_widget{};
      ::cc::mojom::blink::CompositorFrameSinkAssociatedRequest p_compositor_frame_sink{};
      ::cc::mojom::blink::CompositorFrameSinkPrivateRequest p_compositor_frame_sink_private{};
      ::cc::mojom::blink::CompositorFrameSinkClientPtr p_compositor_frame_sink_client{};
      DisplayPrivateAssociatedRequest p_display_private{};
      FrameSinkManager_CreateRootCompositorFrameSink_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadFrameSinkId(&p_frame_sink_id))
        success = false;
      if (!input_data_view.ReadWidget(&p_widget))
        success = false;
      p_compositor_frame_sink =
          input_data_view.TakeCompositorFrameSink<decltype(p_compositor_frame_sink)>();
      p_compositor_frame_sink_private =
          input_data_view.TakeCompositorFrameSinkPrivate<decltype(p_compositor_frame_sink_private)>();
      p_compositor_frame_sink_client =
          input_data_view.TakeCompositorFrameSinkClient<decltype(p_compositor_frame_sink_client)>();
      p_display_private =
          input_data_view.TakeDisplayPrivate<decltype(p_display_private)>();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "FrameSinkManager::CreateRootCompositorFrameSink deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->CreateRootCompositorFrameSink(
std::move(p_frame_sink_id), 
std::move(p_widget), 
std::move(p_compositor_frame_sink), 
std::move(p_compositor_frame_sink_private), 
std::move(p_compositor_frame_sink_client), 
std::move(p_display_private));
      return true;
    }
    case internal::kFrameSinkManager_CreateCompositorFrameSink_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::FrameSinkManager_CreateCompositorFrameSink_Params_Data* params =
          reinterpret_cast<internal::FrameSinkManager_CreateCompositorFrameSink_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      viz::FrameSinkId p_frame_sink_id{};
      ::cc::mojom::blink::CompositorFrameSinkRequest p_compositor_frame_sink{};
      ::cc::mojom::blink::CompositorFrameSinkPrivateRequest p_compositor_frame_sink_private{};
      ::cc::mojom::blink::CompositorFrameSinkClientPtr p_compositor_frame_sink_client{};
      FrameSinkManager_CreateCompositorFrameSink_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadFrameSinkId(&p_frame_sink_id))
        success = false;
      p_compositor_frame_sink =
          input_data_view.TakeCompositorFrameSink<decltype(p_compositor_frame_sink)>();
      p_compositor_frame_sink_private =
          input_data_view.TakeCompositorFrameSinkPrivate<decltype(p_compositor_frame_sink_private)>();
      p_compositor_frame_sink_client =
          input_data_view.TakeCompositorFrameSinkClient<decltype(p_compositor_frame_sink_client)>();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "FrameSinkManager::CreateCompositorFrameSink deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->CreateCompositorFrameSink(
std::move(p_frame_sink_id), 
std::move(p_compositor_frame_sink), 
std::move(p_compositor_frame_sink_private), 
std::move(p_compositor_frame_sink_client));
      return true;
    }
    case internal::kFrameSinkManager_RegisterFrameSinkHierarchy_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::FrameSinkManager_RegisterFrameSinkHierarchy_Params_Data* params =
          reinterpret_cast<internal::FrameSinkManager_RegisterFrameSinkHierarchy_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      viz::FrameSinkId p_parent_frame_sink_id{};
      viz::FrameSinkId p_child_frame_sink_id{};
      FrameSinkManager_RegisterFrameSinkHierarchy_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadParentFrameSinkId(&p_parent_frame_sink_id))
        success = false;
      if (!input_data_view.ReadChildFrameSinkId(&p_child_frame_sink_id))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "FrameSinkManager::RegisterFrameSinkHierarchy deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->RegisterFrameSinkHierarchy(
std::move(p_parent_frame_sink_id), 
std::move(p_child_frame_sink_id));
      return true;
    }
    case internal::kFrameSinkManager_UnregisterFrameSinkHierarchy_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::FrameSinkManager_UnregisterFrameSinkHierarchy_Params_Data* params =
          reinterpret_cast<internal::FrameSinkManager_UnregisterFrameSinkHierarchy_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      viz::FrameSinkId p_parent_frame_sink_id{};
      viz::FrameSinkId p_child_frame_sink_id{};
      FrameSinkManager_UnregisterFrameSinkHierarchy_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadParentFrameSinkId(&p_parent_frame_sink_id))
        success = false;
      if (!input_data_view.ReadChildFrameSinkId(&p_child_frame_sink_id))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "FrameSinkManager::UnregisterFrameSinkHierarchy deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->UnregisterFrameSinkHierarchy(
std::move(p_parent_frame_sink_id), 
std::move(p_child_frame_sink_id));
      return true;
    }
    case internal::kFrameSinkManager_DropTemporaryReference_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::FrameSinkManager_DropTemporaryReference_Params_Data* params =
          reinterpret_cast<internal::FrameSinkManager_DropTemporaryReference_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      viz::SurfaceId p_surface_id{};
      FrameSinkManager_DropTemporaryReference_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadSurfaceId(&p_surface_id))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "FrameSinkManager::DropTemporaryReference deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->DropTemporaryReference(
std::move(p_surface_id));
      return true;
    }
  }
  return false;
}

// static
bool FrameSinkManagerStubDispatch::AcceptWithResponder(
    FrameSinkManager* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kFrameSinkManager_CreateRootCompositorFrameSink_Name: {
      break;
    }
    case internal::kFrameSinkManager_CreateCompositorFrameSink_Name: {
      break;
    }
    case internal::kFrameSinkManager_RegisterFrameSinkHierarchy_Name: {
      break;
    }
    case internal::kFrameSinkManager_UnregisterFrameSinkHierarchy_Name: {
      break;
    }
    case internal::kFrameSinkManager_DropTemporaryReference_Name: {
      break;
    }
  }
  return false;
}

bool FrameSinkManagerRequestValidator::Accept(mojo::Message* message) {
  if (mojo::internal::IsUnserializedOrControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "FrameSinkManager RequestValidator");

  switch (message->header()->name) {
    case internal::kFrameSinkManager_CreateRootCompositorFrameSink_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::FrameSinkManager_CreateRootCompositorFrameSink_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kFrameSinkManager_CreateCompositorFrameSink_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::FrameSinkManager_CreateCompositorFrameSink_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kFrameSinkManager_RegisterFrameSinkHierarchy_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::FrameSinkManager_RegisterFrameSinkHierarchy_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kFrameSinkManager_UnregisterFrameSinkHierarchy_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::FrameSinkManager_UnregisterFrameSinkHierarchy_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kFrameSinkManager_DropTemporaryReference_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::FrameSinkManager_DropTemporaryReference_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

const char FrameSinkManagerClient::Name_[] = "cc::mojom::FrameSinkManagerClient";

FrameSinkManagerClientProxy::FrameSinkManagerClientProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void FrameSinkManagerClientProxy::OnSurfaceCreated(
    const viz::SurfaceInfo& in_surface_info) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::cc::mojom::internal::FrameSinkManagerClient_OnSurfaceCreated_Params_Data);
  size += mojo::internal::PrepareToSerialize<::cc::mojom::SurfaceInfoDataView>(
      in_surface_info, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kFrameSinkManagerClient_OnSurfaceCreated_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::cc::mojom::internal::FrameSinkManagerClient_OnSurfaceCreated_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->surface_info)::BaseType* surface_info_ptr;
  mojo::internal::Serialize<::cc::mojom::SurfaceInfoDataView>(
      in_surface_info, buffer, &surface_info_ptr, &serialization_context);
  params->surface_info.Set(surface_info_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->surface_info.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null surface_info in FrameSinkManagerClient.OnSurfaceCreated request");
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void FrameSinkManagerClientProxy::OnClientConnectionClosed(
    const viz::FrameSinkId& in_frame_sink_id) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::cc::mojom::internal::FrameSinkManagerClient_OnClientConnectionClosed_Params_Data);
  size += mojo::internal::PrepareToSerialize<::cc::mojom::FrameSinkIdDataView>(
      in_frame_sink_id, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kFrameSinkManagerClient_OnClientConnectionClosed_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::cc::mojom::internal::FrameSinkManagerClient_OnClientConnectionClosed_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->frame_sink_id)::BaseType* frame_sink_id_ptr;
  mojo::internal::Serialize<::cc::mojom::FrameSinkIdDataView>(
      in_frame_sink_id, buffer, &frame_sink_id_ptr, &serialization_context);
  params->frame_sink_id.Set(frame_sink_id_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->frame_sink_id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null frame_sink_id in FrameSinkManagerClient.OnClientConnectionClosed request");
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool FrameSinkManagerClientStubDispatch::Accept(
    FrameSinkManagerClient* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kFrameSinkManagerClient_OnSurfaceCreated_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::FrameSinkManagerClient_OnSurfaceCreated_Params_Data* params =
          reinterpret_cast<internal::FrameSinkManagerClient_OnSurfaceCreated_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      viz::SurfaceInfo p_surface_info{};
      FrameSinkManagerClient_OnSurfaceCreated_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadSurfaceInfo(&p_surface_info))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "FrameSinkManagerClient::OnSurfaceCreated deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->OnSurfaceCreated(
std::move(p_surface_info));
      return true;
    }
    case internal::kFrameSinkManagerClient_OnClientConnectionClosed_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::FrameSinkManagerClient_OnClientConnectionClosed_Params_Data* params =
          reinterpret_cast<internal::FrameSinkManagerClient_OnClientConnectionClosed_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      viz::FrameSinkId p_frame_sink_id{};
      FrameSinkManagerClient_OnClientConnectionClosed_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadFrameSinkId(&p_frame_sink_id))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "FrameSinkManagerClient::OnClientConnectionClosed deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->OnClientConnectionClosed(
std::move(p_frame_sink_id));
      return true;
    }
  }
  return false;
}

// static
bool FrameSinkManagerClientStubDispatch::AcceptWithResponder(
    FrameSinkManagerClient* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kFrameSinkManagerClient_OnSurfaceCreated_Name: {
      break;
    }
    case internal::kFrameSinkManagerClient_OnClientConnectionClosed_Name: {
      break;
    }
  }
  return false;
}

bool FrameSinkManagerClientRequestValidator::Accept(mojo::Message* message) {
  if (mojo::internal::IsUnserializedOrControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "FrameSinkManagerClient RequestValidator");

  switch (message->header()->name) {
    case internal::kFrameSinkManagerClient_OnSurfaceCreated_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::FrameSinkManagerClient_OnSurfaceCreated_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kFrameSinkManagerClient_OnClientConnectionClosed_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::FrameSinkManagerClient_OnClientConnectionClosed_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

}  // namespace blink
}  // namespace mojom
}  // namespace cc

namespace mojo {

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif