// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "cc/ipc/local_surface_id.mojom-blink.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "mojo/public/cpp/bindings/lib/wtf_serialization.h"
namespace cc {
namespace mojom {
namespace blink {
LocalSurfaceId::LocalSurfaceId()
    : local_id(),
      nonce() {}

LocalSurfaceId::LocalSurfaceId(
    uint32_t local_id_in,
    ::mojo::common::mojom::blink::UnguessableTokenPtr nonce_in)
    : local_id(std::move(local_id_in)),
      nonce(std::move(nonce_in)) {}

LocalSurfaceId::~LocalSurfaceId() = default;

bool LocalSurfaceId::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
}  // namespace blink
}  // namespace mojom
}  // namespace cc

namespace mojo {


// static
bool StructTraits<::cc::mojom::blink::LocalSurfaceId::DataView, ::cc::mojom::blink::LocalSurfaceIdPtr>::Read(
    ::cc::mojom::blink::LocalSurfaceId::DataView input,
    ::cc::mojom::blink::LocalSurfaceIdPtr* output) {
  bool success = true;
  ::cc::mojom::blink::LocalSurfaceIdPtr result(::cc::mojom::blink::LocalSurfaceId::New());
  
      result->local_id = input.local_id();
      if (!input.ReadNonce(&result->nonce))
        success = false;
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif