// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "cc/ipc/render_pass.mojom-blink.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "mojo/public/cpp/bindings/lib/wtf_serialization.h"
#include "cc/ipc/frame_sink_id_struct_traits.h"
#include "cc/ipc/local_surface_id_struct_traits.h"
#include "cc/ipc/surface_id_struct_traits.h"
#include "third_party/WebKit/Source/platform/mojo/GeometryStructTraits.h"
#include "ui/gfx/geometry/mojo/geometry_struct_traits.h"
namespace cc {
namespace mojom {
namespace blink {
RenderPass::RenderPass()
    : id(),
      output_rect(),
      damage_rect(),
      transform_to_root_target(),
      filters(),
      background_filters(),
      color_space(),
      has_transparent_background(),
      cache_render_pass(false),
      has_damage_from_contributing_content(false),
      quad_list() {}

RenderPass::RenderPass(
    uint64_t id_in,
    ::gfx::mojom::blink::RectPtr output_rect_in,
    ::gfx::mojom::blink::RectPtr damage_rect_in,
    ::gfx::mojom::blink::TransformPtr transform_to_root_target_in,
    ::cc::mojom::blink::FilterOperationsPtr filters_in,
    ::cc::mojom::blink::FilterOperationsPtr background_filters_in,
    ::gfx::mojom::blink::ColorSpacePtr color_space_in,
    bool has_transparent_background_in,
    bool cache_render_pass_in,
    bool has_damage_from_contributing_content_in,
    WTF::Vector<::cc::mojom::blink::DrawQuadPtr> quad_list_in)
    : id(std::move(id_in)),
      output_rect(std::move(output_rect_in)),
      damage_rect(std::move(damage_rect_in)),
      transform_to_root_target(std::move(transform_to_root_target_in)),
      filters(std::move(filters_in)),
      background_filters(std::move(background_filters_in)),
      color_space(std::move(color_space_in)),
      has_transparent_background(std::move(has_transparent_background_in)),
      cache_render_pass(std::move(cache_render_pass_in)),
      has_damage_from_contributing_content(std::move(has_damage_from_contributing_content_in)),
      quad_list(std::move(quad_list_in)) {}

RenderPass::~RenderPass() = default;

bool RenderPass::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
}  // namespace blink
}  // namespace mojom
}  // namespace cc

namespace mojo {


// static
bool StructTraits<::cc::mojom::blink::RenderPass::DataView, ::cc::mojom::blink::RenderPassPtr>::Read(
    ::cc::mojom::blink::RenderPass::DataView input,
    ::cc::mojom::blink::RenderPassPtr* output) {
  bool success = true;
  ::cc::mojom::blink::RenderPassPtr result(::cc::mojom::blink::RenderPass::New());
  
      result->id = input.id();
      if (!input.ReadOutputRect(&result->output_rect))
        success = false;
      if (!input.ReadDamageRect(&result->damage_rect))
        success = false;
      if (!input.ReadTransformToRootTarget(&result->transform_to_root_target))
        success = false;
      if (!input.ReadFilters(&result->filters))
        success = false;
      if (!input.ReadBackgroundFilters(&result->background_filters))
        success = false;
      if (!input.ReadColorSpace(&result->color_space))
        success = false;
      result->has_transparent_background = input.has_transparent_background();
      result->cache_render_pass = input.cache_render_pass();
      result->has_damage_from_contributing_content = input.has_damage_from_contributing_content();
      if (!input.ReadQuadList(&result->quad_list))
        success = false;
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif