// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "cc/ipc/shared_bitmap_allocation_notifier.mojom-blink.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "mojo/public/cpp/bindings/lib/wtf_serialization.h"
namespace cc {
namespace mojom {
namespace blink {
const char SharedBitmapAllocationNotifier::Name_[] = "cc::mojom::SharedBitmapAllocationNotifier";

SharedBitmapAllocationNotifierProxy::SharedBitmapAllocationNotifierProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void SharedBitmapAllocationNotifierProxy::DidAllocateSharedBitmap(
    mojo::ScopedSharedBufferHandle in_buffer, ::gpu::mojom::blink::MailboxPtr in_id) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::cc::mojom::internal::SharedBitmapAllocationNotifier_DidAllocateSharedBitmap_Params_Data);
  size += mojo::internal::PrepareToSerialize<mojo::ScopedSharedBufferHandle>(
      in_buffer, &serialization_context);
  size += mojo::internal::PrepareToSerialize<::gpu::mojom::MailboxDataView>(
      in_id, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kSharedBitmapAllocationNotifier_DidAllocateSharedBitmap_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::cc::mojom::internal::SharedBitmapAllocationNotifier_DidAllocateSharedBitmap_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  mojo::internal::Serialize<mojo::ScopedSharedBufferHandle>(
      in_buffer, &params->buffer, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->buffer),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid buffer in SharedBitmapAllocationNotifier.DidAllocateSharedBitmap request");
  typename decltype(params->id)::BaseType* id_ptr;
  mojo::internal::Serialize<::gpu::mojom::MailboxDataView>(
      in_id, buffer, &id_ptr, &serialization_context);
  params->id.Set(id_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null id in SharedBitmapAllocationNotifier.DidAllocateSharedBitmap request");
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void SharedBitmapAllocationNotifierProxy::DidDeleteSharedBitmap(
    ::gpu::mojom::blink::MailboxPtr in_id) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::cc::mojom::internal::SharedBitmapAllocationNotifier_DidDeleteSharedBitmap_Params_Data);
  size += mojo::internal::PrepareToSerialize<::gpu::mojom::MailboxDataView>(
      in_id, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kSharedBitmapAllocationNotifier_DidDeleteSharedBitmap_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::cc::mojom::internal::SharedBitmapAllocationNotifier_DidDeleteSharedBitmap_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->id)::BaseType* id_ptr;
  mojo::internal::Serialize<::gpu::mojom::MailboxDataView>(
      in_id, buffer, &id_ptr, &serialization_context);
  params->id.Set(id_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null id in SharedBitmapAllocationNotifier.DidDeleteSharedBitmap request");
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool SharedBitmapAllocationNotifierStubDispatch::Accept(
    SharedBitmapAllocationNotifier* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kSharedBitmapAllocationNotifier_DidAllocateSharedBitmap_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::SharedBitmapAllocationNotifier_DidAllocateSharedBitmap_Params_Data* params =
          reinterpret_cast<internal::SharedBitmapAllocationNotifier_DidAllocateSharedBitmap_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      mojo::ScopedSharedBufferHandle p_buffer{};
      ::gpu::mojom::blink::MailboxPtr p_id{};
      SharedBitmapAllocationNotifier_DidAllocateSharedBitmap_ParamsDataView input_data_view(params, &serialization_context);
      
      p_buffer = input_data_view.TakeBuffer();
      if (!input_data_view.ReadId(&p_id))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "SharedBitmapAllocationNotifier::DidAllocateSharedBitmap deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->DidAllocateSharedBitmap(
std::move(p_buffer), 
std::move(p_id));
      return true;
    }
    case internal::kSharedBitmapAllocationNotifier_DidDeleteSharedBitmap_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::SharedBitmapAllocationNotifier_DidDeleteSharedBitmap_Params_Data* params =
          reinterpret_cast<internal::SharedBitmapAllocationNotifier_DidDeleteSharedBitmap_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      ::gpu::mojom::blink::MailboxPtr p_id{};
      SharedBitmapAllocationNotifier_DidDeleteSharedBitmap_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadId(&p_id))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "SharedBitmapAllocationNotifier::DidDeleteSharedBitmap deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->DidDeleteSharedBitmap(
std::move(p_id));
      return true;
    }
  }
  return false;
}

// static
bool SharedBitmapAllocationNotifierStubDispatch::AcceptWithResponder(
    SharedBitmapAllocationNotifier* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kSharedBitmapAllocationNotifier_DidAllocateSharedBitmap_Name: {
      break;
    }
    case internal::kSharedBitmapAllocationNotifier_DidDeleteSharedBitmap_Name: {
      break;
    }
  }
  return false;
}

bool SharedBitmapAllocationNotifierRequestValidator::Accept(mojo::Message* message) {
  if (mojo::internal::IsUnserializedOrControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "SharedBitmapAllocationNotifier RequestValidator");

  switch (message->header()->name) {
    case internal::kSharedBitmapAllocationNotifier_DidAllocateSharedBitmap_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::SharedBitmapAllocationNotifier_DidAllocateSharedBitmap_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kSharedBitmapAllocationNotifier_DidDeleteSharedBitmap_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::SharedBitmapAllocationNotifier_DidDeleteSharedBitmap_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

}  // namespace blink
}  // namespace mojom
}  // namespace cc

namespace mojo {

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif