// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "cc/ipc/surface_id.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "cc/ipc/frame_sink_id_struct_traits.h"
#include "cc/ipc/local_surface_id_struct_traits.h"
#include "mojo/common/common_custom_types_struct_traits.h"
namespace cc {
namespace mojom {
SurfaceId::SurfaceId()
    : frame_sink_id(),
      local_surface_id() {}

SurfaceId::SurfaceId(
    const viz::FrameSinkId& frame_sink_id_in,
    const viz::LocalSurfaceId& local_surface_id_in)
    : frame_sink_id(std::move(frame_sink_id_in)),
      local_surface_id(std::move(local_surface_id_in)) {}

SurfaceId::~SurfaceId() = default;

bool SurfaceId::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
}  // namespace mojom
}  // namespace cc

namespace mojo {


// static
bool StructTraits<::cc::mojom::SurfaceId::DataView, ::cc::mojom::SurfaceIdPtr>::Read(
    ::cc::mojom::SurfaceId::DataView input,
    ::cc::mojom::SurfaceIdPtr* output) {
  bool success = true;
  ::cc::mojom::SurfaceIdPtr result(::cc::mojom::SurfaceId::New());
  
      if (!input.ReadFrameSinkId(&result->frame_sink_id))
        success = false;
      if (!input.ReadLocalSurfaceId(&result->local_surface_id))
        success = false;
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif