// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "cc/ipc/texture_mailbox.mojom-blink.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "mojo/public/cpp/bindings/lib/wtf_serialization.h"
#include "gpu/ipc/common/mailbox_holder_struct_traits.h"
#include "gpu/ipc/common/sync_token_struct_traits.h"
#include "third_party/WebKit/Source/platform/mojo/GeometryStructTraits.h"
#include "ui/gfx/geometry/mojo/geometry_struct_traits.h"
namespace cc {
namespace mojom {
namespace blink {
TextureMailbox::TextureMailbox()
    : mailbox_holder(),
      size_in_pixels(),
      is_overlay_candidate(),
      is_backed_by_surface_texture(),
      wants_promotion_hint(),
      secure_output_only(),
      nearest_neighbor(),
      color_space() {}

TextureMailbox::TextureMailbox(
    const ::gpu::MailboxHolder& mailbox_holder_in,
    const ::blink::WebSize& size_in_pixels_in,
    bool is_overlay_candidate_in,
    bool is_backed_by_surface_texture_in,
    bool wants_promotion_hint_in,
    bool secure_output_only_in,
    bool nearest_neighbor_in,
    ::gfx::mojom::blink::ColorSpacePtr color_space_in)
    : mailbox_holder(std::move(mailbox_holder_in)),
      size_in_pixels(std::move(size_in_pixels_in)),
      is_overlay_candidate(std::move(is_overlay_candidate_in)),
      is_backed_by_surface_texture(std::move(is_backed_by_surface_texture_in)),
      wants_promotion_hint(std::move(wants_promotion_hint_in)),
      secure_output_only(std::move(secure_output_only_in)),
      nearest_neighbor(std::move(nearest_neighbor_in)),
      color_space(std::move(color_space_in)) {}

TextureMailbox::~TextureMailbox() = default;

bool TextureMailbox::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
}  // namespace blink
}  // namespace mojom
}  // namespace cc

namespace mojo {


// static
bool StructTraits<::cc::mojom::blink::TextureMailbox::DataView, ::cc::mojom::blink::TextureMailboxPtr>::Read(
    ::cc::mojom::blink::TextureMailbox::DataView input,
    ::cc::mojom::blink::TextureMailboxPtr* output) {
  bool success = true;
  ::cc::mojom::blink::TextureMailboxPtr result(::cc::mojom::blink::TextureMailbox::New());
  
      if (!input.ReadMailboxHolder(&result->mailbox_holder))
        success = false;
      if (!input.ReadSizeInPixels(&result->size_in_pixels))
        success = false;
      result->is_overlay_candidate = input.is_overlay_candidate();
      result->is_backed_by_surface_texture = input.is_backed_by_surface_texture();
      result->wants_promotion_hint = input.wants_promotion_hint();
      result->secure_output_only = input.secure_output_only();
      result->nearest_neighbor = input.nearest_neighbor();
      if (!input.ReadColorSpace(&result->color_space))
        success = false;
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif