// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CC_IPC_TEXTURE_MAILBOX_RELEASER_MOJOM_SHARED_INTERNAL_H_
#define CC_IPC_TEXTURE_MAILBOX_RELEASER_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/native_struct_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "gpu/ipc/common/sync_token.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace cc {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
constexpr uint32_t kTextureMailboxReleaser_Release_Name = 0;
class  TextureMailboxReleaser_Release_Params_Data {
 public:
  static TextureMailboxReleaser_Release_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::gpu::mojom::internal::SyncToken_Data> sync_token;
  uint8_t is_lost : 1;
  uint8_t padfinal_[7];

 private:
  TextureMailboxReleaser_Release_Params_Data();
  ~TextureMailboxReleaser_Release_Params_Data() = delete;
};
static_assert(sizeof(TextureMailboxReleaser_Release_Params_Data) == 24,
              "Bad sizeof(TextureMailboxReleaser_Release_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace cc

#endif  // CC_IPC_TEXTURE_MAILBOX_RELEASER_MOJOM_SHARED_INTERNAL_H_