// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CC_IPC_TEXTURE_MAILBOX_RELEASER_MOJOM_SHARED_H_
#define CC_IPC_TEXTURE_MAILBOX_RELEASER_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/native_struct_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "cc/ipc/texture_mailbox_releaser.mojom-shared-internal.h"
#include "gpu/ipc/common/sync_token.mojom-shared.h"


namespace cc {
namespace mojom {


}  // namespace mojom
}  // namespace cc

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace cc {
namespace mojom {
// Interface base classes. They are used for type safety check.
class TextureMailboxReleaserInterfaceBase {};

using TextureMailboxReleaserPtrDataView =
    mojo::InterfacePtrDataView<TextureMailboxReleaserInterfaceBase>;
using TextureMailboxReleaserRequestDataView =
    mojo::InterfaceRequestDataView<TextureMailboxReleaserInterfaceBase>;
using TextureMailboxReleaserAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<TextureMailboxReleaserInterfaceBase>;
using TextureMailboxReleaserAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<TextureMailboxReleaserInterfaceBase>;
class TextureMailboxReleaser_Release_ParamsDataView {
 public:
  TextureMailboxReleaser_Release_ParamsDataView() {}

  TextureMailboxReleaser_Release_ParamsDataView(
      internal::TextureMailboxReleaser_Release_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetSyncTokenDataView(
      ::gpu::mojom::SyncTokenDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadSyncToken(UserType* output) {
    auto* pointer = data_->sync_token.Get();
    return mojo::internal::Deserialize<::gpu::mojom::SyncTokenDataView>(
        pointer, output, context_);
  }
  bool is_lost() const {
    return data_->is_lost;
  }
 private:
  internal::TextureMailboxReleaser_Release_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace cc

namespace std {

}  // namespace std

namespace mojo {

}  // namespace mojo


namespace cc {
namespace mojom {

inline void TextureMailboxReleaser_Release_ParamsDataView::GetSyncTokenDataView(
    ::gpu::mojom::SyncTokenDataView* output) {
  auto pointer = data_->sync_token.Get();
  *output = ::gpu::mojom::SyncTokenDataView(pointer, context_);
}



}  // namespace mojom
}  // namespace cc

#endif  // CC_IPC_TEXTURE_MAILBOX_RELEASER_MOJOM_SHARED_H_
