// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CC_IPC_TEXTURE_MAILBOX_RELEASER_MOJOM_H_
#define CC_IPC_TEXTURE_MAILBOX_RELEASER_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/lib/control_message_proxy.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/native_struct.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "cc/ipc/texture_mailbox_releaser.mojom-shared.h"
#include "gpu/ipc/common/sync_token.mojom.h"
#include <string>
#include <vector>


namespace cc {
namespace mojom {
class TextureMailboxReleaser;
using TextureMailboxReleaserPtr = mojo::InterfacePtr<TextureMailboxReleaser>;
using TextureMailboxReleaserPtrInfo = mojo::InterfacePtrInfo<TextureMailboxReleaser>;
using ThreadSafeTextureMailboxReleaserPtr =
    mojo::ThreadSafeInterfacePtr<TextureMailboxReleaser>;
using TextureMailboxReleaserRequest = mojo::InterfaceRequest<TextureMailboxReleaser>;
using TextureMailboxReleaserAssociatedPtr =
    mojo::AssociatedInterfacePtr<TextureMailboxReleaser>;
using ThreadSafeTextureMailboxReleaserAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<TextureMailboxReleaser>;
using TextureMailboxReleaserAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<TextureMailboxReleaser>;
using TextureMailboxReleaserAssociatedRequest =
    mojo::AssociatedInterfaceRequest<TextureMailboxReleaser>;


class TextureMailboxReleaserProxy;

template <typename ImplRefTraits>
class TextureMailboxReleaserStub;

class TextureMailboxReleaserRequestValidator;

class  TextureMailboxReleaser
    : public TextureMailboxReleaserInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Proxy_ = TextureMailboxReleaserProxy;

  template <typename ImplRefTraits>
  using Stub_ = TextureMailboxReleaserStub<ImplRefTraits>;

  using RequestValidator_ = TextureMailboxReleaserRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kReleaseMinVersion = 0,
  };
  virtual ~TextureMailboxReleaser() {}

  virtual void Release(const ::gpu::SyncToken& sync_token, bool is_lost) = 0;
};

class  TextureMailboxReleaserProxy
    : public TextureMailboxReleaser {
 public:
  explicit TextureMailboxReleaserProxy(mojo::MessageReceiverWithResponder* receiver);
  void Release(const ::gpu::SyncToken& sync_token, bool is_lost) override;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  TextureMailboxReleaserStubDispatch {
 public:
  static bool Accept(TextureMailboxReleaser* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      TextureMailboxReleaser* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<TextureMailboxReleaser>>
class TextureMailboxReleaserStub
    : public NON_EXPORTED_BASE(mojo::MessageReceiverWithResponderStatus) {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  TextureMailboxReleaserStub() {}
  ~TextureMailboxReleaserStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return TextureMailboxReleaserStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return TextureMailboxReleaserStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  TextureMailboxReleaserRequestValidator : public NON_EXPORTED_BASE(mojo::MessageReceiver) {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // namespace mojom
}  // namespace cc

namespace mojo {

}  // namespace mojo

#endif  // CC_IPC_TEXTURE_MAILBOX_RELEASER_MOJOM_H_