// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef COMPONENTS_SPELLCHECK_COMMON_SPELLCHECK_MOJOM_SHARED_INTERNAL_H_
#define COMPONENTS_SPELLCHECK_COMMON_SPELLCHECK_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/native_struct_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/common/file.mojom-shared-internal.h"
#include "mojo/common/string16.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace spellcheck {
namespace mojom {
namespace internal {
class SpellCheckBDictLanguage_Data;
using SpellCheckResult_Data = mojo::internal::NativeStruct_Data;

#pragma pack(push, 1)
class  SpellCheckBDictLanguage_Data {
 public:
  static SpellCheckBDictLanguage_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo::common::mojom::internal::File_Data> file;
  mojo::internal::Pointer<mojo::internal::String_Data> language;

 private:
  SpellCheckBDictLanguage_Data();
  ~SpellCheckBDictLanguage_Data() = delete;
};
static_assert(sizeof(SpellCheckBDictLanguage_Data) == 24,
              "Bad sizeof(SpellCheckBDictLanguage_Data)");
constexpr uint32_t kSpellChecker_Initialize_Name = 0;
class  SpellChecker_Initialize_Params_Data {
 public:
  static SpellChecker_Initialize_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::SpellCheckBDictLanguage_Data>>> dictionaries;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<mojo::internal::String_Data>>> custom_words;
  uint8_t enable : 1;
  uint8_t padfinal_[7];

 private:
  SpellChecker_Initialize_Params_Data();
  ~SpellChecker_Initialize_Params_Data() = delete;
};
static_assert(sizeof(SpellChecker_Initialize_Params_Data) == 32,
              "Bad sizeof(SpellChecker_Initialize_Params_Data)");
constexpr uint32_t kSpellChecker_CustomDictionaryChanged_Name = 1;
class  SpellChecker_CustomDictionaryChanged_Params_Data {
 public:
  static SpellChecker_CustomDictionaryChanged_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<mojo::internal::String_Data>>> words_added;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<mojo::internal::String_Data>>> words_removed;

 private:
  SpellChecker_CustomDictionaryChanged_Params_Data();
  ~SpellChecker_CustomDictionaryChanged_Params_Data() = delete;
};
static_assert(sizeof(SpellChecker_CustomDictionaryChanged_Params_Data) == 24,
              "Bad sizeof(SpellChecker_CustomDictionaryChanged_Params_Data)");
constexpr uint32_t kSpellCheckHost_RequestDictionary_Name = 0;
class  SpellCheckHost_RequestDictionary_Params_Data {
 public:
  static SpellCheckHost_RequestDictionary_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  SpellCheckHost_RequestDictionary_Params_Data();
  ~SpellCheckHost_RequestDictionary_Params_Data() = delete;
};
static_assert(sizeof(SpellCheckHost_RequestDictionary_Params_Data) == 8,
              "Bad sizeof(SpellCheckHost_RequestDictionary_Params_Data)");
constexpr uint32_t kSpellCheckHost_NotifyChecked_Name = 1;
class  SpellCheckHost_NotifyChecked_Params_Data {
 public:
  static SpellCheckHost_NotifyChecked_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo::common::mojom::internal::String16_Data> word;
  uint8_t misspelled : 1;
  uint8_t padfinal_[7];

 private:
  SpellCheckHost_NotifyChecked_Params_Data();
  ~SpellCheckHost_NotifyChecked_Params_Data() = delete;
};
static_assert(sizeof(SpellCheckHost_NotifyChecked_Params_Data) == 24,
              "Bad sizeof(SpellCheckHost_NotifyChecked_Params_Data)");
constexpr uint32_t kSpellCheckHost_CallSpellingService_Name = 2;
class  SpellCheckHost_CallSpellingService_Params_Data {
 public:
  static SpellCheckHost_CallSpellingService_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo::common::mojom::internal::String16_Data> text;

 private:
  SpellCheckHost_CallSpellingService_Params_Data();
  ~SpellCheckHost_CallSpellingService_Params_Data() = delete;
};
static_assert(sizeof(SpellCheckHost_CallSpellingService_Params_Data) == 16,
              "Bad sizeof(SpellCheckHost_CallSpellingService_Params_Data)");
class  SpellCheckHost_CallSpellingService_ResponseParams_Data {
 public:
  static SpellCheckHost_CallSpellingService_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t success : 1;
  uint8_t pad0_[7];
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::SpellCheckResult_Data>>> results;

 private:
  SpellCheckHost_CallSpellingService_ResponseParams_Data();
  ~SpellCheckHost_CallSpellingService_ResponseParams_Data() = delete;
};
static_assert(sizeof(SpellCheckHost_CallSpellingService_ResponseParams_Data) == 24,
              "Bad sizeof(SpellCheckHost_CallSpellingService_ResponseParams_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace spellcheck

#endif  // COMPONENTS_SPELLCHECK_COMMON_SPELLCHECK_MOJOM_SHARED_INTERNAL_H_