// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_COMMON_FRAME_MOJOM_SHARED_INTERNAL_H_
#define CONTENT_COMMON_FRAME_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/native_struct_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "content/public/common/window_container_type.mojom-shared-internal.h"
#include "services/service_manager/public/interfaces/interface_provider.mojom-shared-internal.h"
#include "third_party/WebKit/public/platform/referrer.mojom-shared-internal.h"
#include "third_party/WebKit/public/web/window_features.mojom-shared-internal.h"
#include "ui/base/mojo/window_open_disposition.mojom-shared-internal.h"
#include "url/mojo/url.mojom-shared-internal.h"
#include "content/common/mojo_bindings_shared_export.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace content {
namespace mojom {
namespace internal {
class CreateNewWindowParams_Data;
class CreateNewWindowReply_Data;

#pragma pack(push, 1)
class MOJOM_SHARED_CONTENT_EXPORT CreateNewWindowParams_Data {
 public:
  static CreateNewWindowParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t user_gesture : 1;
  uint8_t opener_suppressed : 1;
  uint8_t pad1_[3];
  int32_t window_container_type;
  int64_t session_storage_namespace_id;
  mojo::internal::Pointer<mojo::internal::String_Data> frame_name;
  int32_t disposition;
  uint8_t pad5_[4];
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> target_url;
  mojo::internal::Pointer<::blink::mojom::internal::Referrer_Data> referrer;
  mojo::internal::Pointer<::blink::mojom::internal::WindowFeatures_Data> features;

 private:
  CreateNewWindowParams_Data();
  ~CreateNewWindowParams_Data() = delete;
};
static_assert(sizeof(CreateNewWindowParams_Data) == 64,
              "Bad sizeof(CreateNewWindowParams_Data)");
class MOJOM_SHARED_CONTENT_EXPORT CreateNewWindowReply_Data {
 public:
  static CreateNewWindowReply_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t route_id;
  int32_t main_frame_route_id;
  int32_t main_frame_widget_route_id;
  uint8_t pad2_[4];
  int64_t cloned_session_storage_namespace_id;

 private:
  CreateNewWindowReply_Data();
  ~CreateNewWindowReply_Data() = delete;
};
static_assert(sizeof(CreateNewWindowReply_Data) == 32,
              "Bad sizeof(CreateNewWindowReply_Data)");
constexpr uint32_t kFrame_GetInterfaceProvider_Name = 0;
class MOJOM_SHARED_CONTENT_EXPORT Frame_GetInterfaceProvider_Params_Data {
 public:
  static Frame_GetInterfaceProvider_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data interfaces;
  uint8_t padfinal_[4];

 private:
  Frame_GetInterfaceProvider_Params_Data();
  ~Frame_GetInterfaceProvider_Params_Data() = delete;
};
static_assert(sizeof(Frame_GetInterfaceProvider_Params_Data) == 16,
              "Bad sizeof(Frame_GetInterfaceProvider_Params_Data)");
constexpr uint32_t kFrameBindingsControl_AllowBindings_Name = 0;
class MOJOM_SHARED_CONTENT_EXPORT FrameBindingsControl_AllowBindings_Params_Data {
 public:
  static FrameBindingsControl_AllowBindings_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t enabled_bindings_flags;
  uint8_t padfinal_[4];

 private:
  FrameBindingsControl_AllowBindings_Params_Data();
  ~FrameBindingsControl_AllowBindings_Params_Data() = delete;
};
static_assert(sizeof(FrameBindingsControl_AllowBindings_Params_Data) == 16,
              "Bad sizeof(FrameBindingsControl_AllowBindings_Params_Data)");
constexpr uint32_t kFrameHostInterfaceBroker_GetInterfaceProvider_Name = 0;
class MOJOM_SHARED_CONTENT_EXPORT FrameHostInterfaceBroker_GetInterfaceProvider_Params_Data {
 public:
  static FrameHostInterfaceBroker_GetInterfaceProvider_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data interfaces;
  uint8_t padfinal_[4];

 private:
  FrameHostInterfaceBroker_GetInterfaceProvider_Params_Data();
  ~FrameHostInterfaceBroker_GetInterfaceProvider_Params_Data() = delete;
};
static_assert(sizeof(FrameHostInterfaceBroker_GetInterfaceProvider_Params_Data) == 16,
              "Bad sizeof(FrameHostInterfaceBroker_GetInterfaceProvider_Params_Data)");
constexpr uint32_t kFrameFactory_CreateFrame_Name = 0;
class MOJOM_SHARED_CONTENT_EXPORT FrameFactory_CreateFrame_Params_Data {
 public:
  static FrameFactory_CreateFrame_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t frame_routing_id;
  mojo::internal::Handle_Data frame;
  mojo::internal::Interface_Data host;

 private:
  FrameFactory_CreateFrame_Params_Data();
  ~FrameFactory_CreateFrame_Params_Data() = delete;
};
static_assert(sizeof(FrameFactory_CreateFrame_Params_Data) == 24,
              "Bad sizeof(FrameFactory_CreateFrame_Params_Data)");
constexpr uint32_t kFrameHost_CreateNewWindow_Name = 0;
class MOJOM_SHARED_CONTENT_EXPORT FrameHost_CreateNewWindow_Params_Data {
 public:
  static FrameHost_CreateNewWindow_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::CreateNewWindowParams_Data> params;

 private:
  FrameHost_CreateNewWindow_Params_Data();
  ~FrameHost_CreateNewWindow_Params_Data() = delete;
};
static_assert(sizeof(FrameHost_CreateNewWindow_Params_Data) == 16,
              "Bad sizeof(FrameHost_CreateNewWindow_Params_Data)");
class MOJOM_SHARED_CONTENT_EXPORT FrameHost_CreateNewWindow_ResponseParams_Data {
 public:
  static FrameHost_CreateNewWindow_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::CreateNewWindowReply_Data> reply;

 private:
  FrameHost_CreateNewWindow_ResponseParams_Data();
  ~FrameHost_CreateNewWindow_ResponseParams_Data() = delete;
};
static_assert(sizeof(FrameHost_CreateNewWindow_ResponseParams_Data) == 16,
              "Bad sizeof(FrameHost_CreateNewWindow_ResponseParams_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace content

#endif  // CONTENT_COMMON_FRAME_MOJOM_SHARED_INTERNAL_H_