// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_COMMON_FRAME_SINK_PROVIDER_MOJOM_SHARED_INTERNAL_H_
#define CONTENT_COMMON_FRAME_SINK_PROVIDER_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/native_struct_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "cc/ipc/compositor_frame_sink.mojom-shared-internal.h"
#include "content/common/mojo_bindings_shared_export.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace content {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
constexpr uint32_t kFrameSinkProvider_CreateForWidget_Name = 0;
class MOJOM_SHARED_CONTENT_EXPORT FrameSinkProvider_CreateForWidget_Params_Data {
 public:
  static FrameSinkProvider_CreateForWidget_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t widget_id;
  mojo::internal::Handle_Data request;
  mojo::internal::Interface_Data client;

 private:
  FrameSinkProvider_CreateForWidget_Params_Data();
  ~FrameSinkProvider_CreateForWidget_Params_Data() = delete;
};
static_assert(sizeof(FrameSinkProvider_CreateForWidget_Params_Data) == 24,
              "Bad sizeof(FrameSinkProvider_CreateForWidget_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace content

#endif  // CONTENT_COMMON_FRAME_SINK_PROVIDER_MOJOM_SHARED_INTERNAL_H_