// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "content/common/frame_sink_provider.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
namespace content {
namespace mojom {
const char FrameSinkProvider::Name_[] = "content::mojom::FrameSinkProvider";

FrameSinkProviderProxy::FrameSinkProviderProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void FrameSinkProviderProxy::CreateForWidget(
    int32_t in_widget_id, ::cc::mojom::CompositorFrameSinkRequest in_request, ::cc::mojom::CompositorFrameSinkClientPtr in_client) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::FrameSinkProvider_CreateForWidget_Params_Data);
  size += mojo::internal::PrepareToSerialize<::cc::mojom::CompositorFrameSinkRequestDataView>(
      in_request, &serialization_context);
  size += mojo::internal::PrepareToSerialize<::cc::mojom::CompositorFrameSinkClientPtrDataView>(
      in_client, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kFrameSinkProvider_CreateForWidget_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::FrameSinkProvider_CreateForWidget_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  params->widget_id = in_widget_id;
  mojo::internal::Serialize<::cc::mojom::CompositorFrameSinkRequestDataView>(
      in_request, &params->request, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->request),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid request in FrameSinkProvider.CreateForWidget request");
  mojo::internal::Serialize<::cc::mojom::CompositorFrameSinkClientPtrDataView>(
      in_client, &params->client, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->client),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid client in FrameSinkProvider.CreateForWidget request");
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool FrameSinkProviderStubDispatch::Accept(
    FrameSinkProvider* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kFrameSinkProvider_CreateForWidget_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::FrameSinkProvider_CreateForWidget_Params_Data* params =
          reinterpret_cast<internal::FrameSinkProvider_CreateForWidget_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      int32_t p_widget_id{};
      ::cc::mojom::CompositorFrameSinkRequest p_request{};
      ::cc::mojom::CompositorFrameSinkClientPtr p_client{};
      FrameSinkProvider_CreateForWidget_ParamsDataView input_data_view(params, &serialization_context);
      
      p_widget_id = input_data_view.widget_id();
      p_request =
          input_data_view.TakeRequest<decltype(p_request)>();
      p_client =
          input_data_view.TakeClient<decltype(p_client)>();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "FrameSinkProvider::CreateForWidget deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->CreateForWidget(
std::move(p_widget_id), 
std::move(p_request), 
std::move(p_client));
      return true;
    }
  }
  return false;
}

// static
bool FrameSinkProviderStubDispatch::AcceptWithResponder(
    FrameSinkProvider* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kFrameSinkProvider_CreateForWidget_Name: {
      break;
    }
  }
  return false;
}

bool FrameSinkProviderRequestValidator::Accept(mojo::Message* message) {
  if (mojo::internal::IsUnserializedOrControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "FrameSinkProvider RequestValidator");

  switch (message->header()->name) {
    case internal::kFrameSinkProvider_CreateForWidget_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::FrameSinkProvider_CreateForWidget_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

}  // namespace mojom
}  // namespace content

namespace mojo {

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif