// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "content/common/render_message_filter.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "content/common/frame_messages.h"
#include "content/common/input/input_event_struct_traits.h"
#include "content/common/input_messages.h"
#include "content/common/view_messages.h"
#include "content/public/common/common_param_traits.h"
namespace content {
namespace mojom {
const char RenderMessageFilter::Name_[] = "content::mojom::RenderMessageFilter";
bool RenderMessageFilter::GenerateRoutingID(int32_t* routing_id) {
  NOTREACHED();
  return false;
}
bool RenderMessageFilter::CreateNewWidget(int32_t opener_id, blink::WebPopupType popup_type, ::content::mojom::WidgetPtr widget, int32_t* route_id) {
  NOTREACHED();
  return false;
}
bool RenderMessageFilter::CreateFullscreenWidget(int32_t opener_id, ::content::mojom::WidgetPtr widget, int32_t* route_id) {
  NOTREACHED();
  return false;
}
class RenderMessageFilter_GenerateRoutingID_HandleSyncResponse
    : public mojo::MessageReceiver {
 public:
  RenderMessageFilter_GenerateRoutingID_HandleSyncResponse(
      bool* result, int32_t* out_routing_id)
      : result_(result), out_routing_id_(out_routing_id) {
    DCHECK(!*result_);
  }
  bool Accept(mojo::Message* message) override;
 private:
  bool* result_;
  int32_t* out_routing_id_;DISALLOW_COPY_AND_ASSIGN(RenderMessageFilter_GenerateRoutingID_HandleSyncResponse);
};

class RenderMessageFilter_GenerateRoutingID_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  RenderMessageFilter_GenerateRoutingID_ForwardToCallback(
      RenderMessageFilter::GenerateRoutingIDCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  RenderMessageFilter::GenerateRoutingIDCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(RenderMessageFilter_GenerateRoutingID_ForwardToCallback);
};
class RenderMessageFilter_CreateNewWidget_HandleSyncResponse
    : public mojo::MessageReceiver {
 public:
  RenderMessageFilter_CreateNewWidget_HandleSyncResponse(
      bool* result, int32_t* out_route_id)
      : result_(result), out_route_id_(out_route_id) {
    DCHECK(!*result_);
  }
  bool Accept(mojo::Message* message) override;
 private:
  bool* result_;
  int32_t* out_route_id_;DISALLOW_COPY_AND_ASSIGN(RenderMessageFilter_CreateNewWidget_HandleSyncResponse);
};

class RenderMessageFilter_CreateNewWidget_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  RenderMessageFilter_CreateNewWidget_ForwardToCallback(
      RenderMessageFilter::CreateNewWidgetCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  RenderMessageFilter::CreateNewWidgetCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(RenderMessageFilter_CreateNewWidget_ForwardToCallback);
};
class RenderMessageFilter_CreateFullscreenWidget_HandleSyncResponse
    : public mojo::MessageReceiver {
 public:
  RenderMessageFilter_CreateFullscreenWidget_HandleSyncResponse(
      bool* result, int32_t* out_route_id)
      : result_(result), out_route_id_(out_route_id) {
    DCHECK(!*result_);
  }
  bool Accept(mojo::Message* message) override;
 private:
  bool* result_;
  int32_t* out_route_id_;DISALLOW_COPY_AND_ASSIGN(RenderMessageFilter_CreateFullscreenWidget_HandleSyncResponse);
};

class RenderMessageFilter_CreateFullscreenWidget_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  RenderMessageFilter_CreateFullscreenWidget_ForwardToCallback(
      RenderMessageFilter::CreateFullscreenWidgetCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  RenderMessageFilter::CreateFullscreenWidgetCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(RenderMessageFilter_CreateFullscreenWidget_ForwardToCallback);
};

RenderMessageFilterProxy::RenderMessageFilterProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}
bool RenderMessageFilterProxy::GenerateRoutingID(
    int32_t* param_routing_id) {
  const bool kExpectsResponse = true;
  const bool kIsSync = true;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::RenderMessageFilter_GenerateRoutingID_Params_Data);
  serialization_context.PrepareMessage(
      internal::kRenderMessageFilter_GenerateRoutingID_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::RenderMessageFilter_GenerateRoutingID_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);

  bool result = false;
  std::unique_ptr<mojo::MessageReceiver> responder(
      new RenderMessageFilter_GenerateRoutingID_HandleSyncResponse(
          &result, param_routing_id));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
  return result;
}

void RenderMessageFilterProxy::GenerateRoutingID(
    GenerateRoutingIDCallback callback) {
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::RenderMessageFilter_GenerateRoutingID_Params_Data);
  serialization_context.PrepareMessage(
      internal::kRenderMessageFilter_GenerateRoutingID_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::RenderMessageFilter_GenerateRoutingID_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  std::unique_ptr<mojo::MessageReceiver> responder(
      new RenderMessageFilter_GenerateRoutingID_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}
bool RenderMessageFilterProxy::CreateNewWidget(
    int32_t param_opener_id, blink::WebPopupType param_popup_type, ::content::mojom::WidgetPtr param_widget, int32_t* param_route_id) {
  const bool kExpectsResponse = true;
  const bool kIsSync = true;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::RenderMessageFilter_CreateNewWidget_Params_Data);
  size += mojo::internal::PrepareToSerialize<::content::mojom::WidgetPtrDataView>(
      param_widget, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kRenderMessageFilter_CreateNewWidget_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::RenderMessageFilter_CreateNewWidget_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  params->opener_id = param_opener_id;
  mojo::internal::Serialize<::content::mojom::WebPopupType>(
      param_popup_type, &params->popup_type);
  mojo::internal::Serialize<::content::mojom::WidgetPtrDataView>(
      param_widget, &params->widget, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->widget),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid widget in RenderMessageFilter.CreateNewWidget request");

  bool result = false;
  std::unique_ptr<mojo::MessageReceiver> responder(
      new RenderMessageFilter_CreateNewWidget_HandleSyncResponse(
          &result, param_route_id));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
  return result;
}

void RenderMessageFilterProxy::CreateNewWidget(
    int32_t in_opener_id, blink::WebPopupType in_popup_type, ::content::mojom::WidgetPtr in_widget, CreateNewWidgetCallback callback) {
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::RenderMessageFilter_CreateNewWidget_Params_Data);
  size += mojo::internal::PrepareToSerialize<::content::mojom::WidgetPtrDataView>(
      in_widget, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kRenderMessageFilter_CreateNewWidget_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::RenderMessageFilter_CreateNewWidget_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  params->opener_id = in_opener_id;
  mojo::internal::Serialize<::content::mojom::WebPopupType>(
      in_popup_type, &params->popup_type);
  mojo::internal::Serialize<::content::mojom::WidgetPtrDataView>(
      in_widget, &params->widget, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->widget),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid widget in RenderMessageFilter.CreateNewWidget request");
  std::unique_ptr<mojo::MessageReceiver> responder(
      new RenderMessageFilter_CreateNewWidget_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}
bool RenderMessageFilterProxy::CreateFullscreenWidget(
    int32_t param_opener_id, ::content::mojom::WidgetPtr param_widget, int32_t* param_route_id) {
  const bool kExpectsResponse = true;
  const bool kIsSync = true;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::RenderMessageFilter_CreateFullscreenWidget_Params_Data);
  size += mojo::internal::PrepareToSerialize<::content::mojom::WidgetPtrDataView>(
      param_widget, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kRenderMessageFilter_CreateFullscreenWidget_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::RenderMessageFilter_CreateFullscreenWidget_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  params->opener_id = param_opener_id;
  mojo::internal::Serialize<::content::mojom::WidgetPtrDataView>(
      param_widget, &params->widget, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->widget),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid widget in RenderMessageFilter.CreateFullscreenWidget request");

  bool result = false;
  std::unique_ptr<mojo::MessageReceiver> responder(
      new RenderMessageFilter_CreateFullscreenWidget_HandleSyncResponse(
          &result, param_route_id));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
  return result;
}

void RenderMessageFilterProxy::CreateFullscreenWidget(
    int32_t in_opener_id, ::content::mojom::WidgetPtr in_widget, CreateFullscreenWidgetCallback callback) {
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::RenderMessageFilter_CreateFullscreenWidget_Params_Data);
  size += mojo::internal::PrepareToSerialize<::content::mojom::WidgetPtrDataView>(
      in_widget, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kRenderMessageFilter_CreateFullscreenWidget_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::RenderMessageFilter_CreateFullscreenWidget_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  params->opener_id = in_opener_id;
  mojo::internal::Serialize<::content::mojom::WidgetPtrDataView>(
      in_widget, &params->widget, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->widget),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid widget in RenderMessageFilter.CreateFullscreenWidget request");
  std::unique_ptr<mojo::MessageReceiver> responder(
      new RenderMessageFilter_CreateFullscreenWidget_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}
class RenderMessageFilter_GenerateRoutingID_ProxyToResponder {
 public:
  static RenderMessageFilter::GenerateRoutingIDCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<RenderMessageFilter_GenerateRoutingID_ProxyToResponder> proxy(
        new RenderMessageFilter_GenerateRoutingID_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::Bind(&RenderMessageFilter_GenerateRoutingID_ProxyToResponder::Run,
                      base::Passed(&proxy));
  }

  ~RenderMessageFilter_GenerateRoutingID_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // Is the Service destroying the callback without running it
      // and without first closing the pipe?
      responder_->DCheckInvalid("The callback passed to "
          "RenderMessageFilter::GenerateRoutingID() was never run.");
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  RenderMessageFilter_GenerateRoutingID_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

  void Run(
      int32_t in_routing_id);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(RenderMessageFilter_GenerateRoutingID_ProxyToResponder);
};

bool RenderMessageFilter_GenerateRoutingID_ForwardToCallback::Accept(
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::RenderMessageFilter_GenerateRoutingID_ResponseParams_Data* params =
      reinterpret_cast<
          internal::RenderMessageFilter_GenerateRoutingID_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  int32_t p_routing_id{};
  RenderMessageFilter_GenerateRoutingID_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  p_routing_id = input_data_view.routing_id();
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "RenderMessageFilter::GenerateRoutingID response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_routing_id));
  return true;
}

void RenderMessageFilter_GenerateRoutingID_ProxyToResponder::Run(
    int32_t in_routing_id) {
  mojo::Message message;
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::RenderMessageFilter_GenerateRoutingID_ResponseParams_Data);
  serialization_context.PrepareMessage(
      internal::kRenderMessageFilter_GenerateRoutingID_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::RenderMessageFilter_GenerateRoutingID_ResponseParams_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  params->routing_id = in_routing_id;

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
bool RenderMessageFilter_GenerateRoutingID_HandleSyncResponse::Accept(
    mojo::Message* message) {

  DCHECK(message->is_serialized());
  internal::RenderMessageFilter_GenerateRoutingID_ResponseParams_Data* params =
      reinterpret_cast<internal::RenderMessageFilter_GenerateRoutingID_ResponseParams_Data*>(
          message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  int32_t p_routing_id{};
  RenderMessageFilter_GenerateRoutingID_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  p_routing_id = input_data_view.routing_id();
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "RenderMessageFilter::GenerateRoutingID response deserializer");
    return false;
  }
  *out_routing_id_ = std::move(p_routing_id);
  mojo::internal::SyncMessageResponseSetup::SetCurrentSyncResponseMessage(
      message);
  *result_ = true;
  return true;
}
class RenderMessageFilter_CreateNewWidget_ProxyToResponder {
 public:
  static RenderMessageFilter::CreateNewWidgetCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<RenderMessageFilter_CreateNewWidget_ProxyToResponder> proxy(
        new RenderMessageFilter_CreateNewWidget_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::Bind(&RenderMessageFilter_CreateNewWidget_ProxyToResponder::Run,
                      base::Passed(&proxy));
  }

  ~RenderMessageFilter_CreateNewWidget_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // Is the Service destroying the callback without running it
      // and without first closing the pipe?
      responder_->DCheckInvalid("The callback passed to "
          "RenderMessageFilter::CreateNewWidget() was never run.");
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  RenderMessageFilter_CreateNewWidget_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

  void Run(
      int32_t in_route_id);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(RenderMessageFilter_CreateNewWidget_ProxyToResponder);
};

bool RenderMessageFilter_CreateNewWidget_ForwardToCallback::Accept(
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::RenderMessageFilter_CreateNewWidget_ResponseParams_Data* params =
      reinterpret_cast<
          internal::RenderMessageFilter_CreateNewWidget_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  int32_t p_route_id{};
  RenderMessageFilter_CreateNewWidget_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  p_route_id = input_data_view.route_id();
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "RenderMessageFilter::CreateNewWidget response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_route_id));
  return true;
}

void RenderMessageFilter_CreateNewWidget_ProxyToResponder::Run(
    int32_t in_route_id) {
  mojo::Message message;
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::RenderMessageFilter_CreateNewWidget_ResponseParams_Data);
  serialization_context.PrepareMessage(
      internal::kRenderMessageFilter_CreateNewWidget_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::RenderMessageFilter_CreateNewWidget_ResponseParams_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  params->route_id = in_route_id;

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
bool RenderMessageFilter_CreateNewWidget_HandleSyncResponse::Accept(
    mojo::Message* message) {

  DCHECK(message->is_serialized());
  internal::RenderMessageFilter_CreateNewWidget_ResponseParams_Data* params =
      reinterpret_cast<internal::RenderMessageFilter_CreateNewWidget_ResponseParams_Data*>(
          message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  int32_t p_route_id{};
  RenderMessageFilter_CreateNewWidget_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  p_route_id = input_data_view.route_id();
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "RenderMessageFilter::CreateNewWidget response deserializer");
    return false;
  }
  *out_route_id_ = std::move(p_route_id);
  mojo::internal::SyncMessageResponseSetup::SetCurrentSyncResponseMessage(
      message);
  *result_ = true;
  return true;
}
class RenderMessageFilter_CreateFullscreenWidget_ProxyToResponder {
 public:
  static RenderMessageFilter::CreateFullscreenWidgetCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<RenderMessageFilter_CreateFullscreenWidget_ProxyToResponder> proxy(
        new RenderMessageFilter_CreateFullscreenWidget_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::Bind(&RenderMessageFilter_CreateFullscreenWidget_ProxyToResponder::Run,
                      base::Passed(&proxy));
  }

  ~RenderMessageFilter_CreateFullscreenWidget_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // Is the Service destroying the callback without running it
      // and without first closing the pipe?
      responder_->DCheckInvalid("The callback passed to "
          "RenderMessageFilter::CreateFullscreenWidget() was never run.");
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  RenderMessageFilter_CreateFullscreenWidget_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

  void Run(
      int32_t in_route_id);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(RenderMessageFilter_CreateFullscreenWidget_ProxyToResponder);
};

bool RenderMessageFilter_CreateFullscreenWidget_ForwardToCallback::Accept(
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::RenderMessageFilter_CreateFullscreenWidget_ResponseParams_Data* params =
      reinterpret_cast<
          internal::RenderMessageFilter_CreateFullscreenWidget_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  int32_t p_route_id{};
  RenderMessageFilter_CreateFullscreenWidget_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  p_route_id = input_data_view.route_id();
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "RenderMessageFilter::CreateFullscreenWidget response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_route_id));
  return true;
}

void RenderMessageFilter_CreateFullscreenWidget_ProxyToResponder::Run(
    int32_t in_route_id) {
  mojo::Message message;
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::RenderMessageFilter_CreateFullscreenWidget_ResponseParams_Data);
  serialization_context.PrepareMessage(
      internal::kRenderMessageFilter_CreateFullscreenWidget_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::RenderMessageFilter_CreateFullscreenWidget_ResponseParams_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  params->route_id = in_route_id;

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
bool RenderMessageFilter_CreateFullscreenWidget_HandleSyncResponse::Accept(
    mojo::Message* message) {

  DCHECK(message->is_serialized());
  internal::RenderMessageFilter_CreateFullscreenWidget_ResponseParams_Data* params =
      reinterpret_cast<internal::RenderMessageFilter_CreateFullscreenWidget_ResponseParams_Data*>(
          message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  int32_t p_route_id{};
  RenderMessageFilter_CreateFullscreenWidget_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  p_route_id = input_data_view.route_id();
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "RenderMessageFilter::CreateFullscreenWidget response deserializer");
    return false;
  }
  *out_route_id_ = std::move(p_route_id);
  mojo::internal::SyncMessageResponseSetup::SetCurrentSyncResponseMessage(
      message);
  *result_ = true;
  return true;
}

// static
bool RenderMessageFilterStubDispatch::Accept(
    RenderMessageFilter* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kRenderMessageFilter_GenerateRoutingID_Name: {
      break;
    }
    case internal::kRenderMessageFilter_CreateNewWidget_Name: {
      break;
    }
    case internal::kRenderMessageFilter_CreateFullscreenWidget_Name: {
      break;
    }
  }
  return false;
}

// static
bool RenderMessageFilterStubDispatch::AcceptWithResponder(
    RenderMessageFilter* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kRenderMessageFilter_GenerateRoutingID_Name: {
      mojo::internal::MessageDispatchContext context(message);

      internal::RenderMessageFilter_GenerateRoutingID_Params_Data* params =
          reinterpret_cast<
              internal::RenderMessageFilter_GenerateRoutingID_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      RenderMessageFilter_GenerateRoutingID_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "RenderMessageFilter::GenerateRoutingID deserializer");
        return false;
      }
      RenderMessageFilter::GenerateRoutingIDCallback callback =
          RenderMessageFilter_GenerateRoutingID_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->GenerateRoutingID(std::move(callback));
      return true;
    }
    case internal::kRenderMessageFilter_CreateNewWidget_Name: {
      mojo::internal::MessageDispatchContext context(message);

      internal::RenderMessageFilter_CreateNewWidget_Params_Data* params =
          reinterpret_cast<
              internal::RenderMessageFilter_CreateNewWidget_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      int32_t p_opener_id{};
      blink::WebPopupType p_popup_type{};
      ::content::mojom::WidgetPtr p_widget{};
      RenderMessageFilter_CreateNewWidget_ParamsDataView input_data_view(params, &serialization_context);
      
      p_opener_id = input_data_view.opener_id();
      if (!input_data_view.ReadPopupType(&p_popup_type))
        success = false;
      p_widget =
          input_data_view.TakeWidget<decltype(p_widget)>();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "RenderMessageFilter::CreateNewWidget deserializer");
        return false;
      }
      RenderMessageFilter::CreateNewWidgetCallback callback =
          RenderMessageFilter_CreateNewWidget_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->CreateNewWidget(
std::move(p_opener_id), 
std::move(p_popup_type), 
std::move(p_widget), std::move(callback));
      return true;
    }
    case internal::kRenderMessageFilter_CreateFullscreenWidget_Name: {
      mojo::internal::MessageDispatchContext context(message);

      internal::RenderMessageFilter_CreateFullscreenWidget_Params_Data* params =
          reinterpret_cast<
              internal::RenderMessageFilter_CreateFullscreenWidget_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      int32_t p_opener_id{};
      ::content::mojom::WidgetPtr p_widget{};
      RenderMessageFilter_CreateFullscreenWidget_ParamsDataView input_data_view(params, &serialization_context);
      
      p_opener_id = input_data_view.opener_id();
      p_widget =
          input_data_view.TakeWidget<decltype(p_widget)>();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "RenderMessageFilter::CreateFullscreenWidget deserializer");
        return false;
      }
      RenderMessageFilter::CreateFullscreenWidgetCallback callback =
          RenderMessageFilter_CreateFullscreenWidget_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->CreateFullscreenWidget(
std::move(p_opener_id), 
std::move(p_widget), std::move(callback));
      return true;
    }
  }
  return false;
}

bool RenderMessageFilterRequestValidator::Accept(mojo::Message* message) {
  if (mojo::internal::IsUnserializedOrControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "RenderMessageFilter RequestValidator");

  switch (message->header()->name) {
    case internal::kRenderMessageFilter_GenerateRoutingID_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::RenderMessageFilter_GenerateRoutingID_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kRenderMessageFilter_CreateNewWidget_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::RenderMessageFilter_CreateNewWidget_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kRenderMessageFilter_CreateFullscreenWidget_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::RenderMessageFilter_CreateFullscreenWidget_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

bool RenderMessageFilterResponseValidator::Accept(mojo::Message* message) {
  if (mojo::internal::IsUnserializedOrControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "RenderMessageFilter ResponseValidator");

  if (!mojo::internal::ValidateMessageIsResponse(message, &validation_context))
    return false;
  switch (message->header()->name) {
    case internal::kRenderMessageFilter_GenerateRoutingID_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::RenderMessageFilter_GenerateRoutingID_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kRenderMessageFilter_CreateNewWidget_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::RenderMessageFilter_CreateNewWidget_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kRenderMessageFilter_CreateFullscreenWidget_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::RenderMessageFilter_CreateFullscreenWidget_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}
}  // namespace mojom
}  // namespace content

namespace mojo {

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif