// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "content/common/render_widget_window_tree_client_factory.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
namespace content {
namespace mojom {
const char RenderWidgetWindowTreeClientFactory::Name_[] = "content::mojom::RenderWidgetWindowTreeClientFactory";

RenderWidgetWindowTreeClientFactoryProxy::RenderWidgetWindowTreeClientFactoryProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void RenderWidgetWindowTreeClientFactoryProxy::CreateWindowTreeClientForRenderWidget(
    uint32_t in_routing_id, ::ui::mojom::WindowTreeClientRequest in_window_tree_client) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::RenderWidgetWindowTreeClientFactory_CreateWindowTreeClientForRenderWidget_Params_Data);
  size += mojo::internal::PrepareToSerialize<::ui::mojom::WindowTreeClientRequestDataView>(
      in_window_tree_client, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kRenderWidgetWindowTreeClientFactory_CreateWindowTreeClientForRenderWidget_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::RenderWidgetWindowTreeClientFactory_CreateWindowTreeClientForRenderWidget_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  params->routing_id = in_routing_id;
  mojo::internal::Serialize<::ui::mojom::WindowTreeClientRequestDataView>(
      in_window_tree_client, &params->window_tree_client, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->window_tree_client),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid window_tree_client in RenderWidgetWindowTreeClientFactory.CreateWindowTreeClientForRenderWidget request");
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool RenderWidgetWindowTreeClientFactoryStubDispatch::Accept(
    RenderWidgetWindowTreeClientFactory* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kRenderWidgetWindowTreeClientFactory_CreateWindowTreeClientForRenderWidget_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::RenderWidgetWindowTreeClientFactory_CreateWindowTreeClientForRenderWidget_Params_Data* params =
          reinterpret_cast<internal::RenderWidgetWindowTreeClientFactory_CreateWindowTreeClientForRenderWidget_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      uint32_t p_routing_id{};
      ::ui::mojom::WindowTreeClientRequest p_window_tree_client{};
      RenderWidgetWindowTreeClientFactory_CreateWindowTreeClientForRenderWidget_ParamsDataView input_data_view(params, &serialization_context);
      
      p_routing_id = input_data_view.routing_id();
      p_window_tree_client =
          input_data_view.TakeWindowTreeClient<decltype(p_window_tree_client)>();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "RenderWidgetWindowTreeClientFactory::CreateWindowTreeClientForRenderWidget deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->CreateWindowTreeClientForRenderWidget(
std::move(p_routing_id), 
std::move(p_window_tree_client));
      return true;
    }
  }
  return false;
}

// static
bool RenderWidgetWindowTreeClientFactoryStubDispatch::AcceptWithResponder(
    RenderWidgetWindowTreeClientFactory* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kRenderWidgetWindowTreeClientFactory_CreateWindowTreeClientForRenderWidget_Name: {
      break;
    }
  }
  return false;
}

bool RenderWidgetWindowTreeClientFactoryRequestValidator::Accept(mojo::Message* message) {
  if (mojo::internal::IsUnserializedOrControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "RenderWidgetWindowTreeClientFactory RequestValidator");

  switch (message->header()->name) {
    case internal::kRenderWidgetWindowTreeClientFactory_CreateWindowTreeClientForRenderWidget_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::RenderWidgetWindowTreeClientFactory_CreateWindowTreeClientForRenderWidget_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

}  // namespace mojom
}  // namespace content

namespace mojo {

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif