// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "content/common/service_worker/service_worker.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "content/common/service_worker/service_worker_provider_struct_traits.h"
#include "content/common/service_worker/service_worker_types_struct_traits.h"
namespace content {
namespace mojom {
const char ServiceWorkerDispatcherHost::Name_[] = "content::mojom::ServiceWorkerDispatcherHost";

ServiceWorkerDispatcherHostProxy::ServiceWorkerDispatcherHostProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void ServiceWorkerDispatcherHostProxy::OnProviderCreated(
    ::content::ServiceWorkerProviderHostInfo in_provider_info) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::ServiceWorkerDispatcherHost_OnProviderCreated_Params_Data);
  size += mojo::internal::PrepareToSerialize<::content::mojom::ServiceWorkerProviderHostInfoDataView>(
      in_provider_info, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kServiceWorkerDispatcherHost_OnProviderCreated_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::ServiceWorkerDispatcherHost_OnProviderCreated_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->provider_info)::BaseType* provider_info_ptr;
  mojo::internal::Serialize<::content::mojom::ServiceWorkerProviderHostInfoDataView>(
      in_provider_info, buffer, &provider_info_ptr, &serialization_context);
  params->provider_info.Set(provider_info_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->provider_info.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null provider_info in ServiceWorkerDispatcherHost.OnProviderCreated request");
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void ServiceWorkerDispatcherHostProxy::OnSetHostedVersionId(
    int32_t in_provider_id, int64_t in_version_id, int32_t in_embedded_worker_id, ::content::mojom::URLLoaderFactoryAssociatedRequest in_script_loader_factory) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::ServiceWorkerDispatcherHost_OnSetHostedVersionId_Params_Data);
  size += mojo::internal::PrepareToSerialize<::content::mojom::URLLoaderFactoryAssociatedRequestDataView>(
      in_script_loader_factory, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kServiceWorkerDispatcherHost_OnSetHostedVersionId_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::ServiceWorkerDispatcherHost_OnSetHostedVersionId_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  params->provider_id = in_provider_id;
  params->version_id = in_version_id;
  params->embedded_worker_id = in_embedded_worker_id;
  mojo::internal::Serialize<::content::mojom::URLLoaderFactoryAssociatedRequestDataView>(
      in_script_loader_factory, &params->script_loader_factory, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->script_loader_factory),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_INTERFACE_ID,
      "invalid script_loader_factory in ServiceWorkerDispatcherHost.OnSetHostedVersionId request");
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool ServiceWorkerDispatcherHostStubDispatch::Accept(
    ServiceWorkerDispatcherHost* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kServiceWorkerDispatcherHost_OnProviderCreated_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::ServiceWorkerDispatcherHost_OnProviderCreated_Params_Data* params =
          reinterpret_cast<internal::ServiceWorkerDispatcherHost_OnProviderCreated_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      ::content::ServiceWorkerProviderHostInfo p_provider_info{};
      ServiceWorkerDispatcherHost_OnProviderCreated_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadProviderInfo(&p_provider_info))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "ServiceWorkerDispatcherHost::OnProviderCreated deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->OnProviderCreated(
std::move(p_provider_info));
      return true;
    }
    case internal::kServiceWorkerDispatcherHost_OnSetHostedVersionId_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::ServiceWorkerDispatcherHost_OnSetHostedVersionId_Params_Data* params =
          reinterpret_cast<internal::ServiceWorkerDispatcherHost_OnSetHostedVersionId_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      int32_t p_provider_id{};
      int64_t p_version_id{};
      int32_t p_embedded_worker_id{};
      ::content::mojom::URLLoaderFactoryAssociatedRequest p_script_loader_factory{};
      ServiceWorkerDispatcherHost_OnSetHostedVersionId_ParamsDataView input_data_view(params, &serialization_context);
      
      p_provider_id = input_data_view.provider_id();
      p_version_id = input_data_view.version_id();
      p_embedded_worker_id = input_data_view.embedded_worker_id();
      p_script_loader_factory =
          input_data_view.TakeScriptLoaderFactory<decltype(p_script_loader_factory)>();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "ServiceWorkerDispatcherHost::OnSetHostedVersionId deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->OnSetHostedVersionId(
std::move(p_provider_id), 
std::move(p_version_id), 
std::move(p_embedded_worker_id), 
std::move(p_script_loader_factory));
      return true;
    }
  }
  return false;
}

// static
bool ServiceWorkerDispatcherHostStubDispatch::AcceptWithResponder(
    ServiceWorkerDispatcherHost* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kServiceWorkerDispatcherHost_OnProviderCreated_Name: {
      break;
    }
    case internal::kServiceWorkerDispatcherHost_OnSetHostedVersionId_Name: {
      break;
    }
  }
  return false;
}

bool ServiceWorkerDispatcherHostRequestValidator::Accept(mojo::Message* message) {
  if (mojo::internal::IsUnserializedOrControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "ServiceWorkerDispatcherHost RequestValidator");

  switch (message->header()->name) {
    case internal::kServiceWorkerDispatcherHost_OnProviderCreated_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::ServiceWorkerDispatcherHost_OnProviderCreated_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kServiceWorkerDispatcherHost_OnSetHostedVersionId_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::ServiceWorkerDispatcherHost_OnSetHostedVersionId_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

}  // namespace mojom
}  // namespace content

namespace mojo {

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif