// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_COMMON_SERVICE_WORKER_SERVICE_WORKER_EVENT_DISPATCHER_MOJOM_SHARED_INTERNAL_H_
#define CONTENT_COMMON_SERVICE_WORKER_SERVICE_WORKER_EVENT_DISPATCHER_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/native_struct_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "content/public/common/url_loader.mojom-shared-internal.h"
#include "mojo/common/string16.mojom-shared-internal.h"
#include "mojo/common/time.mojom-shared-internal.h"
#include "third_party/WebKit/public/platform/modules/background_sync/background_sync.mojom-shared-internal.h"
#include "third_party/WebKit/public/platform/modules/fetch/fetch_api_request.mojom-shared-internal.h"
#include "third_party/WebKit/public/platform/modules/payments/payment_app.mojom-shared-internal.h"
#include "third_party/WebKit/public/platform/modules/serviceworker/service_worker_event_status.mojom-shared-internal.h"
#include "third_party/WebKit/public/platform/modules/serviceworker/service_worker_stream_handle.mojom-shared-internal.h"
#include "url/mojo/origin.mojom-shared-internal.h"
#include "url/mojo/url.mojom-shared-internal.h"
#include "content/common/mojo_bindings_shared_export.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace content {
namespace mojom {
namespace internal {
using PlatformNotificationData_Data = mojo::internal::NativeStruct_Data;
using PushEventPayload_Data = mojo::internal::NativeStruct_Data;
using ServiceWorkerResponse_Data = mojo::internal::NativeStruct_Data;
using ExtendableMessageEventSource_Data = mojo::internal::NativeStruct_Data;
class BackgroundFetchSettledFetch_Data;
class FetchEventPreloadHandle_Data;
class ExtendableMessageEvent_Data;

struct BackgroundFetchState_Data {
 public:
  static bool constexpr kIsExtensible = false;

  static bool IsKnownValue(int32_t value) {
    switch (value) {
      case 0:
      case 1:
      case 2:
        return true;
    }
    return false;
  }

  static bool Validate(int32_t value,
                       mojo::internal::ValidationContext* validation_context) {
    if (kIsExtensible || IsKnownValue(value))
      return true;

    ReportValidationError(validation_context,
                          mojo::internal::VALIDATION_ERROR_UNKNOWN_ENUM_VALUE);
    return false;
  }
};

#pragma pack(push, 1)
class MOJOM_SHARED_CONTENT_EXPORT BackgroundFetchSettledFetch_Data {
 public:
  static BackgroundFetchSettledFetch_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::blink::mojom::internal::FetchAPIRequest_Data> request;
  mojo::internal::Pointer<internal::ServiceWorkerResponse_Data> response;

 private:
  BackgroundFetchSettledFetch_Data();
  ~BackgroundFetchSettledFetch_Data() = delete;
};
static_assert(sizeof(BackgroundFetchSettledFetch_Data) == 24,
              "Bad sizeof(BackgroundFetchSettledFetch_Data)");
class MOJOM_SHARED_CONTENT_EXPORT FetchEventPreloadHandle_Data {
 public:
  static FetchEventPreloadHandle_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Interface_Data url_loader;
  mojo::internal::Handle_Data url_loader_client_request;
  uint8_t padfinal_[4];

 private:
  FetchEventPreloadHandle_Data();
  ~FetchEventPreloadHandle_Data() = delete;
};
static_assert(sizeof(FetchEventPreloadHandle_Data) == 24,
              "Bad sizeof(FetchEventPreloadHandle_Data)");
class MOJOM_SHARED_CONTENT_EXPORT ExtendableMessageEvent_Data {
 public:
  static ExtendableMessageEvent_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo::common::mojom::internal::String16_Data> message;
  mojo::internal::Pointer<::url::mojom::internal::Origin_Data> source_origin;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Handle_Data>> message_ports;
  mojo::internal::Pointer<internal::ExtendableMessageEventSource_Data> source;

 private:
  ExtendableMessageEvent_Data();
  ~ExtendableMessageEvent_Data() = delete;
};
static_assert(sizeof(ExtendableMessageEvent_Data) == 40,
              "Bad sizeof(ExtendableMessageEvent_Data)");
constexpr uint32_t kServiceWorkerFetchResponseCallback_OnResponse_Name = 0;
class MOJOM_SHARED_CONTENT_EXPORT ServiceWorkerFetchResponseCallback_OnResponse_Params_Data {
 public:
  static ServiceWorkerFetchResponseCallback_OnResponse_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::ServiceWorkerResponse_Data> response;
  mojo::internal::Pointer<::mojo::common::mojom::internal::Time_Data> dispatch_event_time;

 private:
  ServiceWorkerFetchResponseCallback_OnResponse_Params_Data();
  ~ServiceWorkerFetchResponseCallback_OnResponse_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorkerFetchResponseCallback_OnResponse_Params_Data) == 24,
              "Bad sizeof(ServiceWorkerFetchResponseCallback_OnResponse_Params_Data)");
constexpr uint32_t kServiceWorkerFetchResponseCallback_OnResponseStream_Name = 1;
class MOJOM_SHARED_CONTENT_EXPORT ServiceWorkerFetchResponseCallback_OnResponseStream_Params_Data {
 public:
  static ServiceWorkerFetchResponseCallback_OnResponseStream_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::ServiceWorkerResponse_Data> response;
  mojo::internal::Pointer<::blink::mojom::internal::ServiceWorkerStreamHandle_Data> body_as_stream;
  mojo::internal::Pointer<::mojo::common::mojom::internal::Time_Data> dispatch_event_time;

 private:
  ServiceWorkerFetchResponseCallback_OnResponseStream_Params_Data();
  ~ServiceWorkerFetchResponseCallback_OnResponseStream_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorkerFetchResponseCallback_OnResponseStream_Params_Data) == 32,
              "Bad sizeof(ServiceWorkerFetchResponseCallback_OnResponseStream_Params_Data)");
constexpr uint32_t kServiceWorkerFetchResponseCallback_OnFallback_Name = 2;
class MOJOM_SHARED_CONTENT_EXPORT ServiceWorkerFetchResponseCallback_OnFallback_Params_Data {
 public:
  static ServiceWorkerFetchResponseCallback_OnFallback_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo::common::mojom::internal::Time_Data> dispatch_event_time;

 private:
  ServiceWorkerFetchResponseCallback_OnFallback_Params_Data();
  ~ServiceWorkerFetchResponseCallback_OnFallback_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorkerFetchResponseCallback_OnFallback_Params_Data) == 16,
              "Bad sizeof(ServiceWorkerFetchResponseCallback_OnFallback_Params_Data)");
constexpr uint32_t kServiceWorkerEventDispatcher_DispatchInstallEvent_Name = 0;
class MOJOM_SHARED_CONTENT_EXPORT ServiceWorkerEventDispatcher_DispatchInstallEvent_Params_Data {
 public:
  static ServiceWorkerEventDispatcher_DispatchInstallEvent_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::AssociatedInterface_Data method;

 private:
  ServiceWorkerEventDispatcher_DispatchInstallEvent_Params_Data();
  ~ServiceWorkerEventDispatcher_DispatchInstallEvent_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorkerEventDispatcher_DispatchInstallEvent_Params_Data) == 16,
              "Bad sizeof(ServiceWorkerEventDispatcher_DispatchInstallEvent_Params_Data)");
class MOJOM_SHARED_CONTENT_EXPORT ServiceWorkerEventDispatcher_DispatchInstallEvent_ResponseParams_Data {
 public:
  static ServiceWorkerEventDispatcher_DispatchInstallEvent_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t status;
  uint8_t has_fetch_handler : 1;
  uint8_t pad1_[3];
  mojo::internal::Pointer<::mojo::common::mojom::internal::Time_Data> dispatch_event_time;

 private:
  ServiceWorkerEventDispatcher_DispatchInstallEvent_ResponseParams_Data();
  ~ServiceWorkerEventDispatcher_DispatchInstallEvent_ResponseParams_Data() = delete;
};
static_assert(sizeof(ServiceWorkerEventDispatcher_DispatchInstallEvent_ResponseParams_Data) == 24,
              "Bad sizeof(ServiceWorkerEventDispatcher_DispatchInstallEvent_ResponseParams_Data)");
constexpr uint32_t kServiceWorkerEventDispatcher_DispatchActivateEvent_Name = 1;
class MOJOM_SHARED_CONTENT_EXPORT ServiceWorkerEventDispatcher_DispatchActivateEvent_Params_Data {
 public:
  static ServiceWorkerEventDispatcher_DispatchActivateEvent_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  ServiceWorkerEventDispatcher_DispatchActivateEvent_Params_Data();
  ~ServiceWorkerEventDispatcher_DispatchActivateEvent_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorkerEventDispatcher_DispatchActivateEvent_Params_Data) == 8,
              "Bad sizeof(ServiceWorkerEventDispatcher_DispatchActivateEvent_Params_Data)");
class MOJOM_SHARED_CONTENT_EXPORT ServiceWorkerEventDispatcher_DispatchActivateEvent_ResponseParams_Data {
 public:
  static ServiceWorkerEventDispatcher_DispatchActivateEvent_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t status;
  uint8_t pad0_[4];
  mojo::internal::Pointer<::mojo::common::mojom::internal::Time_Data> dispatch_event_time;

 private:
  ServiceWorkerEventDispatcher_DispatchActivateEvent_ResponseParams_Data();
  ~ServiceWorkerEventDispatcher_DispatchActivateEvent_ResponseParams_Data() = delete;
};
static_assert(sizeof(ServiceWorkerEventDispatcher_DispatchActivateEvent_ResponseParams_Data) == 24,
              "Bad sizeof(ServiceWorkerEventDispatcher_DispatchActivateEvent_ResponseParams_Data)");
constexpr uint32_t kServiceWorkerEventDispatcher_DispatchBackgroundFetchAbortEvent_Name = 2;
class MOJOM_SHARED_CONTENT_EXPORT ServiceWorkerEventDispatcher_DispatchBackgroundFetchAbortEvent_Params_Data {
 public:
  static ServiceWorkerEventDispatcher_DispatchBackgroundFetchAbortEvent_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> tag;

 private:
  ServiceWorkerEventDispatcher_DispatchBackgroundFetchAbortEvent_Params_Data();
  ~ServiceWorkerEventDispatcher_DispatchBackgroundFetchAbortEvent_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorkerEventDispatcher_DispatchBackgroundFetchAbortEvent_Params_Data) == 16,
              "Bad sizeof(ServiceWorkerEventDispatcher_DispatchBackgroundFetchAbortEvent_Params_Data)");
class MOJOM_SHARED_CONTENT_EXPORT ServiceWorkerEventDispatcher_DispatchBackgroundFetchAbortEvent_ResponseParams_Data {
 public:
  static ServiceWorkerEventDispatcher_DispatchBackgroundFetchAbortEvent_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t status;
  uint8_t pad0_[4];
  mojo::internal::Pointer<::mojo::common::mojom::internal::Time_Data> dispatch_event_time;

 private:
  ServiceWorkerEventDispatcher_DispatchBackgroundFetchAbortEvent_ResponseParams_Data();
  ~ServiceWorkerEventDispatcher_DispatchBackgroundFetchAbortEvent_ResponseParams_Data() = delete;
};
static_assert(sizeof(ServiceWorkerEventDispatcher_DispatchBackgroundFetchAbortEvent_ResponseParams_Data) == 24,
              "Bad sizeof(ServiceWorkerEventDispatcher_DispatchBackgroundFetchAbortEvent_ResponseParams_Data)");
constexpr uint32_t kServiceWorkerEventDispatcher_DispatchBackgroundFetchClickEvent_Name = 3;
class MOJOM_SHARED_CONTENT_EXPORT ServiceWorkerEventDispatcher_DispatchBackgroundFetchClickEvent_Params_Data {
 public:
  static ServiceWorkerEventDispatcher_DispatchBackgroundFetchClickEvent_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> tag;
  int32_t state;
  uint8_t padfinal_[4];

 private:
  ServiceWorkerEventDispatcher_DispatchBackgroundFetchClickEvent_Params_Data();
  ~ServiceWorkerEventDispatcher_DispatchBackgroundFetchClickEvent_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorkerEventDispatcher_DispatchBackgroundFetchClickEvent_Params_Data) == 24,
              "Bad sizeof(ServiceWorkerEventDispatcher_DispatchBackgroundFetchClickEvent_Params_Data)");
class MOJOM_SHARED_CONTENT_EXPORT ServiceWorkerEventDispatcher_DispatchBackgroundFetchClickEvent_ResponseParams_Data {
 public:
  static ServiceWorkerEventDispatcher_DispatchBackgroundFetchClickEvent_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t status;
  uint8_t pad0_[4];
  mojo::internal::Pointer<::mojo::common::mojom::internal::Time_Data> dispatch_event_time;

 private:
  ServiceWorkerEventDispatcher_DispatchBackgroundFetchClickEvent_ResponseParams_Data();
  ~ServiceWorkerEventDispatcher_DispatchBackgroundFetchClickEvent_ResponseParams_Data() = delete;
};
static_assert(sizeof(ServiceWorkerEventDispatcher_DispatchBackgroundFetchClickEvent_ResponseParams_Data) == 24,
              "Bad sizeof(ServiceWorkerEventDispatcher_DispatchBackgroundFetchClickEvent_ResponseParams_Data)");
constexpr uint32_t kServiceWorkerEventDispatcher_DispatchBackgroundFetchFailEvent_Name = 4;
class MOJOM_SHARED_CONTENT_EXPORT ServiceWorkerEventDispatcher_DispatchBackgroundFetchFailEvent_Params_Data {
 public:
  static ServiceWorkerEventDispatcher_DispatchBackgroundFetchFailEvent_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> tag;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::BackgroundFetchSettledFetch_Data>>> fetches;

 private:
  ServiceWorkerEventDispatcher_DispatchBackgroundFetchFailEvent_Params_Data();
  ~ServiceWorkerEventDispatcher_DispatchBackgroundFetchFailEvent_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorkerEventDispatcher_DispatchBackgroundFetchFailEvent_Params_Data) == 24,
              "Bad sizeof(ServiceWorkerEventDispatcher_DispatchBackgroundFetchFailEvent_Params_Data)");
class MOJOM_SHARED_CONTENT_EXPORT ServiceWorkerEventDispatcher_DispatchBackgroundFetchFailEvent_ResponseParams_Data {
 public:
  static ServiceWorkerEventDispatcher_DispatchBackgroundFetchFailEvent_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t status;
  uint8_t pad0_[4];
  mojo::internal::Pointer<::mojo::common::mojom::internal::Time_Data> dispatch_event_time;

 private:
  ServiceWorkerEventDispatcher_DispatchBackgroundFetchFailEvent_ResponseParams_Data();
  ~ServiceWorkerEventDispatcher_DispatchBackgroundFetchFailEvent_ResponseParams_Data() = delete;
};
static_assert(sizeof(ServiceWorkerEventDispatcher_DispatchBackgroundFetchFailEvent_ResponseParams_Data) == 24,
              "Bad sizeof(ServiceWorkerEventDispatcher_DispatchBackgroundFetchFailEvent_ResponseParams_Data)");
constexpr uint32_t kServiceWorkerEventDispatcher_DispatchBackgroundFetchedEvent_Name = 5;
class MOJOM_SHARED_CONTENT_EXPORT ServiceWorkerEventDispatcher_DispatchBackgroundFetchedEvent_Params_Data {
 public:
  static ServiceWorkerEventDispatcher_DispatchBackgroundFetchedEvent_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> tag;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::BackgroundFetchSettledFetch_Data>>> fetches;

 private:
  ServiceWorkerEventDispatcher_DispatchBackgroundFetchedEvent_Params_Data();
  ~ServiceWorkerEventDispatcher_DispatchBackgroundFetchedEvent_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorkerEventDispatcher_DispatchBackgroundFetchedEvent_Params_Data) == 24,
              "Bad sizeof(ServiceWorkerEventDispatcher_DispatchBackgroundFetchedEvent_Params_Data)");
class MOJOM_SHARED_CONTENT_EXPORT ServiceWorkerEventDispatcher_DispatchBackgroundFetchedEvent_ResponseParams_Data {
 public:
  static ServiceWorkerEventDispatcher_DispatchBackgroundFetchedEvent_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t status;
  uint8_t pad0_[4];
  mojo::internal::Pointer<::mojo::common::mojom::internal::Time_Data> dispatch_event_time;

 private:
  ServiceWorkerEventDispatcher_DispatchBackgroundFetchedEvent_ResponseParams_Data();
  ~ServiceWorkerEventDispatcher_DispatchBackgroundFetchedEvent_ResponseParams_Data() = delete;
};
static_assert(sizeof(ServiceWorkerEventDispatcher_DispatchBackgroundFetchedEvent_ResponseParams_Data) == 24,
              "Bad sizeof(ServiceWorkerEventDispatcher_DispatchBackgroundFetchedEvent_ResponseParams_Data)");
constexpr uint32_t kServiceWorkerEventDispatcher_DispatchFetchEvent_Name = 6;
class MOJOM_SHARED_CONTENT_EXPORT ServiceWorkerEventDispatcher_DispatchFetchEvent_Params_Data {
 public:
  static ServiceWorkerEventDispatcher_DispatchFetchEvent_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t fetch_event_id;
  uint8_t pad0_[4];
  mojo::internal::Pointer<::blink::mojom::internal::FetchAPIRequest_Data> request;
  mojo::internal::Pointer<internal::FetchEventPreloadHandle_Data> preload_handle;
  mojo::internal::Interface_Data response_callback;

 private:
  ServiceWorkerEventDispatcher_DispatchFetchEvent_Params_Data();
  ~ServiceWorkerEventDispatcher_DispatchFetchEvent_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorkerEventDispatcher_DispatchFetchEvent_Params_Data) == 40,
              "Bad sizeof(ServiceWorkerEventDispatcher_DispatchFetchEvent_Params_Data)");
class MOJOM_SHARED_CONTENT_EXPORT ServiceWorkerEventDispatcher_DispatchFetchEvent_ResponseParams_Data {
 public:
  static ServiceWorkerEventDispatcher_DispatchFetchEvent_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t status;
  uint8_t pad0_[4];
  mojo::internal::Pointer<::mojo::common::mojom::internal::Time_Data> dispatch_event_time;

 private:
  ServiceWorkerEventDispatcher_DispatchFetchEvent_ResponseParams_Data();
  ~ServiceWorkerEventDispatcher_DispatchFetchEvent_ResponseParams_Data() = delete;
};
static_assert(sizeof(ServiceWorkerEventDispatcher_DispatchFetchEvent_ResponseParams_Data) == 24,
              "Bad sizeof(ServiceWorkerEventDispatcher_DispatchFetchEvent_ResponseParams_Data)");
constexpr uint32_t kServiceWorkerEventDispatcher_DispatchNotificationClickEvent_Name = 7;
class MOJOM_SHARED_CONTENT_EXPORT ServiceWorkerEventDispatcher_DispatchNotificationClickEvent_Params_Data {
 public:
  static ServiceWorkerEventDispatcher_DispatchNotificationClickEvent_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> notification_id;
  mojo::internal::Pointer<internal::PlatformNotificationData_Data> notification_data;
  int32_t action_index;
  uint8_t pad2_[4];
  mojo::internal::Pointer<::mojo::common::mojom::internal::String16_Data> reply;

 private:
  ServiceWorkerEventDispatcher_DispatchNotificationClickEvent_Params_Data();
  ~ServiceWorkerEventDispatcher_DispatchNotificationClickEvent_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorkerEventDispatcher_DispatchNotificationClickEvent_Params_Data) == 40,
              "Bad sizeof(ServiceWorkerEventDispatcher_DispatchNotificationClickEvent_Params_Data)");
class MOJOM_SHARED_CONTENT_EXPORT ServiceWorkerEventDispatcher_DispatchNotificationClickEvent_ResponseParams_Data {
 public:
  static ServiceWorkerEventDispatcher_DispatchNotificationClickEvent_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t status;
  uint8_t pad0_[4];
  mojo::internal::Pointer<::mojo::common::mojom::internal::Time_Data> dispatch_event_time;

 private:
  ServiceWorkerEventDispatcher_DispatchNotificationClickEvent_ResponseParams_Data();
  ~ServiceWorkerEventDispatcher_DispatchNotificationClickEvent_ResponseParams_Data() = delete;
};
static_assert(sizeof(ServiceWorkerEventDispatcher_DispatchNotificationClickEvent_ResponseParams_Data) == 24,
              "Bad sizeof(ServiceWorkerEventDispatcher_DispatchNotificationClickEvent_ResponseParams_Data)");
constexpr uint32_t kServiceWorkerEventDispatcher_DispatchNotificationCloseEvent_Name = 8;
class MOJOM_SHARED_CONTENT_EXPORT ServiceWorkerEventDispatcher_DispatchNotificationCloseEvent_Params_Data {
 public:
  static ServiceWorkerEventDispatcher_DispatchNotificationCloseEvent_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> notification_id;
  mojo::internal::Pointer<internal::PlatformNotificationData_Data> notification_data;

 private:
  ServiceWorkerEventDispatcher_DispatchNotificationCloseEvent_Params_Data();
  ~ServiceWorkerEventDispatcher_DispatchNotificationCloseEvent_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorkerEventDispatcher_DispatchNotificationCloseEvent_Params_Data) == 24,
              "Bad sizeof(ServiceWorkerEventDispatcher_DispatchNotificationCloseEvent_Params_Data)");
class MOJOM_SHARED_CONTENT_EXPORT ServiceWorkerEventDispatcher_DispatchNotificationCloseEvent_ResponseParams_Data {
 public:
  static ServiceWorkerEventDispatcher_DispatchNotificationCloseEvent_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t status;
  uint8_t pad0_[4];
  mojo::internal::Pointer<::mojo::common::mojom::internal::Time_Data> dispatch_event_time;

 private:
  ServiceWorkerEventDispatcher_DispatchNotificationCloseEvent_ResponseParams_Data();
  ~ServiceWorkerEventDispatcher_DispatchNotificationCloseEvent_ResponseParams_Data() = delete;
};
static_assert(sizeof(ServiceWorkerEventDispatcher_DispatchNotificationCloseEvent_ResponseParams_Data) == 24,
              "Bad sizeof(ServiceWorkerEventDispatcher_DispatchNotificationCloseEvent_ResponseParams_Data)");
constexpr uint32_t kServiceWorkerEventDispatcher_DispatchPushEvent_Name = 9;
class MOJOM_SHARED_CONTENT_EXPORT ServiceWorkerEventDispatcher_DispatchPushEvent_Params_Data {
 public:
  static ServiceWorkerEventDispatcher_DispatchPushEvent_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::PushEventPayload_Data> payload;

 private:
  ServiceWorkerEventDispatcher_DispatchPushEvent_Params_Data();
  ~ServiceWorkerEventDispatcher_DispatchPushEvent_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorkerEventDispatcher_DispatchPushEvent_Params_Data) == 16,
              "Bad sizeof(ServiceWorkerEventDispatcher_DispatchPushEvent_Params_Data)");
class MOJOM_SHARED_CONTENT_EXPORT ServiceWorkerEventDispatcher_DispatchPushEvent_ResponseParams_Data {
 public:
  static ServiceWorkerEventDispatcher_DispatchPushEvent_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t status;
  uint8_t pad0_[4];
  mojo::internal::Pointer<::mojo::common::mojom::internal::Time_Data> dispatch_event_time;

 private:
  ServiceWorkerEventDispatcher_DispatchPushEvent_ResponseParams_Data();
  ~ServiceWorkerEventDispatcher_DispatchPushEvent_ResponseParams_Data() = delete;
};
static_assert(sizeof(ServiceWorkerEventDispatcher_DispatchPushEvent_ResponseParams_Data) == 24,
              "Bad sizeof(ServiceWorkerEventDispatcher_DispatchPushEvent_ResponseParams_Data)");
constexpr uint32_t kServiceWorkerEventDispatcher_DispatchSyncEvent_Name = 10;
class MOJOM_SHARED_CONTENT_EXPORT ServiceWorkerEventDispatcher_DispatchSyncEvent_Params_Data {
 public:
  static ServiceWorkerEventDispatcher_DispatchSyncEvent_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> tag;
  int32_t last_chance;
  uint8_t padfinal_[4];

 private:
  ServiceWorkerEventDispatcher_DispatchSyncEvent_Params_Data();
  ~ServiceWorkerEventDispatcher_DispatchSyncEvent_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorkerEventDispatcher_DispatchSyncEvent_Params_Data) == 24,
              "Bad sizeof(ServiceWorkerEventDispatcher_DispatchSyncEvent_Params_Data)");
class MOJOM_SHARED_CONTENT_EXPORT ServiceWorkerEventDispatcher_DispatchSyncEvent_ResponseParams_Data {
 public:
  static ServiceWorkerEventDispatcher_DispatchSyncEvent_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t status;
  uint8_t pad0_[4];
  mojo::internal::Pointer<::mojo::common::mojom::internal::Time_Data> dispatch_event_time;

 private:
  ServiceWorkerEventDispatcher_DispatchSyncEvent_ResponseParams_Data();
  ~ServiceWorkerEventDispatcher_DispatchSyncEvent_ResponseParams_Data() = delete;
};
static_assert(sizeof(ServiceWorkerEventDispatcher_DispatchSyncEvent_ResponseParams_Data) == 24,
              "Bad sizeof(ServiceWorkerEventDispatcher_DispatchSyncEvent_ResponseParams_Data)");
constexpr uint32_t kServiceWorkerEventDispatcher_DispatchPaymentRequestEvent_Name = 11;
class MOJOM_SHARED_CONTENT_EXPORT ServiceWorkerEventDispatcher_DispatchPaymentRequestEvent_Params_Data {
 public:
  static ServiceWorkerEventDispatcher_DispatchPaymentRequestEvent_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t payment_request_id;
  uint8_t pad0_[4];
  mojo::internal::Pointer<::payments::mojom::internal::PaymentRequestEventData_Data> request_data;
  mojo::internal::Interface_Data response_callback;

 private:
  ServiceWorkerEventDispatcher_DispatchPaymentRequestEvent_Params_Data();
  ~ServiceWorkerEventDispatcher_DispatchPaymentRequestEvent_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorkerEventDispatcher_DispatchPaymentRequestEvent_Params_Data) == 32,
              "Bad sizeof(ServiceWorkerEventDispatcher_DispatchPaymentRequestEvent_Params_Data)");
class MOJOM_SHARED_CONTENT_EXPORT ServiceWorkerEventDispatcher_DispatchPaymentRequestEvent_ResponseParams_Data {
 public:
  static ServiceWorkerEventDispatcher_DispatchPaymentRequestEvent_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t status;
  uint8_t pad0_[4];
  mojo::internal::Pointer<::mojo::common::mojom::internal::Time_Data> dispatch_event_time;

 private:
  ServiceWorkerEventDispatcher_DispatchPaymentRequestEvent_ResponseParams_Data();
  ~ServiceWorkerEventDispatcher_DispatchPaymentRequestEvent_ResponseParams_Data() = delete;
};
static_assert(sizeof(ServiceWorkerEventDispatcher_DispatchPaymentRequestEvent_ResponseParams_Data) == 24,
              "Bad sizeof(ServiceWorkerEventDispatcher_DispatchPaymentRequestEvent_ResponseParams_Data)");
constexpr uint32_t kServiceWorkerEventDispatcher_DispatchExtendableMessageEvent_Name = 12;
class MOJOM_SHARED_CONTENT_EXPORT ServiceWorkerEventDispatcher_DispatchExtendableMessageEvent_Params_Data {
 public:
  static ServiceWorkerEventDispatcher_DispatchExtendableMessageEvent_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::ExtendableMessageEvent_Data> event;

 private:
  ServiceWorkerEventDispatcher_DispatchExtendableMessageEvent_Params_Data();
  ~ServiceWorkerEventDispatcher_DispatchExtendableMessageEvent_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorkerEventDispatcher_DispatchExtendableMessageEvent_Params_Data) == 16,
              "Bad sizeof(ServiceWorkerEventDispatcher_DispatchExtendableMessageEvent_Params_Data)");
class MOJOM_SHARED_CONTENT_EXPORT ServiceWorkerEventDispatcher_DispatchExtendableMessageEvent_ResponseParams_Data {
 public:
  static ServiceWorkerEventDispatcher_DispatchExtendableMessageEvent_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t status;
  uint8_t pad0_[4];
  mojo::internal::Pointer<::mojo::common::mojom::internal::Time_Data> dispatch_event_time;

 private:
  ServiceWorkerEventDispatcher_DispatchExtendableMessageEvent_ResponseParams_Data();
  ~ServiceWorkerEventDispatcher_DispatchExtendableMessageEvent_ResponseParams_Data() = delete;
};
static_assert(sizeof(ServiceWorkerEventDispatcher_DispatchExtendableMessageEvent_ResponseParams_Data) == 24,
              "Bad sizeof(ServiceWorkerEventDispatcher_DispatchExtendableMessageEvent_ResponseParams_Data)");
constexpr uint32_t kServiceWorkerEventDispatcher_Ping_Name = 13;
class MOJOM_SHARED_CONTENT_EXPORT ServiceWorkerEventDispatcher_Ping_Params_Data {
 public:
  static ServiceWorkerEventDispatcher_Ping_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  ServiceWorkerEventDispatcher_Ping_Params_Data();
  ~ServiceWorkerEventDispatcher_Ping_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorkerEventDispatcher_Ping_Params_Data) == 8,
              "Bad sizeof(ServiceWorkerEventDispatcher_Ping_Params_Data)");
class MOJOM_SHARED_CONTENT_EXPORT ServiceWorkerEventDispatcher_Ping_ResponseParams_Data {
 public:
  static ServiceWorkerEventDispatcher_Ping_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  ServiceWorkerEventDispatcher_Ping_ResponseParams_Data();
  ~ServiceWorkerEventDispatcher_Ping_ResponseParams_Data() = delete;
};
static_assert(sizeof(ServiceWorkerEventDispatcher_Ping_ResponseParams_Data) == 8,
              "Bad sizeof(ServiceWorkerEventDispatcher_Ping_ResponseParams_Data)");
constexpr uint32_t kServiceWorkerInstallEventMethods_RegisterForeignFetchScopes_Name = 0;
class MOJOM_SHARED_CONTENT_EXPORT ServiceWorkerInstallEventMethods_RegisterForeignFetchScopes_Params_Data {
 public:
  static ServiceWorkerInstallEventMethods_RegisterForeignFetchScopes_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::url::mojom::internal::Url_Data>>> sub_scopes;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::url::mojom::internal::Origin_Data>>> origins;

 private:
  ServiceWorkerInstallEventMethods_RegisterForeignFetchScopes_Params_Data();
  ~ServiceWorkerInstallEventMethods_RegisterForeignFetchScopes_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorkerInstallEventMethods_RegisterForeignFetchScopes_Params_Data) == 24,
              "Bad sizeof(ServiceWorkerInstallEventMethods_RegisterForeignFetchScopes_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace content

#endif  // CONTENT_COMMON_SERVICE_WORKER_SERVICE_WORKER_EVENT_DISPATCHER_MOJOM_SHARED_INTERNAL_H_