// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "content/common/service_worker/service_worker_provider.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "content/common/service_worker/service_worker_types_struct_traits.h"
namespace content {
namespace mojom {
ServiceWorkerProviderHostInfo::ServiceWorkerProviderHostInfo()
    : provider_id(),
      route_id(),
      type(),
      is_parent_frame_secure(),
      host_request(),
      client_ptr_info() {}

ServiceWorkerProviderHostInfo::ServiceWorkerProviderHostInfo(
    int32_t provider_id_in,
    int32_t route_id_in,
    ::content::ServiceWorkerProviderType type_in,
    bool is_parent_frame_secure_in,
    ::content::mojom::ServiceWorkerProviderHostAssociatedRequest host_request_in,
    ::content::mojom::ServiceWorkerProviderAssociatedPtrInfo client_ptr_info_in)
    : provider_id(std::move(provider_id_in)),
      route_id(std::move(route_id_in)),
      type(std::move(type_in)),
      is_parent_frame_secure(std::move(is_parent_frame_secure_in)),
      host_request(std::move(host_request_in)),
      client_ptr_info(std::move(client_ptr_info_in)) {}

ServiceWorkerProviderHostInfo::~ServiceWorkerProviderHostInfo() = default;

bool ServiceWorkerProviderHostInfo::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
}  // namespace mojom
}  // namespace content

namespace mojo {


// static
bool StructTraits<::content::mojom::ServiceWorkerProviderHostInfo::DataView, ::content::mojom::ServiceWorkerProviderHostInfoPtr>::Read(
    ::content::mojom::ServiceWorkerProviderHostInfo::DataView input,
    ::content::mojom::ServiceWorkerProviderHostInfoPtr* output) {
  bool success = true;
  ::content::mojom::ServiceWorkerProviderHostInfoPtr result(::content::mojom::ServiceWorkerProviderHostInfo::New());
  
      result->provider_id = input.provider_id();
      result->route_id = input.route_id();
      if (!input.ReadType(&result->type))
        success = false;
      result->is_parent_frame_secure = input.is_parent_frame_secure();
      result->host_request =
          input.TakeHostRequest<decltype(result->host_request)>();
      result->client_ptr_info =
          input.TakeClientPtrInfo<decltype(result->client_ptr_info)>();
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif