// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4065)
#endif

#include "content/common/worker_url_loader_factory_provider.mojom-shared.h"

#include <utility>

#include "base/logging.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"
namespace content {
namespace mojom {

namespace internal {


// static
ServiceWorkerWorkerClient_SetControllerServiceWorker_Params_Data* ServiceWorkerWorkerClient_SetControllerServiceWorker_Params_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(ServiceWorkerWorkerClient_SetControllerServiceWorker_Params_Data))) ServiceWorkerWorkerClient_SetControllerServiceWorker_Params_Data();
}

// static
bool ServiceWorkerWorkerClient_SetControllerServiceWorker_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, validation_context))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const ServiceWorkerWorkerClient_SetControllerServiceWorker_Params_Data* object = static_cast<const ServiceWorkerWorkerClient_SetControllerServiceWorker_Params_Data*>(data);

  static constexpr struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 16 }};

  if (object->header_.version <=
          kVersionSizes[arraysize(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = arraysize(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            validation_context,
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[arraysize(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        validation_context,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  return true;
}

ServiceWorkerWorkerClient_SetControllerServiceWorker_Params_Data::ServiceWorkerWorkerClient_SetControllerServiceWorker_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
WorkerURLLoaderFactoryProvider_GetURLLoaderFactoryAndRegisterClient_Params_Data* WorkerURLLoaderFactoryProvider_GetURLLoaderFactoryAndRegisterClient_Params_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(WorkerURLLoaderFactoryProvider_GetURLLoaderFactoryAndRegisterClient_Params_Data))) WorkerURLLoaderFactoryProvider_GetURLLoaderFactoryAndRegisterClient_Params_Data();
}

// static
bool WorkerURLLoaderFactoryProvider_GetURLLoaderFactoryAndRegisterClient_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, validation_context))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const WorkerURLLoaderFactoryProvider_GetURLLoaderFactoryAndRegisterClient_Params_Data* object = static_cast<const WorkerURLLoaderFactoryProvider_GetURLLoaderFactoryAndRegisterClient_Params_Data*>(data);

  static constexpr struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 24 }};

  if (object->header_.version <=
          kVersionSizes[arraysize(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = arraysize(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            validation_context,
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[arraysize(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        validation_context,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!mojo::internal::ValidateHandleOrInterfaceNonNullable(
          object->loader,
          "invalid loader field in WorkerURLLoaderFactoryProvider_GetURLLoaderFactoryAndRegisterClient_Params", validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateHandleOrInterface(object->loader,
                                                 validation_context)) {
    return false;
  }

  if (!mojo::internal::ValidateHandleOrInterfaceNonNullable(
          object->client,
          "invalid client field in WorkerURLLoaderFactoryProvider_GetURLLoaderFactoryAndRegisterClient_Params", validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateHandleOrInterface(object->client,
                                                 validation_context)) {
    return false;
  }

  return true;
}

WorkerURLLoaderFactoryProvider_GetURLLoaderFactoryAndRegisterClient_Params_Data::WorkerURLLoaderFactoryProvider_GetURLLoaderFactoryAndRegisterClient_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
WorkerURLLoaderFactoryProvider_GetURLLoaderFactory_Params_Data* WorkerURLLoaderFactoryProvider_GetURLLoaderFactory_Params_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(WorkerURLLoaderFactoryProvider_GetURLLoaderFactory_Params_Data))) WorkerURLLoaderFactoryProvider_GetURLLoaderFactory_Params_Data();
}

// static
bool WorkerURLLoaderFactoryProvider_GetURLLoaderFactory_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, validation_context))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const WorkerURLLoaderFactoryProvider_GetURLLoaderFactory_Params_Data* object = static_cast<const WorkerURLLoaderFactoryProvider_GetURLLoaderFactory_Params_Data*>(data);

  static constexpr struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 16 }};

  if (object->header_.version <=
          kVersionSizes[arraysize(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = arraysize(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            validation_context,
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[arraysize(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        validation_context,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!mojo::internal::ValidateHandleOrInterfaceNonNullable(
          object->loader,
          "invalid loader field in WorkerURLLoaderFactoryProvider_GetURLLoaderFactory_Params", validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateHandleOrInterface(object->loader,
                                                 validation_context)) {
    return false;
  }

  return true;
}

WorkerURLLoaderFactoryProvider_GetURLLoaderFactory_Params_Data::WorkerURLLoaderFactoryProvider_GetURLLoaderFactory_Params_Data()
    : header_({sizeof(*this), 0}) {}

}  // namespace internal
}  // namespace mojom
}  // namespace content

#if defined(_MSC_VER)
#pragma warning(pop)
#endif
