// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "content/common/worker_url_loader_factory_provider.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
namespace content {
namespace mojom {
const char ServiceWorkerWorkerClient::Name_[] = "content::mojom::ServiceWorkerWorkerClient";

ServiceWorkerWorkerClientProxy::ServiceWorkerWorkerClientProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void ServiceWorkerWorkerClientProxy::SetControllerServiceWorker(
    int64_t in_controller_version_id) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::ServiceWorkerWorkerClient_SetControllerServiceWorker_Params_Data);
  serialization_context.PrepareMessage(
      internal::kServiceWorkerWorkerClient_SetControllerServiceWorker_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::ServiceWorkerWorkerClient_SetControllerServiceWorker_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  params->controller_version_id = in_controller_version_id;
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool ServiceWorkerWorkerClientStubDispatch::Accept(
    ServiceWorkerWorkerClient* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kServiceWorkerWorkerClient_SetControllerServiceWorker_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::ServiceWorkerWorkerClient_SetControllerServiceWorker_Params_Data* params =
          reinterpret_cast<internal::ServiceWorkerWorkerClient_SetControllerServiceWorker_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      int64_t p_controller_version_id{};
      ServiceWorkerWorkerClient_SetControllerServiceWorker_ParamsDataView input_data_view(params, &serialization_context);
      
      p_controller_version_id = input_data_view.controller_version_id();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "ServiceWorkerWorkerClient::SetControllerServiceWorker deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->SetControllerServiceWorker(
std::move(p_controller_version_id));
      return true;
    }
  }
  return false;
}

// static
bool ServiceWorkerWorkerClientStubDispatch::AcceptWithResponder(
    ServiceWorkerWorkerClient* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kServiceWorkerWorkerClient_SetControllerServiceWorker_Name: {
      break;
    }
  }
  return false;
}

bool ServiceWorkerWorkerClientRequestValidator::Accept(mojo::Message* message) {
  if (mojo::internal::IsUnserializedOrControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "ServiceWorkerWorkerClient RequestValidator");

  switch (message->header()->name) {
    case internal::kServiceWorkerWorkerClient_SetControllerServiceWorker_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::ServiceWorkerWorkerClient_SetControllerServiceWorker_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

const char WorkerURLLoaderFactoryProvider::Name_[] = "content::mojom::WorkerURLLoaderFactoryProvider";

WorkerURLLoaderFactoryProviderProxy::WorkerURLLoaderFactoryProviderProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void WorkerURLLoaderFactoryProviderProxy::GetURLLoaderFactoryAndRegisterClient(
    ::content::mojom::URLLoaderFactoryAssociatedRequest in_loader, ServiceWorkerWorkerClientAssociatedPtrInfo in_client, int32_t in_service_worker_provider_id) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::WorkerURLLoaderFactoryProvider_GetURLLoaderFactoryAndRegisterClient_Params_Data);
  size += mojo::internal::PrepareToSerialize<::content::mojom::URLLoaderFactoryAssociatedRequestDataView>(
      in_loader, &serialization_context);
  size += mojo::internal::PrepareToSerialize<::content::mojom::ServiceWorkerWorkerClientAssociatedPtrInfoDataView>(
      in_client, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kWorkerURLLoaderFactoryProvider_GetURLLoaderFactoryAndRegisterClient_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::WorkerURLLoaderFactoryProvider_GetURLLoaderFactoryAndRegisterClient_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  mojo::internal::Serialize<::content::mojom::URLLoaderFactoryAssociatedRequestDataView>(
      in_loader, &params->loader, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->loader),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_INTERFACE_ID,
      "invalid loader in WorkerURLLoaderFactoryProvider.GetURLLoaderFactoryAndRegisterClient request");
  mojo::internal::Serialize<::content::mojom::ServiceWorkerWorkerClientAssociatedPtrInfoDataView>(
      in_client, &params->client, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->client),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_INTERFACE_ID,
      "invalid client in WorkerURLLoaderFactoryProvider.GetURLLoaderFactoryAndRegisterClient request");
  params->service_worker_provider_id = in_service_worker_provider_id;
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void WorkerURLLoaderFactoryProviderProxy::GetURLLoaderFactory(
    ::content::mojom::URLLoaderFactoryAssociatedRequest in_loader) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::content::mojom::internal::WorkerURLLoaderFactoryProvider_GetURLLoaderFactory_Params_Data);
  size += mojo::internal::PrepareToSerialize<::content::mojom::URLLoaderFactoryAssociatedRequestDataView>(
      in_loader, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kWorkerURLLoaderFactoryProvider_GetURLLoaderFactory_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::content::mojom::internal::WorkerURLLoaderFactoryProvider_GetURLLoaderFactory_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  mojo::internal::Serialize<::content::mojom::URLLoaderFactoryAssociatedRequestDataView>(
      in_loader, &params->loader, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->loader),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_INTERFACE_ID,
      "invalid loader in WorkerURLLoaderFactoryProvider.GetURLLoaderFactory request");
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool WorkerURLLoaderFactoryProviderStubDispatch::Accept(
    WorkerURLLoaderFactoryProvider* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kWorkerURLLoaderFactoryProvider_GetURLLoaderFactoryAndRegisterClient_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::WorkerURLLoaderFactoryProvider_GetURLLoaderFactoryAndRegisterClient_Params_Data* params =
          reinterpret_cast<internal::WorkerURLLoaderFactoryProvider_GetURLLoaderFactoryAndRegisterClient_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      ::content::mojom::URLLoaderFactoryAssociatedRequest p_loader{};
      ServiceWorkerWorkerClientAssociatedPtrInfo p_client{};
      int32_t p_service_worker_provider_id{};
      WorkerURLLoaderFactoryProvider_GetURLLoaderFactoryAndRegisterClient_ParamsDataView input_data_view(params, &serialization_context);
      
      p_loader =
          input_data_view.TakeLoader<decltype(p_loader)>();
      p_client =
          input_data_view.TakeClient<decltype(p_client)>();
      p_service_worker_provider_id = input_data_view.service_worker_provider_id();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "WorkerURLLoaderFactoryProvider::GetURLLoaderFactoryAndRegisterClient deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->GetURLLoaderFactoryAndRegisterClient(
std::move(p_loader), 
std::move(p_client), 
std::move(p_service_worker_provider_id));
      return true;
    }
    case internal::kWorkerURLLoaderFactoryProvider_GetURLLoaderFactory_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::WorkerURLLoaderFactoryProvider_GetURLLoaderFactory_Params_Data* params =
          reinterpret_cast<internal::WorkerURLLoaderFactoryProvider_GetURLLoaderFactory_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      ::content::mojom::URLLoaderFactoryAssociatedRequest p_loader{};
      WorkerURLLoaderFactoryProvider_GetURLLoaderFactory_ParamsDataView input_data_view(params, &serialization_context);
      
      p_loader =
          input_data_view.TakeLoader<decltype(p_loader)>();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "WorkerURLLoaderFactoryProvider::GetURLLoaderFactory deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->GetURLLoaderFactory(
std::move(p_loader));
      return true;
    }
  }
  return false;
}

// static
bool WorkerURLLoaderFactoryProviderStubDispatch::AcceptWithResponder(
    WorkerURLLoaderFactoryProvider* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kWorkerURLLoaderFactoryProvider_GetURLLoaderFactoryAndRegisterClient_Name: {
      break;
    }
    case internal::kWorkerURLLoaderFactoryProvider_GetURLLoaderFactory_Name: {
      break;
    }
  }
  return false;
}

bool WorkerURLLoaderFactoryProviderRequestValidator::Accept(mojo::Message* message) {
  if (mojo::internal::IsUnserializedOrControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "WorkerURLLoaderFactoryProvider RequestValidator");

  switch (message->header()->name) {
    case internal::kWorkerURLLoaderFactoryProvider_GetURLLoaderFactoryAndRegisterClient_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::WorkerURLLoaderFactoryProvider_GetURLLoaderFactoryAndRegisterClient_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kWorkerURLLoaderFactoryProvider_GetURLLoaderFactory_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::WorkerURLLoaderFactoryProvider_GetURLLoaderFactory_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

}  // namespace mojom
}  // namespace content

namespace mojo {

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif