// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_PUBLIC_COMMON_URL_LOADER_FACTORY_MOJOM_SHARED_INTERNAL_H_
#define CONTENT_PUBLIC_COMMON_URL_LOADER_FACTORY_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/native_struct_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "content/public/common/mutable_network_traffic_annotation_tag.mojom-shared-internal.h"
#include "content/public/common/url_loader.mojom-shared-internal.h"
#include "content/public/common/interfaces_shared_export.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace content {
namespace mojom {
namespace internal {
using URLSyncLoadResult_Data = mojo::internal::NativeStruct_Data;

#pragma pack(push, 1)
constexpr uint32_t kURLLoaderFactory_CreateLoaderAndStart_Name = 0;
class MOJOM_SHARED_CONTENT_EXPORT URLLoaderFactory_CreateLoaderAndStart_Params_Data {
 public:
  static URLLoaderFactory_CreateLoaderAndStart_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::AssociatedEndpointHandle_Data loader;
  int32_t routing_id;
  int32_t request_id;
  uint32_t options;
  mojo::internal::Pointer<::content::mojom::internal::URLRequest_Data> request;
  mojo::internal::Interface_Data client;
  mojo::internal::Pointer<::content::mojom::internal::MutableNetworkTrafficAnnotationTag_Data> traffic_annotation;

 private:
  URLLoaderFactory_CreateLoaderAndStart_Params_Data();
  ~URLLoaderFactory_CreateLoaderAndStart_Params_Data() = delete;
};
static_assert(sizeof(URLLoaderFactory_CreateLoaderAndStart_Params_Data) == 48,
              "Bad sizeof(URLLoaderFactory_CreateLoaderAndStart_Params_Data)");
constexpr uint32_t kURLLoaderFactory_SyncLoad_Name = 1;
class MOJOM_SHARED_CONTENT_EXPORT URLLoaderFactory_SyncLoad_Params_Data {
 public:
  static URLLoaderFactory_SyncLoad_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t routing_id;
  int32_t request_id;
  mojo::internal::Pointer<::content::mojom::internal::URLRequest_Data> request;

 private:
  URLLoaderFactory_SyncLoad_Params_Data();
  ~URLLoaderFactory_SyncLoad_Params_Data() = delete;
};
static_assert(sizeof(URLLoaderFactory_SyncLoad_Params_Data) == 24,
              "Bad sizeof(URLLoaderFactory_SyncLoad_Params_Data)");
class MOJOM_SHARED_CONTENT_EXPORT URLLoaderFactory_SyncLoad_ResponseParams_Data {
 public:
  static URLLoaderFactory_SyncLoad_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::URLSyncLoadResult_Data> result;

 private:
  URLLoaderFactory_SyncLoad_ResponseParams_Data();
  ~URLLoaderFactory_SyncLoad_ResponseParams_Data() = delete;
};
static_assert(sizeof(URLLoaderFactory_SyncLoad_ResponseParams_Data) == 16,
              "Bad sizeof(URLLoaderFactory_SyncLoad_ResponseParams_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace content

#endif  // CONTENT_PUBLIC_COMMON_URL_LOADER_FACTORY_MOJOM_SHARED_INTERNAL_H_