// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef MEDIA_GPU_MOJO_JPEG_DECODER_MOJOM_SHARED_INTERNAL_H_
#define MEDIA_GPU_MOJO_JPEG_DECODER_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/native_struct_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "media/mojo/interfaces/media_types.mojom-shared-internal.h"
#include "mojo/common/time.mojom-shared-internal.h"
#include "ui/gfx/geometry/mojo/geometry.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace media {
namespace mojom {
namespace internal {
class BitstreamBuffer_Data;

struct DecodeError_Data {
 public:
  static bool constexpr kIsExtensible = false;

  static bool IsKnownValue(int32_t value) {
    switch (value) {
      case 0:
      case 1:
      case 2:
      case 3:
      case 4:
      case 5:
        return true;
    }
    return false;
  }

  static bool Validate(int32_t value,
                       mojo::internal::ValidationContext* validation_context) {
    if (kIsExtensible || IsKnownValue(value))
      return true;

    ReportValidationError(validation_context,
                          mojo::internal::VALIDATION_ERROR_UNKNOWN_ENUM_VALUE);
    return false;
  }
};

#pragma pack(push, 1)
class  BitstreamBuffer_Data {
 public:
  static BitstreamBuffer_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t id;
  mojo::internal::Handle_Data memory_handle;
  uint32_t size;
  uint8_t pad2_[4];
  int64_t offset;
  mojo::internal::Pointer<::mojo::common::mojom::internal::TimeDelta_Data> timestamp;
  mojo::internal::Pointer<mojo::internal::String_Data> key_id;
  mojo::internal::Pointer<mojo::internal::String_Data> iv;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::media::mojom::internal::SubsampleEntry_Data>>> subsamples;

 private:
  BitstreamBuffer_Data();
  ~BitstreamBuffer_Data() = delete;
};
static_assert(sizeof(BitstreamBuffer_Data) == 64,
              "Bad sizeof(BitstreamBuffer_Data)");
constexpr uint32_t kGpuJpegDecodeAccelerator_Initialize_Name = 0;
class  GpuJpegDecodeAccelerator_Initialize_Params_Data {
 public:
  static GpuJpegDecodeAccelerator_Initialize_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  GpuJpegDecodeAccelerator_Initialize_Params_Data();
  ~GpuJpegDecodeAccelerator_Initialize_Params_Data() = delete;
};
static_assert(sizeof(GpuJpegDecodeAccelerator_Initialize_Params_Data) == 8,
              "Bad sizeof(GpuJpegDecodeAccelerator_Initialize_Params_Data)");
class  GpuJpegDecodeAccelerator_Initialize_ResponseParams_Data {
 public:
  static GpuJpegDecodeAccelerator_Initialize_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t success : 1;
  uint8_t padfinal_[7];

 private:
  GpuJpegDecodeAccelerator_Initialize_ResponseParams_Data();
  ~GpuJpegDecodeAccelerator_Initialize_ResponseParams_Data() = delete;
};
static_assert(sizeof(GpuJpegDecodeAccelerator_Initialize_ResponseParams_Data) == 16,
              "Bad sizeof(GpuJpegDecodeAccelerator_Initialize_ResponseParams_Data)");
constexpr uint32_t kGpuJpegDecodeAccelerator_Decode_Name = 1;
class  GpuJpegDecodeAccelerator_Decode_Params_Data {
 public:
  static GpuJpegDecodeAccelerator_Decode_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::BitstreamBuffer_Data> input_buffer;
  mojo::internal::Pointer<::gfx::mojom::internal::Size_Data> coded_size;
  mojo::internal::Handle_Data output_handle;
  uint32_t output_buffer_size;

 private:
  GpuJpegDecodeAccelerator_Decode_Params_Data();
  ~GpuJpegDecodeAccelerator_Decode_Params_Data() = delete;
};
static_assert(sizeof(GpuJpegDecodeAccelerator_Decode_Params_Data) == 32,
              "Bad sizeof(GpuJpegDecodeAccelerator_Decode_Params_Data)");
class  GpuJpegDecodeAccelerator_Decode_ResponseParams_Data {
 public:
  static GpuJpegDecodeAccelerator_Decode_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t bitstream_buffer_id;
  int32_t error;

 private:
  GpuJpegDecodeAccelerator_Decode_ResponseParams_Data();
  ~GpuJpegDecodeAccelerator_Decode_ResponseParams_Data() = delete;
};
static_assert(sizeof(GpuJpegDecodeAccelerator_Decode_ResponseParams_Data) == 16,
              "Bad sizeof(GpuJpegDecodeAccelerator_Decode_ResponseParams_Data)");
constexpr uint32_t kGpuJpegDecodeAccelerator_Uninitialize_Name = 2;
class  GpuJpegDecodeAccelerator_Uninitialize_Params_Data {
 public:
  static GpuJpegDecodeAccelerator_Uninitialize_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  GpuJpegDecodeAccelerator_Uninitialize_Params_Data();
  ~GpuJpegDecodeAccelerator_Uninitialize_Params_Data() = delete;
};
static_assert(sizeof(GpuJpegDecodeAccelerator_Uninitialize_Params_Data) == 8,
              "Bad sizeof(GpuJpegDecodeAccelerator_Uninitialize_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace media

#endif  // MEDIA_GPU_MOJO_JPEG_DECODER_MOJOM_SHARED_INTERNAL_H_