// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "media/mojo/interfaces/remoting_common.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
namespace media {
namespace mojom {
SinkCapabilities::SinkCapabilities()
    : features(),
      audio(),
      video() {}

SinkCapabilities::SinkCapabilities(
    const std::vector<RemotingSinkFeatures>& features_in,
    const std::vector<RemotingSinkAudioCapabilities>& audio_in,
    const std::vector<RemotingSinkVideoCapabilities>& video_in)
    : features(std::move(features_in)),
      audio(std::move(audio_in)),
      video(std::move(video_in)) {}

SinkCapabilities::~SinkCapabilities() = default;

bool SinkCapabilities::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
}  // namespace mojom
}  // namespace media

namespace mojo {


// static
bool StructTraits<::media::mojom::SinkCapabilities::DataView, ::media::mojom::SinkCapabilitiesPtr>::Read(
    ::media::mojom::SinkCapabilities::DataView input,
    ::media::mojom::SinkCapabilitiesPtr* output) {
  bool success = true;
  ::media::mojom::SinkCapabilitiesPtr result(::media::mojom::SinkCapabilities::New());
  
      if (!input.ReadFeatures(&result->features))
        success = false;
      if (!input.ReadAudio(&result->audio))
        success = false;
      if (!input.ReadVideo(&result->video))
        success = false;
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif