// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4065)
#endif

#include "services/resource_coordinator/public/interfaces/coordination_unit.mojom-shared.h"

#include <utility>

#include "base/logging.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"
namespace resource_coordinator {
namespace mojom {

namespace internal {


// static
CoordinationUnitID_Data* CoordinationUnitID_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(CoordinationUnitID_Data))) CoordinationUnitID_Data();
}

// static
bool CoordinationUnitID_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, validation_context))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const CoordinationUnitID_Data* object = static_cast<const CoordinationUnitID_Data*>(data);

  static constexpr struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 24 }};

  if (object->header_.version <=
          kVersionSizes[arraysize(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = arraysize(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            validation_context,
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[arraysize(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        validation_context,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }


  if (!::resource_coordinator::mojom::internal::CoordinationUnitType_Data
        ::Validate(object->type, validation_context))
    return false;

  return true;
}

CoordinationUnitID_Data::CoordinationUnitID_Data()
    : header_({sizeof(*this), 0}) {}


// static
CoordinationPolicy_Data* CoordinationPolicy_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(CoordinationPolicy_Data))) CoordinationPolicy_Data();
}

// static
bool CoordinationPolicy_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, validation_context))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const CoordinationPolicy_Data* object = static_cast<const CoordinationPolicy_Data*>(data);

  static constexpr struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 16 }};

  if (object->header_.version <=
          kVersionSizes[arraysize(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = arraysize(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            validation_context,
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[arraysize(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        validation_context,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  return true;
}

CoordinationPolicy_Data::CoordinationPolicy_Data()
    : header_({sizeof(*this), 0}) {}


// static
CoordinationPolicyCallback_SetCoordinationPolicy_Params_Data* CoordinationPolicyCallback_SetCoordinationPolicy_Params_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(CoordinationPolicyCallback_SetCoordinationPolicy_Params_Data))) CoordinationPolicyCallback_SetCoordinationPolicy_Params_Data();
}

// static
bool CoordinationPolicyCallback_SetCoordinationPolicy_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, validation_context))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const CoordinationPolicyCallback_SetCoordinationPolicy_Params_Data* object = static_cast<const CoordinationPolicyCallback_SetCoordinationPolicy_Params_Data*>(data);

  static constexpr struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 16 }};

  if (object->header_.version <=
          kVersionSizes[arraysize(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = arraysize(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            validation_context,
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[arraysize(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        validation_context,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->policy, "null policy field in CoordinationPolicyCallback_SetCoordinationPolicy_Params",
          validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->policy, validation_context))
    return false;

  return true;
}

CoordinationPolicyCallback_SetCoordinationPolicy_Params_Data::CoordinationPolicyCallback_SetCoordinationPolicy_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
CoordinationUnit_SendEvent_Params_Data* CoordinationUnit_SendEvent_Params_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(CoordinationUnit_SendEvent_Params_Data))) CoordinationUnit_SendEvent_Params_Data();
}

// static
bool CoordinationUnit_SendEvent_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, validation_context))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const CoordinationUnit_SendEvent_Params_Data* object = static_cast<const CoordinationUnit_SendEvent_Params_Data*>(data);

  static constexpr struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 16 }};

  if (object->header_.version <=
          kVersionSizes[arraysize(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = arraysize(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            validation_context,
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[arraysize(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        validation_context,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->event, "null event field in CoordinationUnit_SendEvent_Params",
          validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->event, validation_context))
    return false;

  return true;
}

CoordinationUnit_SendEvent_Params_Data::CoordinationUnit_SendEvent_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
CoordinationUnit_GetID_Params_Data* CoordinationUnit_GetID_Params_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(CoordinationUnit_GetID_Params_Data))) CoordinationUnit_GetID_Params_Data();
}

// static
bool CoordinationUnit_GetID_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, validation_context))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const CoordinationUnit_GetID_Params_Data* object = static_cast<const CoordinationUnit_GetID_Params_Data*>(data);

  static constexpr struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 8 }};

  if (object->header_.version <=
          kVersionSizes[arraysize(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = arraysize(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            validation_context,
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[arraysize(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        validation_context,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  return true;
}

CoordinationUnit_GetID_Params_Data::CoordinationUnit_GetID_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
CoordinationUnit_GetID_ResponseParams_Data* CoordinationUnit_GetID_ResponseParams_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(CoordinationUnit_GetID_ResponseParams_Data))) CoordinationUnit_GetID_ResponseParams_Data();
}

// static
bool CoordinationUnit_GetID_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, validation_context))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const CoordinationUnit_GetID_ResponseParams_Data* object = static_cast<const CoordinationUnit_GetID_ResponseParams_Data*>(data);

  static constexpr struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 16 }};

  if (object->header_.version <=
          kVersionSizes[arraysize(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = arraysize(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            validation_context,
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[arraysize(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        validation_context,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->id, "null id field in CoordinationUnit_GetID_ResponseParams",
          validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->id, validation_context))
    return false;

  return true;
}

CoordinationUnit_GetID_ResponseParams_Data::CoordinationUnit_GetID_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
CoordinationUnit_AddBinding_Params_Data* CoordinationUnit_AddBinding_Params_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(CoordinationUnit_AddBinding_Params_Data))) CoordinationUnit_AddBinding_Params_Data();
}

// static
bool CoordinationUnit_AddBinding_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, validation_context))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const CoordinationUnit_AddBinding_Params_Data* object = static_cast<const CoordinationUnit_AddBinding_Params_Data*>(data);

  static constexpr struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 16 }};

  if (object->header_.version <=
          kVersionSizes[arraysize(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = arraysize(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            validation_context,
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[arraysize(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        validation_context,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!mojo::internal::ValidateHandleOrInterfaceNonNullable(
          object->request,
          "invalid request field in CoordinationUnit_AddBinding_Params", validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateHandleOrInterface(object->request,
                                                 validation_context)) {
    return false;
  }

  return true;
}

CoordinationUnit_AddBinding_Params_Data::CoordinationUnit_AddBinding_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
CoordinationUnit_AddChild_Params_Data* CoordinationUnit_AddChild_Params_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(CoordinationUnit_AddChild_Params_Data))) CoordinationUnit_AddChild_Params_Data();
}

// static
bool CoordinationUnit_AddChild_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, validation_context))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const CoordinationUnit_AddChild_Params_Data* object = static_cast<const CoordinationUnit_AddChild_Params_Data*>(data);

  static constexpr struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 16 }};

  if (object->header_.version <=
          kVersionSizes[arraysize(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = arraysize(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            validation_context,
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[arraysize(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        validation_context,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->child_id, "null child_id field in CoordinationUnit_AddChild_Params",
          validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->child_id, validation_context))
    return false;

  return true;
}

CoordinationUnit_AddChild_Params_Data::CoordinationUnit_AddChild_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
CoordinationUnit_RemoveChild_Params_Data* CoordinationUnit_RemoveChild_Params_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(CoordinationUnit_RemoveChild_Params_Data))) CoordinationUnit_RemoveChild_Params_Data();
}

// static
bool CoordinationUnit_RemoveChild_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, validation_context))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const CoordinationUnit_RemoveChild_Params_Data* object = static_cast<const CoordinationUnit_RemoveChild_Params_Data*>(data);

  static constexpr struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 16 }};

  if (object->header_.version <=
          kVersionSizes[arraysize(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = arraysize(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            validation_context,
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[arraysize(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        validation_context,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->child_id, "null child_id field in CoordinationUnit_RemoveChild_Params",
          validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->child_id, validation_context))
    return false;

  return true;
}

CoordinationUnit_RemoveChild_Params_Data::CoordinationUnit_RemoveChild_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
CoordinationUnit_SetCoordinationPolicyCallback_Params_Data* CoordinationUnit_SetCoordinationPolicyCallback_Params_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(CoordinationUnit_SetCoordinationPolicyCallback_Params_Data))) CoordinationUnit_SetCoordinationPolicyCallback_Params_Data();
}

// static
bool CoordinationUnit_SetCoordinationPolicyCallback_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, validation_context))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const CoordinationUnit_SetCoordinationPolicyCallback_Params_Data* object = static_cast<const CoordinationUnit_SetCoordinationPolicyCallback_Params_Data*>(data);

  static constexpr struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 16 }};

  if (object->header_.version <=
          kVersionSizes[arraysize(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = arraysize(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            validation_context,
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[arraysize(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        validation_context,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!mojo::internal::ValidateHandleOrInterfaceNonNullable(
          object->callback,
          "invalid callback field in CoordinationUnit_SetCoordinationPolicyCallback_Params", validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateHandleOrInterface(object->callback,
                                                 validation_context)) {
    return false;
  }

  return true;
}

CoordinationUnit_SetCoordinationPolicyCallback_Params_Data::CoordinationUnit_SetCoordinationPolicyCallback_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
CoordinationUnit_SetProperty_Params_Data* CoordinationUnit_SetProperty_Params_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(CoordinationUnit_SetProperty_Params_Data))) CoordinationUnit_SetProperty_Params_Data();
}

// static
bool CoordinationUnit_SetProperty_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, validation_context))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const CoordinationUnit_SetProperty_Params_Data* object = static_cast<const CoordinationUnit_SetProperty_Params_Data*>(data);

  static constexpr struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 32 }};

  if (object->header_.version <=
          kVersionSizes[arraysize(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = arraysize(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            validation_context,
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[arraysize(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        validation_context,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }


  if (!::resource_coordinator::mojom::internal::PropertyType_Data
        ::Validate(object->property_type, validation_context))
    return false;

  if (!mojo::internal::ValidateInlinedUnionNonNullable(
          object->value, "null value field in CoordinationUnit_SetProperty_Params",
          validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateInlinedUnion(object->value, validation_context))
    return false;

  return true;
}

CoordinationUnit_SetProperty_Params_Data::CoordinationUnit_SetProperty_Params_Data()
    : header_({sizeof(*this), 0}) {}

}  // namespace internal
}  // namespace mojom
}  // namespace resource_coordinator

#if defined(_MSC_VER)
#pragma warning(pop)
#endif
