// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SERVICE_CALLBACKS_MOJOM_SHARED_H_
#define SERVICES_RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SERVICE_CALLBACKS_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/native_struct_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "services/resource_coordinator/public/interfaces/service_callbacks.mojom-shared-internal.h"
#include "services/metrics/public/interfaces/ukm_interface.mojom-shared.h"
#include "services/resource_coordinator/public/interfaces/interfaces_internal_shared_export.h"


namespace resource_coordinator {
namespace mojom {


}  // namespace mojom
}  // namespace resource_coordinator

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace resource_coordinator {
namespace mojom {
// Interface base classes. They are used for type safety check.
class ServiceCallbacksInterfaceBase {};

using ServiceCallbacksPtrDataView =
    mojo::InterfacePtrDataView<ServiceCallbacksInterfaceBase>;
using ServiceCallbacksRequestDataView =
    mojo::InterfaceRequestDataView<ServiceCallbacksInterfaceBase>;
using ServiceCallbacksAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<ServiceCallbacksInterfaceBase>;
using ServiceCallbacksAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<ServiceCallbacksInterfaceBase>;
class ServiceCallbacks_IsUkmRecorderInterfaceInitialized_ParamsDataView {
 public:
  ServiceCallbacks_IsUkmRecorderInterfaceInitialized_ParamsDataView() {}

  ServiceCallbacks_IsUkmRecorderInterfaceInitialized_ParamsDataView(
      internal::ServiceCallbacks_IsUkmRecorderInterfaceInitialized_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::ServiceCallbacks_IsUkmRecorderInterfaceInitialized_Params_Data* data_ = nullptr;
};

class ServiceCallbacks_IsUkmRecorderInterfaceInitialized_ResponseParamsDataView {
 public:
  ServiceCallbacks_IsUkmRecorderInterfaceInitialized_ResponseParamsDataView() {}

  ServiceCallbacks_IsUkmRecorderInterfaceInitialized_ResponseParamsDataView(
      internal::ServiceCallbacks_IsUkmRecorderInterfaceInitialized_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool ukm_recorder_already_initialized() const {
    return data_->ukm_recorder_already_initialized;
  }
 private:
  internal::ServiceCallbacks_IsUkmRecorderInterfaceInitialized_ResponseParams_Data* data_ = nullptr;
};

class ServiceCallbacks_SetUkmRecorderInterface_ParamsDataView {
 public:
  ServiceCallbacks_SetUkmRecorderInterface_ParamsDataView() {}

  ServiceCallbacks_SetUkmRecorderInterface_ParamsDataView(
      internal::ServiceCallbacks_SetUkmRecorderInterface_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeUkmRecorderInterface() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::ukm::mojom::UkmRecorderInterfacePtrDataView>(
            &data_->ukm_recorder_interface, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::ServiceCallbacks_SetUkmRecorderInterface_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace resource_coordinator

namespace std {

}  // namespace std

namespace mojo {

}  // namespace mojo


namespace resource_coordinator {
namespace mojom {








}  // namespace mojom
}  // namespace resource_coordinator

#endif  // SERVICES_RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SERVICE_CALLBACKS_MOJOM_SHARED_H_
