// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "services/resource_coordinator/public/interfaces/tracing/tracing.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "ipc/ipc_message_utils.h"
#include "mojo/common/common_custom_types_struct_traits.h"
#include "mojo/common/values_struct_traits.h"
namespace tracing {
namespace mojom {
const char AgentRegistry::Name_[] = "tracing::mojom::AgentRegistry";

AgentRegistryProxy::AgentRegistryProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void AgentRegistryProxy::RegisterAgent(
    AgentPtr in_agent, const std::string& in_label, TraceDataType in_type, bool in_supports_explicit_clock_sync_) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::tracing::mojom::internal::AgentRegistry_RegisterAgent_Params_Data);
  size += mojo::internal::PrepareToSerialize<::tracing::mojom::AgentPtrDataView>(
      in_agent, &serialization_context);
  size += mojo::internal::PrepareToSerialize<mojo::StringDataView>(
      in_label, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kAgentRegistry_RegisterAgent_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::tracing::mojom::internal::AgentRegistry_RegisterAgent_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  mojo::internal::Serialize<::tracing::mojom::AgentPtrDataView>(
      in_agent, &params->agent, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->agent),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid agent in AgentRegistry.RegisterAgent request");
  typename decltype(params->label)::BaseType* label_ptr;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_label, buffer, &label_ptr, &serialization_context);
  params->label.Set(label_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->label.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null label in AgentRegistry.RegisterAgent request");
  mojo::internal::Serialize<::tracing::mojom::TraceDataType>(
      in_type, &params->type);
  params->supports_explicit_clock_sync_ = in_supports_explicit_clock_sync_;
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool AgentRegistryStubDispatch::Accept(
    AgentRegistry* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kAgentRegistry_RegisterAgent_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::AgentRegistry_RegisterAgent_Params_Data* params =
          reinterpret_cast<internal::AgentRegistry_RegisterAgent_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      AgentPtr p_agent{};
      std::string p_label{};
      TraceDataType p_type{};
      bool p_supports_explicit_clock_sync_{};
      AgentRegistry_RegisterAgent_ParamsDataView input_data_view(params, &serialization_context);
      
      p_agent =
          input_data_view.TakeAgent<decltype(p_agent)>();
      if (!input_data_view.ReadLabel(&p_label))
        success = false;
      if (!input_data_view.ReadType(&p_type))
        success = false;
      p_supports_explicit_clock_sync_ = input_data_view.supports_explicit_clock_sync_();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "AgentRegistry::RegisterAgent deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->RegisterAgent(
std::move(p_agent), 
std::move(p_label), 
std::move(p_type), 
std::move(p_supports_explicit_clock_sync_));
      return true;
    }
  }
  return false;
}

// static
bool AgentRegistryStubDispatch::AcceptWithResponder(
    AgentRegistry* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kAgentRegistry_RegisterAgent_Name: {
      break;
    }
  }
  return false;
}

bool AgentRegistryRequestValidator::Accept(mojo::Message* message) {
  if (mojo::internal::IsUnserializedOrControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "AgentRegistry RequestValidator");

  switch (message->header()->name) {
    case internal::kAgentRegistry_RegisterAgent_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::AgentRegistry_RegisterAgent_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

const char Agent::Name_[] = "tracing::mojom::Agent";

class Agent_StartTracing_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  Agent_StartTracing_ForwardToCallback(
      const Agent::StartTracingCallback& callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  Agent::StartTracingCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(Agent_StartTracing_ForwardToCallback);
};

class Agent_RequestClockSyncMarker_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  Agent_RequestClockSyncMarker_ForwardToCallback(
      const Agent::RequestClockSyncMarkerCallback& callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  Agent::RequestClockSyncMarkerCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(Agent_RequestClockSyncMarker_ForwardToCallback);
};

class Agent_RequestBufferStatus_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  Agent_RequestBufferStatus_ForwardToCallback(
      const Agent::RequestBufferStatusCallback& callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  Agent::RequestBufferStatusCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(Agent_RequestBufferStatus_ForwardToCallback);
};

class Agent_GetCategories_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  Agent_GetCategories_ForwardToCallback(
      const Agent::GetCategoriesCallback& callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  Agent::GetCategoriesCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(Agent_GetCategories_ForwardToCallback);
};

AgentProxy::AgentProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void AgentProxy::StartTracing(
    const std::string& in_config, const StartTracingCallback& callback) {
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::tracing::mojom::internal::Agent_StartTracing_Params_Data);
  size += mojo::internal::PrepareToSerialize<mojo::StringDataView>(
      in_config, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kAgent_StartTracing_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::tracing::mojom::internal::Agent_StartTracing_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->config)::BaseType* config_ptr;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_config, buffer, &config_ptr, &serialization_context);
  params->config.Set(config_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->config.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null config in Agent.StartTracing request");
  std::unique_ptr<mojo::MessageReceiver> responder(
      new Agent_StartTracing_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void AgentProxy::StopAndFlush(
    RecorderPtr in_recorder) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::tracing::mojom::internal::Agent_StopAndFlush_Params_Data);
  size += mojo::internal::PrepareToSerialize<::tracing::mojom::RecorderPtrDataView>(
      in_recorder, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kAgent_StopAndFlush_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::tracing::mojom::internal::Agent_StopAndFlush_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  mojo::internal::Serialize<::tracing::mojom::RecorderPtrDataView>(
      in_recorder, &params->recorder, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->recorder),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid recorder in Agent.StopAndFlush request");
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void AgentProxy::RequestClockSyncMarker(
    const std::string& in_sync_id, const RequestClockSyncMarkerCallback& callback) {
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::tracing::mojom::internal::Agent_RequestClockSyncMarker_Params_Data);
  size += mojo::internal::PrepareToSerialize<mojo::StringDataView>(
      in_sync_id, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kAgent_RequestClockSyncMarker_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::tracing::mojom::internal::Agent_RequestClockSyncMarker_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->sync_id)::BaseType* sync_id_ptr;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_sync_id, buffer, &sync_id_ptr, &serialization_context);
  params->sync_id.Set(sync_id_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->sync_id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null sync_id in Agent.RequestClockSyncMarker request");
  std::unique_ptr<mojo::MessageReceiver> responder(
      new Agent_RequestClockSyncMarker_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void AgentProxy::RequestBufferStatus(
    const RequestBufferStatusCallback& callback) {
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::tracing::mojom::internal::Agent_RequestBufferStatus_Params_Data);
  serialization_context.PrepareMessage(
      internal::kAgent_RequestBufferStatus_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::tracing::mojom::internal::Agent_RequestBufferStatus_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  std::unique_ptr<mojo::MessageReceiver> responder(
      new Agent_RequestBufferStatus_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void AgentProxy::GetCategories(
    const GetCategoriesCallback& callback) {
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::tracing::mojom::internal::Agent_GetCategories_Params_Data);
  serialization_context.PrepareMessage(
      internal::kAgent_GetCategories_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::tracing::mojom::internal::Agent_GetCategories_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  std::unique_ptr<mojo::MessageReceiver> responder(
      new Agent_GetCategories_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}
class Agent_StartTracing_ProxyToResponder {
 public:
  static Agent::StartTracingCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<Agent_StartTracing_ProxyToResponder> proxy(
        new Agent_StartTracing_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::Bind(&Agent_StartTracing_ProxyToResponder::Run,
                      base::Passed(&proxy));
  }

  ~Agent_StartTracing_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // Is the Service destroying the callback without running it
      // and without first closing the pipe?
      responder_->DCheckInvalid("The callback passed to "
          "Agent::StartTracing() was never run.");
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  Agent_StartTracing_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

  void Run(
      );

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(Agent_StartTracing_ProxyToResponder);
};

bool Agent_StartTracing_ForwardToCallback::Accept(
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::Agent_StartTracing_ResponseParams_Data* params =
      reinterpret_cast<
          internal::Agent_StartTracing_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  Agent_StartTracing_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "Agent::StartTracing response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run();
  return true;
}

void Agent_StartTracing_ProxyToResponder::Run(
    ) {
  mojo::Message message;
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::tracing::mojom::internal::Agent_StartTracing_ResponseParams_Data);
  serialization_context.PrepareMessage(
      internal::kAgent_StartTracing_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::tracing::mojom::internal::Agent_StartTracing_ResponseParams_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class Agent_RequestClockSyncMarker_ProxyToResponder {
 public:
  static Agent::RequestClockSyncMarkerCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<Agent_RequestClockSyncMarker_ProxyToResponder> proxy(
        new Agent_RequestClockSyncMarker_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::Bind(&Agent_RequestClockSyncMarker_ProxyToResponder::Run,
                      base::Passed(&proxy));
  }

  ~Agent_RequestClockSyncMarker_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // Is the Service destroying the callback without running it
      // and without first closing the pipe?
      responder_->DCheckInvalid("The callback passed to "
          "Agent::RequestClockSyncMarker() was never run.");
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  Agent_RequestClockSyncMarker_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

  void Run(
      base::TimeTicks in_issue_ts, base::TimeTicks in_issue_end_ts);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(Agent_RequestClockSyncMarker_ProxyToResponder);
};

bool Agent_RequestClockSyncMarker_ForwardToCallback::Accept(
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::Agent_RequestClockSyncMarker_ResponseParams_Data* params =
      reinterpret_cast<
          internal::Agent_RequestClockSyncMarker_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  base::TimeTicks p_issue_ts{};
  base::TimeTicks p_issue_end_ts{};
  Agent_RequestClockSyncMarker_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (!input_data_view.ReadIssueTs(&p_issue_ts))
    success = false;
  if (!input_data_view.ReadIssueEndTs(&p_issue_end_ts))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "Agent::RequestClockSyncMarker response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_issue_ts), 
std::move(p_issue_end_ts));
  return true;
}

void Agent_RequestClockSyncMarker_ProxyToResponder::Run(
    base::TimeTicks in_issue_ts, base::TimeTicks in_issue_end_ts) {
  mojo::Message message;
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::tracing::mojom::internal::Agent_RequestClockSyncMarker_ResponseParams_Data);
  size += mojo::internal::PrepareToSerialize<::mojo::common::mojom::TimeTicksDataView>(
      in_issue_ts, &serialization_context);
  size += mojo::internal::PrepareToSerialize<::mojo::common::mojom::TimeTicksDataView>(
      in_issue_end_ts, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kAgent_RequestClockSyncMarker_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::tracing::mojom::internal::Agent_RequestClockSyncMarker_ResponseParams_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->issue_ts)::BaseType* issue_ts_ptr;
  mojo::internal::Serialize<::mojo::common::mojom::TimeTicksDataView>(
      in_issue_ts, buffer, &issue_ts_ptr, &serialization_context);
  params->issue_ts.Set(issue_ts_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->issue_ts.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null issue_ts in ");
  typename decltype(params->issue_end_ts)::BaseType* issue_end_ts_ptr;
  mojo::internal::Serialize<::mojo::common::mojom::TimeTicksDataView>(
      in_issue_end_ts, buffer, &issue_end_ts_ptr, &serialization_context);
  params->issue_end_ts.Set(issue_end_ts_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->issue_end_ts.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null issue_end_ts in ");

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class Agent_RequestBufferStatus_ProxyToResponder {
 public:
  static Agent::RequestBufferStatusCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<Agent_RequestBufferStatus_ProxyToResponder> proxy(
        new Agent_RequestBufferStatus_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::Bind(&Agent_RequestBufferStatus_ProxyToResponder::Run,
                      base::Passed(&proxy));
  }

  ~Agent_RequestBufferStatus_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // Is the Service destroying the callback without running it
      // and without first closing the pipe?
      responder_->DCheckInvalid("The callback passed to "
          "Agent::RequestBufferStatus() was never run.");
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  Agent_RequestBufferStatus_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

  void Run(
      uint32_t in_capacity, uint32_t in_count);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(Agent_RequestBufferStatus_ProxyToResponder);
};

bool Agent_RequestBufferStatus_ForwardToCallback::Accept(
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::Agent_RequestBufferStatus_ResponseParams_Data* params =
      reinterpret_cast<
          internal::Agent_RequestBufferStatus_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  uint32_t p_capacity{};
  uint32_t p_count{};
  Agent_RequestBufferStatus_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  p_capacity = input_data_view.capacity();
  p_count = input_data_view.count();
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "Agent::RequestBufferStatus response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_capacity), 
std::move(p_count));
  return true;
}

void Agent_RequestBufferStatus_ProxyToResponder::Run(
    uint32_t in_capacity, uint32_t in_count) {
  mojo::Message message;
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::tracing::mojom::internal::Agent_RequestBufferStatus_ResponseParams_Data);
  serialization_context.PrepareMessage(
      internal::kAgent_RequestBufferStatus_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::tracing::mojom::internal::Agent_RequestBufferStatus_ResponseParams_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  params->capacity = in_capacity;
  params->count = in_count;

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class Agent_GetCategories_ProxyToResponder {
 public:
  static Agent::GetCategoriesCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<Agent_GetCategories_ProxyToResponder> proxy(
        new Agent_GetCategories_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::Bind(&Agent_GetCategories_ProxyToResponder::Run,
                      base::Passed(&proxy));
  }

  ~Agent_GetCategories_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // Is the Service destroying the callback without running it
      // and without first closing the pipe?
      responder_->DCheckInvalid("The callback passed to "
          "Agent::GetCategories() was never run.");
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  Agent_GetCategories_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

  void Run(
      const std::string& in_categories);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(Agent_GetCategories_ProxyToResponder);
};

bool Agent_GetCategories_ForwardToCallback::Accept(
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::Agent_GetCategories_ResponseParams_Data* params =
      reinterpret_cast<
          internal::Agent_GetCategories_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  std::string p_categories{};
  Agent_GetCategories_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (!input_data_view.ReadCategories(&p_categories))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "Agent::GetCategories response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_categories));
  return true;
}

void Agent_GetCategories_ProxyToResponder::Run(
    const std::string& in_categories) {
  mojo::Message message;
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::tracing::mojom::internal::Agent_GetCategories_ResponseParams_Data);
  size += mojo::internal::PrepareToSerialize<mojo::StringDataView>(
      in_categories, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kAgent_GetCategories_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::tracing::mojom::internal::Agent_GetCategories_ResponseParams_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->categories)::BaseType* categories_ptr;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_categories, buffer, &categories_ptr, &serialization_context);
  params->categories.Set(categories_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->categories.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null categories in ");

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}

// static
bool AgentStubDispatch::Accept(
    Agent* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kAgent_StartTracing_Name: {
      break;
    }
    case internal::kAgent_StopAndFlush_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::Agent_StopAndFlush_Params_Data* params =
          reinterpret_cast<internal::Agent_StopAndFlush_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      RecorderPtr p_recorder{};
      Agent_StopAndFlush_ParamsDataView input_data_view(params, &serialization_context);
      
      p_recorder =
          input_data_view.TakeRecorder<decltype(p_recorder)>();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "Agent::StopAndFlush deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->StopAndFlush(
std::move(p_recorder));
      return true;
    }
    case internal::kAgent_RequestClockSyncMarker_Name: {
      break;
    }
    case internal::kAgent_RequestBufferStatus_Name: {
      break;
    }
    case internal::kAgent_GetCategories_Name: {
      break;
    }
  }
  return false;
}

// static
bool AgentStubDispatch::AcceptWithResponder(
    Agent* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kAgent_StartTracing_Name: {
      mojo::internal::MessageDispatchContext context(message);

      internal::Agent_StartTracing_Params_Data* params =
          reinterpret_cast<
              internal::Agent_StartTracing_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      std::string p_config{};
      Agent_StartTracing_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadConfig(&p_config))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "Agent::StartTracing deserializer");
        return false;
      }
      Agent::StartTracingCallback callback =
          Agent_StartTracing_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->StartTracing(
std::move(p_config), std::move(callback));
      return true;
    }
    case internal::kAgent_StopAndFlush_Name: {
      break;
    }
    case internal::kAgent_RequestClockSyncMarker_Name: {
      mojo::internal::MessageDispatchContext context(message);

      internal::Agent_RequestClockSyncMarker_Params_Data* params =
          reinterpret_cast<
              internal::Agent_RequestClockSyncMarker_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      std::string p_sync_id{};
      Agent_RequestClockSyncMarker_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadSyncId(&p_sync_id))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "Agent::RequestClockSyncMarker deserializer");
        return false;
      }
      Agent::RequestClockSyncMarkerCallback callback =
          Agent_RequestClockSyncMarker_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->RequestClockSyncMarker(
std::move(p_sync_id), std::move(callback));
      return true;
    }
    case internal::kAgent_RequestBufferStatus_Name: {
      mojo::internal::MessageDispatchContext context(message);

      internal::Agent_RequestBufferStatus_Params_Data* params =
          reinterpret_cast<
              internal::Agent_RequestBufferStatus_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      Agent_RequestBufferStatus_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "Agent::RequestBufferStatus deserializer");
        return false;
      }
      Agent::RequestBufferStatusCallback callback =
          Agent_RequestBufferStatus_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->RequestBufferStatus(std::move(callback));
      return true;
    }
    case internal::kAgent_GetCategories_Name: {
      mojo::internal::MessageDispatchContext context(message);

      internal::Agent_GetCategories_Params_Data* params =
          reinterpret_cast<
              internal::Agent_GetCategories_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      Agent_GetCategories_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "Agent::GetCategories deserializer");
        return false;
      }
      Agent::GetCategoriesCallback callback =
          Agent_GetCategories_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->GetCategories(std::move(callback));
      return true;
    }
  }
  return false;
}

bool AgentRequestValidator::Accept(mojo::Message* message) {
  if (mojo::internal::IsUnserializedOrControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "Agent RequestValidator");

  switch (message->header()->name) {
    case internal::kAgent_StartTracing_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::Agent_StartTracing_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kAgent_StopAndFlush_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::Agent_StopAndFlush_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kAgent_RequestClockSyncMarker_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::Agent_RequestClockSyncMarker_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kAgent_RequestBufferStatus_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::Agent_RequestBufferStatus_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kAgent_GetCategories_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::Agent_GetCategories_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

bool AgentResponseValidator::Accept(mojo::Message* message) {
  if (mojo::internal::IsUnserializedOrControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "Agent ResponseValidator");

  if (!mojo::internal::ValidateMessageIsResponse(message, &validation_context))
    return false;
  switch (message->header()->name) {
    case internal::kAgent_StartTracing_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::Agent_StartTracing_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kAgent_RequestClockSyncMarker_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::Agent_RequestClockSyncMarker_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kAgent_RequestBufferStatus_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::Agent_RequestBufferStatus_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kAgent_GetCategories_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::Agent_GetCategories_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}
const char Recorder::Name_[] = "tracing::mojom::Recorder";

RecorderProxy::RecorderProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void RecorderProxy::AddChunk(
    const std::string& in_chunk) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::tracing::mojom::internal::Recorder_AddChunk_Params_Data);
  size += mojo::internal::PrepareToSerialize<mojo::StringDataView>(
      in_chunk, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kRecorder_AddChunk_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::tracing::mojom::internal::Recorder_AddChunk_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->chunk)::BaseType* chunk_ptr;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_chunk, buffer, &chunk_ptr, &serialization_context);
  params->chunk.Set(chunk_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->chunk.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null chunk in Recorder.AddChunk request");
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void RecorderProxy::AddMetadata(
    std::unique_ptr<base::DictionaryValue> in_metadata) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::tracing::mojom::internal::Recorder_AddMetadata_Params_Data);
  size += mojo::internal::PrepareToSerialize<::mojo::common::mojom::DictionaryValueDataView>(
      in_metadata, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kRecorder_AddMetadata_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::tracing::mojom::internal::Recorder_AddMetadata_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->metadata)::BaseType* metadata_ptr;
  mojo::internal::Serialize<::mojo::common::mojom::DictionaryValueDataView>(
      in_metadata, buffer, &metadata_ptr, &serialization_context);
  params->metadata.Set(metadata_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->metadata.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null metadata in Recorder.AddMetadata request");
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool RecorderStubDispatch::Accept(
    Recorder* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kRecorder_AddChunk_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::Recorder_AddChunk_Params_Data* params =
          reinterpret_cast<internal::Recorder_AddChunk_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      std::string p_chunk{};
      Recorder_AddChunk_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadChunk(&p_chunk))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "Recorder::AddChunk deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->AddChunk(
std::move(p_chunk));
      return true;
    }
    case internal::kRecorder_AddMetadata_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::Recorder_AddMetadata_Params_Data* params =
          reinterpret_cast<internal::Recorder_AddMetadata_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      std::unique_ptr<base::DictionaryValue> p_metadata{};
      Recorder_AddMetadata_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadMetadata(&p_metadata))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "Recorder::AddMetadata deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->AddMetadata(
std::move(p_metadata));
      return true;
    }
  }
  return false;
}

// static
bool RecorderStubDispatch::AcceptWithResponder(
    Recorder* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kRecorder_AddChunk_Name: {
      break;
    }
    case internal::kRecorder_AddMetadata_Name: {
      break;
    }
  }
  return false;
}

bool RecorderRequestValidator::Accept(mojo::Message* message) {
  if (mojo::internal::IsUnserializedOrControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "Recorder RequestValidator");

  switch (message->header()->name) {
    case internal::kRecorder_AddChunk_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::Recorder_AddChunk_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kRecorder_AddMetadata_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::Recorder_AddMetadata_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

const char Coordinator::Name_[] = "tracing::mojom::Coordinator";

class Coordinator_StartTracing_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  Coordinator_StartTracing_ForwardToCallback(
      const Coordinator::StartTracingCallback& callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  Coordinator::StartTracingCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(Coordinator_StartTracing_ForwardToCallback);
};

class Coordinator_IsTracing_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  Coordinator_IsTracing_ForwardToCallback(
      const Coordinator::IsTracingCallback& callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  Coordinator::IsTracingCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(Coordinator_IsTracing_ForwardToCallback);
};

class Coordinator_RequestBufferUsage_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  Coordinator_RequestBufferUsage_ForwardToCallback(
      const Coordinator::RequestBufferUsageCallback& callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  Coordinator::RequestBufferUsageCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(Coordinator_RequestBufferUsage_ForwardToCallback);
};

class Coordinator_GetCategories_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  Coordinator_GetCategories_ForwardToCallback(
      const Coordinator::GetCategoriesCallback& callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  Coordinator::GetCategoriesCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(Coordinator_GetCategories_ForwardToCallback);
};

CoordinatorProxy::CoordinatorProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void CoordinatorProxy::StartTracing(
    const std::string& in_config, const StartTracingCallback& callback) {
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::tracing::mojom::internal::Coordinator_StartTracing_Params_Data);
  size += mojo::internal::PrepareToSerialize<mojo::StringDataView>(
      in_config, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kCoordinator_StartTracing_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::tracing::mojom::internal::Coordinator_StartTracing_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->config)::BaseType* config_ptr;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_config, buffer, &config_ptr, &serialization_context);
  params->config.Set(config_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->config.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null config in Coordinator.StartTracing request");
  std::unique_ptr<mojo::MessageReceiver> responder(
      new Coordinator_StartTracing_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void CoordinatorProxy::StopAndFlush(
    mojo::ScopedDataPipeProducerHandle in_stream) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::tracing::mojom::internal::Coordinator_StopAndFlush_Params_Data);
  size += mojo::internal::PrepareToSerialize<mojo::ScopedDataPipeProducerHandle>(
      in_stream, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kCoordinator_StopAndFlush_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::tracing::mojom::internal::Coordinator_StopAndFlush_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  mojo::internal::Serialize<mojo::ScopedDataPipeProducerHandle>(
      in_stream, &params->stream, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->stream),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid stream in Coordinator.StopAndFlush request");
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void CoordinatorProxy::IsTracing(
    const IsTracingCallback& callback) {
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::tracing::mojom::internal::Coordinator_IsTracing_Params_Data);
  serialization_context.PrepareMessage(
      internal::kCoordinator_IsTracing_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::tracing::mojom::internal::Coordinator_IsTracing_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  std::unique_ptr<mojo::MessageReceiver> responder(
      new Coordinator_IsTracing_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void CoordinatorProxy::RequestBufferUsage(
    const RequestBufferUsageCallback& callback) {
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::tracing::mojom::internal::Coordinator_RequestBufferUsage_Params_Data);
  serialization_context.PrepareMessage(
      internal::kCoordinator_RequestBufferUsage_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::tracing::mojom::internal::Coordinator_RequestBufferUsage_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  std::unique_ptr<mojo::MessageReceiver> responder(
      new Coordinator_RequestBufferUsage_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void CoordinatorProxy::GetCategories(
    const GetCategoriesCallback& callback) {
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::tracing::mojom::internal::Coordinator_GetCategories_Params_Data);
  serialization_context.PrepareMessage(
      internal::kCoordinator_GetCategories_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::tracing::mojom::internal::Coordinator_GetCategories_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  std::unique_ptr<mojo::MessageReceiver> responder(
      new Coordinator_GetCategories_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}
class Coordinator_StartTracing_ProxyToResponder {
 public:
  static Coordinator::StartTracingCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<Coordinator_StartTracing_ProxyToResponder> proxy(
        new Coordinator_StartTracing_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::Bind(&Coordinator_StartTracing_ProxyToResponder::Run,
                      base::Passed(&proxy));
  }

  ~Coordinator_StartTracing_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // Is the Service destroying the callback without running it
      // and without first closing the pipe?
      responder_->DCheckInvalid("The callback passed to "
          "Coordinator::StartTracing() was never run.");
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  Coordinator_StartTracing_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

  void Run(
      bool in_success);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(Coordinator_StartTracing_ProxyToResponder);
};

bool Coordinator_StartTracing_ForwardToCallback::Accept(
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::Coordinator_StartTracing_ResponseParams_Data* params =
      reinterpret_cast<
          internal::Coordinator_StartTracing_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  bool p_success{};
  Coordinator_StartTracing_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  p_success = input_data_view.success();
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "Coordinator::StartTracing response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_success));
  return true;
}

void Coordinator_StartTracing_ProxyToResponder::Run(
    bool in_success) {
  mojo::Message message;
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::tracing::mojom::internal::Coordinator_StartTracing_ResponseParams_Data);
  serialization_context.PrepareMessage(
      internal::kCoordinator_StartTracing_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::tracing::mojom::internal::Coordinator_StartTracing_ResponseParams_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  params->success = in_success;

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class Coordinator_IsTracing_ProxyToResponder {
 public:
  static Coordinator::IsTracingCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<Coordinator_IsTracing_ProxyToResponder> proxy(
        new Coordinator_IsTracing_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::Bind(&Coordinator_IsTracing_ProxyToResponder::Run,
                      base::Passed(&proxy));
  }

  ~Coordinator_IsTracing_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // Is the Service destroying the callback without running it
      // and without first closing the pipe?
      responder_->DCheckInvalid("The callback passed to "
          "Coordinator::IsTracing() was never run.");
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  Coordinator_IsTracing_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

  void Run(
      bool in_is_tracing);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(Coordinator_IsTracing_ProxyToResponder);
};

bool Coordinator_IsTracing_ForwardToCallback::Accept(
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::Coordinator_IsTracing_ResponseParams_Data* params =
      reinterpret_cast<
          internal::Coordinator_IsTracing_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  bool p_is_tracing{};
  Coordinator_IsTracing_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  p_is_tracing = input_data_view.is_tracing();
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "Coordinator::IsTracing response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_is_tracing));
  return true;
}

void Coordinator_IsTracing_ProxyToResponder::Run(
    bool in_is_tracing) {
  mojo::Message message;
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::tracing::mojom::internal::Coordinator_IsTracing_ResponseParams_Data);
  serialization_context.PrepareMessage(
      internal::kCoordinator_IsTracing_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::tracing::mojom::internal::Coordinator_IsTracing_ResponseParams_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  params->is_tracing = in_is_tracing;

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class Coordinator_RequestBufferUsage_ProxyToResponder {
 public:
  static Coordinator::RequestBufferUsageCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<Coordinator_RequestBufferUsage_ProxyToResponder> proxy(
        new Coordinator_RequestBufferUsage_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::Bind(&Coordinator_RequestBufferUsage_ProxyToResponder::Run,
                      base::Passed(&proxy));
  }

  ~Coordinator_RequestBufferUsage_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // Is the Service destroying the callback without running it
      // and without first closing the pipe?
      responder_->DCheckInvalid("The callback passed to "
          "Coordinator::RequestBufferUsage() was never run.");
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  Coordinator_RequestBufferUsage_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

  void Run(
      bool in_success, float in_percent_full, uint32_t in_approximate_count);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(Coordinator_RequestBufferUsage_ProxyToResponder);
};

bool Coordinator_RequestBufferUsage_ForwardToCallback::Accept(
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::Coordinator_RequestBufferUsage_ResponseParams_Data* params =
      reinterpret_cast<
          internal::Coordinator_RequestBufferUsage_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  bool p_success{};
  float p_percent_full{};
  uint32_t p_approximate_count{};
  Coordinator_RequestBufferUsage_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  p_success = input_data_view.success();
  p_percent_full = input_data_view.percent_full();
  p_approximate_count = input_data_view.approximate_count();
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "Coordinator::RequestBufferUsage response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_success), 
std::move(p_percent_full), 
std::move(p_approximate_count));
  return true;
}

void Coordinator_RequestBufferUsage_ProxyToResponder::Run(
    bool in_success, float in_percent_full, uint32_t in_approximate_count) {
  mojo::Message message;
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::tracing::mojom::internal::Coordinator_RequestBufferUsage_ResponseParams_Data);
  serialization_context.PrepareMessage(
      internal::kCoordinator_RequestBufferUsage_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::tracing::mojom::internal::Coordinator_RequestBufferUsage_ResponseParams_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  params->success = in_success;
  params->percent_full = in_percent_full;
  params->approximate_count = in_approximate_count;

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class Coordinator_GetCategories_ProxyToResponder {
 public:
  static Coordinator::GetCategoriesCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<Coordinator_GetCategories_ProxyToResponder> proxy(
        new Coordinator_GetCategories_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::Bind(&Coordinator_GetCategories_ProxyToResponder::Run,
                      base::Passed(&proxy));
  }

  ~Coordinator_GetCategories_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // Is the Service destroying the callback without running it
      // and without first closing the pipe?
      responder_->DCheckInvalid("The callback passed to "
          "Coordinator::GetCategories() was never run.");
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  Coordinator_GetCategories_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

  void Run(
      bool in_success, const std::string& in_categories);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(Coordinator_GetCategories_ProxyToResponder);
};

bool Coordinator_GetCategories_ForwardToCallback::Accept(
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::Coordinator_GetCategories_ResponseParams_Data* params =
      reinterpret_cast<
          internal::Coordinator_GetCategories_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  bool p_success{};
  std::string p_categories{};
  Coordinator_GetCategories_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  p_success = input_data_view.success();
  if (!input_data_view.ReadCategories(&p_categories))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "Coordinator::GetCategories response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_success), 
std::move(p_categories));
  return true;
}

void Coordinator_GetCategories_ProxyToResponder::Run(
    bool in_success, const std::string& in_categories) {
  mojo::Message message;
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::tracing::mojom::internal::Coordinator_GetCategories_ResponseParams_Data);
  size += mojo::internal::PrepareToSerialize<mojo::StringDataView>(
      in_categories, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kCoordinator_GetCategories_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::tracing::mojom::internal::Coordinator_GetCategories_ResponseParams_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  params->success = in_success;
  typename decltype(params->categories)::BaseType* categories_ptr;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_categories, buffer, &categories_ptr, &serialization_context);
  params->categories.Set(categories_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->categories.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null categories in ");

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}

// static
bool CoordinatorStubDispatch::Accept(
    Coordinator* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kCoordinator_StartTracing_Name: {
      break;
    }
    case internal::kCoordinator_StopAndFlush_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::Coordinator_StopAndFlush_Params_Data* params =
          reinterpret_cast<internal::Coordinator_StopAndFlush_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      mojo::ScopedDataPipeProducerHandle p_stream{};
      Coordinator_StopAndFlush_ParamsDataView input_data_view(params, &serialization_context);
      
      p_stream = input_data_view.TakeStream();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "Coordinator::StopAndFlush deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->StopAndFlush(
std::move(p_stream));
      return true;
    }
    case internal::kCoordinator_IsTracing_Name: {
      break;
    }
    case internal::kCoordinator_RequestBufferUsage_Name: {
      break;
    }
    case internal::kCoordinator_GetCategories_Name: {
      break;
    }
  }
  return false;
}

// static
bool CoordinatorStubDispatch::AcceptWithResponder(
    Coordinator* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kCoordinator_StartTracing_Name: {
      mojo::internal::MessageDispatchContext context(message);

      internal::Coordinator_StartTracing_Params_Data* params =
          reinterpret_cast<
              internal::Coordinator_StartTracing_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      std::string p_config{};
      Coordinator_StartTracing_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadConfig(&p_config))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "Coordinator::StartTracing deserializer");
        return false;
      }
      Coordinator::StartTracingCallback callback =
          Coordinator_StartTracing_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->StartTracing(
std::move(p_config), std::move(callback));
      return true;
    }
    case internal::kCoordinator_StopAndFlush_Name: {
      break;
    }
    case internal::kCoordinator_IsTracing_Name: {
      mojo::internal::MessageDispatchContext context(message);

      internal::Coordinator_IsTracing_Params_Data* params =
          reinterpret_cast<
              internal::Coordinator_IsTracing_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      Coordinator_IsTracing_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "Coordinator::IsTracing deserializer");
        return false;
      }
      Coordinator::IsTracingCallback callback =
          Coordinator_IsTracing_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->IsTracing(std::move(callback));
      return true;
    }
    case internal::kCoordinator_RequestBufferUsage_Name: {
      mojo::internal::MessageDispatchContext context(message);

      internal::Coordinator_RequestBufferUsage_Params_Data* params =
          reinterpret_cast<
              internal::Coordinator_RequestBufferUsage_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      Coordinator_RequestBufferUsage_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "Coordinator::RequestBufferUsage deserializer");
        return false;
      }
      Coordinator::RequestBufferUsageCallback callback =
          Coordinator_RequestBufferUsage_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->RequestBufferUsage(std::move(callback));
      return true;
    }
    case internal::kCoordinator_GetCategories_Name: {
      mojo::internal::MessageDispatchContext context(message);

      internal::Coordinator_GetCategories_Params_Data* params =
          reinterpret_cast<
              internal::Coordinator_GetCategories_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      Coordinator_GetCategories_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "Coordinator::GetCategories deserializer");
        return false;
      }
      Coordinator::GetCategoriesCallback callback =
          Coordinator_GetCategories_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->GetCategories(std::move(callback));
      return true;
    }
  }
  return false;
}

bool CoordinatorRequestValidator::Accept(mojo::Message* message) {
  if (mojo::internal::IsUnserializedOrControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "Coordinator RequestValidator");

  switch (message->header()->name) {
    case internal::kCoordinator_StartTracing_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::Coordinator_StartTracing_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kCoordinator_StopAndFlush_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::Coordinator_StopAndFlush_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kCoordinator_IsTracing_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::Coordinator_IsTracing_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kCoordinator_RequestBufferUsage_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::Coordinator_RequestBufferUsage_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kCoordinator_GetCategories_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::Coordinator_GetCategories_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

bool CoordinatorResponseValidator::Accept(mojo::Message* message) {
  if (mojo::internal::IsUnserializedOrControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "Coordinator ResponseValidator");

  if (!mojo::internal::ValidateMessageIsResponse(message, &validation_context))
    return false;
  switch (message->header()->name) {
    case internal::kCoordinator_StartTracing_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::Coordinator_StartTracing_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kCoordinator_IsTracing_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::Coordinator_IsTracing_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kCoordinator_RequestBufferUsage_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::Coordinator_RequestBufferUsage_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kCoordinator_GetCategories_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::Coordinator_GetCategories_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}
}  // namespace mojom
}  // namespace tracing

namespace mojo {

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif