// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_UI_GPU_INTERFACES_GPU_SERVICE_MOJOM_SHARED_INTERNAL_H_
#define SERVICES_UI_GPU_INTERFACES_GPU_SERVICE_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/native_struct_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "gpu/ipc/common/gpu_info.mojom-shared-internal.h"
#include "gpu/ipc/common/memory_stats.mojom-shared-internal.h"
#include "gpu/ipc/common/surface_handle.mojom-shared-internal.h"
#include "gpu/ipc/common/sync_token.mojom-shared-internal.h"
#include "media/gpu/mojo/jpeg_decoder.mojom-shared-internal.h"
#include "media/mojo/interfaces/video_encode_accelerator.mojom-shared-internal.h"
#include "ui/gfx/geometry/mojo/geometry.mojom-shared-internal.h"
#include "ui/gfx/mojo/buffer_types.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace ui {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
constexpr uint32_t kGpuService_EstablishGpuChannel_Name = 0;
class  GpuService_EstablishGpuChannel_Params_Data {
 public:
  static GpuService_EstablishGpuChannel_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t client_id;
  uint8_t is_gpu_host : 1;
  uint8_t pad1_[3];
  uint64_t client_tracing_id;

 private:
  GpuService_EstablishGpuChannel_Params_Data();
  ~GpuService_EstablishGpuChannel_Params_Data() = delete;
};
static_assert(sizeof(GpuService_EstablishGpuChannel_Params_Data) == 24,
              "Bad sizeof(GpuService_EstablishGpuChannel_Params_Data)");
class  GpuService_EstablishGpuChannel_ResponseParams_Data {
 public:
  static GpuService_EstablishGpuChannel_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data channel_handle;
  uint8_t padfinal_[4];

 private:
  GpuService_EstablishGpuChannel_ResponseParams_Data();
  ~GpuService_EstablishGpuChannel_ResponseParams_Data() = delete;
};
static_assert(sizeof(GpuService_EstablishGpuChannel_ResponseParams_Data) == 16,
              "Bad sizeof(GpuService_EstablishGpuChannel_ResponseParams_Data)");
constexpr uint32_t kGpuService_CloseChannel_Name = 1;
class  GpuService_CloseChannel_Params_Data {
 public:
  static GpuService_CloseChannel_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t client_id;
  uint8_t padfinal_[4];

 private:
  GpuService_CloseChannel_Params_Data();
  ~GpuService_CloseChannel_Params_Data() = delete;
};
static_assert(sizeof(GpuService_CloseChannel_Params_Data) == 16,
              "Bad sizeof(GpuService_CloseChannel_Params_Data)");
constexpr uint32_t kGpuService_CreateJpegDecodeAccelerator_Name = 2;
class  GpuService_CreateJpegDecodeAccelerator_Params_Data {
 public:
  static GpuService_CreateJpegDecodeAccelerator_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data jda;
  uint8_t padfinal_[4];

 private:
  GpuService_CreateJpegDecodeAccelerator_Params_Data();
  ~GpuService_CreateJpegDecodeAccelerator_Params_Data() = delete;
};
static_assert(sizeof(GpuService_CreateJpegDecodeAccelerator_Params_Data) == 16,
              "Bad sizeof(GpuService_CreateJpegDecodeAccelerator_Params_Data)");
constexpr uint32_t kGpuService_CreateVideoEncodeAccelerator_Name = 3;
class  GpuService_CreateVideoEncodeAccelerator_Params_Data {
 public:
  static GpuService_CreateVideoEncodeAccelerator_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data vea;
  uint8_t padfinal_[4];

 private:
  GpuService_CreateVideoEncodeAccelerator_Params_Data();
  ~GpuService_CreateVideoEncodeAccelerator_Params_Data() = delete;
};
static_assert(sizeof(GpuService_CreateVideoEncodeAccelerator_Params_Data) == 16,
              "Bad sizeof(GpuService_CreateVideoEncodeAccelerator_Params_Data)");
constexpr uint32_t kGpuService_CreateGpuMemoryBuffer_Name = 4;
class  GpuService_CreateGpuMemoryBuffer_Params_Data {
 public:
  static GpuService_CreateGpuMemoryBuffer_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::gfx::mojom::internal::GpuMemoryBufferId_Data> id;
  mojo::internal::Pointer<::gfx::mojom::internal::Size_Data> size;
  int32_t format;
  int32_t usage;
  int32_t client_id;
  uint8_t pad4_[4];
  mojo::internal::Pointer<::gpu::mojom::internal::SurfaceHandle_Data> surface_handle;

 private:
  GpuService_CreateGpuMemoryBuffer_Params_Data();
  ~GpuService_CreateGpuMemoryBuffer_Params_Data() = delete;
};
static_assert(sizeof(GpuService_CreateGpuMemoryBuffer_Params_Data) == 48,
              "Bad sizeof(GpuService_CreateGpuMemoryBuffer_Params_Data)");
class  GpuService_CreateGpuMemoryBuffer_ResponseParams_Data {
 public:
  static GpuService_CreateGpuMemoryBuffer_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::gfx::mojom::internal::GpuMemoryBufferHandle_Data> buffer_handle;

 private:
  GpuService_CreateGpuMemoryBuffer_ResponseParams_Data();
  ~GpuService_CreateGpuMemoryBuffer_ResponseParams_Data() = delete;
};
static_assert(sizeof(GpuService_CreateGpuMemoryBuffer_ResponseParams_Data) == 16,
              "Bad sizeof(GpuService_CreateGpuMemoryBuffer_ResponseParams_Data)");
constexpr uint32_t kGpuService_DestroyGpuMemoryBuffer_Name = 5;
class  GpuService_DestroyGpuMemoryBuffer_Params_Data {
 public:
  static GpuService_DestroyGpuMemoryBuffer_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::gfx::mojom::internal::GpuMemoryBufferId_Data> id;
  int32_t client_id;
  uint8_t pad1_[4];
  mojo::internal::Pointer<::gpu::mojom::internal::SyncToken_Data> sync_token;

 private:
  GpuService_DestroyGpuMemoryBuffer_Params_Data();
  ~GpuService_DestroyGpuMemoryBuffer_Params_Data() = delete;
};
static_assert(sizeof(GpuService_DestroyGpuMemoryBuffer_Params_Data) == 32,
              "Bad sizeof(GpuService_DestroyGpuMemoryBuffer_Params_Data)");
constexpr uint32_t kGpuService_GetVideoMemoryUsageStats_Name = 6;
class  GpuService_GetVideoMemoryUsageStats_Params_Data {
 public:
  static GpuService_GetVideoMemoryUsageStats_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  GpuService_GetVideoMemoryUsageStats_Params_Data();
  ~GpuService_GetVideoMemoryUsageStats_Params_Data() = delete;
};
static_assert(sizeof(GpuService_GetVideoMemoryUsageStats_Params_Data) == 8,
              "Bad sizeof(GpuService_GetVideoMemoryUsageStats_Params_Data)");
class  GpuService_GetVideoMemoryUsageStats_ResponseParams_Data {
 public:
  static GpuService_GetVideoMemoryUsageStats_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::gpu::mojom::internal::VideoMemoryUsageStats_Data> stats;

 private:
  GpuService_GetVideoMemoryUsageStats_ResponseParams_Data();
  ~GpuService_GetVideoMemoryUsageStats_ResponseParams_Data() = delete;
};
static_assert(sizeof(GpuService_GetVideoMemoryUsageStats_ResponseParams_Data) == 16,
              "Bad sizeof(GpuService_GetVideoMemoryUsageStats_ResponseParams_Data)");
constexpr uint32_t kGpuService_RequestCompleteGpuInfo_Name = 7;
class  GpuService_RequestCompleteGpuInfo_Params_Data {
 public:
  static GpuService_RequestCompleteGpuInfo_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  GpuService_RequestCompleteGpuInfo_Params_Data();
  ~GpuService_RequestCompleteGpuInfo_Params_Data() = delete;
};
static_assert(sizeof(GpuService_RequestCompleteGpuInfo_Params_Data) == 8,
              "Bad sizeof(GpuService_RequestCompleteGpuInfo_Params_Data)");
class  GpuService_RequestCompleteGpuInfo_ResponseParams_Data {
 public:
  static GpuService_RequestCompleteGpuInfo_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::gpu::mojom::internal::GpuInfo_Data> gpu_info;

 private:
  GpuService_RequestCompleteGpuInfo_ResponseParams_Data();
  ~GpuService_RequestCompleteGpuInfo_ResponseParams_Data() = delete;
};
static_assert(sizeof(GpuService_RequestCompleteGpuInfo_ResponseParams_Data) == 16,
              "Bad sizeof(GpuService_RequestCompleteGpuInfo_ResponseParams_Data)");
constexpr uint32_t kGpuService_LoadedShader_Name = 8;
class  GpuService_LoadedShader_Params_Data {
 public:
  static GpuService_LoadedShader_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> key;
  mojo::internal::Pointer<mojo::internal::String_Data> data;

 private:
  GpuService_LoadedShader_Params_Data();
  ~GpuService_LoadedShader_Params_Data() = delete;
};
static_assert(sizeof(GpuService_LoadedShader_Params_Data) == 24,
              "Bad sizeof(GpuService_LoadedShader_Params_Data)");
constexpr uint32_t kGpuService_DestroyingVideoSurface_Name = 9;
class  GpuService_DestroyingVideoSurface_Params_Data {
 public:
  static GpuService_DestroyingVideoSurface_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t surface_id;
  uint8_t padfinal_[4];

 private:
  GpuService_DestroyingVideoSurface_Params_Data();
  ~GpuService_DestroyingVideoSurface_Params_Data() = delete;
};
static_assert(sizeof(GpuService_DestroyingVideoSurface_Params_Data) == 16,
              "Bad sizeof(GpuService_DestroyingVideoSurface_Params_Data)");
class  GpuService_DestroyingVideoSurface_ResponseParams_Data {
 public:
  static GpuService_DestroyingVideoSurface_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  GpuService_DestroyingVideoSurface_ResponseParams_Data();
  ~GpuService_DestroyingVideoSurface_ResponseParams_Data() = delete;
};
static_assert(sizeof(GpuService_DestroyingVideoSurface_ResponseParams_Data) == 8,
              "Bad sizeof(GpuService_DestroyingVideoSurface_ResponseParams_Data)");
constexpr uint32_t kGpuService_WakeUpGpu_Name = 10;
class  GpuService_WakeUpGpu_Params_Data {
 public:
  static GpuService_WakeUpGpu_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  GpuService_WakeUpGpu_Params_Data();
  ~GpuService_WakeUpGpu_Params_Data() = delete;
};
static_assert(sizeof(GpuService_WakeUpGpu_Params_Data) == 8,
              "Bad sizeof(GpuService_WakeUpGpu_Params_Data)");
constexpr uint32_t kGpuService_GpuSwitched_Name = 11;
class  GpuService_GpuSwitched_Params_Data {
 public:
  static GpuService_GpuSwitched_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  GpuService_GpuSwitched_Params_Data();
  ~GpuService_GpuSwitched_Params_Data() = delete;
};
static_assert(sizeof(GpuService_GpuSwitched_Params_Data) == 8,
              "Bad sizeof(GpuService_GpuSwitched_Params_Data)");
constexpr uint32_t kGpuService_DestroyAllChannels_Name = 12;
class  GpuService_DestroyAllChannels_Params_Data {
 public:
  static GpuService_DestroyAllChannels_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  GpuService_DestroyAllChannels_Params_Data();
  ~GpuService_DestroyAllChannels_Params_Data() = delete;
};
static_assert(sizeof(GpuService_DestroyAllChannels_Params_Data) == 8,
              "Bad sizeof(GpuService_DestroyAllChannels_Params_Data)");
constexpr uint32_t kGpuService_Crash_Name = 13;
class  GpuService_Crash_Params_Data {
 public:
  static GpuService_Crash_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  GpuService_Crash_Params_Data();
  ~GpuService_Crash_Params_Data() = delete;
};
static_assert(sizeof(GpuService_Crash_Params_Data) == 8,
              "Bad sizeof(GpuService_Crash_Params_Data)");
constexpr uint32_t kGpuService_Hang_Name = 14;
class  GpuService_Hang_Params_Data {
 public:
  static GpuService_Hang_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  GpuService_Hang_Params_Data();
  ~GpuService_Hang_Params_Data() = delete;
};
static_assert(sizeof(GpuService_Hang_Params_Data) == 8,
              "Bad sizeof(GpuService_Hang_Params_Data)");
constexpr uint32_t kGpuService_ThrowJavaException_Name = 15;
class  GpuService_ThrowJavaException_Params_Data {
 public:
  static GpuService_ThrowJavaException_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  GpuService_ThrowJavaException_Params_Data();
  ~GpuService_ThrowJavaException_Params_Data() = delete;
};
static_assert(sizeof(GpuService_ThrowJavaException_Params_Data) == 8,
              "Bad sizeof(GpuService_ThrowJavaException_Params_Data)");
constexpr uint32_t kGpuService_Stop_Name = 16;
class  GpuService_Stop_Params_Data {
 public:
  static GpuService_Stop_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  GpuService_Stop_Params_Data();
  ~GpuService_Stop_Params_Data() = delete;
};
static_assert(sizeof(GpuService_Stop_Params_Data) == 8,
              "Bad sizeof(GpuService_Stop_Params_Data)");
class  GpuService_Stop_ResponseParams_Data {
 public:
  static GpuService_Stop_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  GpuService_Stop_ResponseParams_Data();
  ~GpuService_Stop_ResponseParams_Data() = delete;
};
static_assert(sizeof(GpuService_Stop_ResponseParams_Data) == 8,
              "Bad sizeof(GpuService_Stop_ResponseParams_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace ui

#endif  // SERVICES_UI_GPU_INTERFACES_GPU_SERVICE_MOJOM_SHARED_INTERNAL_H_