// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "services/ui/public/interfaces/display/output_protection.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
namespace display {
namespace mojom {
const char OutputProtection::Name_[] = "display::mojom::OutputProtection";

class OutputProtection_QueryContentProtectionStatus_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  OutputProtection_QueryContentProtectionStatus_ForwardToCallback(
      const OutputProtection::QueryContentProtectionStatusCallback& callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  OutputProtection::QueryContentProtectionStatusCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(OutputProtection_QueryContentProtectionStatus_ForwardToCallback);
};

class OutputProtection_SetContentProtection_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  OutputProtection_SetContentProtection_ForwardToCallback(
      const OutputProtection::SetContentProtectionCallback& callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  OutputProtection::SetContentProtectionCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(OutputProtection_SetContentProtection_ForwardToCallback);
};

OutputProtectionProxy::OutputProtectionProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void OutputProtectionProxy::QueryContentProtectionStatus(
    int64_t in_display_id, const QueryContentProtectionStatusCallback& callback) {
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::display::mojom::internal::OutputProtection_QueryContentProtectionStatus_Params_Data);
  serialization_context.PrepareMessage(
      internal::kOutputProtection_QueryContentProtectionStatus_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::display::mojom::internal::OutputProtection_QueryContentProtectionStatus_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  params->display_id = in_display_id;
  std::unique_ptr<mojo::MessageReceiver> responder(
      new OutputProtection_QueryContentProtectionStatus_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void OutputProtectionProxy::SetContentProtection(
    int64_t in_display_id, uint32_t in_desired_method_mask, const SetContentProtectionCallback& callback) {
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::display::mojom::internal::OutputProtection_SetContentProtection_Params_Data);
  serialization_context.PrepareMessage(
      internal::kOutputProtection_SetContentProtection_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::display::mojom::internal::OutputProtection_SetContentProtection_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  params->display_id = in_display_id;
  params->desired_method_mask = in_desired_method_mask;
  std::unique_ptr<mojo::MessageReceiver> responder(
      new OutputProtection_SetContentProtection_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}
class OutputProtection_QueryContentProtectionStatus_ProxyToResponder {
 public:
  static OutputProtection::QueryContentProtectionStatusCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<OutputProtection_QueryContentProtectionStatus_ProxyToResponder> proxy(
        new OutputProtection_QueryContentProtectionStatus_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::Bind(&OutputProtection_QueryContentProtectionStatus_ProxyToResponder::Run,
                      base::Passed(&proxy));
  }

  ~OutputProtection_QueryContentProtectionStatus_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // Is the Service destroying the callback without running it
      // and without first closing the pipe?
      responder_->DCheckInvalid("The callback passed to "
          "OutputProtection::QueryContentProtectionStatus() was never run.");
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  OutputProtection_QueryContentProtectionStatus_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

  void Run(
      bool in_success, uint32_t in_link_mask, uint32_t in_protection_mask);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(OutputProtection_QueryContentProtectionStatus_ProxyToResponder);
};

bool OutputProtection_QueryContentProtectionStatus_ForwardToCallback::Accept(
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::OutputProtection_QueryContentProtectionStatus_ResponseParams_Data* params =
      reinterpret_cast<
          internal::OutputProtection_QueryContentProtectionStatus_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  bool p_success{};
  uint32_t p_link_mask{};
  uint32_t p_protection_mask{};
  OutputProtection_QueryContentProtectionStatus_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  p_success = input_data_view.success();
  p_link_mask = input_data_view.link_mask();
  p_protection_mask = input_data_view.protection_mask();
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "OutputProtection::QueryContentProtectionStatus response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_success), 
std::move(p_link_mask), 
std::move(p_protection_mask));
  return true;
}

void OutputProtection_QueryContentProtectionStatus_ProxyToResponder::Run(
    bool in_success, uint32_t in_link_mask, uint32_t in_protection_mask) {
  mojo::Message message;
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::display::mojom::internal::OutputProtection_QueryContentProtectionStatus_ResponseParams_Data);
  serialization_context.PrepareMessage(
      internal::kOutputProtection_QueryContentProtectionStatus_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::display::mojom::internal::OutputProtection_QueryContentProtectionStatus_ResponseParams_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  params->success = in_success;
  params->link_mask = in_link_mask;
  params->protection_mask = in_protection_mask;

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class OutputProtection_SetContentProtection_ProxyToResponder {
 public:
  static OutputProtection::SetContentProtectionCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<OutputProtection_SetContentProtection_ProxyToResponder> proxy(
        new OutputProtection_SetContentProtection_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::Bind(&OutputProtection_SetContentProtection_ProxyToResponder::Run,
                      base::Passed(&proxy));
  }

  ~OutputProtection_SetContentProtection_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // Is the Service destroying the callback without running it
      // and without first closing the pipe?
      responder_->DCheckInvalid("The callback passed to "
          "OutputProtection::SetContentProtection() was never run.");
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  OutputProtection_SetContentProtection_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

  void Run(
      bool in_success);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(OutputProtection_SetContentProtection_ProxyToResponder);
};

bool OutputProtection_SetContentProtection_ForwardToCallback::Accept(
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::OutputProtection_SetContentProtection_ResponseParams_Data* params =
      reinterpret_cast<
          internal::OutputProtection_SetContentProtection_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  bool p_success{};
  OutputProtection_SetContentProtection_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  p_success = input_data_view.success();
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "OutputProtection::SetContentProtection response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_success));
  return true;
}

void OutputProtection_SetContentProtection_ProxyToResponder::Run(
    bool in_success) {
  mojo::Message message;
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::display::mojom::internal::OutputProtection_SetContentProtection_ResponseParams_Data);
  serialization_context.PrepareMessage(
      internal::kOutputProtection_SetContentProtection_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::display::mojom::internal::OutputProtection_SetContentProtection_ResponseParams_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  params->success = in_success;

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}

// static
bool OutputProtectionStubDispatch::Accept(
    OutputProtection* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kOutputProtection_QueryContentProtectionStatus_Name: {
      break;
    }
    case internal::kOutputProtection_SetContentProtection_Name: {
      break;
    }
  }
  return false;
}

// static
bool OutputProtectionStubDispatch::AcceptWithResponder(
    OutputProtection* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kOutputProtection_QueryContentProtectionStatus_Name: {
      mojo::internal::MessageDispatchContext context(message);

      internal::OutputProtection_QueryContentProtectionStatus_Params_Data* params =
          reinterpret_cast<
              internal::OutputProtection_QueryContentProtectionStatus_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      int64_t p_display_id{};
      OutputProtection_QueryContentProtectionStatus_ParamsDataView input_data_view(params, &serialization_context);
      
      p_display_id = input_data_view.display_id();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "OutputProtection::QueryContentProtectionStatus deserializer");
        return false;
      }
      OutputProtection::QueryContentProtectionStatusCallback callback =
          OutputProtection_QueryContentProtectionStatus_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->QueryContentProtectionStatus(
std::move(p_display_id), std::move(callback));
      return true;
    }
    case internal::kOutputProtection_SetContentProtection_Name: {
      mojo::internal::MessageDispatchContext context(message);

      internal::OutputProtection_SetContentProtection_Params_Data* params =
          reinterpret_cast<
              internal::OutputProtection_SetContentProtection_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      int64_t p_display_id{};
      uint32_t p_desired_method_mask{};
      OutputProtection_SetContentProtection_ParamsDataView input_data_view(params, &serialization_context);
      
      p_display_id = input_data_view.display_id();
      p_desired_method_mask = input_data_view.desired_method_mask();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "OutputProtection::SetContentProtection deserializer");
        return false;
      }
      OutputProtection::SetContentProtectionCallback callback =
          OutputProtection_SetContentProtection_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->SetContentProtection(
std::move(p_display_id), 
std::move(p_desired_method_mask), std::move(callback));
      return true;
    }
  }
  return false;
}

bool OutputProtectionRequestValidator::Accept(mojo::Message* message) {
  if (mojo::internal::IsUnserializedOrControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "OutputProtection RequestValidator");

  switch (message->header()->name) {
    case internal::kOutputProtection_QueryContentProtectionStatus_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::OutputProtection_QueryContentProtectionStatus_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kOutputProtection_SetContentProtection_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::OutputProtection_SetContentProtection_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

bool OutputProtectionResponseValidator::Accept(mojo::Message* message) {
  if (mojo::internal::IsUnserializedOrControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "OutputProtection ResponseValidator");

  if (!mojo::internal::ValidateMessageIsResponse(message, &validation_context))
    return false;
  switch (message->header()->name) {
    case internal::kOutputProtection_QueryContentProtectionStatus_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::OutputProtection_QueryContentProtectionStatus_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kOutputProtection_SetContentProtection_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::OutputProtection_SetContentProtection_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}
}  // namespace mojom
}  // namespace display

namespace mojo {

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif