// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_UI_PUBLIC_INTERFACES_DISPLAY_TEST_DISPLAY_CONTROLLER_MOJOM_H_
#define SERVICES_UI_PUBLIC_INTERFACES_DISPLAY_TEST_DISPLAY_CONTROLLER_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/lib/control_message_proxy.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/native_struct.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "services/ui/public/interfaces/display/test_display_controller.mojom-shared.h"
#include <string>
#include <vector>


namespace display {
namespace mojom {
class TestDisplayController;
using TestDisplayControllerPtr = mojo::InterfacePtr<TestDisplayController>;
using TestDisplayControllerPtrInfo = mojo::InterfacePtrInfo<TestDisplayController>;
using ThreadSafeTestDisplayControllerPtr =
    mojo::ThreadSafeInterfacePtr<TestDisplayController>;
using TestDisplayControllerRequest = mojo::InterfaceRequest<TestDisplayController>;
using TestDisplayControllerAssociatedPtr =
    mojo::AssociatedInterfacePtr<TestDisplayController>;
using ThreadSafeTestDisplayControllerAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<TestDisplayController>;
using TestDisplayControllerAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<TestDisplayController>;
using TestDisplayControllerAssociatedRequest =
    mojo::AssociatedInterfaceRequest<TestDisplayController>;


class TestDisplayControllerProxy;

template <typename ImplRefTraits>
class TestDisplayControllerStub;

class TestDisplayControllerRequestValidator;

class  TestDisplayController
    : public TestDisplayControllerInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Proxy_ = TestDisplayControllerProxy;

  template <typename ImplRefTraits>
  using Stub_ = TestDisplayControllerStub<ImplRefTraits>;

  using RequestValidator_ = TestDisplayControllerRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kToggleAddRemoveDisplayMinVersion = 0,
  };
  virtual ~TestDisplayController() {}

  virtual void ToggleAddRemoveDisplay() = 0;
};

class  TestDisplayControllerProxy
    : public TestDisplayController {
 public:
  explicit TestDisplayControllerProxy(mojo::MessageReceiverWithResponder* receiver);
  void ToggleAddRemoveDisplay() override;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  TestDisplayControllerStubDispatch {
 public:
  static bool Accept(TestDisplayController* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      TestDisplayController* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<TestDisplayController>>
class TestDisplayControllerStub
    : public NON_EXPORTED_BASE(mojo::MessageReceiverWithResponderStatus) {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  TestDisplayControllerStub() {}
  ~TestDisplayControllerStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return TestDisplayControllerStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return TestDisplayControllerStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  TestDisplayControllerRequestValidator : public NON_EXPORTED_BASE(mojo::MessageReceiver) {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // namespace mojom
}  // namespace display

namespace mojo {

}  // namespace mojo

#endif  // SERVICES_UI_PUBLIC_INTERFACES_DISPLAY_TEST_DISPLAY_CONTROLLER_MOJOM_H_