// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_NOTIFICATIONS_NOTIFICATION_MOJOM_BLINK_H_
#define THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_NOTIFICATIONS_NOTIFICATION_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/lib/control_message_proxy.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/native_struct.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "third_party/WebKit/public/platform/modules/notifications/notification.mojom-shared.h"

#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/WebKit/Source/platform/wtf/HashFunctions.h"
#include "third_party/WebKit/Source/platform/wtf/Optional.h"
#include "third_party/WebKit/Source/platform/wtf/text/WTFString.h"
#include "third_party/WebKit/public/platform/WebCommon.h"


namespace WTF {
struct blink_mojom_internal_NotificationActionType_DataHashFn {
  static unsigned GetHash(const ::blink::mojom::NotificationActionType& value) {
    using utype = std::underlying_type<::blink::mojom::NotificationActionType>::type;
    return DefaultHash<utype>::Hash().GetHash(static_cast<utype>(value));
  }
  static bool Equal(const ::blink::mojom::NotificationActionType& left, const ::blink::mojom::NotificationActionType& right) {
    return left == right;
  }
  static const bool safe_to_compare_to_empty_or_deleted = true;
};

template <>
struct DefaultHash<::blink::mojom::NotificationActionType> {
  using Hash = blink_mojom_internal_NotificationActionType_DataHashFn;
};

template <>
struct HashTraits<::blink::mojom::NotificationActionType>
    : public GenericHashTraits<::blink::mojom::NotificationActionType> {
  static_assert(true,
                "-1000000 is a reserved enum value");
  static_assert(true,
                "-1000001 is a reserved enum value");
  static const bool hasIsEmptyValueFunction = true;
  static bool IsEmptyValue(const ::blink::mojom::NotificationActionType& value) {
    return value == static_cast<::blink::mojom::NotificationActionType>(-1000000);
  }
  static void ConstructDeletedValue(::blink::mojom::NotificationActionType& slot, bool) {
    slot = static_cast<::blink::mojom::NotificationActionType>(-1000001);
  }
  static bool IsDeletedValue(const ::blink::mojom::NotificationActionType& value) {
    return value == static_cast<::blink::mojom::NotificationActionType>(-1000001);
  }
};
}  // namespace WTF


namespace WTF {
struct blink_mojom_internal_NotificationDirection_DataHashFn {
  static unsigned GetHash(const ::blink::mojom::NotificationDirection& value) {
    using utype = std::underlying_type<::blink::mojom::NotificationDirection>::type;
    return DefaultHash<utype>::Hash().GetHash(static_cast<utype>(value));
  }
  static bool Equal(const ::blink::mojom::NotificationDirection& left, const ::blink::mojom::NotificationDirection& right) {
    return left == right;
  }
  static const bool safe_to_compare_to_empty_or_deleted = true;
};

template <>
struct DefaultHash<::blink::mojom::NotificationDirection> {
  using Hash = blink_mojom_internal_NotificationDirection_DataHashFn;
};

template <>
struct HashTraits<::blink::mojom::NotificationDirection>
    : public GenericHashTraits<::blink::mojom::NotificationDirection> {
  static_assert(true,
                "-1000000 is a reserved enum value");
  static_assert(true,
                "-1000001 is a reserved enum value");
  static const bool hasIsEmptyValueFunction = true;
  static bool IsEmptyValue(const ::blink::mojom::NotificationDirection& value) {
    return value == static_cast<::blink::mojom::NotificationDirection>(-1000000);
  }
  static void ConstructDeletedValue(::blink::mojom::NotificationDirection& slot, bool) {
    slot = static_cast<::blink::mojom::NotificationDirection>(-1000001);
  }
  static bool IsDeletedValue(const ::blink::mojom::NotificationDirection& value) {
    return value == static_cast<::blink::mojom::NotificationDirection>(-1000001);
  }
};
}  // namespace WTF


namespace blink {
namespace mojom {
namespace blink {
using NotificationActionType = NotificationActionType;  // Alias for definition in the parent namespace.
using NotificationDirection = NotificationDirection;  // Alias for definition in the parent namespace.
class NotificationAction;
using NotificationActionPtr = mojo::StructPtr<NotificationAction>;

class Notification;
using NotificationPtr = mojo::StructPtr<Notification>;







class BLINK_PLATFORM_EXPORT NotificationAction {
 public:
  using DataView = NotificationActionDataView;
  using Data_ = internal::NotificationAction_Data;

  template <typename... Args>
  static NotificationActionPtr New(Args&&... args) {
    return NotificationActionPtr(
        base::in_place,
        std::forward<Args>(args)...);
  }

  template <typename U>
  static NotificationActionPtr From(const U& u) {
    return mojo::TypeConverter<NotificationActionPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, NotificationAction>::Convert(*this);
  }


  NotificationAction();

  NotificationAction(
      NotificationActionType type,
      const WTF::String& action,
      const WTF::String& title,
      const WTF::String& icon,
      const WTF::String& placeholder);

  ~NotificationAction();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = NotificationActionPtr>
  NotificationActionPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, NotificationAction>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::StructSerializeImpl<
        NotificationAction::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return mojo::internal::StructDeserializeImpl<
        NotificationAction::DataView, WTF::Vector<uint8_t>>(
            input, output, Validate);
  }

  NotificationActionType type;
  WTF::String action;
  WTF::String title;
  WTF::String icon;
  WTF::String placeholder;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};



class BLINK_PLATFORM_EXPORT Notification {
 public:
  using DataView = NotificationDataView;
  using Data_ = internal::Notification_Data;
  static constexpr int32_t kMaximumDeveloperDataBytes = 1048576;

  template <typename... Args>
  static NotificationPtr New(Args&&... args) {
    return NotificationPtr(
        base::in_place,
        std::forward<Args>(args)...);
  }

  template <typename U>
  static NotificationPtr From(const U& u) {
    return mojo::TypeConverter<NotificationPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, Notification>::Convert(*this);
  }


  Notification();

  Notification(
      const WTF::String& title,
      NotificationDirection direction,
      const WTF::String& lang,
      const WTF::String& body,
      const WTF::String& tag,
      const WTF::String& icon,
      const WTF::String& badge,
      const WTF::Vector<uint32_t>& vibration_pattern,
      double timestamp,
      bool renotify,
      bool silent,
      bool require_interaction,
      const WTF::Vector<int8_t>& data,
      WTF::Vector<NotificationActionPtr> actions);

  ~Notification();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = NotificationPtr>
  NotificationPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, Notification>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::StructSerializeImpl<
        Notification::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return mojo::internal::StructDeserializeImpl<
        Notification::DataView, WTF::Vector<uint8_t>>(
            input, output, Validate);
  }

  WTF::String title;
  NotificationDirection direction;
  WTF::String lang;
  WTF::String body;
  WTF::String tag;
  WTF::String icon;
  WTF::String badge;
  WTF::Vector<uint32_t> vibration_pattern;
  double timestamp;
  bool renotify;
  bool silent;
  bool require_interaction;
  WTF::Vector<int8_t> data;
  WTF::Vector<NotificationActionPtr> actions;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(Notification);
};


template <typename StructPtrType>
NotificationActionPtr NotificationAction::Clone() const {
  return New(
      mojo::Clone(type),
      mojo::Clone(action),
      mojo::Clone(title),
      mojo::Clone(icon),
      mojo::Clone(placeholder)
  );
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, NotificationAction>::value>::type*>
bool NotificationAction::Equals(const T& other) const {
  if (!mojo::Equals(this->type, other.type))
    return false;
  if (!mojo::Equals(this->action, other.action))
    return false;
  if (!mojo::Equals(this->title, other.title))
    return false;
  if (!mojo::Equals(this->icon, other.icon))
    return false;
  if (!mojo::Equals(this->placeholder, other.placeholder))
    return false;
  return true;
}
template <typename StructPtrType>
NotificationPtr Notification::Clone() const {
  return New(
      mojo::Clone(title),
      mojo::Clone(direction),
      mojo::Clone(lang),
      mojo::Clone(body),
      mojo::Clone(tag),
      mojo::Clone(icon),
      mojo::Clone(badge),
      mojo::Clone(vibration_pattern),
      mojo::Clone(timestamp),
      mojo::Clone(renotify),
      mojo::Clone(silent),
      mojo::Clone(require_interaction),
      mojo::Clone(data),
      mojo::Clone(actions)
  );
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, Notification>::value>::type*>
bool Notification::Equals(const T& other) const {
  if (!mojo::Equals(this->title, other.title))
    return false;
  if (!mojo::Equals(this->direction, other.direction))
    return false;
  if (!mojo::Equals(this->lang, other.lang))
    return false;
  if (!mojo::Equals(this->body, other.body))
    return false;
  if (!mojo::Equals(this->tag, other.tag))
    return false;
  if (!mojo::Equals(this->icon, other.icon))
    return false;
  if (!mojo::Equals(this->badge, other.badge))
    return false;
  if (!mojo::Equals(this->vibration_pattern, other.vibration_pattern))
    return false;
  if (!mojo::Equals(this->timestamp, other.timestamp))
    return false;
  if (!mojo::Equals(this->renotify, other.renotify))
    return false;
  if (!mojo::Equals(this->silent, other.silent))
    return false;
  if (!mojo::Equals(this->require_interaction, other.require_interaction))
    return false;
  if (!mojo::Equals(this->data, other.data))
    return false;
  if (!mojo::Equals(this->actions, other.actions))
    return false;
  return true;
}


}  // namespace blink
}  // namespace mojom
}  // namespace blink

namespace mojo {


template <>
struct BLINK_PLATFORM_EXPORT StructTraits<::blink::mojom::blink::NotificationAction::DataView,
                                         ::blink::mojom::blink::NotificationActionPtr> {
  static bool IsNull(const ::blink::mojom::blink::NotificationActionPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::blink::NotificationActionPtr* output) { output->reset(); }

  static decltype(::blink::mojom::blink::NotificationAction::type) type(
      const ::blink::mojom::blink::NotificationActionPtr& input) {
    return input->type;
  }

  static const decltype(::blink::mojom::blink::NotificationAction::action)& action(
      const ::blink::mojom::blink::NotificationActionPtr& input) {
    return input->action;
  }

  static const decltype(::blink::mojom::blink::NotificationAction::title)& title(
      const ::blink::mojom::blink::NotificationActionPtr& input) {
    return input->title;
  }

  static const decltype(::blink::mojom::blink::NotificationAction::icon)& icon(
      const ::blink::mojom::blink::NotificationActionPtr& input) {
    return input->icon;
  }

  static const decltype(::blink::mojom::blink::NotificationAction::placeholder)& placeholder(
      const ::blink::mojom::blink::NotificationActionPtr& input) {
    return input->placeholder;
  }

  static bool Read(::blink::mojom::blink::NotificationAction::DataView input, ::blink::mojom::blink::NotificationActionPtr* output);
};


template <>
struct BLINK_PLATFORM_EXPORT StructTraits<::blink::mojom::blink::Notification::DataView,
                                         ::blink::mojom::blink::NotificationPtr> {
  static bool IsNull(const ::blink::mojom::blink::NotificationPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::blink::NotificationPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::blink::Notification::title)& title(
      const ::blink::mojom::blink::NotificationPtr& input) {
    return input->title;
  }

  static decltype(::blink::mojom::blink::Notification::direction) direction(
      const ::blink::mojom::blink::NotificationPtr& input) {
    return input->direction;
  }

  static const decltype(::blink::mojom::blink::Notification::lang)& lang(
      const ::blink::mojom::blink::NotificationPtr& input) {
    return input->lang;
  }

  static const decltype(::blink::mojom::blink::Notification::body)& body(
      const ::blink::mojom::blink::NotificationPtr& input) {
    return input->body;
  }

  static const decltype(::blink::mojom::blink::Notification::tag)& tag(
      const ::blink::mojom::blink::NotificationPtr& input) {
    return input->tag;
  }

  static const decltype(::blink::mojom::blink::Notification::icon)& icon(
      const ::blink::mojom::blink::NotificationPtr& input) {
    return input->icon;
  }

  static const decltype(::blink::mojom::blink::Notification::badge)& badge(
      const ::blink::mojom::blink::NotificationPtr& input) {
    return input->badge;
  }

  static const decltype(::blink::mojom::blink::Notification::vibration_pattern)& vibration_pattern(
      const ::blink::mojom::blink::NotificationPtr& input) {
    return input->vibration_pattern;
  }

  static decltype(::blink::mojom::blink::Notification::timestamp) timestamp(
      const ::blink::mojom::blink::NotificationPtr& input) {
    return input->timestamp;
  }

  static decltype(::blink::mojom::blink::Notification::renotify) renotify(
      const ::blink::mojom::blink::NotificationPtr& input) {
    return input->renotify;
  }

  static decltype(::blink::mojom::blink::Notification::silent) silent(
      const ::blink::mojom::blink::NotificationPtr& input) {
    return input->silent;
  }

  static decltype(::blink::mojom::blink::Notification::require_interaction) require_interaction(
      const ::blink::mojom::blink::NotificationPtr& input) {
    return input->require_interaction;
  }

  static const decltype(::blink::mojom::blink::Notification::data)& data(
      const ::blink::mojom::blink::NotificationPtr& input) {
    return input->data;
  }

  static const decltype(::blink::mojom::blink::Notification::actions)& actions(
      const ::blink::mojom::blink::NotificationPtr& input) {
    return input->actions;
  }

  static bool Read(::blink::mojom::blink::Notification::DataView input, ::blink::mojom::blink::NotificationPtr* output);
};

}  // namespace mojo

#endif  // THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_NOTIFICATIONS_NOTIFICATION_MOJOM_BLINK_H_