// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "third_party/WebKit/public/platform/modules/offscreencanvas/offscreen_canvas_surface.mojom-blink.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "mojo/public/cpp/bindings/lib/wtf_serialization.h"
#include "cc/ipc/frame_sink_id_struct_traits.h"
#include "cc/ipc/local_surface_id_struct_traits.h"
#include "cc/ipc/surface_id_struct_traits.h"
#include "cc/ipc/surface_info_struct_traits.h"
#include "cc/ipc/surface_sequence_struct_traits.h"
#include "third_party/WebKit/Source/platform/mojo/GeometryStructTraits.h"
#include "ui/gfx/geometry/mojo/geometry_struct_traits.h"
namespace blink {
namespace mojom {
namespace blink {
const char OffscreenCanvasSurface::Name_[] = "blink::mojom::OffscreenCanvasSurface";

OffscreenCanvasSurfaceProxy::OffscreenCanvasSurfaceProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void OffscreenCanvasSurfaceProxy::Require(
    const viz::SurfaceId& in_surface_id, const viz::SurfaceSequence& in_sequence) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::blink::mojom::internal::OffscreenCanvasSurface_Require_Params_Data);
  size += mojo::internal::PrepareToSerialize<::cc::mojom::SurfaceIdDataView>(
      in_surface_id, &serialization_context);
  size += mojo::internal::PrepareToSerialize<::cc::mojom::SurfaceSequenceDataView>(
      in_sequence, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kOffscreenCanvasSurface_Require_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::blink::mojom::internal::OffscreenCanvasSurface_Require_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->surface_id)::BaseType* surface_id_ptr;
  mojo::internal::Serialize<::cc::mojom::SurfaceIdDataView>(
      in_surface_id, buffer, &surface_id_ptr, &serialization_context);
  params->surface_id.Set(surface_id_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->surface_id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null surface_id in OffscreenCanvasSurface.Require request");
  typename decltype(params->sequence)::BaseType* sequence_ptr;
  mojo::internal::Serialize<::cc::mojom::SurfaceSequenceDataView>(
      in_sequence, buffer, &sequence_ptr, &serialization_context);
  params->sequence.Set(sequence_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->sequence.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null sequence in OffscreenCanvasSurface.Require request");
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void OffscreenCanvasSurfaceProxy::Satisfy(
    const viz::SurfaceSequence& in_sequence) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::blink::mojom::internal::OffscreenCanvasSurface_Satisfy_Params_Data);
  size += mojo::internal::PrepareToSerialize<::cc::mojom::SurfaceSequenceDataView>(
      in_sequence, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kOffscreenCanvasSurface_Satisfy_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::blink::mojom::internal::OffscreenCanvasSurface_Satisfy_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->sequence)::BaseType* sequence_ptr;
  mojo::internal::Serialize<::cc::mojom::SurfaceSequenceDataView>(
      in_sequence, buffer, &sequence_ptr, &serialization_context);
  params->sequence.Set(sequence_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->sequence.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null sequence in OffscreenCanvasSurface.Satisfy request");
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool OffscreenCanvasSurfaceStubDispatch::Accept(
    OffscreenCanvasSurface* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kOffscreenCanvasSurface_Require_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::OffscreenCanvasSurface_Require_Params_Data* params =
          reinterpret_cast<internal::OffscreenCanvasSurface_Require_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      viz::SurfaceId p_surface_id{};
      viz::SurfaceSequence p_sequence{};
      OffscreenCanvasSurface_Require_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadSurfaceId(&p_surface_id))
        success = false;
      if (!input_data_view.ReadSequence(&p_sequence))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "OffscreenCanvasSurface::Require deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->Require(
std::move(p_surface_id), 
std::move(p_sequence));
      return true;
    }
    case internal::kOffscreenCanvasSurface_Satisfy_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::OffscreenCanvasSurface_Satisfy_Params_Data* params =
          reinterpret_cast<internal::OffscreenCanvasSurface_Satisfy_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      viz::SurfaceSequence p_sequence{};
      OffscreenCanvasSurface_Satisfy_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadSequence(&p_sequence))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "OffscreenCanvasSurface::Satisfy deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->Satisfy(
std::move(p_sequence));
      return true;
    }
  }
  return false;
}

// static
bool OffscreenCanvasSurfaceStubDispatch::AcceptWithResponder(
    OffscreenCanvasSurface* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kOffscreenCanvasSurface_Require_Name: {
      break;
    }
    case internal::kOffscreenCanvasSurface_Satisfy_Name: {
      break;
    }
  }
  return false;
}

bool OffscreenCanvasSurfaceRequestValidator::Accept(mojo::Message* message) {
  if (mojo::internal::IsUnserializedOrControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "OffscreenCanvasSurface RequestValidator");

  switch (message->header()->name) {
    case internal::kOffscreenCanvasSurface_Require_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::OffscreenCanvasSurface_Require_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kOffscreenCanvasSurface_Satisfy_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::OffscreenCanvasSurface_Satisfy_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

const char OffscreenCanvasSurfaceClient::Name_[] = "blink::mojom::OffscreenCanvasSurfaceClient";

OffscreenCanvasSurfaceClientProxy::OffscreenCanvasSurfaceClientProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void OffscreenCanvasSurfaceClientProxy::OnSurfaceCreated(
    const viz::SurfaceInfo& in_surface_info) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::blink::mojom::internal::OffscreenCanvasSurfaceClient_OnSurfaceCreated_Params_Data);
  size += mojo::internal::PrepareToSerialize<::cc::mojom::SurfaceInfoDataView>(
      in_surface_info, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kOffscreenCanvasSurfaceClient_OnSurfaceCreated_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::blink::mojom::internal::OffscreenCanvasSurfaceClient_OnSurfaceCreated_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->surface_info)::BaseType* surface_info_ptr;
  mojo::internal::Serialize<::cc::mojom::SurfaceInfoDataView>(
      in_surface_info, buffer, &surface_info_ptr, &serialization_context);
  params->surface_info.Set(surface_info_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->surface_info.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null surface_info in OffscreenCanvasSurfaceClient.OnSurfaceCreated request");
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool OffscreenCanvasSurfaceClientStubDispatch::Accept(
    OffscreenCanvasSurfaceClient* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kOffscreenCanvasSurfaceClient_OnSurfaceCreated_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::OffscreenCanvasSurfaceClient_OnSurfaceCreated_Params_Data* params =
          reinterpret_cast<internal::OffscreenCanvasSurfaceClient_OnSurfaceCreated_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      viz::SurfaceInfo p_surface_info{};
      OffscreenCanvasSurfaceClient_OnSurfaceCreated_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadSurfaceInfo(&p_surface_info))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "OffscreenCanvasSurfaceClient::OnSurfaceCreated deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->OnSurfaceCreated(
std::move(p_surface_info));
      return true;
    }
  }
  return false;
}

// static
bool OffscreenCanvasSurfaceClientStubDispatch::AcceptWithResponder(
    OffscreenCanvasSurfaceClient* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kOffscreenCanvasSurfaceClient_OnSurfaceCreated_Name: {
      break;
    }
  }
  return false;
}

bool OffscreenCanvasSurfaceClientRequestValidator::Accept(mojo::Message* message) {
  if (mojo::internal::IsUnserializedOrControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "OffscreenCanvasSurfaceClient RequestValidator");

  switch (message->header()->name) {
    case internal::kOffscreenCanvasSurfaceClient_OnSurfaceCreated_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::OffscreenCanvasSurfaceClient_OnSurfaceCreated_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

const char OffscreenCanvasProvider::Name_[] = "blink::mojom::OffscreenCanvasProvider";

OffscreenCanvasProviderProxy::OffscreenCanvasProviderProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void OffscreenCanvasProviderProxy::CreateOffscreenCanvasSurface(
    const viz::FrameSinkId& in_parent_frame_sink_id, const viz::FrameSinkId& in_frame_sink_id, OffscreenCanvasSurfaceClientPtr in_client, OffscreenCanvasSurfaceRequest in_surface) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::blink::mojom::internal::OffscreenCanvasProvider_CreateOffscreenCanvasSurface_Params_Data);
  size += mojo::internal::PrepareToSerialize<::cc::mojom::FrameSinkIdDataView>(
      in_parent_frame_sink_id, &serialization_context);
  size += mojo::internal::PrepareToSerialize<::cc::mojom::FrameSinkIdDataView>(
      in_frame_sink_id, &serialization_context);
  size += mojo::internal::PrepareToSerialize<::blink::mojom::OffscreenCanvasSurfaceClientPtrDataView>(
      in_client, &serialization_context);
  size += mojo::internal::PrepareToSerialize<::blink::mojom::OffscreenCanvasSurfaceRequestDataView>(
      in_surface, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kOffscreenCanvasProvider_CreateOffscreenCanvasSurface_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::blink::mojom::internal::OffscreenCanvasProvider_CreateOffscreenCanvasSurface_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->parent_frame_sink_id)::BaseType* parent_frame_sink_id_ptr;
  mojo::internal::Serialize<::cc::mojom::FrameSinkIdDataView>(
      in_parent_frame_sink_id, buffer, &parent_frame_sink_id_ptr, &serialization_context);
  params->parent_frame_sink_id.Set(parent_frame_sink_id_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->parent_frame_sink_id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null parent_frame_sink_id in OffscreenCanvasProvider.CreateOffscreenCanvasSurface request");
  typename decltype(params->frame_sink_id)::BaseType* frame_sink_id_ptr;
  mojo::internal::Serialize<::cc::mojom::FrameSinkIdDataView>(
      in_frame_sink_id, buffer, &frame_sink_id_ptr, &serialization_context);
  params->frame_sink_id.Set(frame_sink_id_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->frame_sink_id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null frame_sink_id in OffscreenCanvasProvider.CreateOffscreenCanvasSurface request");
  mojo::internal::Serialize<::blink::mojom::OffscreenCanvasSurfaceClientPtrDataView>(
      in_client, &params->client, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->client),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid client in OffscreenCanvasProvider.CreateOffscreenCanvasSurface request");
  mojo::internal::Serialize<::blink::mojom::OffscreenCanvasSurfaceRequestDataView>(
      in_surface, &params->surface, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->surface),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid surface in OffscreenCanvasProvider.CreateOffscreenCanvasSurface request");
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void OffscreenCanvasProviderProxy::CreateCompositorFrameSink(
    const viz::FrameSinkId& in_frame_sink_id, ::cc::mojom::blink::CompositorFrameSinkClientPtr in_client, ::cc::mojom::blink::CompositorFrameSinkRequest in_sink) {
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  mojo::Message message;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::internal::SerializationContext serialization_context;
  size_t size = sizeof(::blink::mojom::internal::OffscreenCanvasProvider_CreateCompositorFrameSink_Params_Data);
  size += mojo::internal::PrepareToSerialize<::cc::mojom::FrameSinkIdDataView>(
      in_frame_sink_id, &serialization_context);
  size += mojo::internal::PrepareToSerialize<::cc::mojom::CompositorFrameSinkClientPtrDataView>(
      in_client, &serialization_context);
  size += mojo::internal::PrepareToSerialize<::cc::mojom::CompositorFrameSinkRequestDataView>(
      in_sink, &serialization_context);
  serialization_context.PrepareMessage(
      internal::kOffscreenCanvasProvider_CreateCompositorFrameSink_Name,
      kFlags, size, &message);
  auto* buffer = (&message)->payload_buffer();
  auto params =
      ::blink::mojom::internal::OffscreenCanvasProvider_CreateCompositorFrameSink_Params_Data::New(buffer);
  ALLOW_UNUSED_LOCAL(params);
  typename decltype(params->frame_sink_id)::BaseType* frame_sink_id_ptr;
  mojo::internal::Serialize<::cc::mojom::FrameSinkIdDataView>(
      in_frame_sink_id, buffer, &frame_sink_id_ptr, &serialization_context);
  params->frame_sink_id.Set(frame_sink_id_ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->frame_sink_id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null frame_sink_id in OffscreenCanvasProvider.CreateCompositorFrameSink request");
  mojo::internal::Serialize<::cc::mojom::CompositorFrameSinkClientPtrDataView>(
      in_client, &params->client, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->client),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid client in OffscreenCanvasProvider.CreateCompositorFrameSink request");
  mojo::internal::Serialize<::cc::mojom::CompositorFrameSinkRequestDataView>(
      in_sink, &params->sink, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->sink),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid sink in OffscreenCanvasProvider.CreateCompositorFrameSink request");
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool OffscreenCanvasProviderStubDispatch::Accept(
    OffscreenCanvasProvider* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kOffscreenCanvasProvider_CreateOffscreenCanvasSurface_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::OffscreenCanvasProvider_CreateOffscreenCanvasSurface_Params_Data* params =
          reinterpret_cast<internal::OffscreenCanvasProvider_CreateOffscreenCanvasSurface_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      viz::FrameSinkId p_parent_frame_sink_id{};
      viz::FrameSinkId p_frame_sink_id{};
      OffscreenCanvasSurfaceClientPtr p_client{};
      OffscreenCanvasSurfaceRequest p_surface{};
      OffscreenCanvasProvider_CreateOffscreenCanvasSurface_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadParentFrameSinkId(&p_parent_frame_sink_id))
        success = false;
      if (!input_data_view.ReadFrameSinkId(&p_frame_sink_id))
        success = false;
      p_client =
          input_data_view.TakeClient<decltype(p_client)>();
      p_surface =
          input_data_view.TakeSurface<decltype(p_surface)>();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "OffscreenCanvasProvider::CreateOffscreenCanvasSurface deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->CreateOffscreenCanvasSurface(
std::move(p_parent_frame_sink_id), 
std::move(p_frame_sink_id), 
std::move(p_client), 
std::move(p_surface));
      return true;
    }
    case internal::kOffscreenCanvasProvider_CreateCompositorFrameSink_Name: {
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::OffscreenCanvasProvider_CreateCompositorFrameSink_Params_Data* params =
          reinterpret_cast<internal::OffscreenCanvasProvider_CreateCompositorFrameSink_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      viz::FrameSinkId p_frame_sink_id{};
      ::cc::mojom::blink::CompositorFrameSinkClientPtr p_client{};
      ::cc::mojom::blink::CompositorFrameSinkRequest p_sink{};
      OffscreenCanvasProvider_CreateCompositorFrameSink_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadFrameSinkId(&p_frame_sink_id))
        success = false;
      p_client =
          input_data_view.TakeClient<decltype(p_client)>();
      p_sink =
          input_data_view.TakeSink<decltype(p_sink)>();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "OffscreenCanvasProvider::CreateCompositorFrameSink deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->CreateCompositorFrameSink(
std::move(p_frame_sink_id), 
std::move(p_client), 
std::move(p_sink));
      return true;
    }
  }
  return false;
}

// static
bool OffscreenCanvasProviderStubDispatch::AcceptWithResponder(
    OffscreenCanvasProvider* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kOffscreenCanvasProvider_CreateOffscreenCanvasSurface_Name: {
      break;
    }
    case internal::kOffscreenCanvasProvider_CreateCompositorFrameSink_Name: {
      break;
    }
  }
  return false;
}

bool OffscreenCanvasProviderRequestValidator::Accept(mojo::Message* message) {
  if (mojo::internal::IsUnserializedOrControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "OffscreenCanvasProvider RequestValidator");

  switch (message->header()->name) {
    case internal::kOffscreenCanvasProvider_CreateOffscreenCanvasSurface_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::OffscreenCanvasProvider_CreateOffscreenCanvasSurface_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kOffscreenCanvasProvider_CreateCompositorFrameSink_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::OffscreenCanvasProvider_CreateCompositorFrameSink_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

}  // namespace blink
}  // namespace mojom
}  // namespace blink

namespace mojo {

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif