// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_OFFSCREENCANVAS_OFFSCREEN_CANVAS_SURFACE_MOJOM_SHARED_INTERNAL_H_
#define THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_OFFSCREENCANVAS_OFFSCREEN_CANVAS_SURFACE_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/native_struct_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "cc/ipc/frame_sink_id.mojom-shared-internal.h"
#include "cc/ipc/frame_sink_manager.mojom-shared-internal.h"
#include "cc/ipc/compositor_frame_sink.mojom-shared-internal.h"
#include "cc/ipc/surface_id.mojom-shared-internal.h"
#include "cc/ipc/surface_info.mojom-shared-internal.h"
#include "cc/ipc/surface_sequence.mojom-shared-internal.h"
#include "third_party/WebKit/public/offscreen_canvas_mojo_bindings_shared_export.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace blink {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
constexpr uint32_t kOffscreenCanvasSurface_Require_Name = 0;
class MOJOM_SHARED_CONTENT_EXPORT OffscreenCanvasSurface_Require_Params_Data {
 public:
  static OffscreenCanvasSurface_Require_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::cc::mojom::internal::SurfaceId_Data> surface_id;
  mojo::internal::Pointer<::cc::mojom::internal::SurfaceSequence_Data> sequence;

 private:
  OffscreenCanvasSurface_Require_Params_Data();
  ~OffscreenCanvasSurface_Require_Params_Data() = delete;
};
static_assert(sizeof(OffscreenCanvasSurface_Require_Params_Data) == 24,
              "Bad sizeof(OffscreenCanvasSurface_Require_Params_Data)");
constexpr uint32_t kOffscreenCanvasSurface_Satisfy_Name = 1;
class MOJOM_SHARED_CONTENT_EXPORT OffscreenCanvasSurface_Satisfy_Params_Data {
 public:
  static OffscreenCanvasSurface_Satisfy_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::cc::mojom::internal::SurfaceSequence_Data> sequence;

 private:
  OffscreenCanvasSurface_Satisfy_Params_Data();
  ~OffscreenCanvasSurface_Satisfy_Params_Data() = delete;
};
static_assert(sizeof(OffscreenCanvasSurface_Satisfy_Params_Data) == 16,
              "Bad sizeof(OffscreenCanvasSurface_Satisfy_Params_Data)");
constexpr uint32_t kOffscreenCanvasSurfaceClient_OnSurfaceCreated_Name = 0;
class MOJOM_SHARED_CONTENT_EXPORT OffscreenCanvasSurfaceClient_OnSurfaceCreated_Params_Data {
 public:
  static OffscreenCanvasSurfaceClient_OnSurfaceCreated_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::cc::mojom::internal::SurfaceInfo_Data> surface_info;

 private:
  OffscreenCanvasSurfaceClient_OnSurfaceCreated_Params_Data();
  ~OffscreenCanvasSurfaceClient_OnSurfaceCreated_Params_Data() = delete;
};
static_assert(sizeof(OffscreenCanvasSurfaceClient_OnSurfaceCreated_Params_Data) == 16,
              "Bad sizeof(OffscreenCanvasSurfaceClient_OnSurfaceCreated_Params_Data)");
constexpr uint32_t kOffscreenCanvasProvider_CreateOffscreenCanvasSurface_Name = 0;
class MOJOM_SHARED_CONTENT_EXPORT OffscreenCanvasProvider_CreateOffscreenCanvasSurface_Params_Data {
 public:
  static OffscreenCanvasProvider_CreateOffscreenCanvasSurface_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::cc::mojom::internal::FrameSinkId_Data> parent_frame_sink_id;
  mojo::internal::Pointer<::cc::mojom::internal::FrameSinkId_Data> frame_sink_id;
  mojo::internal::Interface_Data client;
  mojo::internal::Handle_Data surface;
  uint8_t padfinal_[4];

 private:
  OffscreenCanvasProvider_CreateOffscreenCanvasSurface_Params_Data();
  ~OffscreenCanvasProvider_CreateOffscreenCanvasSurface_Params_Data() = delete;
};
static_assert(sizeof(OffscreenCanvasProvider_CreateOffscreenCanvasSurface_Params_Data) == 40,
              "Bad sizeof(OffscreenCanvasProvider_CreateOffscreenCanvasSurface_Params_Data)");
constexpr uint32_t kOffscreenCanvasProvider_CreateCompositorFrameSink_Name = 1;
class MOJOM_SHARED_CONTENT_EXPORT OffscreenCanvasProvider_CreateCompositorFrameSink_Params_Data {
 public:
  static OffscreenCanvasProvider_CreateCompositorFrameSink_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::cc::mojom::internal::FrameSinkId_Data> frame_sink_id;
  mojo::internal::Interface_Data client;
  mojo::internal::Handle_Data sink;
  uint8_t padfinal_[4];

 private:
  OffscreenCanvasProvider_CreateCompositorFrameSink_Params_Data();
  ~OffscreenCanvasProvider_CreateCompositorFrameSink_Params_Data() = delete;
};
static_assert(sizeof(OffscreenCanvasProvider_CreateCompositorFrameSink_Params_Data) == 32,
              "Bad sizeof(OffscreenCanvasProvider_CreateCompositorFrameSink_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_OFFSCREENCANVAS_OFFSCREEN_CANVAS_SURFACE_MOJOM_SHARED_INTERNAL_H_