// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_PAYMENTS_PAYMENT_APP_MOJOM_BLINK_H_
#define THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_PAYMENTS_PAYMENT_APP_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/lib/control_message_proxy.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/native_struct.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "third_party/WebKit/public/platform/modules/payments/payment_app.mojom-shared.h"
#include "mojo/common/time.mojom-blink.h"
#include "third_party/WebKit/public/platform/modules/payments/payment_request.mojom-blink.h"
#include "url/mojo/url.mojom-blink.h"

#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/WebKit/Source/platform/wtf/HashFunctions.h"
#include "third_party/WebKit/Source/platform/wtf/Optional.h"
#include "third_party/WebKit/Source/platform/wtf/text/WTFString.h"
#include "third_party/WebKit/public/platform/WebCommon.h"


namespace WTF {
struct payments_mojom_internal_PaymentHandlerStatus_DataHashFn {
  static unsigned GetHash(const ::payments::mojom::PaymentHandlerStatus& value) {
    using utype = std::underlying_type<::payments::mojom::PaymentHandlerStatus>::type;
    return DefaultHash<utype>::Hash().GetHash(static_cast<utype>(value));
  }
  static bool Equal(const ::payments::mojom::PaymentHandlerStatus& left, const ::payments::mojom::PaymentHandlerStatus& right) {
    return left == right;
  }
  static const bool safe_to_compare_to_empty_or_deleted = true;
};

template <>
struct DefaultHash<::payments::mojom::PaymentHandlerStatus> {
  using Hash = payments_mojom_internal_PaymentHandlerStatus_DataHashFn;
};

template <>
struct HashTraits<::payments::mojom::PaymentHandlerStatus>
    : public GenericHashTraits<::payments::mojom::PaymentHandlerStatus> {
  static_assert(true,
                "-1000000 is a reserved enum value");
  static_assert(true,
                "-1000001 is a reserved enum value");
  static const bool hasIsEmptyValueFunction = true;
  static bool IsEmptyValue(const ::payments::mojom::PaymentHandlerStatus& value) {
    return value == static_cast<::payments::mojom::PaymentHandlerStatus>(-1000000);
  }
  static void ConstructDeletedValue(::payments::mojom::PaymentHandlerStatus& slot, bool) {
    slot = static_cast<::payments::mojom::PaymentHandlerStatus>(-1000001);
  }
  static bool IsDeletedValue(const ::payments::mojom::PaymentHandlerStatus& value) {
    return value == static_cast<::payments::mojom::PaymentHandlerStatus>(-1000001);
  }
};
}  // namespace WTF


namespace payments {
namespace mojom {
namespace blink {
using PaymentHandlerStatus = PaymentHandlerStatus;  // Alias for definition in the parent namespace.
class PaymentManager;
using PaymentManagerPtr = mojo::InterfacePtr<PaymentManager>;
using PaymentManagerPtrInfo = mojo::InterfacePtrInfo<PaymentManager>;
using ThreadSafePaymentManagerPtr =
    mojo::ThreadSafeInterfacePtr<PaymentManager>;
using PaymentManagerRequest = mojo::InterfaceRequest<PaymentManager>;
using PaymentManagerAssociatedPtr =
    mojo::AssociatedInterfacePtr<PaymentManager>;
using ThreadSafePaymentManagerAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<PaymentManager>;
using PaymentManagerAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<PaymentManager>;
using PaymentManagerAssociatedRequest =
    mojo::AssociatedInterfaceRequest<PaymentManager>;

class PaymentHandlerResponseCallback;
using PaymentHandlerResponseCallbackPtr = mojo::InterfacePtr<PaymentHandlerResponseCallback>;
using PaymentHandlerResponseCallbackPtrInfo = mojo::InterfacePtrInfo<PaymentHandlerResponseCallback>;
using ThreadSafePaymentHandlerResponseCallbackPtr =
    mojo::ThreadSafeInterfacePtr<PaymentHandlerResponseCallback>;
using PaymentHandlerResponseCallbackRequest = mojo::InterfaceRequest<PaymentHandlerResponseCallback>;
using PaymentHandlerResponseCallbackAssociatedPtr =
    mojo::AssociatedInterfacePtr<PaymentHandlerResponseCallback>;
using ThreadSafePaymentHandlerResponseCallbackAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<PaymentHandlerResponseCallback>;
using PaymentHandlerResponseCallbackAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<PaymentHandlerResponseCallback>;
using PaymentHandlerResponseCallbackAssociatedRequest =
    mojo::AssociatedInterfaceRequest<PaymentHandlerResponseCallback>;

class ImageObject;
using ImageObjectPtr = mojo::StructPtr<ImageObject>;

class PaymentInstrument;
using PaymentInstrumentPtr = mojo::StructPtr<PaymentInstrument>;

class PaymentRequestEventData;
using PaymentRequestEventDataPtr = mojo::StructPtr<PaymentRequestEventData>;

class PaymentHandlerResponse;
using PaymentHandlerResponsePtr = mojo::InlinedStructPtr<PaymentHandlerResponse>;


class PaymentManagerProxy;

template <typename ImplRefTraits>
class PaymentManagerStub;

class PaymentManagerRequestValidator;
class PaymentManagerResponseValidator;

class BLINK_PLATFORM_EXPORT PaymentManager
    : public PaymentManagerInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Proxy_ = PaymentManagerProxy;

  template <typename ImplRefTraits>
  using Stub_ = PaymentManagerStub<ImplRefTraits>;

  using RequestValidator_ = PaymentManagerRequestValidator;
  using ResponseValidator_ = PaymentManagerResponseValidator;
  enum MethodMinVersions : uint32_t {
    kInitMinVersion = 0,
    kDeletePaymentInstrumentMinVersion = 0,
    kGetPaymentInstrumentMinVersion = 0,
    kKeysOfPaymentInstrumentsMinVersion = 0,
    kHasPaymentInstrumentMinVersion = 0,
    kSetPaymentInstrumentMinVersion = 0,
    kClearPaymentInstrumentsMinVersion = 0,
  };
  virtual ~PaymentManager() {}

  virtual void Init(const WTF::String& service_worker_script_url, const WTF::String& service_worker_scope) = 0;


  using DeletePaymentInstrumentCallback = base::OnceCallback<void(PaymentHandlerStatus)>;
  virtual void DeletePaymentInstrument(const WTF::String& instrument_key, DeletePaymentInstrumentCallback callback) = 0;


  using GetPaymentInstrumentCallback = base::OnceCallback<void(PaymentInstrumentPtr, PaymentHandlerStatus)>;
  virtual void GetPaymentInstrument(const WTF::String& instrument_key, GetPaymentInstrumentCallback callback) = 0;


  using KeysOfPaymentInstrumentsCallback = base::OnceCallback<void(const WTF::Vector<WTF::String>&, PaymentHandlerStatus)>;
  virtual void KeysOfPaymentInstruments(KeysOfPaymentInstrumentsCallback callback) = 0;


  using HasPaymentInstrumentCallback = base::OnceCallback<void(PaymentHandlerStatus)>;
  virtual void HasPaymentInstrument(const WTF::String& instrument_key, HasPaymentInstrumentCallback callback) = 0;


  using SetPaymentInstrumentCallback = base::OnceCallback<void(PaymentHandlerStatus)>;
  virtual void SetPaymentInstrument(const WTF::String& instrument_key, PaymentInstrumentPtr instrument, SetPaymentInstrumentCallback callback) = 0;


  using ClearPaymentInstrumentsCallback = base::OnceCallback<void(PaymentHandlerStatus)>;
  virtual void ClearPaymentInstruments(ClearPaymentInstrumentsCallback callback) = 0;
};

class PaymentHandlerResponseCallbackProxy;

template <typename ImplRefTraits>
class PaymentHandlerResponseCallbackStub;

class PaymentHandlerResponseCallbackRequestValidator;

class BLINK_PLATFORM_EXPORT PaymentHandlerResponseCallback
    : public PaymentHandlerResponseCallbackInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Proxy_ = PaymentHandlerResponseCallbackProxy;

  template <typename ImplRefTraits>
  using Stub_ = PaymentHandlerResponseCallbackStub<ImplRefTraits>;

  using RequestValidator_ = PaymentHandlerResponseCallbackRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kOnPaymentHandlerResponseMinVersion = 0,
  };
  virtual ~PaymentHandlerResponseCallback() {}

  virtual void OnPaymentHandlerResponse(PaymentHandlerResponsePtr response, WTF::Time dispatch_event_time) = 0;
};

class BLINK_PLATFORM_EXPORT PaymentManagerProxy
    : public PaymentManager {
 public:
  explicit PaymentManagerProxy(mojo::MessageReceiverWithResponder* receiver);
  void Init(const WTF::String& service_worker_script_url, const WTF::String& service_worker_scope) override;
  void DeletePaymentInstrument(const WTF::String& instrument_key, DeletePaymentInstrumentCallback callback) override;
  void GetPaymentInstrument(const WTF::String& instrument_key, GetPaymentInstrumentCallback callback) override;
  void KeysOfPaymentInstruments(KeysOfPaymentInstrumentsCallback callback) override;
  void HasPaymentInstrument(const WTF::String& instrument_key, HasPaymentInstrumentCallback callback) override;
  void SetPaymentInstrument(const WTF::String& instrument_key, PaymentInstrumentPtr instrument, SetPaymentInstrumentCallback callback) override;
  void ClearPaymentInstruments(ClearPaymentInstrumentsCallback callback) override;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};

class BLINK_PLATFORM_EXPORT PaymentHandlerResponseCallbackProxy
    : public PaymentHandlerResponseCallback {
 public:
  explicit PaymentHandlerResponseCallbackProxy(mojo::MessageReceiverWithResponder* receiver);
  void OnPaymentHandlerResponse(PaymentHandlerResponsePtr response, WTF::Time dispatch_event_time) override;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class BLINK_PLATFORM_EXPORT PaymentManagerStubDispatch {
 public:
  static bool Accept(PaymentManager* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      PaymentManager* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<PaymentManager>>
class PaymentManagerStub
    : public NON_EXPORTED_BASE(mojo::MessageReceiverWithResponderStatus) {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  PaymentManagerStub() {}
  ~PaymentManagerStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return PaymentManagerStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return PaymentManagerStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_PLATFORM_EXPORT PaymentHandlerResponseCallbackStubDispatch {
 public:
  static bool Accept(PaymentHandlerResponseCallback* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      PaymentHandlerResponseCallback* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<PaymentHandlerResponseCallback>>
class PaymentHandlerResponseCallbackStub
    : public NON_EXPORTED_BASE(mojo::MessageReceiverWithResponderStatus) {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  PaymentHandlerResponseCallbackStub() {}
  ~PaymentHandlerResponseCallbackStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return PaymentHandlerResponseCallbackStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return PaymentHandlerResponseCallbackStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_PLATFORM_EXPORT PaymentManagerRequestValidator : public NON_EXPORTED_BASE(mojo::MessageReceiver) {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_PLATFORM_EXPORT PaymentHandlerResponseCallbackRequestValidator : public NON_EXPORTED_BASE(mojo::MessageReceiver) {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_PLATFORM_EXPORT PaymentManagerResponseValidator : public NON_EXPORTED_BASE(mojo::MessageReceiver) {
 public:
  bool Accept(mojo::Message* message) override;
};





class BLINK_PLATFORM_EXPORT PaymentHandlerResponse {
 public:
  using DataView = PaymentHandlerResponseDataView;
  using Data_ = internal::PaymentHandlerResponse_Data;

  template <typename... Args>
  static PaymentHandlerResponsePtr New(Args&&... args) {
    return PaymentHandlerResponsePtr(
        base::in_place,
        std::forward<Args>(args)...);
  }

  template <typename U>
  static PaymentHandlerResponsePtr From(const U& u) {
    return mojo::TypeConverter<PaymentHandlerResponsePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, PaymentHandlerResponse>::Convert(*this);
  }


  PaymentHandlerResponse();

  PaymentHandlerResponse(
      const WTF::String& method_name,
      const WTF::String& stringified_details);

  ~PaymentHandlerResponse();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = PaymentHandlerResponsePtr>
  PaymentHandlerResponsePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, PaymentHandlerResponse>::value>::type* = nullptr>
  bool Equals(const T& other) const;
  size_t Hash(size_t seed) const;

  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::StructSerializeImpl<
        PaymentHandlerResponse::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return mojo::internal::StructDeserializeImpl<
        PaymentHandlerResponse::DataView, WTF::Vector<uint8_t>>(
            input, output, Validate);
  }

  WTF::String method_name;
  WTF::String stringified_details;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};





class BLINK_PLATFORM_EXPORT ImageObject {
 public:
  using DataView = ImageObjectDataView;
  using Data_ = internal::ImageObject_Data;

  template <typename... Args>
  static ImageObjectPtr New(Args&&... args) {
    return ImageObjectPtr(
        base::in_place,
        std::forward<Args>(args)...);
  }

  template <typename U>
  static ImageObjectPtr From(const U& u) {
    return mojo::TypeConverter<ImageObjectPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ImageObject>::Convert(*this);
  }


  ImageObject();

  explicit ImageObject(
      const ::blink::KURL& src);

  ~ImageObject();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ImageObjectPtr>
  ImageObjectPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, ImageObject>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::StructSerializeImpl<
        ImageObject::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return mojo::internal::StructDeserializeImpl<
        ImageObject::DataView, WTF::Vector<uint8_t>>(
            input, output, Validate);
  }

  ::blink::KURL src;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};



class BLINK_PLATFORM_EXPORT PaymentInstrument {
 public:
  using DataView = PaymentInstrumentDataView;
  using Data_ = internal::PaymentInstrument_Data;

  template <typename... Args>
  static PaymentInstrumentPtr New(Args&&... args) {
    return PaymentInstrumentPtr(
        base::in_place,
        std::forward<Args>(args)...);
  }

  template <typename U>
  static PaymentInstrumentPtr From(const U& u) {
    return mojo::TypeConverter<PaymentInstrumentPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, PaymentInstrument>::Convert(*this);
  }


  PaymentInstrument();

  PaymentInstrument(
      const WTF::String& name,
      WTF::Vector<ImageObjectPtr> icons,
      const WTF::Vector<WTF::String>& enabled_methods,
      const WTF::String& stringified_capabilities);

  ~PaymentInstrument();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = PaymentInstrumentPtr>
  PaymentInstrumentPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, PaymentInstrument>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::StructSerializeImpl<
        PaymentInstrument::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return mojo::internal::StructDeserializeImpl<
        PaymentInstrument::DataView, WTF::Vector<uint8_t>>(
            input, output, Validate);
  }

  WTF::String name;
  WTF::Vector<ImageObjectPtr> icons;
  WTF::Vector<WTF::String> enabled_methods;
  WTF::String stringified_capabilities;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(PaymentInstrument);
};



class BLINK_PLATFORM_EXPORT PaymentRequestEventData {
 public:
  using DataView = PaymentRequestEventDataDataView;
  using Data_ = internal::PaymentRequestEventData_Data;

  template <typename... Args>
  static PaymentRequestEventDataPtr New(Args&&... args) {
    return PaymentRequestEventDataPtr(
        base::in_place,
        std::forward<Args>(args)...);
  }

  template <typename U>
  static PaymentRequestEventDataPtr From(const U& u) {
    return mojo::TypeConverter<PaymentRequestEventDataPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, PaymentRequestEventData>::Convert(*this);
  }


  PaymentRequestEventData();

  PaymentRequestEventData(
      const ::blink::KURL& top_level_origin,
      const ::blink::KURL& payment_request_origin,
      const WTF::String& payment_request_id,
      WTF::Vector<::payments::mojom::blink::PaymentMethodDataPtr> method_data,
      ::payments::mojom::blink::PaymentCurrencyAmountPtr total,
      WTF::Vector<::payments::mojom::blink::PaymentDetailsModifierPtr> modifiers,
      const WTF::String& instrument_key);

  ~PaymentRequestEventData();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = PaymentRequestEventDataPtr>
  PaymentRequestEventDataPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, PaymentRequestEventData>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::StructSerializeImpl<
        PaymentRequestEventData::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return mojo::internal::StructDeserializeImpl<
        PaymentRequestEventData::DataView, WTF::Vector<uint8_t>>(
            input, output, Validate);
  }

  ::blink::KURL top_level_origin;
  ::blink::KURL payment_request_origin;
  WTF::String payment_request_id;
  WTF::Vector<::payments::mojom::blink::PaymentMethodDataPtr> method_data;
  ::payments::mojom::blink::PaymentCurrencyAmountPtr total;
  WTF::Vector<::payments::mojom::blink::PaymentDetailsModifierPtr> modifiers;
  WTF::String instrument_key;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(PaymentRequestEventData);
};



template <typename StructPtrType>
ImageObjectPtr ImageObject::Clone() const {
  return New(
      mojo::Clone(src)
  );
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, ImageObject>::value>::type*>
bool ImageObject::Equals(const T& other) const {
  if (!mojo::Equals(this->src, other.src))
    return false;
  return true;
}
template <typename StructPtrType>
PaymentInstrumentPtr PaymentInstrument::Clone() const {
  return New(
      mojo::Clone(name),
      mojo::Clone(icons),
      mojo::Clone(enabled_methods),
      mojo::Clone(stringified_capabilities)
  );
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, PaymentInstrument>::value>::type*>
bool PaymentInstrument::Equals(const T& other) const {
  if (!mojo::Equals(this->name, other.name))
    return false;
  if (!mojo::Equals(this->icons, other.icons))
    return false;
  if (!mojo::Equals(this->enabled_methods, other.enabled_methods))
    return false;
  if (!mojo::Equals(this->stringified_capabilities, other.stringified_capabilities))
    return false;
  return true;
}
template <typename StructPtrType>
PaymentRequestEventDataPtr PaymentRequestEventData::Clone() const {
  return New(
      mojo::Clone(top_level_origin),
      mojo::Clone(payment_request_origin),
      mojo::Clone(payment_request_id),
      mojo::Clone(method_data),
      mojo::Clone(total),
      mojo::Clone(modifiers),
      mojo::Clone(instrument_key)
  );
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, PaymentRequestEventData>::value>::type*>
bool PaymentRequestEventData::Equals(const T& other) const {
  if (!mojo::Equals(this->top_level_origin, other.top_level_origin))
    return false;
  if (!mojo::Equals(this->payment_request_origin, other.payment_request_origin))
    return false;
  if (!mojo::Equals(this->payment_request_id, other.payment_request_id))
    return false;
  if (!mojo::Equals(this->method_data, other.method_data))
    return false;
  if (!mojo::Equals(this->total, other.total))
    return false;
  if (!mojo::Equals(this->modifiers, other.modifiers))
    return false;
  if (!mojo::Equals(this->instrument_key, other.instrument_key))
    return false;
  return true;
}
template <typename StructPtrType>
PaymentHandlerResponsePtr PaymentHandlerResponse::Clone() const {
  return New(
      mojo::Clone(method_name),
      mojo::Clone(stringified_details)
  );
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, PaymentHandlerResponse>::value>::type*>
bool PaymentHandlerResponse::Equals(const T& other) const {
  if (!mojo::Equals(this->method_name, other.method_name))
    return false;
  if (!mojo::Equals(this->stringified_details, other.stringified_details))
    return false;
  return true;
}


}  // namespace blink
}  // namespace mojom
}  // namespace payments

namespace mojo {


template <>
struct BLINK_PLATFORM_EXPORT StructTraits<::payments::mojom::blink::ImageObject::DataView,
                                         ::payments::mojom::blink::ImageObjectPtr> {
  static bool IsNull(const ::payments::mojom::blink::ImageObjectPtr& input) { return !input; }
  static void SetToNull(::payments::mojom::blink::ImageObjectPtr* output) { output->reset(); }

  static const decltype(::payments::mojom::blink::ImageObject::src)& src(
      const ::payments::mojom::blink::ImageObjectPtr& input) {
    return input->src;
  }

  static bool Read(::payments::mojom::blink::ImageObject::DataView input, ::payments::mojom::blink::ImageObjectPtr* output);
};


template <>
struct BLINK_PLATFORM_EXPORT StructTraits<::payments::mojom::blink::PaymentInstrument::DataView,
                                         ::payments::mojom::blink::PaymentInstrumentPtr> {
  static bool IsNull(const ::payments::mojom::blink::PaymentInstrumentPtr& input) { return !input; }
  static void SetToNull(::payments::mojom::blink::PaymentInstrumentPtr* output) { output->reset(); }

  static const decltype(::payments::mojom::blink::PaymentInstrument::name)& name(
      const ::payments::mojom::blink::PaymentInstrumentPtr& input) {
    return input->name;
  }

  static const decltype(::payments::mojom::blink::PaymentInstrument::icons)& icons(
      const ::payments::mojom::blink::PaymentInstrumentPtr& input) {
    return input->icons;
  }

  static const decltype(::payments::mojom::blink::PaymentInstrument::enabled_methods)& enabled_methods(
      const ::payments::mojom::blink::PaymentInstrumentPtr& input) {
    return input->enabled_methods;
  }

  static const decltype(::payments::mojom::blink::PaymentInstrument::stringified_capabilities)& stringified_capabilities(
      const ::payments::mojom::blink::PaymentInstrumentPtr& input) {
    return input->stringified_capabilities;
  }

  static bool Read(::payments::mojom::blink::PaymentInstrument::DataView input, ::payments::mojom::blink::PaymentInstrumentPtr* output);
};


template <>
struct BLINK_PLATFORM_EXPORT StructTraits<::payments::mojom::blink::PaymentRequestEventData::DataView,
                                         ::payments::mojom::blink::PaymentRequestEventDataPtr> {
  static bool IsNull(const ::payments::mojom::blink::PaymentRequestEventDataPtr& input) { return !input; }
  static void SetToNull(::payments::mojom::blink::PaymentRequestEventDataPtr* output) { output->reset(); }

  static const decltype(::payments::mojom::blink::PaymentRequestEventData::top_level_origin)& top_level_origin(
      const ::payments::mojom::blink::PaymentRequestEventDataPtr& input) {
    return input->top_level_origin;
  }

  static const decltype(::payments::mojom::blink::PaymentRequestEventData::payment_request_origin)& payment_request_origin(
      const ::payments::mojom::blink::PaymentRequestEventDataPtr& input) {
    return input->payment_request_origin;
  }

  static const decltype(::payments::mojom::blink::PaymentRequestEventData::payment_request_id)& payment_request_id(
      const ::payments::mojom::blink::PaymentRequestEventDataPtr& input) {
    return input->payment_request_id;
  }

  static const decltype(::payments::mojom::blink::PaymentRequestEventData::method_data)& method_data(
      const ::payments::mojom::blink::PaymentRequestEventDataPtr& input) {
    return input->method_data;
  }

  static const decltype(::payments::mojom::blink::PaymentRequestEventData::total)& total(
      const ::payments::mojom::blink::PaymentRequestEventDataPtr& input) {
    return input->total;
  }

  static const decltype(::payments::mojom::blink::PaymentRequestEventData::modifiers)& modifiers(
      const ::payments::mojom::blink::PaymentRequestEventDataPtr& input) {
    return input->modifiers;
  }

  static const decltype(::payments::mojom::blink::PaymentRequestEventData::instrument_key)& instrument_key(
      const ::payments::mojom::blink::PaymentRequestEventDataPtr& input) {
    return input->instrument_key;
  }

  static bool Read(::payments::mojom::blink::PaymentRequestEventData::DataView input, ::payments::mojom::blink::PaymentRequestEventDataPtr* output);
};


template <>
struct BLINK_PLATFORM_EXPORT StructTraits<::payments::mojom::blink::PaymentHandlerResponse::DataView,
                                         ::payments::mojom::blink::PaymentHandlerResponsePtr> {
  static bool IsNull(const ::payments::mojom::blink::PaymentHandlerResponsePtr& input) { return !input; }
  static void SetToNull(::payments::mojom::blink::PaymentHandlerResponsePtr* output) { output->reset(); }

  static const decltype(::payments::mojom::blink::PaymentHandlerResponse::method_name)& method_name(
      const ::payments::mojom::blink::PaymentHandlerResponsePtr& input) {
    return input->method_name;
  }

  static const decltype(::payments::mojom::blink::PaymentHandlerResponse::stringified_details)& stringified_details(
      const ::payments::mojom::blink::PaymentHandlerResponsePtr& input) {
    return input->stringified_details;
  }

  static bool Read(::payments::mojom::blink::PaymentHandlerResponse::DataView input, ::payments::mojom::blink::PaymentHandlerResponsePtr* output);
};

}  // namespace mojo

#endif  // THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_PAYMENTS_PAYMENT_APP_MOJOM_BLINK_H_