// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_PAYMENTS_PAYMENT_APP_MOJOM_SHARED_INTERNAL_H_
#define THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_PAYMENTS_PAYMENT_APP_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/native_struct_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/common/time.mojom-shared-internal.h"
#include "third_party/WebKit/public/platform/modules/payments/payment_request.mojom-shared-internal.h"
#include "url/mojo/url.mojom-shared-internal.h"
#include "third_party/WebKit/public/mojo_bindings_shared_export.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace payments {
namespace mojom {
namespace internal {
class ImageObject_Data;
class PaymentInstrument_Data;
class PaymentRequestEventData_Data;
class PaymentHandlerResponse_Data;

struct PaymentHandlerStatus_Data {
 public:
  static bool constexpr kIsExtensible = false;

  static bool IsKnownValue(int32_t value) {
    switch (value) {
      case 0:
      case 1:
      case 2:
      case 3:
      case 4:
      case 5:
      case 6:
        return true;
    }
    return false;
  }

  static bool Validate(int32_t value,
                       mojo::internal::ValidationContext* validation_context) {
    if (kIsExtensible || IsKnownValue(value))
      return true;

    ReportValidationError(validation_context,
                          mojo::internal::VALIDATION_ERROR_UNKNOWN_ENUM_VALUE);
    return false;
  }
};

#pragma pack(push, 1)
class MOJOM_SHARED_CONTENT_EXPORT ImageObject_Data {
 public:
  static ImageObject_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> src;

 private:
  ImageObject_Data();
  ~ImageObject_Data() = delete;
};
static_assert(sizeof(ImageObject_Data) == 16,
              "Bad sizeof(ImageObject_Data)");
class MOJOM_SHARED_CONTENT_EXPORT PaymentInstrument_Data {
 public:
  static PaymentInstrument_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> name;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::ImageObject_Data>>> icons;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<mojo::internal::String_Data>>> enabled_methods;
  mojo::internal::Pointer<mojo::internal::String_Data> stringified_capabilities;

 private:
  PaymentInstrument_Data();
  ~PaymentInstrument_Data() = delete;
};
static_assert(sizeof(PaymentInstrument_Data) == 40,
              "Bad sizeof(PaymentInstrument_Data)");
class MOJOM_SHARED_CONTENT_EXPORT PaymentRequestEventData_Data {
 public:
  static PaymentRequestEventData_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> top_level_origin;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> payment_request_origin;
  mojo::internal::Pointer<mojo::internal::String_Data> payment_request_id;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::payments::mojom::internal::PaymentMethodData_Data>>> method_data;
  mojo::internal::Pointer<::payments::mojom::internal::PaymentCurrencyAmount_Data> total;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::payments::mojom::internal::PaymentDetailsModifier_Data>>> modifiers;
  mojo::internal::Pointer<mojo::internal::String_Data> instrument_key;

 private:
  PaymentRequestEventData_Data();
  ~PaymentRequestEventData_Data() = delete;
};
static_assert(sizeof(PaymentRequestEventData_Data) == 64,
              "Bad sizeof(PaymentRequestEventData_Data)");
class MOJOM_SHARED_CONTENT_EXPORT PaymentHandlerResponse_Data {
 public:
  static PaymentHandlerResponse_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> method_name;
  mojo::internal::Pointer<mojo::internal::String_Data> stringified_details;

 private:
  PaymentHandlerResponse_Data();
  ~PaymentHandlerResponse_Data() = delete;
};
static_assert(sizeof(PaymentHandlerResponse_Data) == 24,
              "Bad sizeof(PaymentHandlerResponse_Data)");
constexpr uint32_t kPaymentManager_Init_Name = 0;
class MOJOM_SHARED_CONTENT_EXPORT PaymentManager_Init_Params_Data {
 public:
  static PaymentManager_Init_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> service_worker_script_url;
  mojo::internal::Pointer<mojo::internal::String_Data> service_worker_scope;

 private:
  PaymentManager_Init_Params_Data();
  ~PaymentManager_Init_Params_Data() = delete;
};
static_assert(sizeof(PaymentManager_Init_Params_Data) == 24,
              "Bad sizeof(PaymentManager_Init_Params_Data)");
constexpr uint32_t kPaymentManager_DeletePaymentInstrument_Name = 1;
class MOJOM_SHARED_CONTENT_EXPORT PaymentManager_DeletePaymentInstrument_Params_Data {
 public:
  static PaymentManager_DeletePaymentInstrument_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> instrument_key;

 private:
  PaymentManager_DeletePaymentInstrument_Params_Data();
  ~PaymentManager_DeletePaymentInstrument_Params_Data() = delete;
};
static_assert(sizeof(PaymentManager_DeletePaymentInstrument_Params_Data) == 16,
              "Bad sizeof(PaymentManager_DeletePaymentInstrument_Params_Data)");
class MOJOM_SHARED_CONTENT_EXPORT PaymentManager_DeletePaymentInstrument_ResponseParams_Data {
 public:
  static PaymentManager_DeletePaymentInstrument_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t status;
  uint8_t padfinal_[4];

 private:
  PaymentManager_DeletePaymentInstrument_ResponseParams_Data();
  ~PaymentManager_DeletePaymentInstrument_ResponseParams_Data() = delete;
};
static_assert(sizeof(PaymentManager_DeletePaymentInstrument_ResponseParams_Data) == 16,
              "Bad sizeof(PaymentManager_DeletePaymentInstrument_ResponseParams_Data)");
constexpr uint32_t kPaymentManager_GetPaymentInstrument_Name = 2;
class MOJOM_SHARED_CONTENT_EXPORT PaymentManager_GetPaymentInstrument_Params_Data {
 public:
  static PaymentManager_GetPaymentInstrument_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> instrument_key;

 private:
  PaymentManager_GetPaymentInstrument_Params_Data();
  ~PaymentManager_GetPaymentInstrument_Params_Data() = delete;
};
static_assert(sizeof(PaymentManager_GetPaymentInstrument_Params_Data) == 16,
              "Bad sizeof(PaymentManager_GetPaymentInstrument_Params_Data)");
class MOJOM_SHARED_CONTENT_EXPORT PaymentManager_GetPaymentInstrument_ResponseParams_Data {
 public:
  static PaymentManager_GetPaymentInstrument_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::PaymentInstrument_Data> instrument;
  int32_t status;
  uint8_t padfinal_[4];

 private:
  PaymentManager_GetPaymentInstrument_ResponseParams_Data();
  ~PaymentManager_GetPaymentInstrument_ResponseParams_Data() = delete;
};
static_assert(sizeof(PaymentManager_GetPaymentInstrument_ResponseParams_Data) == 24,
              "Bad sizeof(PaymentManager_GetPaymentInstrument_ResponseParams_Data)");
constexpr uint32_t kPaymentManager_KeysOfPaymentInstruments_Name = 3;
class MOJOM_SHARED_CONTENT_EXPORT PaymentManager_KeysOfPaymentInstruments_Params_Data {
 public:
  static PaymentManager_KeysOfPaymentInstruments_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  PaymentManager_KeysOfPaymentInstruments_Params_Data();
  ~PaymentManager_KeysOfPaymentInstruments_Params_Data() = delete;
};
static_assert(sizeof(PaymentManager_KeysOfPaymentInstruments_Params_Data) == 8,
              "Bad sizeof(PaymentManager_KeysOfPaymentInstruments_Params_Data)");
class MOJOM_SHARED_CONTENT_EXPORT PaymentManager_KeysOfPaymentInstruments_ResponseParams_Data {
 public:
  static PaymentManager_KeysOfPaymentInstruments_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<mojo::internal::String_Data>>> keys;
  int32_t status;
  uint8_t padfinal_[4];

 private:
  PaymentManager_KeysOfPaymentInstruments_ResponseParams_Data();
  ~PaymentManager_KeysOfPaymentInstruments_ResponseParams_Data() = delete;
};
static_assert(sizeof(PaymentManager_KeysOfPaymentInstruments_ResponseParams_Data) == 24,
              "Bad sizeof(PaymentManager_KeysOfPaymentInstruments_ResponseParams_Data)");
constexpr uint32_t kPaymentManager_HasPaymentInstrument_Name = 4;
class MOJOM_SHARED_CONTENT_EXPORT PaymentManager_HasPaymentInstrument_Params_Data {
 public:
  static PaymentManager_HasPaymentInstrument_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> instrument_key;

 private:
  PaymentManager_HasPaymentInstrument_Params_Data();
  ~PaymentManager_HasPaymentInstrument_Params_Data() = delete;
};
static_assert(sizeof(PaymentManager_HasPaymentInstrument_Params_Data) == 16,
              "Bad sizeof(PaymentManager_HasPaymentInstrument_Params_Data)");
class MOJOM_SHARED_CONTENT_EXPORT PaymentManager_HasPaymentInstrument_ResponseParams_Data {
 public:
  static PaymentManager_HasPaymentInstrument_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t status;
  uint8_t padfinal_[4];

 private:
  PaymentManager_HasPaymentInstrument_ResponseParams_Data();
  ~PaymentManager_HasPaymentInstrument_ResponseParams_Data() = delete;
};
static_assert(sizeof(PaymentManager_HasPaymentInstrument_ResponseParams_Data) == 16,
              "Bad sizeof(PaymentManager_HasPaymentInstrument_ResponseParams_Data)");
constexpr uint32_t kPaymentManager_SetPaymentInstrument_Name = 5;
class MOJOM_SHARED_CONTENT_EXPORT PaymentManager_SetPaymentInstrument_Params_Data {
 public:
  static PaymentManager_SetPaymentInstrument_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> instrument_key;
  mojo::internal::Pointer<internal::PaymentInstrument_Data> instrument;

 private:
  PaymentManager_SetPaymentInstrument_Params_Data();
  ~PaymentManager_SetPaymentInstrument_Params_Data() = delete;
};
static_assert(sizeof(PaymentManager_SetPaymentInstrument_Params_Data) == 24,
              "Bad sizeof(PaymentManager_SetPaymentInstrument_Params_Data)");
class MOJOM_SHARED_CONTENT_EXPORT PaymentManager_SetPaymentInstrument_ResponseParams_Data {
 public:
  static PaymentManager_SetPaymentInstrument_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t status;
  uint8_t padfinal_[4];

 private:
  PaymentManager_SetPaymentInstrument_ResponseParams_Data();
  ~PaymentManager_SetPaymentInstrument_ResponseParams_Data() = delete;
};
static_assert(sizeof(PaymentManager_SetPaymentInstrument_ResponseParams_Data) == 16,
              "Bad sizeof(PaymentManager_SetPaymentInstrument_ResponseParams_Data)");
constexpr uint32_t kPaymentManager_ClearPaymentInstruments_Name = 6;
class MOJOM_SHARED_CONTENT_EXPORT PaymentManager_ClearPaymentInstruments_Params_Data {
 public:
  static PaymentManager_ClearPaymentInstruments_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  PaymentManager_ClearPaymentInstruments_Params_Data();
  ~PaymentManager_ClearPaymentInstruments_Params_Data() = delete;
};
static_assert(sizeof(PaymentManager_ClearPaymentInstruments_Params_Data) == 8,
              "Bad sizeof(PaymentManager_ClearPaymentInstruments_Params_Data)");
class MOJOM_SHARED_CONTENT_EXPORT PaymentManager_ClearPaymentInstruments_ResponseParams_Data {
 public:
  static PaymentManager_ClearPaymentInstruments_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t status;
  uint8_t padfinal_[4];

 private:
  PaymentManager_ClearPaymentInstruments_ResponseParams_Data();
  ~PaymentManager_ClearPaymentInstruments_ResponseParams_Data() = delete;
};
static_assert(sizeof(PaymentManager_ClearPaymentInstruments_ResponseParams_Data) == 16,
              "Bad sizeof(PaymentManager_ClearPaymentInstruments_ResponseParams_Data)");
constexpr uint32_t kPaymentHandlerResponseCallback_OnPaymentHandlerResponse_Name = 0;
class MOJOM_SHARED_CONTENT_EXPORT PaymentHandlerResponseCallback_OnPaymentHandlerResponse_Params_Data {
 public:
  static PaymentHandlerResponseCallback_OnPaymentHandlerResponse_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::PaymentHandlerResponse_Data> response;
  mojo::internal::Pointer<::mojo::common::mojom::internal::Time_Data> dispatch_event_time;

 private:
  PaymentHandlerResponseCallback_OnPaymentHandlerResponse_Params_Data();
  ~PaymentHandlerResponseCallback_OnPaymentHandlerResponse_Params_Data() = delete;
};
static_assert(sizeof(PaymentHandlerResponseCallback_OnPaymentHandlerResponse_Params_Data) == 24,
              "Bad sizeof(PaymentHandlerResponseCallback_OnPaymentHandlerResponse_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace payments

#endif  // THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_PAYMENTS_PAYMENT_APP_MOJOM_SHARED_INTERNAL_H_