// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_PRESENTATION_PRESENTATION_MOJOM_SHARED_INTERNAL_H_
#define THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_PRESENTATION_PRESENTATION_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/native_struct_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "url/mojo/url.mojom-shared-internal.h"
#include "third_party/WebKit/public/mojo_bindings_shared_export.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace blink {
namespace mojom {
namespace internal {
class PresentationInfo_Data;
class PresentationError_Data;
class PresentationConnectionMessage_Data;

struct ScreenAvailability_Data {
 public:
  static bool constexpr kIsExtensible = false;

  static bool IsKnownValue(int32_t value) {
    switch (value) {
      case 0:
      case 1:
      case 2:
      case 3:
      case 4:
        return true;
    }
    return false;
  }

  static bool Validate(int32_t value,
                       mojo::internal::ValidationContext* validation_context) {
    if (kIsExtensible || IsKnownValue(value))
      return true;

    ReportValidationError(validation_context,
                          mojo::internal::VALIDATION_ERROR_UNKNOWN_ENUM_VALUE);
    return false;
  }
};

struct PresentationConnectionState_Data {
 public:
  static bool constexpr kIsExtensible = false;

  static bool IsKnownValue(int32_t value) {
    switch (value) {
      case 0:
      case 1:
      case 2:
      case 3:
        return true;
    }
    return false;
  }

  static bool Validate(int32_t value,
                       mojo::internal::ValidationContext* validation_context) {
    if (kIsExtensible || IsKnownValue(value))
      return true;

    ReportValidationError(validation_context,
                          mojo::internal::VALIDATION_ERROR_UNKNOWN_ENUM_VALUE);
    return false;
  }
};

struct PresentationConnectionCloseReason_Data {
 public:
  static bool constexpr kIsExtensible = false;

  static bool IsKnownValue(int32_t value) {
    switch (value) {
      case 0:
      case 1:
      case 2:
        return true;
    }
    return false;
  }

  static bool Validate(int32_t value,
                       mojo::internal::ValidationContext* validation_context) {
    if (kIsExtensible || IsKnownValue(value))
      return true;

    ReportValidationError(validation_context,
                          mojo::internal::VALIDATION_ERROR_UNKNOWN_ENUM_VALUE);
    return false;
  }
};

struct PresentationErrorType_Data {
 public:
  static bool constexpr kIsExtensible = false;

  static bool IsKnownValue(int32_t value) {
    switch (value) {
      case 0:
      case 1:
      case 2:
      case 3:
      case 4:
        return true;
    }
    return false;
  }

  static bool Validate(int32_t value,
                       mojo::internal::ValidationContext* validation_context) {
    if (kIsExtensible || IsKnownValue(value))
      return true;

    ReportValidationError(validation_context,
                          mojo::internal::VALIDATION_ERROR_UNKNOWN_ENUM_VALUE);
    return false;
  }
};

#pragma pack(push, 1)


class MOJOM_SHARED_CONTENT_EXPORT PresentationConnectionMessage_Data {
 public:
  // Used to identify Mojom Union Data Classes.
  typedef void MojomUnionDataType;

  PresentationConnectionMessage_Data() {}
  // Do nothing in the destructor since it won't be called when it is a
  // non-inlined union.
  ~PresentationConnectionMessage_Data() {}

  static PresentationConnectionMessage_Data* New(mojo::internal::Buffer* buf) {
    return new (buf->Allocate(sizeof(PresentationConnectionMessage_Data))) PresentationConnectionMessage_Data();
  }

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context,
                       bool inlined);

  bool is_null() const { return size == 0; }

  void set_null() {
    size = 0U;
    tag = static_cast<PresentationConnectionMessage_Tag>(0);
    data.unknown = 0U;
  }

  enum class PresentationConnectionMessage_Tag : uint32_t {

    MESSAGE,
    DATA,
  };

  // A note on layout:
  // "Each non-static data member is allocated as if it were the sole member of
  // a struct." - Section 9.5.2 ISO/IEC 14882:2011 (The C++ Spec)
  union MOJO_ALIGNAS(8) Union_ {
    mojo::internal::Pointer<mojo::internal::String_Data> f_message;
    mojo::internal::Pointer<mojo::internal::Array_Data<uint8_t>> f_data;
    uint64_t unknown;
  };

  uint32_t size;
  PresentationConnectionMessage_Tag tag;
  Union_ data;
};
static_assert(sizeof(PresentationConnectionMessage_Data) == mojo::internal::kUnionDataSize,
              "Bad sizeof(PresentationConnectionMessage_Data)");
class MOJOM_SHARED_CONTENT_EXPORT PresentationInfo_Data {
 public:
  static PresentationInfo_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> url;
  mojo::internal::Pointer<mojo::internal::String_Data> id;

 private:
  PresentationInfo_Data();
  ~PresentationInfo_Data() = delete;
};
static_assert(sizeof(PresentationInfo_Data) == 24,
              "Bad sizeof(PresentationInfo_Data)");
class MOJOM_SHARED_CONTENT_EXPORT PresentationError_Data {
 public:
  static PresentationError_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t error_type;
  uint8_t pad0_[4];
  mojo::internal::Pointer<mojo::internal::String_Data> message;

 private:
  PresentationError_Data();
  ~PresentationError_Data() = delete;
};
static_assert(sizeof(PresentationError_Data) == 24,
              "Bad sizeof(PresentationError_Data)");
constexpr uint32_t kPresentationConnection_OnMessage_Name = 0;
class MOJOM_SHARED_CONTENT_EXPORT PresentationConnection_OnMessage_Params_Data {
 public:
  static PresentationConnection_OnMessage_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  internal::PresentationConnectionMessage_Data message;

 private:
  PresentationConnection_OnMessage_Params_Data();
  ~PresentationConnection_OnMessage_Params_Data() = delete;
};
static_assert(sizeof(PresentationConnection_OnMessage_Params_Data) == 24,
              "Bad sizeof(PresentationConnection_OnMessage_Params_Data)");
class MOJOM_SHARED_CONTENT_EXPORT PresentationConnection_OnMessage_ResponseParams_Data {
 public:
  static PresentationConnection_OnMessage_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t success : 1;
  uint8_t padfinal_[7];

 private:
  PresentationConnection_OnMessage_ResponseParams_Data();
  ~PresentationConnection_OnMessage_ResponseParams_Data() = delete;
};
static_assert(sizeof(PresentationConnection_OnMessage_ResponseParams_Data) == 16,
              "Bad sizeof(PresentationConnection_OnMessage_ResponseParams_Data)");
constexpr uint32_t kPresentationConnection_DidChangeState_Name = 1;
class MOJOM_SHARED_CONTENT_EXPORT PresentationConnection_DidChangeState_Params_Data {
 public:
  static PresentationConnection_DidChangeState_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t state;
  uint8_t padfinal_[4];

 private:
  PresentationConnection_DidChangeState_Params_Data();
  ~PresentationConnection_DidChangeState_Params_Data() = delete;
};
static_assert(sizeof(PresentationConnection_DidChangeState_Params_Data) == 16,
              "Bad sizeof(PresentationConnection_DidChangeState_Params_Data)");
constexpr uint32_t kPresentationConnection_OnClose_Name = 2;
class MOJOM_SHARED_CONTENT_EXPORT PresentationConnection_OnClose_Params_Data {
 public:
  static PresentationConnection_OnClose_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  PresentationConnection_OnClose_Params_Data();
  ~PresentationConnection_OnClose_Params_Data() = delete;
};
static_assert(sizeof(PresentationConnection_OnClose_Params_Data) == 8,
              "Bad sizeof(PresentationConnection_OnClose_Params_Data)");
constexpr uint32_t kPresentationService_SetClient_Name = 0;
class MOJOM_SHARED_CONTENT_EXPORT PresentationService_SetClient_Params_Data {
 public:
  static PresentationService_SetClient_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Interface_Data client;

 private:
  PresentationService_SetClient_Params_Data();
  ~PresentationService_SetClient_Params_Data() = delete;
};
static_assert(sizeof(PresentationService_SetClient_Params_Data) == 16,
              "Bad sizeof(PresentationService_SetClient_Params_Data)");
constexpr uint32_t kPresentationService_SetDefaultPresentationUrls_Name = 1;
class MOJOM_SHARED_CONTENT_EXPORT PresentationService_SetDefaultPresentationUrls_Params_Data {
 public:
  static PresentationService_SetDefaultPresentationUrls_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::url::mojom::internal::Url_Data>>> presentation_urls;

 private:
  PresentationService_SetDefaultPresentationUrls_Params_Data();
  ~PresentationService_SetDefaultPresentationUrls_Params_Data() = delete;
};
static_assert(sizeof(PresentationService_SetDefaultPresentationUrls_Params_Data) == 16,
              "Bad sizeof(PresentationService_SetDefaultPresentationUrls_Params_Data)");
constexpr uint32_t kPresentationService_ListenForScreenAvailability_Name = 2;
class MOJOM_SHARED_CONTENT_EXPORT PresentationService_ListenForScreenAvailability_Params_Data {
 public:
  static PresentationService_ListenForScreenAvailability_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> availability_url;

 private:
  PresentationService_ListenForScreenAvailability_Params_Data();
  ~PresentationService_ListenForScreenAvailability_Params_Data() = delete;
};
static_assert(sizeof(PresentationService_ListenForScreenAvailability_Params_Data) == 16,
              "Bad sizeof(PresentationService_ListenForScreenAvailability_Params_Data)");
constexpr uint32_t kPresentationService_StopListeningForScreenAvailability_Name = 3;
class MOJOM_SHARED_CONTENT_EXPORT PresentationService_StopListeningForScreenAvailability_Params_Data {
 public:
  static PresentationService_StopListeningForScreenAvailability_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> availability_url;

 private:
  PresentationService_StopListeningForScreenAvailability_Params_Data();
  ~PresentationService_StopListeningForScreenAvailability_Params_Data() = delete;
};
static_assert(sizeof(PresentationService_StopListeningForScreenAvailability_Params_Data) == 16,
              "Bad sizeof(PresentationService_StopListeningForScreenAvailability_Params_Data)");
constexpr uint32_t kPresentationService_StartPresentation_Name = 4;
class MOJOM_SHARED_CONTENT_EXPORT PresentationService_StartPresentation_Params_Data {
 public:
  static PresentationService_StartPresentation_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::url::mojom::internal::Url_Data>>> presentation_urls;

 private:
  PresentationService_StartPresentation_Params_Data();
  ~PresentationService_StartPresentation_Params_Data() = delete;
};
static_assert(sizeof(PresentationService_StartPresentation_Params_Data) == 16,
              "Bad sizeof(PresentationService_StartPresentation_Params_Data)");
class MOJOM_SHARED_CONTENT_EXPORT PresentationService_StartPresentation_ResponseParams_Data {
 public:
  static PresentationService_StartPresentation_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::PresentationInfo_Data> presentation_info;
  mojo::internal::Pointer<internal::PresentationError_Data> error;

 private:
  PresentationService_StartPresentation_ResponseParams_Data();
  ~PresentationService_StartPresentation_ResponseParams_Data() = delete;
};
static_assert(sizeof(PresentationService_StartPresentation_ResponseParams_Data) == 24,
              "Bad sizeof(PresentationService_StartPresentation_ResponseParams_Data)");
constexpr uint32_t kPresentationService_ReconnectPresentation_Name = 5;
class MOJOM_SHARED_CONTENT_EXPORT PresentationService_ReconnectPresentation_Params_Data {
 public:
  static PresentationService_ReconnectPresentation_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::url::mojom::internal::Url_Data>>> presentation_urls;
  mojo::internal::Pointer<mojo::internal::String_Data> presentation_id;

 private:
  PresentationService_ReconnectPresentation_Params_Data();
  ~PresentationService_ReconnectPresentation_Params_Data() = delete;
};
static_assert(sizeof(PresentationService_ReconnectPresentation_Params_Data) == 24,
              "Bad sizeof(PresentationService_ReconnectPresentation_Params_Data)");
class MOJOM_SHARED_CONTENT_EXPORT PresentationService_ReconnectPresentation_ResponseParams_Data {
 public:
  static PresentationService_ReconnectPresentation_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::PresentationInfo_Data> presentation_info;
  mojo::internal::Pointer<internal::PresentationError_Data> error;

 private:
  PresentationService_ReconnectPresentation_ResponseParams_Data();
  ~PresentationService_ReconnectPresentation_ResponseParams_Data() = delete;
};
static_assert(sizeof(PresentationService_ReconnectPresentation_ResponseParams_Data) == 24,
              "Bad sizeof(PresentationService_ReconnectPresentation_ResponseParams_Data)");
constexpr uint32_t kPresentationService_SetPresentationConnection_Name = 6;
class MOJOM_SHARED_CONTENT_EXPORT PresentationService_SetPresentationConnection_Params_Data {
 public:
  static PresentationService_SetPresentationConnection_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::PresentationInfo_Data> presentation_info;
  mojo::internal::Interface_Data controller_connection_ptr;
  mojo::internal::Handle_Data receiver_connection_request;
  uint8_t padfinal_[4];

 private:
  PresentationService_SetPresentationConnection_Params_Data();
  ~PresentationService_SetPresentationConnection_Params_Data() = delete;
};
static_assert(sizeof(PresentationService_SetPresentationConnection_Params_Data) == 32,
              "Bad sizeof(PresentationService_SetPresentationConnection_Params_Data)");
constexpr uint32_t kPresentationService_CloseConnection_Name = 7;
class MOJOM_SHARED_CONTENT_EXPORT PresentationService_CloseConnection_Params_Data {
 public:
  static PresentationService_CloseConnection_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> presentation_url;
  mojo::internal::Pointer<mojo::internal::String_Data> presentation_id;

 private:
  PresentationService_CloseConnection_Params_Data();
  ~PresentationService_CloseConnection_Params_Data() = delete;
};
static_assert(sizeof(PresentationService_CloseConnection_Params_Data) == 24,
              "Bad sizeof(PresentationService_CloseConnection_Params_Data)");
constexpr uint32_t kPresentationService_Terminate_Name = 8;
class MOJOM_SHARED_CONTENT_EXPORT PresentationService_Terminate_Params_Data {
 public:
  static PresentationService_Terminate_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> presentation_url;
  mojo::internal::Pointer<mojo::internal::String_Data> presentation_id;

 private:
  PresentationService_Terminate_Params_Data();
  ~PresentationService_Terminate_Params_Data() = delete;
};
static_assert(sizeof(PresentationService_Terminate_Params_Data) == 24,
              "Bad sizeof(PresentationService_Terminate_Params_Data)");
constexpr uint32_t kPresentationServiceClient_OnScreenAvailabilityUpdated_Name = 0;
class MOJOM_SHARED_CONTENT_EXPORT PresentationServiceClient_OnScreenAvailabilityUpdated_Params_Data {
 public:
  static PresentationServiceClient_OnScreenAvailabilityUpdated_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> url;
  int32_t availability;
  uint8_t padfinal_[4];

 private:
  PresentationServiceClient_OnScreenAvailabilityUpdated_Params_Data();
  ~PresentationServiceClient_OnScreenAvailabilityUpdated_Params_Data() = delete;
};
static_assert(sizeof(PresentationServiceClient_OnScreenAvailabilityUpdated_Params_Data) == 24,
              "Bad sizeof(PresentationServiceClient_OnScreenAvailabilityUpdated_Params_Data)");
constexpr uint32_t kPresentationServiceClient_OnDefaultPresentationStarted_Name = 1;
class MOJOM_SHARED_CONTENT_EXPORT PresentationServiceClient_OnDefaultPresentationStarted_Params_Data {
 public:
  static PresentationServiceClient_OnDefaultPresentationStarted_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::PresentationInfo_Data> presentation_info;

 private:
  PresentationServiceClient_OnDefaultPresentationStarted_Params_Data();
  ~PresentationServiceClient_OnDefaultPresentationStarted_Params_Data() = delete;
};
static_assert(sizeof(PresentationServiceClient_OnDefaultPresentationStarted_Params_Data) == 16,
              "Bad sizeof(PresentationServiceClient_OnDefaultPresentationStarted_Params_Data)");
constexpr uint32_t kPresentationServiceClient_OnReceiverConnectionAvailable_Name = 2;
class MOJOM_SHARED_CONTENT_EXPORT PresentationServiceClient_OnReceiverConnectionAvailable_Params_Data {
 public:
  static PresentationServiceClient_OnReceiverConnectionAvailable_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::PresentationInfo_Data> presentation_info;
  mojo::internal::Interface_Data controller_connection_ptr;
  mojo::internal::Handle_Data receiver_connection_request;
  uint8_t padfinal_[4];

 private:
  PresentationServiceClient_OnReceiverConnectionAvailable_Params_Data();
  ~PresentationServiceClient_OnReceiverConnectionAvailable_Params_Data() = delete;
};
static_assert(sizeof(PresentationServiceClient_OnReceiverConnectionAvailable_Params_Data) == 32,
              "Bad sizeof(PresentationServiceClient_OnReceiverConnectionAvailable_Params_Data)");
constexpr uint32_t kPresentationServiceClient_OnConnectionStateChanged_Name = 3;
class MOJOM_SHARED_CONTENT_EXPORT PresentationServiceClient_OnConnectionStateChanged_Params_Data {
 public:
  static PresentationServiceClient_OnConnectionStateChanged_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::PresentationInfo_Data> presentation_info;
  int32_t newState;
  uint8_t padfinal_[4];

 private:
  PresentationServiceClient_OnConnectionStateChanged_Params_Data();
  ~PresentationServiceClient_OnConnectionStateChanged_Params_Data() = delete;
};
static_assert(sizeof(PresentationServiceClient_OnConnectionStateChanged_Params_Data) == 24,
              "Bad sizeof(PresentationServiceClient_OnConnectionStateChanged_Params_Data)");
constexpr uint32_t kPresentationServiceClient_OnConnectionClosed_Name = 4;
class MOJOM_SHARED_CONTENT_EXPORT PresentationServiceClient_OnConnectionClosed_Params_Data {
 public:
  static PresentationServiceClient_OnConnectionClosed_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::PresentationInfo_Data> presentation_info;
  int32_t reason;
  uint8_t pad1_[4];
  mojo::internal::Pointer<mojo::internal::String_Data> message;

 private:
  PresentationServiceClient_OnConnectionClosed_Params_Data();
  ~PresentationServiceClient_OnConnectionClosed_Params_Data() = delete;
};
static_assert(sizeof(PresentationServiceClient_OnConnectionClosed_Params_Data) == 32,
              "Bad sizeof(PresentationServiceClient_OnConnectionClosed_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_PRESENTATION_PRESENTATION_MOJOM_SHARED_INTERNAL_H_