// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_REPORTING_MOJOM_SHARED_H_
#define THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_REPORTING_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/native_struct_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "third_party/WebKit/public/platform/reporting.mojom-shared-internal.h"
#include "mojo/common/values.mojom-shared.h"
#include "url/mojo/url.mojom-shared.h"
#include "third_party/WebKit/public/mojo_bindings_shared_export.h"


namespace content {
namespace mojom {


}  // namespace mojom
}  // namespace content

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace content {
namespace mojom {
// Interface base classes. They are used for type safety check.
class ReportingServiceProxyInterfaceBase {};

using ReportingServiceProxyPtrDataView =
    mojo::InterfacePtrDataView<ReportingServiceProxyInterfaceBase>;
using ReportingServiceProxyRequestDataView =
    mojo::InterfaceRequestDataView<ReportingServiceProxyInterfaceBase>;
using ReportingServiceProxyAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<ReportingServiceProxyInterfaceBase>;
using ReportingServiceProxyAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<ReportingServiceProxyInterfaceBase>;
class ReportingServiceProxy_QueueReport_ParamsDataView {
 public:
  ReportingServiceProxy_QueueReport_ParamsDataView() {}

  ReportingServiceProxy_QueueReport_ParamsDataView(
      internal::ReportingServiceProxy_QueueReport_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetUrlDataView(
      ::url::mojom::UrlDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUrl(UserType* output) {
    auto* pointer = data_->url.Get();
    return mojo::internal::Deserialize<::url::mojom::UrlDataView>(
        pointer, output, context_);
  }
  inline void GetGroupDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadGroup(UserType* output) {
    auto* pointer = data_->group.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetTypeDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadType(UserType* output) {
    auto* pointer = data_->type.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetBodyDataView(
      ::mojo::common::mojom::ValueDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadBody(UserType* output) {
    auto* pointer = &data_->body;
    return mojo::internal::Deserialize<::mojo::common::mojom::ValueDataView>(
        pointer, output, context_);
  }
 private:
  internal::ReportingServiceProxy_QueueReport_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace content

namespace std {

}  // namespace std

namespace mojo {

}  // namespace mojo


namespace content {
namespace mojom {

inline void ReportingServiceProxy_QueueReport_ParamsDataView::GetUrlDataView(
    ::url::mojom::UrlDataView* output) {
  auto pointer = data_->url.Get();
  *output = ::url::mojom::UrlDataView(pointer, context_);
}
inline void ReportingServiceProxy_QueueReport_ParamsDataView::GetGroupDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->group.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void ReportingServiceProxy_QueueReport_ParamsDataView::GetTypeDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->type.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void ReportingServiceProxy_QueueReport_ParamsDataView::GetBodyDataView(
    ::mojo::common::mojom::ValueDataView* output) {
  auto pointer = &data_->body;
  *output = ::mojo::common::mojom::ValueDataView(pointer, context_);
}



}  // namespace mojom
}  // namespace content

#endif  // THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_REPORTING_MOJOM_SHARED_H_
